/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DIALOGADDACTION_H
#define DIALOGADDACTION_H
//#include "quicklaunchaction.h"

#include "dialogaddaction.h"
#include <QDialog>
#include <QTreeWidgetItem>
#include <QAbstractButton>
#include<QDomDocument>
namespace Ui {
class DialogAddAction;
}

class DialogAddAction : public QDialog
{
          Q_OBJECT


public:
          DialogAddAction(QStringList list,QIcon icon ,QWidget *parent = 0);
          DialogAddAction(QWidget *parent = 0);
          ~DialogAddAction();
signals:
          void accepteAdd(QString text);
          void accepteChange(QStringList list);
private:
          Ui::DialogAddAction *ui;
          QString m_type;
          QString m_iconName;
          QDomDocument m_doc;
private slots:
      //    void chargeTreeWidget();
       void   chargeXmlDocument();
       void addMenuDirectory(QString name, QString directory,QString category);
       void chargeAppDesktop();
          void on_treeWidget_itemSelectionChanged();
          void on_buttonBox_clicked(QAbstractButton *button);
          void applyAdd();
          void on_pushButton_clicked();
          void on_toolButton_clicked();
          void on_lineEditIcon_textChanged(const QString &arg1);
};

#endif // DIALOGADDACTION_H
