#include "elokabautostart.h"
#include <EDir>
#include <QDir>
#include <QDebug>
#include <QSettings>
#include <QTextCodec>
QStringList ElokabAutoStart::dirsList()
{
        QStringList dirs;
        dirs <<Edir::dataHomeDir()+"/autostart" << "/etc/xdg/autostart";
return dirs;


}
QStringList ElokabAutoStart::filesList()
{
         QStringList list;
          QStringList fileTemp;//for duplicat desktop file
        foreach (QString dir, dirsList()) {
                qDebug()<<dir<<"=========================================";

                QDir dirS(dir);
                QStringList filters;
                filters<<"*.desktop";
                dirS.setNameFilters(filters);

                foreach (QString subFile, dirS.entryList(QDir::AllEntries| QDir::NoSymLinks| QDir::NoDotAndDotDot )){
                        QString file=(dir+"/"+subFile);

                        if(isElokabValidDesktop(file)==true){

                                if(!fileTemp.contains(subFile)){
                                    fileTemp.append(subFile);
                                        list.append(file);
                                }

                        }

                }
        }
          fileTemp.clear();
        return  list;
}

bool ElokabAutoStart::isElokabValidDesktop(const QString &fileName)
{
        QSettings settings(fileName,QSettings::IniFormat);
        settings.setIniCodec(QTextCodec::codecForName("UTF-8"));
        settings.beginGroup("Desktop Entry");

        QString notShowIn=settings.value("NotShowIn").toString();
        QString onlyShowIn=settings.value("OnlyShowIn").toString();
        QString exec=settings.value("Exec").toString();

        settings.endGroup();

        if(notShowIn.contains("X-Elokab")){

                return false;
        }
        if(!onlyShowIn.contains("X-Elokab")&& !onlyShowIn.isEmpty()){

                return false;
        }
        if(exec.isEmpty()){

                return false;
        }

        return true;
}

QStringList ElokabAutoStart::elokabDescktopEntry(const QString &fileName)
{
        QSettings settings(fileName,QSettings::IniFormat);
        settings.setIniCodec(QTextCodec::codecForName("UTF-8"));
        settings.beginGroup("Desktop Entry");

        QString name=settings.value("Name").toString();
        QString icon=settings.value("Icon").toString();
        QString exec=settings.value("Exec").toString();
      //  QString type=settings.value("Type").toString();
         QString comment=settings.value("Comment").toString();

        QVariant Vsystry=settings.value("X-Elokab-Need-SysTray",false);
        QVariant VautoStart=settings.value("X-Elokab-Autostart",true);
      QString systry;
      QString autostar;

       if(Vsystry.toString()=="true")
                systry="1";
       else
                systry="0";

       if(VautoStart.toString()=="true")
                autostar="1";
       else
                autostar="0";





        settings.endGroup();

        QStringList list;
        return list<<name<<icon<<comment<<exec<<systry<<autostar;
}
