#include "menufolders.h"
#include <EIcon>
#include <EDir>
#include <QDesktopServices>
#include <QStyle>
#include <QSettings>
#include <QUrl>
#include <QProcess>
#include <QDebug>
#include <QMessageBox>
MenuFolders::MenuFolders(QWidget *parent) :
    QMenu(parent)
{

    setTitle(trUtf8("Folders"));
    chargeMenus();
    refreshIcons();
}
void MenuFolders::chargeMenus()
{

    actHomeFolder=new QAction(trUtf8("Home"),this);
    actHomeFolder->setData(QDir::homePath());
    actHomeFolder->setIcon(EIcon::fromTheme("user-home",("folder-home")));
    connect(actHomeFolder, SIGNAL(triggered()), this, SLOT(execFolder()));
    this->addAction(actHomeFolder);
    //مجلد سطح المكتب
    if(QFile::exists(Edir::desktopDir())){
        actDesktopFolder=new QAction(trUtf8("Desktop"),this);
        actDesktopFolder->setData(Edir::desktopDir());
        actDesktopFolder->setIcon(EIcon::fromTheme("user-desktop",("folder-desktop")));
        connect(actDesktopFolder, SIGNAL(triggered()), this, SLOT(execFolder()));
        this->addAction(actDesktopFolder);
    }
    //مجلد الصوت
    if(QFile::exists(Edir::musicDir())){
        actMusicFolder=new QAction(trUtf8("Music"),this);
        actMusicFolder->setData(Edir::musicDir());
        actMusicFolder->setIcon(EIcon::fromTheme("folder-music",("folder-sound")));
        connect(actMusicFolder, SIGNAL(triggered()), this, SLOT(execFolder()));
        this->addAction(actMusicFolder);
    }
    //مجلد الصور
    if(QFile::exists(Edir::picturesDir())){
        actPicturesFolder=new QAction(trUtf8("Pictures"),this);
        actPicturesFolder->setData(Edir::picturesDir());
        actPicturesFolder->setIcon(EIcon::fromTheme("folder-images",("folder-image")));
        connect(actPicturesFolder, SIGNAL(triggered()), this, SLOT(execFolder()));
        this->addAction(actPicturesFolder);
    }
    //مجلد المستندات
    if(QFile::exists(Edir::documentsDir())){
        actDocumentsFolder=new QAction(trUtf8("Documents"),this);
        actDocumentsFolder->setData(Edir::documentsDir());
        actDocumentsFolder->setIcon(EIcon::fromTheme("folder-documents",("folder_documents")));
        connect(actDocumentsFolder, SIGNAL(triggered()), this, SLOT(execFolder()));
        this->addAction(actDocumentsFolder);
    }
    //مجلد الفيديو
    if(QFile::exists(Edir::moviesDir())){
        actMoviesFolder=new QAction(trUtf8("Movies"),this);
        actMoviesFolder->setData(Edir::moviesDir());
        actMoviesFolder->setIcon(EIcon::fromTheme("folder-video",("folder-videos")));
        connect(actMoviesFolder, SIGNAL(triggered()), this, SLOT(execFolder()));
        this->addAction(actMoviesFolder);
    }

}
void MenuFolders::refreshIcons()
{

 //this->setIcon(EIcon::fromTheme("folder"));


}

void MenuFolders::execFolder()
{


    QSettings setting("elokab","elokabsettings");
    setting.beginGroup("DefaultBrowser");
    bool defaultBrowser=(setting.value("defaultBrowser",false).toBool());
    QString costumBrowser=(setting.value("BROWSER","elokab-fm").toString());
    setting.endGroup();


    QAction *action = qobject_cast<QAction *>(sender());

    if(defaultBrowser==true)     {
        //تشغيل مجلدات المستخدم كمجلد المستندات والصور وغيرها

        if (action){
            QString localDir=action->data().toString();
            QDesktopServices::openUrl( QUrl::fromLocalFile(localDir) );
            qDebug()<<QUrl::fromLocalFile(localDir).toString() ;

        }
    }else{
        if (action){
            QString localDir=action->data().toString();


            QString prog=costumBrowser.section(" ",0,0);
            QStringList list;
            if(!costumBrowser.section(" ",1,1).trimmed().isEmpty())
                list<<costumBrowser.section(" ",1,1).trimmed();

            list<<localDir;
            QProcess process;
            process.startDetached(prog,list);
            // qDebug()<<prog;
            //    qDebug()<<list;
        }
    }

    //   this->hide();
}
