﻿#include "menusettingsapps.h"

#include <EMimIcon>
#include <QSettings>
#include <QDirIterator>
#include <QLocale>
#include <QTextCodec>
MenuSettingsApps::MenuSettingsApps(QWidget *parent):
    QMenu(parent)
{

    QDir dir=Edir::dataDir();
    dir.cdUp();

    QString lc=this->locale().name().section("_",0,0);
    //defualt path to "/usr/share/applications/elokab-settings.desktop"
    QSettings gs( dir.absolutePath()+"/applications/elokab-settings.desktop",QSettings::IniFormat);
    gs.setIniCodec(QTextCodec::codecForName("UTF-8"));
    gs.beginGroup("Desktop Entry");

    QString nameold=gs.value("Name",tr("Elokab Settings")).toString();
    QString name=gs.value("Name["+lc+"]",nameold).toString();
    QString icon=gs.value("Icon").toString();
    setTitle(name);
    setIcon(EIcon::fromTheme(icon));
    gs.endGroup();
     //defualt path to "/usr/share/elokab/elokab-settings/elokab-settings.desktop"
    QString serviceDir=Edir::dataDir()+"/elokab-settings/serviceslibs";
    QDirIterator it(serviceDir, QStringList("*.desktop"),
                    QDir::Files | QDir::NoDotAndDotDot);

    while (it.hasNext())
    {
        it.next();

        setupAction(it.filePath());
    }

}
void MenuSettingsApps::setupAction(const QString &file)
{
    QString lc=this->locale().name().section("_",0,0);


    QSettings gs(file,QSettings::IniFormat);
    gs.setIniCodec(QTextCodec::codecForName("UTF-8"));
    gs.beginGroup("Desktop Entry");

    QString type=gs.value("Type").toString();
    QString exec=gs.value("X-EKB-name").toString();
    QString nameold=gs.value("Name").toString();
    QString name=gs.value("Name["+lc+"]",nameold).toString();
    QString icon=gs.value("Icon").toString();
    QString commentold=gs.value("Comment").toString();
    QString comment=gs.value("Comment["+lc+"]",commentold).toString();
    if(type!="Service")return;
    QAction *a=  addAction(EIcon::fromTheme(icon),
                           name,this,SLOT(lanchApplication()));
   a->setData(file);
   a->setToolTip(comment);

}
void MenuSettingsApps::lanchApplication()
{
    QAction *action = qobject_cast<QAction *>(sender());
    if (action){
        //  qDebug()<<"===================="<<action->data().toStringList();
        QString data=action->data().toString();
        EMimIcon::launchApplication(data);
    }
}
