/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "dialogedit.h"
#include "ui_dialogedit.h"

#include <EIcon>
#include<QFile>
#include<QFileDialog>
DialogEdit::DialogEdit(bool isMenu, QWidget *parent) :
        QDialog(parent),
        ui(new Ui::DialogEdit)
{
        ui->setupUi(this);
        if(isMenu==true){
            ui->widgetCommand->setVisible(false);
        }else{
            ui->widgetCommand->setVisible(true);
        }
}

//_____________________________________________________________________
DialogEdit::~DialogEdit()
{
        delete ui;
}

//_____________________________________________________________________
void DialogEdit::setName(const QString &name)
{
  ui->lineEditName->setText(name);
}

//_____________________________________________________________________
void DialogEdit::setGeniric(const QString &name)
{
        ui->lineEditDescription->setText(name);
}

//_____________________________________________________________________
void DialogEdit::setIconName(const QString &name)
{
         ui->lineEditIconName->setText(name);

                 ui->toolButtonIcon->setIcon(EIcon::fromTheme(name));


}

//_____________________________________________________________________
void DialogEdit::setCommand(const QString &name)
{
         ui->lineEditCommand->setText(name);
}

//_____________________________________________________________________
void DialogEdit::setMenuList(const QStringList &list,int indx)
{
     foreach (QString s, list) {
          ui->comboBoxMenu->addItem(s);
     }
     ui->comboBoxMenu->setCurrentIndex(indx);
}

//_____________________________________________________________________
QString DialogEdit::getName()
{
    return ui->lineEditName->text();
}

//_____________________________________________________________________
QString DialogEdit::getGeniric()
{
         return ui->lineEditDescription->text();
}

//_____________________________________________________________________
QString DialogEdit::getIconName()
{
         return ui->lineEditIconName->text();
}

//_____________________________________________________________________
QString DialogEdit::getCommand()
{
         return ui->lineEditCommand->text();
}

//_____________________________________________________________________
 QIcon DialogEdit::getIcon()
 {
    return ui->toolButtonIcon->icon();
 }

 //_____________________________________________________________________
int DialogEdit::getMenuIndex()
{
   return ui->comboBoxMenu->currentIndex();
}

//_____________________________________________________________________
void DialogEdit::on_lineEditIconName_textChanged(const QString &arg1)
{
        QIcon icon;
        icon=EIcon::fromTheme(arg1).pixmap(48,48);


             ui->toolButtonIcon->setIcon(icon);


}

//_____________________________________________________________________
void DialogEdit::on_toolButtonIcon_clicked()
{
        QFileDialog dlg;

        QString fn = dlg.getOpenFileName(this, tr("Open Images Files..."),
                                         QDir::homePath(),
                                         trUtf8("Image File (*.png *.svg *.svgz *.svg.gz *.xpm);;All Files (*)"));
        if (!fn.isEmpty())
        {
                  ui->toolButtonIcon->setIcon(QIcon(fn));
                  ui->lineEditIconName->setText(fn);

        }
}

//_____________________________________________________________________
void DialogEdit::on_toolButtonCommand_clicked()
{
        QFileDialog dlg;

        QString fn = dlg.getOpenFileName(this, tr("Open Files..."),
                                         QDir::homePath(), trUtf8("All Files (*)"));
        if (!fn.isEmpty())
        {
                  ui->lineEditCommand->setText(fn);

        }
}
