/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DIALOGEDIT_H
#define DIALOGEDIT_H

#include <QDialog>
#include <QIcon>
namespace Ui {
class DialogEdit;
}

/**
 * @brief The DialogEdit class
 *نافذة التعديل على القوائم
 */

class DialogEdit : public QDialog
{
        Q_OBJECT
        
public:
        explicit DialogEdit(bool isMenu,QWidget *parent = 0);
        ~DialogEdit();
public slots:
        void setName(const QString &name);
        void setGeniric(const QString &name);
        void setIconName(const QString &name);
        void setCommand(const QString &name);
        void setMenuList(const QStringList &list, int indx);
//void setElokabOnly(bool only);
        QString getName();
        QString getGeniric();
        QString getIconName();
        QString getCommand();
        QIcon getIcon();
        int getMenuIndex();
       // bool isElokabOnly();
private slots:
        void on_lineEditIconName_textChanged(const QString &arg1);

        void on_toolButtonIcon_clicked();

        void on_toolButtonCommand_clicked();

private:
        Ui::DialogEdit *ui;
};

#endif // DIALOGEDIT_H
