/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "mainwindow.h"
#include  "ui_mainwindow.h"
#include <EIcon>
#include <EDir>
#include <EMimIcon>
#include <DesktopFile>
#include "dialogedit.h"
#include <QFileInfo>

#include <QMessageBox>
#define MOVE_FILE   'm'
#define COPY_FILE   'c'
MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow),m_hasClipboard(0)
{
//    qDebug()<<"datadir=============="<< Edir::dataDir();
//    qDebug()<<"cachDir()=============="<< Edir::cachDir();
//    qDebug()<<"dataHomeDir()=============="<< Edir::dataHomeDir();
//    qDebug()<<"configDir()=============="<< Edir::configDir();
//       qDebug()<<"applicationsDirs()=============="<< Edir::applicationsDirs();
//       qDebug()<<"applicationsHomeDir()=============="<< Edir::applicationsHomeDir();

//qDebug()<<"XDG_RUNTIME_DIR()"<< getenv("XDG_RUNTIME_DIR");
//qDebug()<<"XDG_CACHE_HOME()"<< getenv("XDG_CACHE_HOME");
//qDebug()<<QDesktopServices::storageLocation(QDesktopServices::);
//    QSettings globalSetting("elokab","elokabsettings");
//    globalSetting.beginGroup("Themes");
//    QIcon::setThemeName(globalSetting.value("iconsTheme",QIcon::themeName()).toString());
//    globalSetting.endGroup();



    setWindowIcon(EIcon::fromTheme("menu-editor"));
    msetting=new ElokabSettings;
    ui->setupUi(this);

    ui->comboBox->setVisible(false);
//      mhashIcons=new QHash<QString,QIcon>;
    connect(msetting,SIGNAL(iconThemeChanged()),this,SLOT(refrechIcons()));


    ui->actionNew_Item->setIcon(EIcon::fromTheme("document-add",("add")));
    ui->actionNewmenu->setIcon(EIcon::fromTheme("document-add",("list-add")));


    ui->actionDelete->setIcon(EIcon::fromTheme("edit-delete",("document-delete")));
    ui->actionQuite->setIcon(EIcon::fromTheme("application-exit",("document-close")));
    ui->actionEditItem->setIcon(EIcon::fromTheme("document-edit",("gtk-edit")));
    ui->actionOrigenal->setIcon(EIcon::fromTheme("reload",("document-revert")));

    ui->actionCopy->setIcon(EIcon::fromTheme("gtk-copy",("edit-copy")));
    ui->actionCut->setIcon(EIcon::fromTheme("gtk-cut",("edit-cut")));
    ui->actionPast->setIcon(EIcon::fromTheme("gtk-paste",("edit-paste")));

    ui->actionCopy->setShortcut(QKeySequence::Copy);
    ui->actionCut->setShortcut(QKeySequence::Cut);
    ui->actionPast->setShortcut(QKeySequence::Paste);

    ui->toolButtonAdd->setDefaultAction(ui->actionNew_Item);
    ui->toolButtonDelet->setDefaultAction(ui->actionDelete);
    ui->toolButtonEdit->setDefaultAction(ui->actionEditItem);
    ui->toolButtonAddMenu->setDefaultAction(ui->actionNewmenu);

    ui->toolButtonCopy->setDefaultAction(ui->actionCopy);
    ui->toolButtonCut->setDefaultAction(ui->actionCut);
    ui->toolButtonPaste->setDefaultAction(ui->actionPast);

    ui->actionCopy->setEnabled(false);
    ui->actionCut->setEnabled(false);

    connect(ui->actionEditItem,SIGNAL(triggered()),this,SLOT(editCurrentItem()));
    connect(ui->actionNew_Item,SIGNAL(triggered()),this,SLOT(addNewItem()));
    connect(ui->actionDelete,SIGNAL(triggered()),this,SLOT(deletItem()));
    connect(ui->actionNewmenu,SIGNAL(triggered()),this,SLOT(addNewMenu()));
    connect(ui->actionOrigenal,SIGNAL(triggered()),this,SLOT(reloadAppList()));
    //clipboard
 //   connect(ui->actionPast,SLOT(setEnabled(bool)),this,SIGNAL(reloadAppList()));
   // ui->actionPast->setEnabled(m_hasClipboard);
    m_clipboardItem=new QTreeWidgetItem;
    connect(ui->actionCopy,SIGNAL(triggered()),this,SLOT(copyItem()));
    connect(ui->actionCut,SIGNAL(triggered()),this,SLOT(cutItem()));
connect(ui->actionPast,SIGNAL(triggered()),this,SLOT(pastItem()));
connect(this,SIGNAL(hasClipboard(bool)),ui->actionPast,SLOT(setEnabled(bool)));

  gen =    new MenuGen(this->locale().name().section("_",0,0),this);

  gen->genirateAppFile();
  delete gen;
    //  mPMenu=new MenuProgrammes(trUtf8("Applications"),this);
    QDir dir;
    dir.mkpath(Edir::configHomeDir()+"/menus");
       dir.mkpath(Edir::dataHomeDir()+"/desktop-directories");
    chargeXmlDocument();
     emit hasClipboard(false);
}

//_____________________________________________________________________
MainWindow::~MainWindow()
{
    delete ui;
}

//_____________________________________________________________________
void MainWindow::chargeXmlDocument()
{

    QString xmlPath=Edir::configHomeDir()+"/menus/elokab-applications.menu";
    if(!QFile::exists(xmlPath)){
        QDir appDir(qApp->applicationDirPath());
        appDir.cdUp();
        appDir.cdUp();
        xmlPath=  appDir.absolutePath()+"/etc/xdg/menus/elokab-applications.menu";
        //  xmlPath="/etc/xdg/menus/elokab-applications.menu";
    }

    QFile file(xmlPath);



    if (!file.open(QIODevice::ReadOnly)){
        qDebug()<<file.errorString();
        return;
    }
    if (!m_doc.setContent(&file)) {
        qDebug()<<"error xmlContent";
        file.close();
        return;
    }
    file.close();

    // print out the element names of all elements that are direct children
    // of the outermost element.
    QDomElement docElem = m_doc.documentElement();

    QDomNode n = docElem.firstChild();
    while(!n.isNull()) {
        QDomElement menu = n.toElement(); // try to convert the node to an element.
        if(!menu.isNull()) {
            // qDebug()<<menu.tagName(); // the node really is an element.
            if(menu.tagName()=="Menu"){
                QString name=   menu.firstChildElement("Name").text();
                QString directory=  menu.firstChildElement("Directory").text();
                QString category;

                QDomNode Include = menu.firstChildElement("Include");
                QDomNode And = Include.firstChildElement("And");
                QDomElement Cat = And.toElement();
                if(!Cat.isNull()) {
                    category=   Cat.firstChildElement("Category").text();

                }
                //                qDebug()<<name;
                //                qDebug()<<directory;
                //                qDebug()<<category;

                addMenuDirectory(name,directory,category);
            }
        }
        n = n.nextSibling();
    }
    chargeAppDesktop();
}

//____________________________________________________________________________________
void MainWindow::addMenuDirectory(QString name, QString directory,QString category)
{

    QString directoryPath=Edir::dataHomeDir()+"/desktop-directories/"+directory;
    if(!QFile::exists(directoryPath)){
        QDir appDir(qApp->applicationDirPath());
        appDir.cdUp();

        directoryPath=  appDir.absolutePath()+"/share/desktop-directories/"+directory;

    }

    QString lc=this->locale().name().section("_",0,0);


    DesktopFile xdg(directoryPath,"Desktop Entry",lc);
    QString oldname=xdg.value("Name").toString();
    QString text=xdg.value("Name["+lc+"]",oldname).toString();
    QString icon=xdg.value("Icon").toString();
    QString oldComment=xdg.value("Comment").toString();
    QString comment=xdg.value("Comment["+lc+"]",oldComment).toString();

    QTreeWidgetItem *item=new QTreeWidgetItem(ui->treeWidget);
    item->setText(0,text);
    item->setToolTip(0,comment);
    item->setData(1,Qt::UserRole,category);
    item->setData(0,Qt::UserRole,icon);
    item->setData(2,Qt::UserRole,directory);
    item->setData(3,Qt::UserRole,name);
 QIcon icnF=EIcon::fromTheme(icon,"applications-other");


 item->setIcon(0,icnF);

}
void MainWindow::refrechIcons()
{
//EIcon::seTemeName(QIcon::themeName());
}

//_____________________________________________________________________
void MainWindow::chargeAppDesktop()
{
    //--------فتح -ملف بيانات التطبيقات-----------------------------
    QFile file(Edir::configDir()+"/applictions");

    if (!file.open(QFile::ReadOnly)){
        qDebug()<<file.fileName()+" \n  "+file.errorString();
        return ;
    }

    //-----------------------------------------------------------------------------------
    QTextStream textStream(&file);
    QString  line= textStream.readLine();//قراءة السطر الاول

QString lc=this->locale().name().section("_",0,0);
    //-----------------قراءة الملف سطراسكرا----------------------------------------------
    while (!line.isNull()) {

        DesktopFile dsg(line.section("|",0,0),"Desktop Entry",lc);
        QString oldname=dsg.value("Name").toString();
        QString name=dsg.value("Name["+lc+"]",oldname).toString();
        QString exec=dsg.value("Exec").toString();
        QString category=dsg.value("Categories","Other").toString();
        QString icon=dsg.value("Icon").toString();
        QString oldgenericName=dsg.value("GenericName").toString();
        QString genericName=dsg.value("GenericName["+lc+"]",oldgenericName).toString();

        QString oldcomment=dsg.value("Comment",genericName).toString();
         QString comment=dsg.value("Comment["+lc+"]",oldcomment).toString();
         QString mime=line.section("|",0,0);
        //-----------------------قراءة بيانات السطر----------------------------
//        QString name=line.section("|",0,0);   //الاسم
//        QString exec=line.section("|",1,1);    //التطبيق
//        QString category=line.section("|",2,2); //المجموعة
//        QString icon=line.section("|",3,3);     //الايقونة
//        QString mime=line.section("|",4,4);     //المسار
//        QString comment=line.section("|",5,5);  //
        QStringList list;
        list<<exec<<icon.trimmed()<<mime;      // البيانات المخبأة
//qDebug()<<name<<list;
        //-----------------------اضافة غنصر للشجرة----------------------------
        QTreeWidgetItem *item=new QTreeWidgetItem;
        item->setText(0,name);
        item->setToolTip(0,comment);
        item->setData(1,Qt::UserRole,list);//حفظ البيانات في الداتا

            QIcon icnF=EIcon::fromTheme(icon);
            item->setIcon(0,icnF);


        //--------اضافة العنصر الى الاب بالبحث عن المجموعة------------------------
        bool exist=false;
        for(int i=0;i<ui->treeWidget->topLevelItemCount();i++){
            QString cat=ui->treeWidget->topLevelItem(i)->data(1,Qt::UserRole).toString();
            if(category.contains(cat.trimmed())&&exist==false){
                ui->treeWidget->topLevelItem(i)->addChild(item);
                exist=true;
            }
        }
        //-----اذا كانت المجموغة غير موجودة سيصنف ك اخرى--------------------------------
        if(exist==false)
            for(int i=0;i<ui->treeWidget->topLevelItemCount();i++){
                QString cat=ui->treeWidget->topLevelItem(i)->data(1,Qt::UserRole).toString();

                if(cat=="Other"){
                    ui->treeWidget->topLevelItem(i)->addChild(item);
                }
            }

        line= textStream.readLine();
    }
    file.close();

}

//_____________________________________________________________________
void MainWindow::on_treeWidget_itemSelectionChanged()
{

    QTreeWidgetItem *item=ui->treeWidget->currentItem();
    if(!item)return;



    if(!item->parent()){
ui->actionCopy->setEnabled(false);
ui->actionCut->setEnabled(false);
        ui->statusBar->showMessage(item->text(0));
        return;
    }
    ui->actionCopy->setEnabled(true);
    ui->actionCut->setEnabled(true);
    QStringList list=item->data(1,Qt::UserRole).toStringList();

    ui->statusBar->showMessage(list.at(2));
}

//_____________________________________________________________________
void MainWindow::editCurrentItem()
{

    QTreeWidgetItem *item=ui->treeWidget->currentItem();
    if(!item)return;

    if(!item->parent()){

        editCurrentMenu();
        return;
    }

    QTreeWidgetItem *topParent=item->parent();

    int indx=ui->treeWidget->indexOfTopLevelItem(topParent);

    QStringList list=item->data(1,Qt::UserRole).toStringList();
    DialogEdit *dlg=new DialogEdit(false,this);
    dlg->setName(item->text(0));
    dlg->setGeniric(item->toolTip(0));
    dlg->setCommand(list.at(0));
    dlg->setIconName(list.at(1));
    dlg->setWindowTitle(tr("Edit ")+item->text(0));
    dlg->setMenuList(menusList(),indx);
    QString path=list.at(2);

    if(dlg->exec()==QDialog::Accepted){
        if(dlg->getName().isEmpty())
            return;

        item->setText(0,dlg->getName());
        item->setIcon(0,dlg->getIcon());
        item->setToolTip(0,dlg->getGeniric());
        //قائنة بالمعلومات المخبأة
        QStringList listnew;
        listnew.append(dlg->getCommand());
        listnew.append(dlg->getIconName()) ;
        listnew.append(path);
        item->setData(1,Qt::UserRole,listnew);
        //اذا تغير اب العنصر سيتم نقله
        int newIndex=dlg->getMenuIndex();
        if(newIndex!=indx){
            QTreeWidgetItem *itemNew=new QTreeWidgetItem;
            //نسخ العنصر
            itemNew=item->clone();
            //حذف العنصر
            topParent->takeChild(topParent->indexOfChild(item));
            //اضافة الغنصر الجديد
            ui->treeWidget->topLevelItem(newIndex)->addChild(itemNew);
            ui->treeWidget->setCurrentItem(itemNew);
        }

        //انشاء ملف ديسكتوب جدبد في المنزل بحث
        // سيتجاهل الموجود في الجذر في حالة وجوده
      //  QString fileName=path;

        QFileInfo fi(path);


        creatAppDesktop(fi.fileName());

      //  gen->genirateAppFile(QString());
    }

}

//_____________________________________________________________________
void MainWindow::editCurrentMenu()
{
    QTreeWidgetItem *item=ui->treeWidget->currentItem();
    DialogEdit *dlg=new DialogEdit(true,this);
    dlg->setWindowTitle(tr("edit Menu ")+item->text(0));
    dlg->setName(item->text(0));
    dlg->setIconName(item->data(0,Qt::UserRole).toString());
    dlg->setGeniric(item->toolTip(0));

    if(dlg->exec()==QDialog::Accepted){
        if(dlg->getName().isEmpty())
            return;


        QString text=     dlg->getName();
        QString iconName= dlg->getIconName();
        QString geniric=   dlg->getGeniric();

        item->setText(0,text);
        item->setToolTip(0,geniric);
        item->setIcon(0,dlg->getIcon());
        item->setData(0,Qt::UserRole,iconName);

        //save the derectory

        QString directoryPath=Edir::dataHomeDir()+"/desktop-directories/"+item->data(2,Qt::UserRole).toString();

/*
        QSettings settings(directoryPath,QSettings::IniFormat);
        settings.setIniCodec("UTF-8");
        settings.beginGroup("Desktop Entry");
        settings.setValue("Name",text);
        settings.setValue("Comment",geniric);
        settings.setValue("Icon",iconName);
        settings.setValue("Type","Directory");

        settings.endGroup();
      //  gen->genirateAppFile(QString());
        removeUnicodeSpace(directoryPath);
        */

        //----------------------------------------------------------------
                QFile fileS(directoryPath);

                if (! fileS.open(QIODevice::WriteOnly ))
                    return ;

                QTextStream out(&fileS);
                out.setCodec(QTextCodec::codecForName("UTF-8"));
                out<<"[Desktop Entry]"<<endl;;

                out<<"Type=Directory"<<endl;
                out<<"Name="<<text.trimmed()<<endl;
                out<<"Comment="<<geniric.trimmed()<<endl;
                out<<"Icon="<<iconName.trimmed()<<endl;



                fileS.close();
       // ---------------------------------------------------------------------

    }
}
/************************************************************
                         عنضر جديد
*************************************************************/
void MainWindow::addNewItem()
{

    QTreeWidgetItem *itemSelected=ui->treeWidget->currentItem();
    QTreeWidgetItem *topParent;
    if(itemSelected->parent()){
        topParent=  itemSelected->parent();
    }else{
        topParent=  itemSelected;
    }
    int indx=ui->treeWidget->indexOfTopLevelItem(topParent);


    DialogEdit *dlg=new DialogEdit(false,this);
    dlg->setWindowTitle(tr("Add New application"));
    dlg->setMenuList(menusList(),indx);
    dlg->setIconName("application-x-executable");
    if(dlg->exec()==QDialog::Accepted){
        if(dlg->getName().isEmpty())
            return;

        QTreeWidgetItem *item=new QTreeWidgetItem;


        item->setText(0,dlg->getName());
        item->setIcon(0,dlg->getIcon());
        item->setToolTip(0,dlg->getGeniric());
        QStringList listnew;
        listnew.append(dlg->getCommand());
        listnew.append(dlg->getIconName()) ;
        listnew.append(Edir::dataHomeDir()+"/applications/"+dlg->getName()+".desktop");
        item->setData(1,Qt::UserRole,listnew);


        //اذا تغير اب العنصر سيتم نقله
        int newIndex=dlg->getMenuIndex();
        if(newIndex!=indx){
            //اضافة الغنصر الجديد
            ui->treeWidget->topLevelItem(newIndex)->addChild(item);

        }else{
            topParent->addChild(item);
        }



        item->setSelected(true);
        ui->treeWidget->setCurrentItem(item);


        creatAppDesktop(dlg->getName()+".desktop");
       // gen->appFilesExist();
    }
//gen->blockSignals(false);
}
/************************************************************
                         حذف العنصر
*************************************************************/
void MainWindow::deletItem()
{
    QTreeWidgetItem *itemSelected=ui->treeWidget->currentItem();
    if(!itemSelected)return;
    int ret = QMessageBox::warning(this, itemSelected->text(0),
                                   tr( "This action cannot be undone.\n"
                                       "Do you want to permanently delete this item? "
                                       ),
                                   QMessageBox::Yes | QMessageBox::Discard);
    if(ret==QMessageBox::Discard)
        return;

    if(!itemSelected->parent()){
        QString name=itemSelected->data(3,Qt::UserRole).toString();
        int index=ui->treeWidget->indexOfTopLevelItem(itemSelected);
        ui->treeWidget->takeTopLevelItem(index);

        removeNode(name);
        return;
    }


removeItem(itemSelected);


 //   gen->genirateAppFile(QString());


}

//_____________________________________________________________________
void MainWindow::removeItem(QTreeWidgetItem *itemSelected)
{
    QStringList list=itemSelected->data(1,Qt::UserRole).toStringList();
    QString path=list.at(2);
    QFileInfo fi(path);
    if(!fi.isWritable()){
        QSettings setting("elokab","menuApps");
        setting.beginGroup("Menu");
        QStringList     m_desktopList=setting.value("Exclud",0).toStringList();

        m_desktopList.append(fi.fileName());
        setting.setValue("Exclud",m_desktopList);
        setting.endGroup();
        setting.sync();
    }else{
        QFile::remove(path);
    }
    int indx=itemSelected->parent()->indexOfChild(itemSelected);
    itemSelected->parent()->takeChild(indx);
}

/***********************************************************
 *                    ملف ثائمة جديد
 ***********************************************************/
void MainWindow::addNewMenu()
{

    DialogEdit *dlg=new DialogEdit(true,this);
    dlg->setWindowTitle(tr("Add New Menu"));
    if(dlg->exec()==QDialog::Accepted){
        if(dlg->getName().isEmpty())
            return;

        QString text=dlg->getName();
        QString iconName=dlg->getIconName();
        QString geniric=dlg->getGeniric();
        QTreeWidgetItem *item=new QTreeWidgetItem(ui->treeWidget);

        item->setText(0,text);
        item->setIcon(0,dlg->getIcon());
        item->setToolTip(0,geniric);

        item->setData(1,Qt::UserRole,text);
        item->setData(0,Qt::UserRole,iconName);
        item->setData(2,Qt::UserRole,"elokab-"+text+".directory");
         item->setData(3,Qt::UserRole,text);
        item->setSelected(true);
        ui->treeWidget->setCurrentItem(item);
        // Here we append a new element to the end of the document
        QDomElement racine = m_doc.documentElement();

        QDomElement menu = m_doc.createElement("Menu");
        racine.appendChild(menu);

        QDomElement name = m_doc.createElement("Name");
        QDomText t1 = m_doc.createTextNode(text);
        name.appendChild(t1);
        menu.appendChild(name);


        QDomElement directory = m_doc.createElement("Directory");
        QDomText t2 = m_doc.createTextNode("elokab-"+text+".directory");
        directory.appendChild(t2);
        menu.appendChild(directory);

        QDomElement Include = m_doc.createElement("Include");
        menu.appendChild(Include);

        QDomElement And = m_doc.createElement("And");
        Include.appendChild(And);

        QDomElement Category = m_doc.createElement("Category");
        QDomText t3 = m_doc.createTextNode(text);
        Category.appendChild(t3);
        And.appendChild(Category);


        saveDocumment();


        //save the derectory

        QString directoryPath=Edir::dataHomeDir()+"/desktop-directories/elokab-"+text+".directory";

/*
         QSettings settings(directoryPath,QSettings::IniFormat);
        settings.setIniCodec("UTF-8");
        settings.beginGroup("Desktop Entry");
        settings.setValue("Name",text);
        settings.setValue("Comment",geniric);
        settings.setValue("Icon",iconName);
        settings.setValue("Type","Directory");


        settings.endGroup();
        removeUnicodeSpace(directoryPath);
   */
        //----------------------------------------------------------------
                QFile fileS(directoryPath);

                if (! fileS.open(QIODevice::WriteOnly ))
                    return ;

                QTextStream out(&fileS);
                out.setCodec(QTextCodec::codecForName("UTF-8"));
                out<<"[Desktop Entry]"<< endl;;

                out<<"Type=Directory"<< endl;
                out<<"Name="<<text.trimmed()<<endl;
                out<<"Comment="<<geniric.trimmed()<<endl;
                out<<"Icon="<<iconName.trimmed()<<endl;



                fileS.close();
       // ---------------------------------------------------------------------
    }

}

//_____________________________________________________________________
void MainWindow::saveDocumment()
{

    QString menuFile=Edir::configHomeDir()+"/menus/elokab-applications.menu";
    QFile file( menuFile);
    if ( !file.open(QIODevice::WriteOnly)){
        qDebug()<<file.errorString();
        return ;
    }
    QTextStream out(&file);                       //الكتابة
    m_doc.save(out,1);                      //حفظ الملف
    file.close();
}

//_____________________________________________________________________
bool MainWindow::removeNode(const QString &name)
{
//    qDebug()<<name;
    QDomElement docElem = m_doc.documentElement();

    QDomNode n = docElem.firstChild();
    while(!n.isNull()) {
        QDomElement menu = n.toElement(); // try to convert the node to an element.
        if(!menu.isNull()) {

            if(menu.tagName()=="Menu"){
                QString mname=   menu.firstChildElement("Name").text();
                if(mname==name){
                    docElem.removeChild(n);
                    break;
                }
            }

        }
        n = n.nextSibling();
    }
    saveDocumment();
    return true;
}

//_____________________________________________________________________
void MainWindow::creatAppDesktop(const QString &fileApp)
{
//->blockSignals(true);
    QTreeWidgetItem *item=ui->treeWidget->currentItem();
    if(!item)return;
    if(!item->parent())return;
    QStringList list=item->data(1,Qt::UserRole).toStringList();


    QString fileName=Edir::dataHomeDir()+"/applications/"+fileApp;

    //QFileInfo fi(fileName);

/*
    QSettings settings(fileName,QSettings::IniFormat);
    settings.setIniCodec(QTextCodec::codecForLocale());
    settings.beginGroup("Desktop Entry");

    settings.setValue("Type","Application");
    settings.setValue("Name",item->text(0));
    settings.setValue("Comment",item->toolTip(0));
    settings.setValue("Exec",list.at(0));
    settings.setValue("Icon",list.at(1));
    settings.setValue("Categories",item->parent()->data(1,Qt::UserRole).toString());
    settings.setValue("X-ELOKAB",true);


    settings.endGroup();

    removeUnicodeSpace(fileName);
*/
    //TODO: change for this
    //----------------------------------------------------------------
            QFile fileS(fileName);

            if (! fileS.open(QIODevice::WriteOnly ))
                return ;

            QTextStream out(&fileS);
            out.setCodec(QTextCodec::codecForName("UTF-8"));
            out<<"[Desktop Entry]"<<endl;;

            out<<"Type=Application"<<endl;
            out<<"Name="<<item->text(0).trimmed()<<endl;
            out<<"Comment="<<item->toolTip(0).trimmed()<<endl;
            out<<"Categories="<<item->parent()->data(1,Qt::UserRole).toString().trimmed()<<endl;
            out<<"Icon="<<list.at(1).trimmed()<<endl;
            out<<"Exec="<<list.at(0).trimmed()<<endl;
            out<<"X-ELOKAB="<<true<<endl;

            fileS.close();
   // ---------------------------------------------------------------------

}

//_____________________________________________________________________
void MainWindow::removeUnicodeSpace(const QString &fileName)
{
    //->blockSignals(true);
    qApp->processEvents();
    //  qDebug()<<fileName;
    //read--------------------
    QFile file(fileName);
    if (!file.open(QIODevice::ReadOnly ))
        return;
    // qDebug()<<fileName;
    QTextStream in(&file);
    in.setCodec(QTextCodec::codecForName("UTF-8"));

    QString txt = in.readAll();
    file.close();
    //---------------------------------
    QTextCodec *codec = QTextCodec::codecForName("UTF-8");
      QByteArray encodedString =QByteArray::fromPercentEncoding(txt.toUtf8());

      QString string = codec->toUnicode(encodedString);

    // Write----------------------
    qApp->processEvents();
    QFile fileS(fileName);

    if (! fileS.open(QIODevice::WriteOnly ))
        return;
    //  qDebug()<<txt;
    QTextStream out(&fileS);
    out.setCodec(QTextCodec::codecForName("UTF-8"));
    out<<string;
    fileS.close();

}

/*************************************************
 *               تحديث القائمة الاصلية
  ************************************************/
void MainWindow::reloadAppList()
{
    int ret = QMessageBox::warning(this, "Reload Applications",
                                   tr( "This action cannot be undone.\n"
                                       "Do you want to restore the system menu? Warning: This will remove all custom menus."
                                       ),
                                   QMessageBox::Yes | QMessageBox::Discard);
    if(ret==QMessageBox::Discard)
        return;

    //remove excluded list
    QSettings setting("elokab","menuApps");
    setting.beginGroup("Menu");
    QStringList     m_desktopList;
    setting.setValue("Exclud",m_desktopList);

    setting.endGroup();
    setting.sync();
    //remove xmlmenu
    QString menuFile=Edir::configHomeDir()+"/menus/elokab-applications.menu";
    QFile::remove(menuFile);
    //remove derectory
    QString dir= Edir::dataHomeDir()+"/desktop-directories";
    QDir dirS( dir);
    foreach (QString subfile, dirS.entryList(QStringList()<<"*.directory",QDir::AllEntries|  QDir::NoDotAndDotDot )){

              if(subfile.startsWith("elokab")){
                         QFile::remove(dir+"/"+subfile);
              }
    }

    QString dirD= Edir::dataHomeDir()+"/applications";
    QDir dirDS( dirD);
    foreach (QString subfile, dirDS.entryList(QStringList()<<"*.desktop",QDir::AllEntries|  QDir::NoDotAndDotDot )){

                       QString fileName= dirDS.absoluteFilePath(subfile);
                       QSettings settings(fileName,QSettings::IniFormat);
                       settings.beginGroup("Desktop Entry");
                       bool isElokabApp=settings.value("X-ELOKAB",false).toBool();
                       settings.endGroup();

                       if(isElokabApp){
                           QFile::remove(fileName);
//                           qDebug()<<fileName;
                       }
    }
    m_doc.clear();
    ui->treeWidget->clear();


    chargeXmlDocument();
   // gen->genirateAppFile();
}

//_____________________________________________________________________
QStringList  MainWindow::menusList()
{
    //قائمة بجميع القوائم
    QStringList listMenu;
    for(int i=0;i<ui->treeWidget->topLevelItemCount();i++){
        listMenu<<ui->treeWidget->topLevelItem(i)->text(0);
    }
    return listMenu;
}

//_____________________________________________________________________
void  MainWindow::copyItem()
{
    QTreeWidgetItem *item=ui->treeWidget->currentItem();
    if(!item)return;

    if(!item->parent())return;

   m_clipboardItem=item->clone();
   m_hasClipboard=true;
      emit hasClipboard(true);
         m_clipboardType=COPY_FILE;
         m_n=1;
}

//_____________________________________________________________________
void  MainWindow::cutItem()
{
    QTreeWidgetItem *item=ui->treeWidget->currentItem();
    if(!item)return;

    if(!item->parent())return;

   m_clipboardItem=item->clone();

 // removeItem(item);
    QFile::remove(item->data(1,Qt::UserRole).toStringList().at(2));
   int indx=item->parent()->indexOfChild(item);
   item->parent()->takeChild(indx);

   m_hasClipboard=true;
      emit hasClipboard(true);
      m_clipboardType=MOVE_FILE;
}

//_____________________________________________________________________
void  MainWindow::pastItem()
{
     if(m_hasClipboard==false)return;
     QTreeWidgetItem *itemSelected=ui->treeWidget->currentItem();
     if(!itemSelected)return;
     QTreeWidgetItem *topParent;
     if(itemSelected->parent()){
          topParent=  itemSelected->parent();
     }else{
          topParent=  itemSelected;
     }

     QTreeWidgetItem *item=m_clipboardItem->clone();

     if(m_clipboardType==COPY_FILE){
          m_n++;
          QString txt =item->text(0);
          item->setText(0,txt+"-"+QString::number(m_n));
     }


     topParent->addChild(item);
     item->setSelected(true);
     ui->treeWidget->setCurrentItem(item);

     if(m_clipboardType==COPY_FILE){
          creatAppDesktop(item->text(0)+".desktop");
     }else{
          //    QStringList list=item->data(1,Qt::UserRole).toStringList().at(2);
          QString path=item->data(1,Qt::UserRole).toStringList().at(2);
          QFileInfo fi(path);
          creatAppDesktop(fi.fileName());

     }


     if(m_clipboardType==MOVE_FILE){
          m_hasClipboard=false;
          emit hasClipboard(false);
     }

}

void MainWindow::on_comboBox_currentIndexChanged(const QString &arg1)
{
    QIcon::setThemeName(arg1);
    EIcon::seTemeName(arg1);
}
