/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DIALOGQMLPROPERTY_H
#define DIALOGQMLPROPERTY_H
#include <ButtonColor>
#include <QDialog>
#include <QHBoxLayout>
#include <QLabel>
#include <QLineEdit>
#include <QSpinBox>
#include <QCheckBox>

//! Class String Property
class LayoutString:public QHBoxLayout
{
public:
        LayoutString(const QString &caption,const QString &txt);
             QString propertyName(){return label->text();}
             QString propertyValue(){return lineEdit->text();}
    private:
 QLabel *label;
 QLineEdit *lineEdit;
};

//! Class Int Property
class LayoutInt:public QHBoxLayout
{
public:
        LayoutInt(const QString &caption,int value);
             QString propertyName(){return label->text();}
             QString propertyValue(){return QString::number(spinBox->value());}
    private:
 QLabel *label;
 QSpinBox *spinBox;
};

//! Class Bool Property
class LayoutBool:public QHBoxLayout
{
public:
        LayoutBool(const QString &caption,bool value);
             QString propertyName(){return label->text();}
             QString propertyValue(){
                     if(checkBox->isChecked())
                             return "true";

                       return "false";
             }
    private:
 QLabel *label;
 QCheckBox *checkBox;
};

//! Class Color Property
class LayoutColor:public QHBoxLayout
{
public:
        LayoutColor(const QString &caption,QColor color);
             QString propertyName(){return label->text();}
             QString propertyValue(){return buttonColor->color().name();}
    private:
 QLabel *label;
 ButtonColor *buttonColor;
};

//----------------------------------------------------------------------------
//! Class DialogQmlProperty
namespace Ui {
class DialogQmlProperty;
}

class DialogQmlProperty : public QDialog
{
        Q_OBJECT
        
public:
        explicit DialogQmlProperty(const QString &fileName, const QString &title, QWidget *parent = 0);
        ~DialogQmlProperty();
        
private slots:
        void on_buttonBox_accepted();

private:
        Ui::DialogQmlProperty *ui;

QString m_fileName;
QList<LayoutString *>listString;
QList<LayoutInt *>listInt;
QList<LayoutBool *>listBool;
QList<LayoutColor *>listColor;
private slots:

void loadQmlProprety(const QString &fileName);

};

#endif // DIALOGQMLPROPERTY_H
