/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef QMLCONTAINER_H
#define QMLCONTAINER_H

#include <QGraphicsItem>
#include <QDeclarativeView>
class QmlContainer: public QGraphicsObject
{
    Q_OBJECT
public:
    QmlContainer(const QString &file, QGraphicsItem *parent = 0);
    ~QmlContainer();

    QRectF boundingRect() const;
    void paint(QPainter *, const QStyleOptionGraphicsItem *option, QWidget *widget);
  QObject *item;
signals:
    void positionChanged();

        void setCpuValue(int);
        void setMemValue(int);
        void setSwapValue(int);
        void setUptimeValue(QString);
protected:
    QVariant itemChange(GraphicsItemChange change, const QVariant &value);

    void mousePressEvent(QGraphicsSceneMouseEvent *);
    void mouseMoveEvent(QGraphicsSceneMouseEvent *);
    void mouseReleaseEvent(QGraphicsSceneMouseEvent *);

private:
    QRectF m_rectF;
    QPointF m_oldPosition;
QPointF  m_pos;
QString m_fileName;
    //------Qml-------
    QDeclarativeView *view;

//----
    int lasP;
    int curP;
    private slots:
            void loadSettings();
                   void saveSettings();
                void positionHasChanged();
void animMe(QPointF p);
void animtoBorder();
public slots:
//void setClassToconnect(int name);
};

#endif
