/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "widgetdesktop.h"


#include "classname.h"
#include <fcntl.h>
#include <unistd.h>
#include <sysstat/cpustat.hpp>
#include <sysstat/memstat.hpp>
#include <sysstat/netstat.hpp>
#include <QDeclarativeView>
#include <QApplication>
#include <QDebug>
#include <QSettings>
#include <QTimer>
#include <QDir>

WidgetDesktop::WidgetDesktop(QGraphicsScene *scene,QObject *parent) :
        QObject(parent),
        mCpuStat(0),
        mMemStat(0),
        mSwapStat(0),
        uptimeStat(0)
{
     m_scene=scene;
 loadsettings();



}
void WidgetDesktop::loadsettings()
{
        QSettings setting("elokab","settings");
        setting.beginGroup("Desktop-Widget");

   QStringList   templist=setting.value("ListWidget").toStringList();
      setting.endGroup();
      if(listWidget.count()==0){
              listWidget=templist;
              loadQmlWidgets();
             return;
      }

/*
      foreach (QString f, templist) {
              if(!listWidget.contains(f))
                      addWidgetToSceen(f);
      }
      foreach (QString f, listWidget) {
              if(!templist.contains(f)){
                     removeWidget(f);

              }
      }
      */
      foreach (QString f, listWidget) {

                     removeWidget(f);
       }
      foreach (QString f, templist) {

                      addWidgetToSceen(f);
      }
      listWidget=templist;
}

void WidgetDesktop::loadQmlWidgets()
{


     if(listWidget.count()>0)
     {
             foreach (QString fileName, listWidget) {
                     if(!QFile::exists(fileName))
                     continue;

                     addWidgetToSceen(fileName);
             }
     }
}

void WidgetDesktop::addWidgetToSceen(const QString & fileName)
{

        QmlContainer *qmlContainer=new QmlContainer(fileName);
 qDebug()<<"adding filename 0";
        QFileInfo fi(fileName);
        QString desktopFile=fi.absoluteDir().path()+"/qmlwidget.desktop";

        foreach (QString myClass, className::classeNames(desktopFile)) {
                qDebug()<<desktopFile<<myClass;
                if(myClass==CPUVALUE){

                        connect(this,SIGNAL(setCpu(int)),qmlContainer->item,SIGNAL(cpuValue(int)));
                      //  qmlContainer->setClassToconnect(className::CpuValue);

                        loadSystatCpu();

                         hatchListStat.insert(fileName,className::CpuValue);
                }
                if(myClass==MEMVAlUE){
                      qDebug()<<"loadSystatmem 1";
                         //  qmlContainer->setClassToconnect(className::MemValue);
                        loadSystatMem();

                         hatchListStat.insert(fileName,className::MemValue);
                       connect(this,SIGNAL(setMem(int)),qmlContainer->item,SIGNAL(memValue(int)));
                        qDebug()<<"loadSystatCpu 5";

                }
                if(myClass==SWAPVAlUE){
                        connect(this,SIGNAL(setSwap(int)),qmlContainer->item,SIGNAL(swapValue(int)));
                      //  qmlContainer->setClassToconnect(className::SwapValue);
                        loadSystatSwap();
                         hatchListStat.insert(fileName,className::SwapValue);
                }
                if(myClass==UPTIMEVAlUE){
                        connect(this,SIGNAL(setUptime(QString)),qmlContainer->item,SIGNAL(uptimeValue(QString)));
                     //   qmlContainer->setClassToconnect(className::UpTimeValue);
                        loadUpTime();
                        hatchListStat.insert(fileName,className::UpTimeValue);
                }
                if(myClass==SYSINFO){
                        connect(this,SIGNAL(setSysInfo(QString)),qmlContainer->item,SIGNAL(sysInfo(QString)));
                     //   qmlContainer->setClassToconnect(className::UpTimeValue);
                        loadSysInfo();
                        hatchListStat.insert(fileName,className::UpTimeValue);
                }
        }
        hatchListWidget.insert(fileName,qmlContainer);
        m_scene->addItem(qmlContainer);

}





//---------------------------------------------------------------------------------------------------------
//                                                Sys stat
//---------------------------------------------------------------------------------------------------------
void WidgetDesktop::loadSystatCpu()
{

        if(!mCpuStat){
                mCpuStat= new SysStat::CpuStat(this);
                qobject_cast<SysStat::CpuStat*>(mCpuStat)->setMonitoring(SysStat::CpuStat::LoadOnly);
                connect(qobject_cast<SysStat::CpuStat*>(mCpuStat), SIGNAL(update(float, float, float, float)), this, SLOT(cpuUpdate(float, float, float, float)));
                mCpuStat->setUpdateInterval(2000);
        }


        //
}
void WidgetDesktop::loadSystatMem()
{
  //  connect(this,SIGNAL(setMem(int)),qmlContainer->item,SIGNAL(memValue(int)));
   qDebug()<<"loadSystatmemoir 2";


        if(!mMemStat){
                mMemStat = new SysStat::MemStat(this);
                 qDebug()<<"SysStat::MemStat 3";

                qobject_cast<SysStat::MemStat*>(mMemStat)->setMonitoredSource("memory");
                connect(qobject_cast<SysStat::MemStat*>(mMemStat), SIGNAL(memoryUpdate(float, float, float)), this, SLOT(memoryUpdate(float, float, float)));
                mMemStat->setUpdateInterval(2000);
                  qDebug()<<"SysStat::MemStat 4";
        }


        //
}
void WidgetDesktop::loadSystatSwap()
{
        if(!mSwapStat){
                mSwapStat= new SysStat::MemStat(this);
                qobject_cast<SysStat::MemStat*>(mSwapStat)->setMonitoredSource("swap");
                connect(qobject_cast<SysStat::MemStat*>(mSwapStat), SIGNAL(swapUpdate(float)), this, SLOT(swapUpdate(float)));
                mSwapStat->setUpdateInterval(2000 );
        }
        //
}
void WidgetDesktop::loadUpTime()
{
        if(!uptimeStat){
                uptimeStat=new UptimeStat;
                connect(uptimeStat,SIGNAL(setUptime(QString)),this,SIGNAL(setUptime(QString)));
                uptimeStat->update();
        }
}

void WidgetDesktop::loadSysInfo()
{
        QFile file("/proc/cpuinfo")  ;
        if (!file.open(QIODevice::ReadOnly | QIODevice::Text))
                return;
        //qDebug()<<file.readAll();
        QTextStream in(&file);
        QString line;
        do {
                line = in.readLine();
                qDebug()<<line;
                if(line.contains("model name")){
                        qDebug()<<line;
                        line=line.section(":",1,1);
                        emit setSysInfo(line);
                        break;
                }
        } while (!line.isNull());


}

template <typename T>
T clamp(const T &value, const T &min, const T &max)
{
    return qMin(qMax(value, min), max);
}
/*******************************************
 **************update the cpu used*********
 *******************************************/
void WidgetDesktop::cpuUpdate(float user, float /*nice*/, float system, float /*other*/)
{
        int y_system = clamp(static_cast<int>(system * 100.0)           , 0, 99);
        int y_user   = clamp(static_cast<int>(user   * 100.0) + y_system, 0, 99);
//        int y_nice   = clamp(static_cast<int>(nice   * 100.0) + y_user  , 0, 99);
//        int y_other  = clamp(static_cast<int>(other  * 100.0) + y_nice  , 0, 99);


  emit setCpu(y_user);

 }
/*******************************************
 **************update the swap used*********
 *******************************************/
void WidgetDesktop::swapUpdate(float used)
{
        int y_used = clamp(static_cast<int>(used * 100.0), 0, 99);

       emit setSwap(y_used);
}
void WidgetDesktop::memoryUpdate(float apps, float /*buffers*/, float /*cached*/)
{

        int y_apps    = clamp(static_cast<int>(apps    * 100.0)            , 0, 99);
        // int y_buffers = clamp(static_cast<int>(buffers * 100.0) + y_apps   , 0, 99);
        //int y_cached  = clamp(static_cast<int>(cached  * 100.0) + y_buffers, 0, 99);

        //  int mbuffers = clamp(static_cast<int>(buffers  * 100.0), 0, 99);
        // int mcached  = clamp(static_cast<int>(cached  * 100.0), 0, 99);

        emit setMem(y_apps);
}
/*******************************************
 **************update the Uptime*********
 *******************************************/

///----------REMOVE WIDGET AND STAT NON VALIDE---------------
void WidgetDesktop::removeWidget(const QString & fileName)
{
        if(hatchListWidget.contains(fileName)){

                 hatchListWidget[fileName]->blockSignals(true);
                delete   hatchListWidget[fileName];
                hatchListWidget.take(fileName);

        }
        QString f=fileName;
        foreach (f, hatchListStat) {
                   hatchListStat.take(fileName);
        }
    deletStat();
}

//----------------------------------------------------------------
//                  delte stat non available
//----------------------------------------------------------------
void WidgetDesktop::deletStat()
{

                if(hatchListStat.key(className::CpuValue).isNull()){
                    if(mCpuStat){
                        delete mCpuStat;
                        mCpuStat=0;
                    }
                 }
                if(hatchListStat.key(className::MemValue).isNull()){
                    if(mMemStat){
                        delete mMemStat;
                        mMemStat=0;
                    }
                 }
                if(hatchListStat.key(className::SwapValue).isNull()){
                    if(mSwapStat){
                        delete mSwapStat;
                        mSwapStat=0;
                    }
                 }
                if(hatchListStat.key(className::UpTimeValue).isNull()){
                    if(uptimeStat){
                        delete uptimeStat;
                        uptimeStat=0;
                    }
                 }
}
