/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef WIDGETDESKTOP_H
#define WIDGETDESKTOP_H
#include "sysstat/uptimestat.h"
#include "qmlcontainer.h"
#include <QObject>
#include <QGraphicsScene>
namespace SysStat {
    class BaseStat;
}
class QmlWidget;
class WidgetDesktop : public QObject
{
        Q_OBJECT
public:
        explicit WidgetDesktop(QGraphicsScene *scene,QObject *parent = 0);
signals:
        void setCpu(int);
        void setMem(int);
        void setSwap(int);
        void setUptime(QString);
        void setSysInfo(QString);
signals:
        
public slots:
void loadsettings();
private slots:
        void loadQmlWidgets();
        void addWidgetToSceen(const QString & fileName);
        void removeWidget(const QString & fileName);
       // void loadQmlpath(const QString & path);


        //---------------------------
        void loadSystatCpu() ;
        void loadSystatMem() ;
        void loadSystatSwap();
        void cpuUpdate(float user, float, float system, float);
        void memoryUpdate(float apps, float, float);
        void swapUpdate(float used);
          //------------------------
        void loadUpTime();
void loadSysInfo();
        //-------------------
        void deletStat();

 private:
           QGraphicsScene *m_scene;
             SysStat::BaseStat *mCpuStat;
           SysStat::BaseStat *mMemStat;
            SysStat::BaseStat *mSwapStat;
            UptimeStat *uptimeStat;
  QHash<QString , QmlContainer*> hatchListWidget ;
  QHash<QString , int> hatchListStat ;
 // QHash<QString , QmlItemWidget*> hatchListItem ;

  QStringList listWidget;
int UpTime;
};

#endif // WIDGETDESKTOP_H
