/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DESKTOPSCEEN_H
#define DESKTOPSCEEN_H
#include <MenuGen>
#include "scene.h"
#include "DesktopWidget/widgetdesktop.h"
#include "iconview/iconsview.h"
#include <ElokabSettings>
//#include "qxt/qxtglobalshortcut.h"
#include <QGraphicsView>
/**
 * @brief The DesktopSceen class
 * @brief النافذة الرئيسية لسطح المكنب
 * @author أبو زكريا
 * @date 19/10/2014
 */

class DesktopSceen : public QGraphicsView
{
    Q_OBJECT
public:
    explicit DesktopSceen(QWidget *parent = 0);
    
signals:

public slots:
    

private :
    IconsView *iconsView;
    WidgetDesktop *desktopObjectWidget;
    ElokabSettings *m_settings;

    Scene *m_sceen;
    QStringList m_listBgr;
    int m_curListIndexOf;
    QString m_pixFileName;
    QString m_folderDir;

    // QAction *actIconView;
    QAction *m_actRealigne;
    bool m_iconView;
    QAction *m_actNextWall;
    QAction *m_actSetting;
    QAction *m_actQmlWidget;
    QAction *m_actOpenDesktopFolder;
    QAction  *m_actReload;
QAction  *m_actShudown;
QAction  *m_actRun;
    MenuGen *gen;
private slots:
    void loadIconThemes();

    void loadSettings();
    void resizeDesktop(int /*screen*/);
    void showContextMenu(QPoint);

    void showHideFileView(bool showView);
    void showSettingDialog();
    void showAddWidgetDialog();

    void openDesktopFolder();
    void updatShortcut();
void showDialogPower();
void showDialogRun();
};

#endif // DESKTOPSCEEN_H
