/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ICONDESKTOP_H
#define ICONDESKTOP_H
#include <EMimIcon>
#include <QGraphicsSceneMoveEvent>
#include <QGraphicsItem>

#include <QIcon>

/**
 * @class IconDesktop
 * @brief ايقونات طح المكنب
 * @author أبو زكريا
 * @date 19/10/2014
 */

class IconDesktop: public QGraphicsObject
{



public:
        //! file the file path
        //! width the icon width
        //! lc the locale name
        IconDesktop(const QString & file,const int &width,const QString & lc,const int &mode, QGraphicsItem * parent=0);

        QRectF boundingRect() const;
        void paint(QPainter * painter, const QStyleOptionGraphicsItem *, QWidget * = 0);


        void setIconWidth(int width);
        void getPropertie();
        void getOpenWith();
        void renameFile();
      void launchApp();
        void setExecAppMode(int mode);
        void setText(const QString & text);
        QPixmap pixmap(){return m_pm;}
void updatIcon();
public slots:
  void saveIttemPos();

protected:
 void  mouseMoveEvent(QGraphicsSceneMouseEvent *event) ;
        virtual void mousePressEvent(QGraphicsSceneMouseEvent *);
        virtual void mouseReleaseEvent(QGraphicsSceneMouseEvent * event);

        /*virtual*/ void hoverEnterEvent(QGraphicsSceneHoverEvent * event);
        /*virtual*/ void hoverLeaveEvent(QGraphicsSceneHoverEvent * event);
        /*virtual*/ void mouseDoubleClickEvent(QGraphicsSceneMouseEvent * event);

        QVariant itemChange(GraphicsItemChange change, const QVariant &value);



private:
        QString m_file;
     int m_iconWidth;

        QPixmap m_pm; // std
        QPixmap m_pm_hi; // highlight
        bool m_highlight;

        QString m_text;
        int  m_execAppMode;

        QPointF m_oldPosition;
        QString m_icon;


        QString m_mimeInfo;
        enum ActionType { ActionExec, ActionScript, ActionFile };
        ActionType m_type;
        QString m_data;
        void setDataFile(QString fileName, const QString &lc);

        void setIcon(const QIcon & icon);


};

#endif
