/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ICONSVIEW_H
#define ICONSVIEW_H
#include "iconview/icondesktop.h"

#include <EIcon>
#include <QAction>
#include <QGraphicsItem>
#include <QFileSystemWatcher>

/**
 * @class IconsView
 * @brief حاوي ايقونات طح المكنب
 * @author أبو زكريا
 * @date 19/10/2014
 */
class IconsView: public QGraphicsObject
{
        Q_OBJECT
public:
        IconsView(const QPointF &pos, QGraphicsScene *scene,const QString & lc, QGraphicsItem *parent = 0);
        ~IconsView();

        QRectF boundingRect() const;
        void paint(QPainter *, const QStyleOptionGraphicsItem *option, QWidget *widget);
        //! قائمة بعناصر انشاء جديد
        QMenu *menuTemplates;
        //! قائمة بعناصر ترتيب حسب
        QMenu *menuRealigne;
        //! قائمة بعناصر اوامر لكل عنصر
        QMenu *menuIconFile;
QAction *actReload;
private:



        //! قائمة عناصر سطح المكتب ومساراتها
        QHash<QString , IconDesktop*> listItemesFiles ;
        //! قائمة تحوي العناصر ويدجات التي تحوي الايقونات لتحريكها
        QHash<QGraphicsWidget*, IconDesktop*> listGraphicsWidget ;
        //! متتبع حالة التغير لملفات سطح المكتب
        QFileSystemWatcher * m_fileSystemWatcher;
        //! المجلد الحالي لسطح المكتب
        QString m_curentdirLocation;
        //! المشهد الحاوي للايقونات
        QGraphicsScene *m_scene;
        //!  كيفية ترترب الايقونات
        /* BY_NAME   1 BY_TYPE   2  BY_SIZE   3 */
        int m_sort;
        //! حجم الايقونات
        int m_iconWidth;
int m_execMode;
        bool m_alignHorizontale;
 QString m_lC;
public slots:
        //! حذف كل الايقونات
        void deletAll();
        //! المجلد الحالي لسطح المكتب
        void  setDirFilesName(QString dir);

        //! جلب اعدادات المستخدم
        void loadSettings();
 void updateIconList();
        void updatIcons();

void sortBy();
private slots:
        //! حفظ مواقع الايقونات
        void saveDesktopIttemsPos();
        //! جلب الايقونات
        void loadIconsList();
        //! ترتيب حسب
        void realigneBy(int sort);
        //! تحديث قائمة الايقونات
        void updateIconList(const QString&);

        //! تحريك الايقونات الى مواضعها الجديدة في حالة الترتيب
        void animeIcons(QHash<IconDesktop *, QPoint> listItemesPoints );
        void animeOpacity(IconDesktop *Ib);
        //! حذف العناصر ويدجات التي تحوي الايقونات بعد تحريكها
       void saveIttemsPos();
      //  void removeWid(QGraphicsWidget *wid, IconDesktop *Ib);
        //! قائمة بعناصر انشاء جديد
        void creatMenuTemplate();

        QString  getTemplateApp(const QString &fileName);
        void creatMenuFile();

       // void creatLinkFile();
      //  void creatLinkDir();
        void creatLink();
        void creatAppxFile();
        //! تنفيذ الاوامر
        void execTemplate();
        void creatNewFile(const QString fileSource);
        void creatNewDir();
        void openWithSelectedIcons();
        void getSelectedIttemsProperty();
        void renameSelectedIcons();
        void openSelectedIcons();
        void removeSelectedIcons();

        void dragEnterEvent(QGraphicsSceneDragDropEvent *e);
        //! It's required to have dragMoveEvent as QGraphicsScene needs it to handle drops.
        void dragMoveEvent(QGraphicsSceneDragDropEvent *);
        void dropEvent(QGraphicsSceneDragDropEvent *e);


};

#endif
