#include "qmlanimation.h"

#include <QGraphicsProxyWidget>
#include <QDeclarativeView>
#include <QDebug>
#include <QMessageBox>
#include <QDeclarativeError>

QmlAnimation::QmlAnimation(const QRect &rect, QGraphicsItem *parent)
    : QGraphicsProxyWidget(parent),mDeclarativeView(0),mWidget(0),mRect(rect)

{

   // connect(engine(), SIGNAL(quit()), SLOT(close()));
 //   setResizeMode(QDeclarativeView::SizeRootObjectToView);

  // Qt versions prior to 4.8.0 don't have QML/JS debugging services built in
    // -----------QDeclarativeView ----------------
   mWidget=new QWidget;
  mDeclarativeView=new QDeclarativeView(mWidget);






}

bool QmlAnimation::setQmlFile(const QString &fileName)
{
    mDeclarativeView->setSource(QUrl::fromLocalFile(fileName));
    if(mDeclarativeView->status()==QDeclarativeView::Error){
        QString msg;
        foreach (QDeclarativeError derror, mDeclarativeView->errors()) {
            msg+=  derror.toString()+"\n";
        }


        delete mDeclarativeView;
        mDeclarativeView=0;

        QMessageBox::information(0,"Error",msg);

        return false;
    }
    connect(mDeclarativeView,SIGNAL(statusChanged(QDeclarativeView::Status)),this,
            SLOT(aimationStatusChanged(QDeclarativeView::Status)));

    mDeclarativeView->setResizeMode(QDeclarativeView::SizeRootObjectToView);
    mDeclarativeView->setSceneRect(mRect);
    mDeclarativeView->rootObject()->setProperty("width",mRect.width());
    mDeclarativeView->rootObject()->setProperty("height",mRect.height());
   // mDeclarativeView->setFixedSize(mRect.size());
    mDeclarativeView->resize(mRect.size());
    mDeclarativeView->setOptimizationFlags(QGraphicsView::DontSavePainterState);
    mDeclarativeView->setViewportUpdateMode(QGraphicsView::BoundingRectViewportUpdate);
    setWidget(mWidget);

    return true;
}
 void QmlAnimation::setRect(QRect rect)
 {
mRect=rect;

 }
QmlAnimation::~QmlAnimation()
{
      deleteLater();

    if(mDeclarativeView){
        delete mDeclarativeView;
        mDeclarativeView=0;
        qDebug()<<"mDeclarativeView deleted ::-------------------------------";
    }

//    delete mWidget;
     qDebug()<<"QmlAnimation delet all::-------------------------------";
}

void QmlAnimation::aimationStatusChanged(QDeclarativeView::Status status)
{
     QString msg;
    switch (status) {
    case QDeclarativeView::Null:
        qDebug()<<"QDeclarativeView::Null";
        break;

    case QDeclarativeView::Ready:
        qDebug()<<"QDeclarativeView::Ready";
        break;

    case QDeclarativeView::Loading:
        qDebug()<<"QDeclarativeView::Loading";
        break;

    case QDeclarativeView::Error:

        //mDeclarativeView->setSource(QUrl());




        foreach (QDeclarativeError derror, mDeclarativeView->errors()) {
            msg+=  derror.toString()+"\n";
        }
        delete mDeclarativeView;
        mDeclarativeView=0;
         QMessageBox::information(0,"Error",msg);
        qDebug()<<"QDeclarativeView::Error deleted";
        emit hasError();
        break;
    default:
        break;
    }
}

