/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SCENE_H
#define SCENE_H
 #include "../common/menuprogrammes.h"
#include "qmlanimation.h"
#include <QGraphicsScene>
#include <QGraphicsItem>
#include <QGraphicsWidget>
#include <QGraphicsSceneDragDropEvent>
#include <QGraphicsSceneContextMenuEvent>
#include <QMenu>

#include <QDeclarativeView>
class IconsView;
QT_BEGIN_NAMESPACE
QT_END_NAMESPACE

/**
 * @class Scene
 * @brief مشهد سطح المكنب
 * @author ابو زكريا
  */
class Scene : public QGraphicsScene
{
    Q_OBJECT
public:
    explicit Scene(QObject *parent = 0);
    
signals:
    void isFolderImages(bool f);
protected:
    void contextMenuEvent(QGraphicsSceneContextMenuEvent * event);
    virtual void  mouseMoveEvent(QGraphicsSceneMouseEvent *event) ;
public slots:

    void nextWallpaper();
    void loadSettings();
    void setBackground();
    void  setMenu(QMenu *menu);
    void setMenuStandard(QMenu *menu);
    void  setMenuIcon(QMenu *menu);
    void setApplicationsMenu();
    void updatIcons();
    // void  setMenuFiles(QMenu *menu);
private:
    QGraphicsPixmapItem *m_itemBackground;
    QGraphicsPixmapItem *m_itemBackgroundCache;
    QGraphicsWidget *m_graphicsWidget;
       QmlAnimation *mQmlAnimation;
    int m_slideTime;
    QPixmap m_pixPattern;
    int m_type;
    QColor m_color;
    QString m_appPath;
    QStringList m_listBgr;
    QString m_pixFileName;
    QString m_folderDir;
    QString m_animationFile;

    int m_aspectRatio;
    int m_curListIndexOf;
    bool m_showMenuApp;
    QTimer *m_timerSlide;
    QMenu mymenu;
    QMenu menuStandard;
    QMenu menuIcon;
    MenuProgrammes *mPmenu;
    IconsView *iconsView;
private slots:


    void setBackgroundimage(const QPixmap &pix);
    void  setBackgroundColor();
    void  setBackgroundPattern();
    void  setBackgroundImage();
    void  setBackgroundImageFolder();
 //   void aimationStatusChanged(QDeclarativeView::Status status);
    void setBackgroundAnimation();

    void  creatListOfBgr();
    void  startAnimmation();
    void  setBackgroundCache();


};

#endif // SCENE_H
