/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*************************************************************************
 *original code by razor qt
 **************************************************************************/
#include "dockactiontask.h"

#include<EDir>
#include <QtGui/QContextMenuEvent>
#include<QWidget>
#include<QToolButton>
#include <X11UTILLS>
//#include <X11/extensions/Xcomposite.h>
#define  ABOVE 0
#define  NORMAL 1
#define  BELOW 2
#define _MaximizeHoriz 0
#define _MaximizeVert 1
#define _MaximizeBoth 2

//____________________________________________________________________________________
DockActionTask::DockActionTask(const Window window, QWidget *parent) :
     QAction(parent),
     m_Window(window)
{
    this->setCheckable(true);

     //this->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Expanding);
    setObjectName("DockButtonTask");
  //   setIconSize(size);
     updateText();
     //getIcon();
     //this->setMinimumWidth(16);
     connect(this,SIGNAL(triggered()),SLOT(udatStat()));
}

//____________________________________________________________________________________
QString getIconFromDesktopApp(QString fileName )
{



     QFile file(Edir::configHomeDir()+"/applictions");

     if (!file.open(QFile::ReadOnly)){
          return "";
     }
     QTextStream textStream(&file);
     QString line;

     line= textStream.readLine();//premier line
     while (!line.isNull()) {

          QString exec=line.section("|",1,1);

          if(exec.contains(fileName)){

               QString icon=line.section("|",2,2);
               file.close();
               return icon;

          }
          line= textStream.readLine();
     }
     file.close();
     return "";
}

//____________________________________________________________________________________
void DockActionTask::getIcon()
{
     QIcon icon;

     //from appname    
     if(QIcon::hasThemeIcon(appName())){
          icon=QIcon::fromTheme(appName());
          QPixmap pixmap = icon.pixmap(QSize(128, 128),QIcon::Active,QIcon::Off);
          setIconNew(QIcon(pixmap));
        // qDebug()<<"getIcon from appname-------------"<<appName();
          return;
     }

     //from classe name
     if(QIcon::hasThemeIcon(classeName())){
              icon=QIcon::fromTheme(classeName().toLower());
          QPixmap pixmap = icon.pixmap(QSize(128, 128),QIcon::Active,QIcon::Off);
          setIconNew(QIcon(pixmap));
         // qDebug()<<"getIcon from classename-------------"<<classeName();
          return;
     }
     //from xdgappname
     icon=QIcon::fromTheme(getIconFromDesktopApp(appName()));
     if(!icon.isNull()){
          QPixmap pixmap = icon.pixmap(QSize(128, 128),QIcon::Active,QIcon::Off);
          setIconNew(QIcon(pixmap));
       //  qDebug()<<"getIconFromDesktopAppappName------------"<<appName();
          return;
     }

     //from xdgclassename  
     icon=QIcon::fromTheme(getIconFromDesktopApp(classeName()));
     if(!icon.isNull()){
          QPixmap pixmap = icon.pixmap(QSize(128, 128),QIcon::Active,QIcon::Off);
          setIconNew(QIcon(pixmap));
          //qDebug()<<"getIconFromDesktopAppclasseName-------------"<<classeName();
          return;
     }

     icon=X11UTILLS::getWindowIcon(m_Window);
       if (!icon.isNull()){
          QPixmap pix=icon.pixmap(128).scaled(128,128) ;
          setIconNew(QIcon(pix));
    // qDebug()<<"getIconFromX11UTILLS::getWindowIcon-------------"<<appName();

     }else
          setIconNew(EIcon::fromTheme("application-x-executable").pixmap(128));
}
//____________________________________________________________________________________
void DockActionTask::setIconNew(const QIcon &icon)
{
    myIcon=icon;
    QPixmap pixIcon=QPixmap(icon.pixmap(128)).scaled(128,128);

    QPainter  painter;

    QSize iSize;

    QRect target;

    //draw orig icon
    switch (m_screenEdge) {
    case EDGE::POS_BOT:
        iSize=QSize(128,170);
        target=QRect(0,0, 128, 128);
        break;
    case EDGE::POS_TOP:
        iSize=QSize(128,170);
        target=QRect(0,41, 128, 128);
        break;
    case EDGE::POS_RIGHt:
        iSize=QSize(128,128);
        target=QRect(0,0, 128, 128);
        break;
    case EDGE::POS_LEFT:
        iSize=QSize(128,128);
        target=QRect(0,0, 128, 128);
        break;
    default:
        break;
    }

    QPixmap pix(iSize);
    pix.fill(Qt::transparent);
    painter.begin(&pix);
    painter.drawPixmap(target,icon.pixmap(128) );

    qreal rx=0.80;
    int r;
    switch (m_screenEdge) {
    case EDGE::POS_BOT:
        r=128;
        for (int i =130; i <171; ++i) {

            painter.setOpacity(rx);
            painter.drawPixmap(0,i,128,1,pixIcon,0,r,128,1);
            r--;
            rx=rx-0.02;
            if(rx<0.02)rx=0.00;
        }
        break;
    case EDGE::POS_TOP:
        r=0;
        for (int i =40; i >-1; --i) {
            //        qDebug()<<i;
            painter.setOpacity(rx);
            painter.drawPixmap(0,i,128,1,pixIcon,0,r,128,1);
            r++;
            rx=rx-0.02;
            if(rx<0.02)rx=0.00;
        }
        break;
    case EDGE::POS_RIGHt:

        break;
    case EDGE::POS_LEFT:

        break;
    default:
        break;
    }

     //active window
    painter.setOpacity(100);
    QPixmap picin(":/icons/active");
    QRect rectDist=QRect(iSize.width()/3,(iSize.height()/3)*2,iSize.width()/3,iSize.height()/3);

    painter.drawPixmap(rectDist, picin,picin.rect());

    painter.end();

    setIcon(QIcon(pix));
}

//____________________________________________________________________________________
void DockActionTask::updateText()
{
     QString title =X11UTILLS::getWindowTitle(m_Window);

     setText(title.replace("&", "&&"));
     setToolTip(title);
     //     qDebug()<<"title-------------------------------------"<<title;
}

//____________________________________________________________________________________
QString DockActionTask::appName()
{
     //qDebug()<<"getApplicationName : "<<    X11UTILLS::getApplicationName(m_Window);

     return  X11UTILLS::getApplicationName(m_Window);

}

//____________________________________________________________________________________
QString DockActionTask::classeName()
{
     // qDebug()<<"getApplicationClasseName : "<<    X11UTILLS::getApplicationClasseName(m_Window);

     return  X11UTILLS::getApplicationClasseName(m_Window);

}

//____________________________________________________________________________________
QMenu *DockActionTask::taskMenu()
{

     QHash<QString ,bool>wState=X11UTILLS::states(m_Window);
     QHash<QString ,bool>wAllow=X11UTILLS::allowed(m_Window);

     QMenu *menu=new QMenu(trUtf8("Application"));
     QAction* a;



     // ** قوائم اسطح المكتب **************************
     int deskNum =X11UTILLS::getNumDesktop();
     if (deskNum > 1)
     {
          int winDesk =  X11UTILLS::getWindowDesktop(m_Window);
          QMenu* deskMenu = menu->addMenu(tr("To &Desktop"));
          // **امر نقل النافذة الى كل اسطح المكتب  ****************************
          a = deskMenu->addAction(tr("&All Desktops"));
          a->setData(-1);
          a->setEnabled(winDesk != -1);
          connect(a, SIGNAL(triggered(bool)), this, SLOT(moveWindowToDesktop()));
          deskMenu->addSeparator();

          // **امر نقل النافذة الى  سطح مكتب محدد  ****************************

          for (int i=0; i<deskNum; ++i)
          {
               a = deskMenu->addAction(tr("Desktop &%1").arg(i+1));
               a->setData(i);
               a->setEnabled( i != winDesk );
               connect(a, SIGNAL(triggered(bool)), this, SLOT(moveWindowToDesktop()));
          }

          // **امر نقل النافذة الى سطح المكتب الحالي  ****************************

          int curDesk = X11UTILLS::getActiveDesktop();

          a = menu->addAction(tr("&To Current Desktop"));
          a->setData(curDesk);
          a->setEnabled( curDesk != winDesk );
          connect(a, SIGNAL(triggered(bool)), this, SLOT(moveWindowToDesktop()));
     }

     // **قوائم اوامر النوافذ ****************************
     menu->addSeparator();

     // **امر تكبير النوافذ ****************************
     a = menu->addAction(tr("Ma&ximize"));
     a->setEnabled((wAllow["MaximizeHoriz"] && wAllow["MaximizeVert"]) &&
                   (! wState["MaximizedHoriz"] || ! wState["MaximizedVert"] ));
     a->setData(_MaximizeBoth);
     connect(a, SIGNAL(triggered(bool)), this, SLOT(maximizeWindow()));

     // **امر تكبير عمودي او افقي النوافذ ****************************
//     if (event->modifiers() & Qt::ShiftModifier)
//     {

//          a = menu->addAction(tr("Maximize vertically"));
//          a->setEnabled((wAllow["MaximizeVert"]) && (! wState["MaximizedVert"] || wState["Hidden"]));
//          a->setData(_MaximizeVert);
//          connect(a, SIGNAL(triggered(bool)), this, SLOT(maximizeWindow()));

//          a = menu->addAction(tr("Maximize horizontally"));
//          a->setEnabled((wAllow["MaximizeHoriz"]) && (! wState["MaximizedHoriz"] ||  wState["Hidden"]));
//          a->setData(_MaximizeHoriz);
//          connect(a, SIGNAL(triggered(bool)), this, SLOT(maximizeWindow()));
//     }

     // **امر استعادة النوافذ ****************************
     a = menu->addAction(tr("&Restore"));
     a->setEnabled( wState["Hidden"] ||  wState["MaximizedHoriz"] ||  wState["MaximizedVert"]);
     connect(a, SIGNAL(triggered(bool)), this, SLOT(unMaximizeWindow()));

     // **امر تصغير النوافذ ****************************
     a = menu->addAction(tr("Mi&nimize"));
     a->setEnabled(wAllow["Minimize"] && ! wState["Hidden"]);
     connect(a, SIGNAL(triggered(bool)), this, SLOT(minimizeWindow()));

     // **امر تحجيم النوافذ ****************************
     if ( wState["Shaded"])
     {
          a = menu->addAction(tr("Roll down"));
        a->setEnabled(wAllow["Shade"] && ! wState["Hidden"]);
          connect(a, SIGNAL(triggered(bool)), this, SLOT(unShadeWindow()));
     }
     else
     {
          a = menu->addAction(tr("Roll up"));
          a->setEnabled(wAllow["Shade"] && ! wState["Hidden"]);
          connect(a, SIGNAL(triggered(bool)), this, SLOT(shadeWindow()));
     }


     // **قوائم وضعية النوافذ ****************************
     menu->addSeparator();

     QMenu* layerMenu = menu->addMenu(tr("&Layer"));

     a = layerMenu->addAction(tr("Always on &top"));
     a->setEnabled(wAllow["AboveLayer"] && ! wState["AboveLayer"]);
     a->setData(ABOVE);
     connect(a, SIGNAL(triggered(bool)), this, SLOT(setApplicationLayer()));

     a = layerMenu->addAction(tr("&Normal"));
     a->setEnabled( wState["AboveLayer"] ||  wState["BelowLayer"]);
     a->setData( NORMAL);
     connect(a, SIGNAL(triggered(bool)), this, SLOT(setApplicationLayer()));

     a = layerMenu->addAction(tr("Always on &bottom"));
     a->setEnabled(wAllow["BelowLayer"] && ! wState["BelowLayer"]);
     a->setData(BELOW);
     connect(a, SIGNAL(triggered(bool)), this, SLOT(setApplicationLayer()));


     // ** امر اغلاق النافذة *****************************
     menu->addSeparator();
     a = menu->addAction( tr("&Close"));
     connect(a, SIGNAL(triggered(bool)), this, SLOT(closeApplication()));

     // ** امر اضافة المشغل الى نافذة الارساء *****************************

     a = menu->addSeparator();
     a = menu->addAction( tr("&Start New instance"));
     connect(a, SIGNAL(triggered(bool)), this, SLOT(startNewInstance()));

     menu->addAction(m_actParent);
     // ** قوائم انافذة الرئيسية *****************************

     QMenu *mnuDock=menu->addMenu(tr("Dock bar"));
     mnuDock->addActions(m_listQctions);

   return  menu;
}


void DockActionTask::udatStat()
{
    if (m_isActive) {
         minimizeWindow();
    }else {
         restoreWindow();
    }
}

//___________________________________________________________تصغير النافذة
void DockActionTask::minimizeWindow()
{
     X11UTILLS::minimizeWindow(m_Window);
}

//___________________________________________________________استعادة النافذة
void DockActionTask::restoreWindow()
{
     int winDesktop = X11UTILLS::getWindowDesktop(m_Window);
     if (X11UTILLS::getActiveDesktop() != winDesktop)
          X11UTILLS::setActiveDesktop(winDesktop);
     X11UTILLS::raiseWindow(m_Window);
}
//___________________________________________________________  النافذة الى سطح مكتب
void DockActionTask::moveWindowToDesktop()
{
     QAction* act = qobject_cast<QAction*>(sender());
     if (!act)
          return;

     bool ok;
     int desk = act->data().toInt(&ok);

     if (!ok)
          return;

     X11UTILLS::moveWindowToDesktop(m_Window, desk);
}
//___________________________________________________________استعادة النافذة من التكبير
void DockActionTask::unMaximizeWindow()
{
     X11UTILLS::deMaximizeWindow(m_Window);
}

//___________________________________________________________تحجيم النافذة اي نظليلها
void DockActionTask::shadeWindow()
{
     X11UTILLS::shadeWindow(m_Window, true);
}

//___________________________________________________________استعادة النافذة من التحجيم
void DockActionTask::unShadeWindow()
{
     X11UTILLS::shadeWindow(m_Window, false);
}

//___________________________________________________________غلق النافذة
void DockActionTask::closeApplication()
{
     X11UTILLS::closeWindow(m_Window);
}

//___________________________________________________________تكبير النافذة
void DockActionTask::maximizeWindow()
{
     QAction* act = qobject_cast<QAction*>(sender());
     if (!act)
          return;



     X11UTILLS::maximizeWindow(m_Window,act->data().toInt());
}

//___________________________________________________________وضع النافذة فوق او تحت او عادي
void DockActionTask::setApplicationLayer()
{
     QAction* act = qobject_cast<QAction*>(sender());
     if (!act)
          return;



     X11UTILLS::setWindowLayer(m_Window, act->data().toInt());
}

//___________________________________________________________
void DockActionTask::setParentActions(QList<QAction *>list)
{
     m_listQctions=list;
}

//___________________________________________________________
void DockActionTask::setParentAction(QAction *act)
{
     m_actParent=act;

}

//___________________________________________________________
void DockActionTask::updatPixmap()
{
     QPixmap  originalPixmap =QPixmap::grabWindow(m_Window);

     //    QPixmap  originalPixmap =  QPixmap::fromX11Pixmap(XCompositeNameWindowPixmap(QX11Info::display(), m_Window));
     pixPrevew=originalPixmap.scaled(200,150, Qt::KeepAspectRatio);
}

//___________________________________________________________تشغيل نسخة جديدة من البرنامج
void DockActionTask::startNewInstance()
{
     QProcess process;
     process.startDetached(appName());
}
