/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
/*************************************************************************
 *original code by razor qt
 **************************************************************************/

#ifndef DACTIONTASKBAR_H
#define DACTIONTASKBAR_H
#include <QtGui>
#include <EIcon>
#include "commonedge.h"
#include <X11/Xlib.h>
#include <QToolButton>
/**
 * @brief The ButtonTask class زر تطبيق في مبدل المهام
 */
class DockActionTask : public QAction
{
    Q_OBJECT
public:


    explicit DockActionTask(const Window window, QWidget *parent = 0);
    QString appName();
    QString classeName();
    QPixmap pixmap()
    {
        return pixPrevew;
    }
signals:
    void entered(Window wid);
    void leaved();


protected:

   // void mousePressEvent(QMouseEvent *event);
    void enterEvent ( QEvent * /*e*/ )
    {
        emit entered(m_Window);
    }

    void leaveEvent ( QEvent * /*e*/ )
    {
        leaved();
    }


protected:
   // void contextMenuEvent( QContextMenuEvent* event);
private:
   bool m_isActive;
    Window  m_Window;
    QAction *m_actParent;
    QList<QAction *>m_listQctions;
    QPixmap pixPrevew;
    int m_screenEdge;
    QIcon myIcon;
    QString m_title;

private slots:

    void getIcon();                /// ايقونة البرنامج
  void setIconNew(const QIcon &icon);
    void startNewInstance();       /// تشغيل نسخة جديدة
    /**********عمليات النوافذ***************/
    void minimizeWindow();                  /// تصغير النافذة
    void restoreWindow();                   /// استعادة النافذة من التصغير
    void moveWindowToDesktop();             /// نقل النافذة الى سطح المكت//
    void unMaximizeWindow();                /// استعادة النافذة من التكبير
    void shadeWindow();                     /// تحجيم النافذة اي نظليلها
    void unShadeWindow();                   /// استعادة النافذة من التحجيم
    void closeApplication();                /// غلق النافذة
    void maximizeWindow();                  /// تكبير التافذة
    void setApplicationLayer();             /// وضع النافذة فوق تحت عادي
void udatStat();
public slots:
void setActiveWin(bool arg){m_isActive=arg;}
QMenu *taskMenu();
    void setParentActions(QList<QAction *>list); /// وامر من لنافذة الاب
    void setParentAction(QAction *act);          ///
    void updatPixmap();                           /// تحديث الصورة
    void updateText();                /// نص لابرنامج
    void setScreenEdge(int edg){m_screenEdge=edg;getIcon();}
    QIcon icon(){return myIcon;}

    void setWindowTitle(QString title){m_title=title;}
    QString windowTitle(){return m_title;}
};

#endif // DACTIONTASKBAR_H
