/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ANIMMATION_H
#define ANIMMATION_H
#include <QtCore>
#include <QAction>
#include <QTimer>
#include <QObject>
#include <QWidget>


/**
 * @brief The DockAnimmation class
 * @brief خاص بتحريك الايقونة عند الضغط
 * @author أبو زكريا
 * @date 19/10/2014
 */
class DockAnimmation: public QObject
{
    Q_OBJECT
public:
    explicit DockAnimmation(QObject *parent = 0);


public slots:
    /**
     * @brief AnimationStart بدأ الحركة
     * @param btn الزر المستهدف
     * @param size الحجم
     */
    void AnimationStart(QAction *btn, QSize size);
    /**
     * @brief AnimationStopتوقيف الحركة
     */
    void AnimationStop();
    /**
     * @brief setStyle
     * @param style نوع الحركة
     */
    void setStyle(int style)
    {
        m_style=style;
    }


private:
    /**
 * @brief The AnimmationType enum نوع الحركة
 */
    enum AnimmationType{
        ANIM_NONE,
        ANIM_ZOOM ,
        ANIM_ROTAT ,
        ANIM_IMAGE,
        ANIM_BUNSE
    };

    QTimer *timerAnim;
    int m_style;
    QAction *buttonAct;
    int m_iconSize;

    int m_animStyle;

    QPixmap m_pix;
    qreal m_rot;
    qreal m_def;
private slots:
    /*!< تفعيل الحركة */
    void goAnimation();
    /*!< تكبير الزر */
    void buttonZoomIn();
    /*!< تدوير الزر */
    void buttonRotate();
    /*!< رسم صورة متحركة على الزر */
    void buttonImage();

    void buttonBunse();
};

#endif // ANIMMATION_H
