/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "dockbarwidget.h"
#include "ui_dockbarwidget.h"


#include <MenuGen>
//#include "dockdialogsettings.h"
#include "dockbutton.h"
#include "docklayout.h"
#include "addactions/dialogaddaction.h"

#include "dockactiontask.h"

#include <QThread>

#include <QX11Info>
#include <EDir>
#include <QApplication>
#include <QDesktopWidget>
#include <QTimer>
#include <QDebug>
#include <QMouseEvent>
#include <QMenu>
#include <QFileSystemModel>
#include <QFileIconProvider>

#include <X11UTILLS>

#include <X11/extensions/shape.h>
//#define EDGE_BOT 0     /*bottom edge*/
//#define EDGE_TOP 1     /*top edge*/
//#define EDGE_RIGHt 2     /*right edge*/
//#define EDGE_LEFT 3     /*left edge*/

//#define EDGE::TYPE_AUTO 0     /*type auto hide*/
//#define EDGE::TYPE_SPACE 1     /*type reserve space*/
//#define EDGE::TYPE_TOP 2     /*type on top*/
//#define EDGE::TYPE_BOT 3     /*type on bottom*/
#define MIMETYPE "ddock"

#define ANIM_ZOOM 1
DockBarWidget::DockBarWidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::DockBarWidget),
    m_minH(16)/*,
    formInfo(0)*/
{
m_settings=new ElokabSettings(this);
    ui->setupUi(this);



    //--------------------------------
    setLayoutDirection(Qt::LeftToRight);
    QApplication::setAttribute(Qt::AA_DontShowIconsInMenus ,false);
   setWindowFlags(Qt::CustomizeWindowHint);
   setAttribute(Qt::WA_X11NetWmWindowTypeDock);
    setObjectName("elokab-dock");
//    setWindowTitle("Elokab-Dock");
    this->setPalette(Qt::transparent);
    this->setAttribute(Qt::WA_TranslucentBackground,true);
    m_rootWindow = QX11Info::appRootWindow();
    setAcceptDrops(true);

    QFont font;
    font.setPointSize(16);

    QToolTip::setFont(font);


    connect(QApplication::desktop(), SIGNAL(workAreaResized(int)),
            this, SLOT(   resizeDock()));
    timerShow=new QTimer;
    timerHide=new QTimer;
    timerShowHide=new QTimer;
    connect(timerShow,SIGNAL(timeout()) ,this,SLOT(moveToShow()));
    connect(timerHide,SIGNAL(timeout()) ,this,SLOT(moveToHide()));
    connect(timerShowHide,SIGNAL(timeout()) ,this,SLOT(getActinveWindowProperty()));


    connect(m_settings,SIGNAL(iconThemeChanged()) ,this,SLOT(loadIconThemes()));
   connect(m_settings,SIGNAL(ThemesChanged()) ,this,SLOT(loadSetting()));
   connect(m_settings,SIGNAL(dockThemesChanged()) ,this,SLOT(loadSetting()));
    crateStyle();

    this->setMaximumSize(16,16);
    this->setMaximumSize(QApplication::desktop()->width(),QApplication::desktop()->height());
    //  QIcon::setThemeName("Macbuntu-Icons");
    m_layout = new DockLayout(ui->widgetBgr);
    //ui->horizontalLayoutAction->addLayout(m_layout);

    actSettings=new QAction(trUtf8("Dock settings"),this);
    connect(actSettings,SIGNAL(triggered()) ,this,SLOT(dockSettings()));

    actAddActions=new QAction(trUtf8("Add Lancher"),this);
    connect(actAddActions,SIGNAL(triggered()) ,this,SLOT(addLancher()));

    actQuit=new QAction(trUtf8("Quit"),this);
    connect(actQuit,SIGNAL(triggered()),qApp,SLOT(quit()));

    m_actAddToLancher=new QAction(EIcon::fromTheme("list-add"),trUtf8("Add to lancher"),this);
    connect(m_actAddToLancher,SIGNAL(triggered()),this,SLOT(addAppTaskToLancher()));


    setContextMenuPolicy(Qt::CustomContextMenu);
    connect( this,SIGNAL(customContextMenuRequested(QPoint)) ,this,SLOT(customContextMenu(QPoint)));


   loadSetting();
    addQuickLaunch(false);
    loadIconThemes();
QTimer::singleShot(1000,this,SLOT(arrangeDock()));


}

DockBarWidget::~DockBarWidget()
{
    delete ui;
}

void DockBarWidget::crateStyle()
{
//    QString curentStyle=m_settings->loadStyleWidget();
//    QApplication::setStyle( QStyleFactory::create(curentStyle)) ;
}
void DockBarWidget::show()
{
    QWidget::show();
    X11UTILLS::moveWindowToDesktop(this->winId(), -1);
    // resizeDock();
}
void DockBarWidget::resizeEvent ( QResizeEvent * /*event*/ )
{

    QRect screen = QApplication::desktop()->availableGeometry(-1);
    if(m_PositionEdge==EDGE::POS_BOT||m_PositionEdge==EDGE::POS_TOP){

        if(this->width()>screen.width()){
            m_minH= m_minH-1;
            foreach (DockButton *btnQ,m_buttons){

                btnQ->setIconSize(QSize(m_minH,m_minH+m_refSize));
            }


        }
    }else{
        if(this->height()>screen.height()){
            m_minH= m_minH-1;
            foreach (DockButton *btnQ,m_buttons){

                btnQ->setIconSize(QSize(m_minH,m_minH+m_refSize));
            }


        }
    }


    resizeDock();


}
void DockBarWidget::resizeDock()
{
     QRect screen = QApplication::desktop()->screenGeometry(-1);
    QRect screenAvailable = QApplication::desktop()->availableGeometry(-1);

    int leftH=(screen.width()/2)-(this->width()/2);
    int toptV=(screen.height()/2)-(this->height()/2);
    /****************************************************************
            ***************define the info bull pos*************************
           ******* EDGE_BOT 0    EDGE_TOP 1   EDGE_RIGHt 2  EDGE_LEFT 3 ****
           *****************************************************************/
    if(m_PositionEdge==EDGE::POS_BOT){

        int top=screen.height()-this->height();
        move(leftH,top);

    }else  if(m_PositionEdge==EDGE::POS_TOP){
        move(leftH,0);
    }else if(m_PositionEdge==EDGE::POS_RIGHt){
        move(screen.width()-this->width(),toptV);
    }else if(m_PositionEdge==EDGE::POS_LEFT){
        move(0,toptV);
    }

    if(isExpanding==true){

        if(m_PositionEdge==EDGE::POS_BOT||m_PositionEdge==EDGE::POS_TOP){

            this->move(screenAvailable.left(),this->pos().y());
            this->resize(screenAvailable.width(),this->sizeHint().height());
        }else{
            this->resize(this->sizeHint().width(),screenAvailable.height());
            this->move(this->pos().x(),screenAvailable.top());
        }

    }else{

        if(m_PositionEdge==EDGE::POS_BOT||m_PositionEdge==EDGE::POS_TOP){
            this->move((screenAvailable.width()/2)-(this->width()/2),this->pos().y());
        }else{
            this->move(this->pos().x(),(screenAvailable.height()/2)-(this->height()/2));
        }

    }


}

void DockBarWidget::enterEvent(QEvent *)
{

    if(m_ArrangementType==EDGE::TYPE_BOT){

        this->activateWindow();
        this->raise();
        this->show();
    }

    if(m_ArrangementType==EDGE::TYPE_AUTO){
        timerShowHide->stop();
        mouseEntered=true;
        timerShow->singleShot(250, timerShow, SLOT(start()));
        timerShow->setInterval(5);
    }

}

void DockBarWidget::leaveEvent(QEvent *)
{
    if(m_ArrangementType==EDGE::TYPE_BOT){
        if(QCursor::pos().x()<this->pos().x()||
                QCursor::pos().y()<this->pos().y() ||
                QCursor::pos().y()>this->pos().y()+this->height()||
                QCursor::pos().x()>this->pos().x()+this->width()){
            this->setVisible(true);
            this->lower();
        }
    }

    if(m_ArrangementType==EDGE::TYPE_AUTO){
        timerShowHide->start(500);
        mouseEntered=false;
    }

}


void DockBarWidget::moveToHide()
{

    timerShow->stop();
    QRect screen = QApplication::desktop()->screenGeometry(-1);
    if(mouseEntered==true){
        timerHide->stop();
        return;
    }

    /*****************************************************************
     ******* EDGE_BOT 0    EDGE_TOP 1   EDGE_RIGHt 2  EDGE_LEFT 3 ****
     *****************************************************************/
    switch (m_PositionEdge) {

    case EDGE::POS_BOT:

        if(this->pos().y()>=screen.height()-2){
            timerHide->stop();
            return;
        }
        this->move(this->pos().x(),this->pos().y()+2);
        break;

    case EDGE::POS_TOP:

        if(this->pos().y()<=-(this->height()-2)){
            timerHide->stop();
            return;
        }
        this->move(this->pos().x(),this->pos().y()-2);
        break;

    case EDGE::POS_RIGHt:

        if(this->pos().x()>=screen.width()-2){
            timerHide->stop();
            return;
        }
        this->move(this->pos().x()+2,this->pos().y());
        break;

    case EDGE::POS_LEFT:

        if(this->pos().x()<=-(this->width()-2)){
            timerHide->stop();
            return;
        }
        this->move(this->pos().x()-2,this->pos().y());
        break;

    default:
        break;
    }


}
void DockBarWidget::moveToShow()
{
    timerHide->stop();
    if(mouseEntered==false){
        timerShow->stop();
        return;
    }
    QRect screen = QApplication::desktop()->screenGeometry(-1);
    /****************************************************************
           ******* EDGE_BOT 0    EDGE_TOP 1   EDGE_RIGHt 2  EDGE_LEFT 3 ****
           *****************************************************************/
    switch (m_PositionEdge) {

    case EDGE::POS_BOT:

        if(this->pos().y()<=screen.height()-this->height()){
            timerShow->stop();
            return;
        }
        this->move(this->pos().x(),this->pos().y()-2);
        break;

    case EDGE::POS_TOP:

        if(this->pos().y()>=0){
            timerShow->stop();
            return;
        }
        this->move(this->pos().x(),this->pos().y()+2);
        break;

    case EDGE::POS_RIGHt:

        if(this->pos().x()<=screen.width()-this->width()){
            timerShow->stop();
            return;
        }
        this->move(this->pos().x()-2,this->pos().y());
        break;

    case EDGE::POS_LEFT:

        if(this->pos().x()>=0){
            timerShow->stop();
            return;
        }
        this->move(this->pos().x()+2,this->pos().y());
        break;

    default:
        break;
    }

}

void DockBarWidget::loadSetting()
{

    QSettings setting("elokab","settings");

    setting.beginGroup("Dock-Style");

    QString arrangement=setting.value("Arrangement","auto-hide").toString();
    m_ArrangementType=EDGE::arrangementToInt(arrangement);

    QString positon=setting.value("Position","bottom").toString();
    m_PositionEdge=EDGE::posToInt(positon);

    m_minH=setting.value("iconSize",48).toInt();
    m_animmationStyle=setting.value("animmationStyle",ANIM_ZOOM).toInt();
    isExpanding=setting.value("Expanding",false).toBool();
    m_showPreview=setting.value("showPreview",false).toBool();
    int bleft=(setting.value("borderLeft",5).toInt());
    int bright=(setting.value("borderRight",5).toInt());
    int btop=(setting.value("borderTop",5).toInt());
    int bbot=(setting.value("borderBot",5).toInt());
     m_customToolTip=setting.value("CustomToolTip",true).toBool();
    setting.endGroup();




    m_layout->setContentsMargins(bleft,btop,bright,bbot);
    m_layout->setSizeH(m_minH);
    /****************************************************************
       ******* EDGE_BOT 0    EDGE_TOP 1   EDGE_RIGHt 2  EDGE_LEFT 3 ****
    *****************************************************************/
    if(m_PositionEdge==EDGE::POS_BOT||m_PositionEdge==EDGE::POS_TOP)
        m_refSize=m_minH/3;
    else
        m_refSize=0;

    if(m_PositionEdge==EDGE::POS_BOT||m_PositionEdge==EDGE::POS_TOP){
        m_layout->setHorizontalLayout(true,isExpanding);
    }else {
        m_layout->setHorizontalLayout(false,isExpanding);
    }

    foreach (DockButton *btnQ,m_buttons){
        btnQ->setIconSize(QSize(m_minH,m_minH+m_refSize));
        btnQ->setAnimation(m_animmationStyle,m_PositionEdge);
    }
    foreach (DockActionTask *btnT,m_actionsTask){
        //btnT->setIconSize(QSize(m_minH,m_minH+m_refSize));
        btnT->setScreenEdge(m_PositionEdge);
    }
    //********************************

    // ui->widgetBgr->setStyleSheet(style);
    QString qssFile=Edir::configDir()+"/dockTheme.css";
    if(!QFile::exists(qssFile))
        qssFile= Edir::dataDir()+"/themes/default/dockTheme.css";
    if(!QFile::exists(qssFile))
        qssFile= ":/icons/dockTheme.css";

    QFile file;
    file.setFileName(qssFile);
    if(file.open( QFile::ReadOnly)){
        QTextStream textStream(&file);
        textStream.setCodec(QTextCodec::codecForLocale());
        QString line;
        line = textStream.readAll();//premier line


        //              QFile qss(qssFile);
        //                          qss.open(QFile::ReadOnly);
        ui->widgetBgr->setStyleSheet(line);
        file.close();
    }
    //*************************
    timerShowHide->stop();
arrangeDock();

  QApplication::setLayoutDirection(Qt::LeftToRight);

    setAttribute(Qt::WA_AlwaysShowToolTips,false);

}
void DockBarWidget::arrangeDock()
{
    switch (m_ArrangementType)
    {
    case EDGE::TYPE_AUTO:

        setWindowFlags(Qt::FramelessWindowHint|Qt::WindowStaysOnTopHint);
        timerShowHide->start(500);
        m_autoHide=true;
        reserveSpace(false);
        break;
    case EDGE::TYPE_SPACE:

        setWindowFlags(Qt::FramelessWindowHint|Qt::WindowStaysOnTopHint);
        m_autoHide=false;
        reserveSpace(true);
        break;
    case EDGE::TYPE_TOP:
        reserveSpace(false);
        m_autoHide=false;
        setWindowFlags(Qt::FramelessWindowHint|Qt::WindowStaysOnTopHint);
        break;
    case EDGE::TYPE_BOT:
        reserveSpace(false);
        m_autoHide=false;
        setWindowFlags(Qt::FramelessWindowHint|Qt::WindowStaysOnBottomHint);
        break;
    }
    resizeDock();
    this->show();

}

void DockBarWidget::loadIconThemes()
{
    qDebug()<<"loadIconThemes******************"<<QIcon::themeName();
    QIcon icn1=EIcon::fromTheme("configure",("document-properties"));
    QIcon icn2=EIcon::fromTheme("list-add",("add"));
    QIcon icn3=EIcon::fromTheme("application-exit",("exit"));

    actSettings->setIcon(icn1);
    actAddActions->setIcon(icn2);
    actQuit->setIcon(icn3);
    foreach (DockButton *btnQ,m_buttons){
        btnQ->refreshIcon();
    }
}

void DockBarWidget::reserveSpace(bool arg)
{

    Window wid =this->winId();
    QRect screen = QApplication::desktop()->screenGeometry(0);
    QRect rect;
    int mScreenNum= QApplication::desktop()->primaryScreen();
    QRect desktop = QApplication::desktop()->screen(mScreenNum)->geometry();
    rect.moveLeft(screen.left());


         /****************define the  pos of the dock***********************
          ******* EDGE_BOT 0    EDGE_TOP 1   EDGE_RIGHt 2  EDGE_LEFT 3 ****
          *****************************************************************/

    rect = this->rect();
    if (m_PositionEdge == EDGE::EDGE::POS_BOT){


        rect.moveBottom(screen.bottom());
    } else if (m_PositionEdge == EDGE::POS_TOP){

        rect.moveTop(screen.top());

    }else if(m_PositionEdge==EDGE::POS_RIGHt){

        rect.moveRight(screen.right());

    }else if(m_PositionEdge==EDGE::POS_LEFT){

        rect.moveLeft(screen.left());
    }

    this->setGeometry(rect);

/*** Values for setting _NET_WM_STRUT_PARTIAL property.*
*    values[0] = left; values[1] = right;              *
*    values[2] = top;  values[3] = bottom;             *
*                                                      *
*    values[4] = leftStartY;    values[5] = leftEndY;  *
*    values[6] = rightStartY;   values[7] = rightEndY; *
*    values[8] = topStartX;     values[9] = topEndX;   *
*    values[10] = bottomStartX; values[11]= bottomEndX;*
********************************************************/

    QVector<unsigned long> values;
    values.fill(0, 12);
    foreach (int i, values) {
        values[i]=0;
    }
    if (arg==false){
        X11UTILLS::removeWindowProperty(wid, "_NET_WM_STRUT");
        X11UTILLS::removeWindowProperty(wid, "_NET_WM_STRUT_PARTIAL");
        return;
    }

    if (m_PositionEdge == EDGE::POS_BOT){

            values[3]= desktop.height() - rect.y();
            values[10]= rect.left();
            values[11]= rect.right();
    }else if (m_PositionEdge == EDGE::POS_TOP){

        values[2]= rect.bottom();
        values[8]= rect.left();
        values[9]= rect.right();

    }else if(m_PositionEdge==EDGE::POS_RIGHt){

        values[1]= desktop.width() - rect.x();
        values[6]= rect.top();
        values[7]= rect.bottom();
    }else if(m_PositionEdge==EDGE::POS_LEFT){

        values[0]= rect.width();
        values[4]= rect.top();
        values[5]= rect.bottom();
    }
    X11UTILLS::setWindowPropertyCardinalArray(wid, "_NET_WM_STRUT_PARTIAL", values);
    values.resize(4);
    X11UTILLS::setWindowPropertyCardinalArray(wid, "_NET_WM_STRUT", values);
    this->setGeometry(rect);

}

//_________________________________________________________________________
void DockBarWidget::dockSettings()
{

       QString fileName=Edir::progPath("elokab-settings");

qDebug()<<"fileName"<<fileName;
    QProcess prosess;

    prosess.startDetached(fileName,QStringList()<<"docksetting");
}
//___________________________________________________________QuickLaunch
void DockBarWidget::addQuickLaunch(bool fallaback)

{

    QSettings setting("elokab","dockQuickLanche") ;
    setting.setFallbacksEnabled(fallaback);
    int count = setting.beginReadArray("QuickApps");
    qDebug()<<count<<fallaback;
    if(count==0){

        if(fallaback){
            addButton(new ActionDock("/usr/share/applications/elokab-settings.desktop", this));
            addButton(new ActionDock("/usr/share/applications/elokab-fm.desktop", this));
            addButton(new ActionDock("/usr/share/applications/elokab-terminal.desktop", this));
        }
        else{
             addQuickLaunch(true);
        }
    }

    // QString desktop;
    QString file;
    QString execname;
    QString exec;
    QString icon;
    for (int i = 0; i < count; ++i){

        setting.setArrayIndex(i);
        //  desktop = setting.value("desktop", "").toString();
        file = setting.value("file", "").toString();

        if (! file.isEmpty()){
            if(QFile::exists(file))
                addButton(new ActionDock(file,this));

        }else{

            execname = setting.value("name", "").toString();
            exec = setting.value("exec", "").toString();
            icon = setting.value("icon", "").toString();
            // qDebug()<<"execname arry=========="<<execname<<i;
            addButton(new ActionDock(execname, exec,icon, this));  }
    } // for

    setting.endArray();
}

//___________________________________________________________QuickLaunch
void DockBarWidget::customContextMenu(QPoint)
{
    QString locale = QLocale::system().name().section("_",0,0);

    QMenu menu;
    if(locale=="ar")
       menu. setLayoutDirection(Qt::RightToLeft);

    menu.addAction(actAddActions);
    menu.addAction(actSettings);
    menu.addSeparator();
    menu.addAction(actQuit);
    menu.exec(this->cursor().pos());
}

//___________________________________________________________QuickLaunch
int DockBarWidget::indexOfButton(DockButton* button) const
{
    return m_layout->indexOf(button);
}

//___________________________________________________________QuickLaunch
int DockBarWidget::countOfButtons() const
{
    return m_layout->count();
}

//___________________________________________________________QuickLaunch
void DockBarWidget::addButton(ActionDock* action)
{

    int newIndex = 0;
    QList<int> keys = m_buttons.uniqueKeys();
    qSort(keys);
    foreach (int index, keys)
    {
        if (newIndex != index)
            break;
        ++newIndex;
    }

    DockButton* btn = new DockButton(QSize(m_minH,m_minH+m_refSize),newIndex, action, this);
    btn->setIconSize(QSize(m_minH,m_minH+m_refSize));
   //qDebug()<<"ID========="<<btn->text()<<newIndex;
    m_layout->addWidget(btn);
    m_buttons[newIndex] = btn;
    btn->setAnimation(m_animmationStyle,m_PositionEdge);
    connect(btn, SIGNAL(buttonDeleted(int)), this, SLOT(buttonDeleted(int)));
    connect(btn, SIGNAL(settingsChanged()), this, SLOT(saveSettings()));

    connect(btn, SIGNAL(switchButtons(int,int)), this, SLOT(switchButtons(int,int)));
    connect(btn,SIGNAL(entered(DockButton*)),this,SLOT(setQuickEntered(DockButton*)) );
  //  connect(btn,SIGNAL(leaved()),this,SLOT(sebtnDockSorted()) );


}

//___________________________________________________________QuickLaunch
void DockBarWidget::dragEnterEvent(QDragEnterEvent *e)

{
    if (e->mimeData()->hasFormat(MIMETYPE))
    {
        e->acceptProposedAction();
        return;
    }
    // Getting URL from Desktp File...
    if (e->mimeData()->hasUrls())
    {
        e->acceptProposedAction();
        return;
    }

    if (e->source() && e->source()->parent() == this)
    {
        e->acceptProposedAction();
    }
}

//___________________________________________________________QuickLaunch
void DockBarWidget::dropEvent(QDropEvent *e)
{
    const QMimeData *mime = e->mimeData();

    QList<QUrl> duplicates;

    foreach (QUrl url, mime->urls())
    {
        if (duplicates.contains(url))
            continue;
        else
            duplicates << url;

        QString fileName(url.toLocalFile());

        //   qDebug()<<"droped filename-------"<<fileName;
        addButton(new ActionDock(fileName, this));

    }
    saveSettings();
}

//___________________________________________________________QuickLaunch
void DockBarWidget::buttonDeleted(int id)
{

    DockButton *b = m_buttons[id];
 //    qDebug()<<"deleted ID========="<<b->text()<<id;
    m_layout->removeWidget(b);
    m_buttons.remove(id);
    b->deleteLater();
    saveSettings();
}

//___________________________________________________________QuickLaunch
void DockBarWidget::saveSettings()
{

    QSettings settings("elokab","dockQuickLanche") ;
//    settings.setIniCodec(QTextCodec::codecForName("UTF-8"));
    settings.remove("QuickApps");
    settings.beginWriteArray("QuickApps");
    int i = 0;

    foreach(DockButton *b, m_layout->buttons())
    {
        if(!m_buttonsTask.key(b)){
            qDebug()<<"b saved===="<<b->text();
        settings.setArrayIndex(i);

        QHashIterator<QString,QString> it(b->settingsMap());
        while (it.hasNext())
        {
            it.next();
            settings.setValue(it.key(), it.value());
        }

        ++i;
        }
    }

    settings.endArray();
}

//___________________________________________________________QuickLaunch
void DockBarWidget::addLancher()
{

    QRect screen = QApplication::desktop()->screenGeometry(-1);
    DialogAddAction *dlg=new DialogAddAction;
    connect(dlg,SIGNAL(accepteAdd(QString)) ,this,SLOT(addButton(QString)));
  dlg->show();
  dlg->move(screen.width()/2-dlg->width()/2,screen.height()/2-dlg->height()/2);

}

//___________________________________________________________QuickLaunch
void DockBarWidget::addButton(QString txt)
{
    QString exec=txt.section("|",1,1);
    foreach (DockButton *btnk,m_buttons){

        QRegExp ex("\\%[A-Z]");
        QRegExp ex2("\\%[a-z]");
        exec.remove(ex);
        exec.remove(ex2);
        exec.remove("-caption");
        exec.trimmed();
        exec=exec.section('/', -1).toLower().trimmed();
     QString mData=btnk->data().section('/', -1).toLower();
   //  qDebug()<<"addButton"<<mData<<exec;
        if(mData==exec )
        {
            QString missage=tr("this application exist");
             QMessageBox::information(0,"",missage);
            return;
        }

    }
    //  qDebug()<<"recever text ;"<<txt;
    addButton(new ActionDock(txt.section("|",0,0), txt.section("|",1,1), txt.section("|",2,2), this));
    saveSettings();
}

//___________________________________________________________QuickLaunch
void DockBarWidget::switchButtons(int first, int second)
{

    DockButton *w1 = m_buttons[first];
    DockButton *w2 = m_buttons[second];
    m_layout->swapButtons(w1, w2);
    saveSettings();

}

//___________________________________________________________ Taskbar
void DockBarWidget::refreshTaskList()
{


    //              قائمة مؤقة بجميع معرفات النوافذ الحاضرة
    QList<Window> listWindow = X11UTILLS::getClientList();

    //              قائمة بجميع معرفات النولفذ والازرار
    QMutableHashIterator<Window, DockActionTask*> i(m_actionsTask);

    // ---------------حذف جميع الازرار ومعرفاتها السابقة-----------------------
    while (i.hasNext())
    {
        i.next();

        int r = listWindow.removeAll(i.key());
        if (!r)
        {

            foreach (DockButton *btnQuick,m_buttonsAllTask){
                if(btnQuick->isTasked())

                {
                    if(m_buttonsAllTask.key(btnQuick)==i.key()){
                        btnQuick->removeAction(btnQuick->defaultAction());
                        btnQuick->resetAction();
                        btnQuick->setTaskbar(false);
                        m_buttonsAllTask.remove(i.key());

                    }
                }

            }


            if(m_buttonsTask.contains(i.key())){
                DockButton *b = m_buttonsTask[i.key()];
                int indx=m_buttons.key(b);
                 m_layout->removeWidget(b);
                m_buttons.remove(indx);

                m_buttonsTask.remove(i.key());

                m_buttonsAllTask.remove(i.key());

                b->deleteLater();
                m_layout->removeWidget(i.value());
            }

            //
            delete i.value();
            i.remove();

        }
    }

    //---------------------------انشاء زر جديد ----------------------------------
    foreach (Window window, listWindow)
    {

        //            انشاء زر جديد للنوافذ الحاضرة
        DockActionTask *actionTask=new DockActionTask(window,this);
        actionTask->setScreenEdge(m_PositionEdge);
        QString appname=actionTask->appName();
        QString className=actionTask->classeName();
        actionTask->setObjectName("btnTask");
        //
        actionTask->setWindowTitle(appname);

        //
        QAction *actAddToLancher=new QAction(EIcon::fromTheme("list-add"),trUtf8("Add to lancher"),actionTask);
        connect(actAddToLancher,SIGNAL(triggered()),this,SLOT(addAppTaskToLancher()));
        QList<QAction *>listact;

        QAction *act=new QAction(actionTask);
        act->setSeparator(true);
        listact<<(actAddActions);
        listact<<(actSettings);
        listact<<act;
        listact<<actQuit;
        actionTask->setParentAction(actAddToLancher);
        actionTask->setParentActions(listact);

        //            اضافة ازر للقائمة
        m_actionsTask.insert(window, actionTask);

        //        اضافة الزر للبنال
        //  m_layout->addWidget(btn);
        //qDebug()<<"appname===New======"<<appname.toLower();;
        //qDebug()<<"classename==New===="<<className.toLower();
        bool hasTask=false;

        foreach (DockButton *btnk,m_buttons){


         QString mData=btnk->data().section('/', -1).toLower();
            if(mData==appname.toLower()||mData==className.toLower() )

                  /*  || (btnk->data().contains("/")&&!appname.isEmpty()
                        && btnk->data().contains(appname))

                    ||(btnk->data().contains("/")&&!className.isEmpty()
                       && btnk->data().toLower().contains(className.toLower()))*/

            {

                if(! btnk->isTasked()){
                    btnk->setTaskAction(actionTask);
                    btnk-> setTaskbar(true);

                    m_buttonsAllTask[window]=btnk;
                    hasTask=true;
                    break;
                }
            }

        }

        if( !hasTask){
            int newIndex = 0;
            QList<int> keys = m_buttons.uniqueKeys();
            qSort(keys);
            foreach (int index, keys)
            {
                if (newIndex != index)
                    break;
                ++newIndex;
            }

            DockButton* btnNew = new DockButton(QSize(m_minH,m_minH+m_refSize),
                                                newIndex, new ActionDock(actionTask->windowTitle(), "","", this), this);
            btnNew->setIconSize(QSize(m_minH,m_minH+m_refSize));
            m_layout->addWidget(btnNew);
            btnNew->setTaskAction(actionTask);
            m_buttonsTask[window]=btnNew;
            m_buttonsAllTask[window]=btnNew;
            m_buttons[newIndex] = btnNew;
            connect(btnNew, SIGNAL(switchButtons(int,int)), this, SLOT(switchButtons(int,int)));
            connect(btnNew,SIGNAL(entered(DockButton*)),this,SLOT(setQuickEntered(DockButton*)) );
            btnNew->setTaskbar(true);

        }
    }

    activeWindowChanged();

}

QMenu *DockBarWidget::getTaskMenu(DockButton *btn)
{


   Window window= m_buttonsAllTask.key(btn);
   if(window){
       DockActionTask *act=m_actionsTask.value(window);
       if(act){
          return  act->taskMenu();
       }

   }
   return new QMenu();

}

//___________________________________________________________ Taskbar
void DockBarWidget::addAppTaskToLancher()
{
    //add
    QAction *action = qobject_cast<QAction *>(sender());

    DockActionTask *btn= qobject_cast<DockActionTask *>(action->parent());
    QString name=btn->appName();
    QString classename=btn->classeName();


    QString missage=tr("this application exist");
    foreach (DockButton *btnQuik,m_buttons){

        if(btnQuik->data().contains("/") && btnQuik->data().contains(name)){
            QMessageBox::information(0,"",missage);
            return;
        }
        else if(btnQuik->data()==name||btnQuik->data()==classename){
            QMessageBox::information(0,"",missage);
            return;

        }

    }
    QString appToAdd= getinfoAppFromDesktopApp(name,classename);
    if(appToAdd==""){
        QMessageBox::information(0,"",tr("this application is not xdg desktop valid"));
        return;
    }
    addButton(new ActionDock(appToAdd/*.section("|",0,0),
                             appToAdd.section("|",1,1),
                             appToAdd.section("|",2,2)*/, this));


    saveSettings();
}

//___________________________________________________________ Taskbar
QString DockBarWidget::getinfoAppFromDesktopApp(QString appName ,QString className)
{

          QFile file(Edir::configDir()+"/applictions");

          if (!file.open(QFile::ReadOnly)){
                    return "";
          }
          QTextStream textStream(&file);
          QString line;

          line= textStream.readLine();//premier line
          while (!line.isNull()) {

                    QString exec=line.section("|",1,1);
                    QString deskt=line.section("|",0,0);
                    if(exec.contains(appName)||exec.contains(className)
                            ||deskt.contains(appName)||deskt.contains(className)){
//                            //  qDebug()<<"contain :"<<exec;
//                              QString name=line.section("|",0,0);

//                              QString icon=line.section("|",2,2);
                              file.close();
                              return deskt;

                    }
                    line= textStream.readLine();
          }
          file.close();
          return "";

}

//___________________________________________________________ Taskbar
void DockBarWidget::activeWindowChanged()
{
    //        نزع التفعيل من كل الازرار
    foreach (DockActionTask *actTask,m_actionsTask){
        actTask->setChecked(false);
        actTask->setActiveWin(false);
        actTask->updateText();
    }
    //        البحث عن النافذة المفعلة
    m_Active_window = X11UTILLS::getActiveAppWindow();
    //       تفيل زر النافذة المفعلة اذا كان موجودا
    if (m_actionsTask.contains(m_Active_window)){
        m_actionsTask.value(m_Active_window)->setChecked(true);
        m_actionsTask.value(m_Active_window)->setActiveWin(true);

    }

}
/*
//___________________________________________________________ Taskbar
DockButton* DockBarWidget::buttonByWindow(Window window) const
{
//    if (m_actionsTask.contains(window)){
//        m_actionsTask.value(window)->setChecked(true);
//        m_actionsTask.value(window)->setActiveWin(true);
//        return m_buttonsTask.value(window);
//    }
//    return 0;
}
*/
//___________________________________________________________ Taskbar
void  DockBarWidget::x11EventFilter(XEvent* event)
{

    if (event->xproperty.window == m_rootWindow)
    {

        // Windows list changed ...............................

        if (event->xproperty.atom == X11UTILLS::atom("_NET_CLIENT_LIST"))
        {
         //   qDebug()<<event->type;
         //  qDebug()<<"getClientList : "<<  X11UTILLS::getClientList();
            refreshTaskList();
            return;
        }

        // Activate window ....................................
        if (event->xproperty.atom == X11UTILLS::atom("_NET_ACTIVE_WINDOW"))
        {

            activeWindowChanged();
            return;
        }

        // Desktop switch .....................................
        if (event->xproperty.atom == X11UTILLS::atom("_NET_CURRENT_DESKTOP"))
        {

            return;
        }
    }
    if (event->xproperty.atom == 292)
    {


        activeWindowChanged();
        //                refreshTaskList();
        return;
    }
}

//___________________________________________________________ Taskbar
void DockBarWidget::getActinveWindowProperty()
{

    //----------------

    QRect screen = QApplication::desktop()->screenGeometry(-1);


    if (m_Active_window == 0||m_Active_window==this->winId()){
        mouseEntered=true;
        timerHide->stop();
        timerShow->start(5);
        return ;
    }


    QRect rect= X11UTILLS::getwindowGeometry(m_Active_window);
    int  wLeft=rect.x();
    int wTop=rect.y();
    int wRight=rect.width()+wLeft;
    int wBot=rect.height()+wTop;


    /*****************************************************************
     ************تحديد اذا كانت النافذة المفعلة تلامس الدوك************
     ******* EDGE_BOT 0    EDGE_TOP 1   EDGE_RIGHt 2  EDGE_LEFT 3 ****
     *****************************************************************/

    if(m_PositionEdge==EDGE::POS_BOT){
        if(wBot+1>screen.height()-this->frameGeometry().height()){
            mouseEntered=false;
            timerShow->stop();
            timerHide->start(5);
        }else{
            mouseEntered=true;
            timerHide->stop();
            timerShow->start(5);
        }
    }else if(m_PositionEdge==EDGE::POS_TOP){
        if(wTop-1<this->frameGeometry().height()){
            mouseEntered=false;
            timerHide->start(5);
        }else{
            mouseEntered=true;
            timerShow->start(5);
        }
    }else if(m_PositionEdge==EDGE::POS_RIGHt){
        if(wRight+1>screen.width()-this->frameGeometry().width()){
            mouseEntered=false;
            timerShow->stop();
            timerHide->start(5);
        }else{
            mouseEntered=true;
            timerHide->stop();
            timerShow->start(5);
        }
    }else if(m_PositionEdge==EDGE::POS_LEFT){
        if(wLeft-1<this->frameGeometry().width()){
            mouseEntered=false;
            timerHide->start(5);
        }else{
            mouseEntered=true;
            timerShow->start(5);
        }
    }

}

//___________________________________________________________ Taskbar
void DockBarWidget::setTaskEntered(Window window)
{
    Q_UNUSED (window)
/*
    DockButton* toolbtn = buttonByWindow(window);
    //       xwininfoتفيل زر النافذة المفعلة اذا كان موجودا
    if (toolbtn){
        QPixmap pix(QIcon(toolbtn->icon()).pixmap(48,48));

        QPixmap pixp;//QIcon(toolbtn->icon()).pixmap(48,48));
        if(m_showPreview)
             pixp=toolbtn->pixmap();
        if(formInfo){

            formInfo->hide();
            formInfo->resize(64,64);
            if(m_showPreview)
            formInfo->setpreview(pixp,m_showPreview);
            formInfo->setPixmap(pix);
            formInfo->setTitle(toolbtn->text());
            setInfoShow();
        }
    }

*/
}


void DockBarWidget::setQuickEntered(DockButton *b)
{
   // QRect screen = QApplication::desktop()->screenGeometry(t);

//    DockButton *b = m_buttonsQuick[id];
    if(m_customToolTip){
        QFont font;
        font.setPointSize(14);

        QToolTip::setFont(font);
        QPoint p;
        if(m_PositionEdge==EDGE::POS_TOP)
            p=QPoint(pos().x()+b->pos().x(),m_minH+10);

        else if(m_PositionEdge==EDGE::POS_BOT)
            p=(QPoint(pos().x()+b->pos().x(),pos().y()-m_minH-10));

        else if(m_PositionEdge==EDGE::POS_LEFT)
            p=QPoint(width()+10,pos().y()+b->pos().y());

        else if(m_PositionEdge==EDGE::POS_RIGHt)
            p=QPoint(pos().x()-10,pos().y()+b->pos().y());

        QToolTip::showText((p),b->defaultAction()->text());
    }
  /*
QPixmap pix(b->icon().pixmap(48,48));
    //
    if(formInfo){

        formInfo->setpreview(QPixmap(),false);
        formInfo->hide();
        formInfo->resize(64,64);
        formInfo->setPixmap(pix);
        formInfo->setTitle(b->text());
        setInfoShow();

    }
    */
}
void DockBarWidget::setInfoShow()
{
    /*
 QRect screen = QApplication::desktop()->screenGeometry(-1);

    formInfo->resize(220,64);


    if(m_screenEdge==EDGE_TOP)
        formInfo->move(this->cursor().pos().x()-(110),formInfo->pos().y());

    if(m_screenEdge==EDGE_BOT)
        formInfo->move(this->cursor().pos().x()-(110),screen.height()-formInfo->height()-this->height());

    if(m_screenEdge==EDGE_LEFT)
        formInfo->move(formInfo->pos().x(),this->cursor().pos().y()-(formInfo->height()/2));

    if(m_screenEdge==EDGE_RIGHt)
        formInfo->move(screen.width()-this->width()-220,this->cursor().pos().y()-(formInfo->height()/2));

   formInfo->show();

*/

}
