/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DOCKBARWIDGET_H
#define DOCKBARWIDGET_H
#include "dockactiontask.h"
//#include "dockforminfo.h"
//#include "commun.h"
#include <X11/Xlib.h>
#include <X11/X.h>
#include <ElokabSettings>
#include <QWidget>
#include <QToolButton>
#include <QMouseEvent>
class ActionDock;
class QDragEnterEvent;
class DockLayout;
class DockButton;

namespace Ui {
class DockBarWidget;
}

class DockBarWidget : public QWidget
{
    Q_OBJECT

public:
    explicit DockBarWidget(QWidget *parent = 0);
    ~DockBarWidget();
    void show();
    QAction *actAddActions;
    QAction *actSettings;
    QAction *actQuit;
    void  x11EventFilter(XEvent* event);
    //************
    int indexOfButton(DockButton* button) const;
    int countOfButtons() const;
protected :

    void resizeEvent (QResizeEvent *);
    void enterEvent(QEvent *);
    void leaveEvent(QEvent *);

private:
    Ui::DockBarWidget *ui;
    int m_minH;
int m_refSize;
//    DockFormInfo *formInfo;
bool m_showPreview;
    //int m_maxH;
    bool  m_onTop;
    int m_ArrangementType;
        int m_PositionEdge;
//     enum ArrangementType {TYPE_AUTO ,     /*type auto hide*/
//                        TYPE_SPACE ,    /*type reserve space*/
//                        TYPE_TOP ,     /*type on top*/
//                        TYPE_BOT     /*type on bottom*/ };

//    enum PositionEdge { POS_BOT ,    /*bottom edge*/
//                      POS_TOP ,    /*top edge*/
//                      POS_RIGHt ,     /*right edge*/
//                      POS_LEFT      /*left edge*/ };

//    PositionEdge posToInt(QString pos){
//        if(pos=="bottom")return POS_BOT;
//        else if(pos=="top")return POS_TOP;
//        else if(pos=="right")return POS_RIGHt;
//        else if(pos=="left")return POS_LEFT;
//        else return POS_BOT;
//    }
//    ArrangementType arrangementToInt(QString type){
//        if(type=="auto-hide")return TYPE_AUTO;
//        else if(type=="reserve-space")return TYPE_SPACE;
//        else if(type=="on-top")return TYPE_TOP;
//        else if(type=="on-bottom")return TYPE_BOT;
//        else return TYPE_AUTO;
//    }

    //  int m_style;
    int m_animmationStyle;
    bool m_autoHide;
    QTimer *timerShow;
    QTimer *timerHide;
    QTimer *timerShowHide;
    bool mouseEntered;
    QSize m_size;
    //***************************
    DockLayout *m_layout;
bool m_customToolTip;

    bool isExpanding;

    //task

    QHash<int,DockButton*> m_buttons;
    QHash<Window, DockActionTask*> m_actionsTask;
    QHash<Window,DockButton*> m_buttonsTask;
    QHash<Window,DockButton*> m_buttonsAllTask;

    QAction *m_actAddToLancher;
    Qt::ToolButtonStyle mButtonStyle;
    Window m_rootWindow;
    Window m_Active_window;
    ElokabSettings *m_settings;
private slots:
    void crateStyle();
    void resizeDock();

    void moveToHide();
    void moveToShow();


    //    QString setStyleDefault();
    void loadSetting();
    void arrangeDock();
    void loadIconThemes();
    void reserveSpace(bool arg);
    void dockSettings();
    //******************************
    void addQuickLaunch(bool fallaback);
    void addButton(ActionDock* action);

    void buttonDeleted(int);
    void customContextMenu(QPoint);
    void addLancher();
    void addButton(QString txt);
    void switchButtons(int first, int second);
    void saveSettings();

    void dragEnterEvent(QDragEnterEvent *e);
    void dropEvent(QDropEvent *e);

    //********************task


    void refreshTaskList();
    void addAppTaskToLancher();
    void activeWindowChanged();
    QString getinfoAppFromDesktopApp(QString appName ,QString className);

    void getActinveWindowProperty();

    //*****tooltips
    void setTaskEntered(Window window);
    void setQuickEntered(DockButton *b);
    void setInfoShow();
public slots:
    QMenu *getTaskMenu(DockButton *btn);

};

#endif // DOCKBARWIDGET_H
