/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "dockdialogsettings.h"
#include "ui_dialogsettings.h"
#include "about/widgetabout.h"
#include "mimIcon/iconxdg.h"
#include <QSettings>
#include <QColorDialog>
#include <QFileDialog>
#include <QDebug>
#include <QTextCodec>
#include <QPainter>
#define STYLE_GRAD  0
#define STYLE_IMAGE  1
#define STYLE_3D 2

#define ANIM_ZOOM 1

//____________________________________________________________________________________
DockDialogSettings::DockDialogSettings(QWidget *parent) :
     QDialog(parent),
     ui(new Ui::DialogSettings)
{
     ui->setupUi(this);
     this->setAttribute(Qt::WA_DeleteOnClose,true);
     btn_colorTop   =new ButtonColor;
     btn_colorRight=new ButtonColor;
     btn_colorBot=new ButtonColor;
     btn_colorLeft=new ButtonColor;
     btn_colorBorder=new ButtonColor;
     btn_colorSelect=new ButtonColor;
     //-----ifobul

     //btn_colorInfoBgr   =new ButtonColor;
  //   btn_colorInfoBorder=new ButtonColor;
  //   btn_colorInfoFont=new ButtonColor;
     connect(btn_colorTop,SIGNAL(colorChanged()),this,SLOT(getStyleGradien()));
     connect(btn_colorRight,SIGNAL(colorChanged()),this,SLOT(getStyleGradien()));
     connect(btn_colorBot,SIGNAL(colorChanged()),this,SLOT(getStyleGradien()));
     connect(btn_colorLeft,SIGNAL(colorChanged()),this,SLOT(getStyleGradien()));
     connect(btn_colorBorder,SIGNAL(colorChanged()),this,SLOT(getStyleGradien()));
     connect(btn_colorSelect,SIGNAL(colorChanged()),this,SLOT(getStyleGradien()));

     ui->horizontalLayout_select->addWidget(btn_colorSelect);
     ui->horizontalLayout_border->addWidget(btn_colorBorder);
     //------infobull
     //ui->hLayoutbgrColor->addWidget(btn_colorInfoBgr);
    // ui->hLayoutborderColor->addWidget(btn_colorInfoBorder);
    // ui->hLayoutFontColor->addWidget(btn_colorInfoFont);

//     iconsSetting=new widgetIconsThemes;
  //   ui->verticalLayoutIcons->addWidget(iconsSetting);
    QString locale = QLocale::system().name().section("_",0,0);
     if(locale=="ar")
          setLayoutDirection(Qt::RightToLeft);
     this->setWindowIcon(IconXdg::fromTheme("configure",("document-properties")));
     this->setObjectName("dockConfig");
     this->setAttribute(Qt::WA_DeleteOnClose,true);
     /* اضافة صور الشكل الثلاثي الى القائمة المنسدلة*/
     ui->comboBox3D->addItem(QIcon(":/images/bgrGlass"), tr("White"),":/images/bgrGlass");
     ui-> comboBox3D->addItem(QIcon(":/images/bgrBlack"), tr("Black"),":/images/bgrBlack");

     WidgetAbout *wAbout=new WidgetAbout;
     wAbout->setPixmap(IconXdg::fromTheme("elokab-dock").pixmap(96));
     ui->verticalLayoutAbout->addWidget(wAbout);
     qDebug()<<"loqd settings";
     loadSetting();

     /*تطبيق الشكل هلى المعاينة*/
     getStyleGradien();

}

//____________________________________________________________________________________
DockDialogSettings::~DockDialogSettings()
{
     qDebug()<<"dock settings Ui deleted";
     delete ui;
}

//____________________________________________________________________________________
QString DockDialogSettings::getDirIconTeme(QString dir)
{
     QDir dirPath(dir);
     if(!QFile::exists(dir+"/index.theme"))return "";


     QSettings settings(dir+"/index.theme",QSettings::IniFormat);
     //settings.setIniCodec(QTextCodec::codecForName("UTF-8"));
     settings.beginGroup("Icon Theme");
     if(!settings.contains("Directories"))return "" ;
     QString name=settings.value("Name","").toString();
     //   QString directories=settings.value("Example","").toString();
     // qDebug()<<dir+"/index.theme  :"<<name<<" : "<<directories;
     settings.endGroup();
     return dirPath.dirName();

}
QColor listToColor(QList<QVariant>list)
{
    int red=0,green=0, bleu=0,alpha=255;
    int count=list.count();
    if(count>0)red=list.at(0).toInt();
    if(count>1)green=list.at(1).toInt();
    if(count>2)bleu=list.at(2).toInt();
    if(count>3)alpha=list.at(3).toInt();
    return QColor(red,green,bleu,alpha);
}
QList<QVariant> colorToList(QColor color)
{
    int red=(color.red());
    int green=(color.green());
    int bleu=(color.blue());
    int alpha=(color.alpha());
    return QList<QVariant>()<<red<<green<<bleu<<alpha;
}
//____________________________________________________________________________________
void DockDialogSettings::loadSetting()
{
     QSettings setting("elokab","settings");
     /*تحميل كل اعدادات الممستخدم من الوان واشكال وموضع الى الخ
     كل هذه المعلومات موجودة افتراضيا في مجلد المستخدم في هذا المسار
     QDir::homePath()+"/.config/elokab/applictions*/
     setting.beginGroup("Dock-Style");

     QString arrangement=setting.value("Arrangement","auto-hide").toString();
       ui->comboBoxArrangement->setCurrentIndex(EDGE::arrangementToInt(arrangement));

     QString positon=setting.value("Position","bottom").toString();
     int edge=EDGE::posToInt(positon);
      ui->comboBoxPosition->setCurrentIndex(edge);


     ui->spinBoxIconSize->setValue(setting.value("iconSize",48).toInt());
     ui->comboBoxAnim->setCurrentIndex(setting.value("animmationStyle",ANIM_ZOOM).toInt());
     ui->checkBoxExpanding->setChecked(setting.value("Expanding",false).toBool());
     //          QString iconstheme=setting.value("iconsTheme",QIcon::themeName()).toString();
     ui->cBoxCustumToolTip->setChecked(setting.value("CustomToolTip",true).toBool());

     QList<QVariant>   colorTop=setting.value("color1",QList<QVariant>()<<56<< 56<< 56<< 255).toList();
     QList<QVariant>   colorRight=setting.value("color2",QList<QVariant>()<<76<< 76<< 76<<255).toList();
     QList<QVariant>   colorBot=setting.value("color3",QList<QVariant>()<<0<< 0<< 0<< 255).toList();
     QList<QVariant>   colorLeft=setting.value("color4",QList<QVariant>()<<43<< 43<< 43<< 255).toList();
     QList<QVariant>   colorBorder=setting.value("colorBorder",QList<QVariant>()<<34<< 34<<34<<255).toList();
     QList<QVariant>   colorSelect=setting.value("colorSelect",QList<QVariant>()<<255<< 50<< 20<<255).toList();

//     QColor   InfoBgrColor=setting.value("InfoBgrColor",QColor(76, 76, 76, 255)).value<QColor>();
//     QColor   InfoBorderColor=setting.value("InfoBorderColor",QColor(34, 34,34,255)).value<QColor>();
//     QColor   InfoFontColor=setting.value("InfoFontColor",QColor(255, 255, 255,255)).value<QColor>();


     m_stop=setting.value("stop","0.02").toString();
     m_stop2=setting.value("stop2","0.96").toString();
     ui->lineEditImageFile->setText(setting.value("pixFileName","").toString());
     ui->checkBoxRepeat->setChecked(setting.value("imageRepeat",false).toBool());
     ui->spinBoxBleft->setValue(setting.value("borderLeft",5).toInt());
     ui->spinBoxBright->setValue(setting.value("borderRight",5).toInt());
     ui->spinBoxBtop->setValue(setting.value("borderTop",3).toInt());
     ui->spinBoxBbottom->setValue(setting.value("borderBot",1).toInt());
     ui->comboBoxBackStyle->setCurrentIndex(setting.value("backgroundStyle",STYLE_3D).toInt());
     ui->comboBox3D->setCurrentIndex(setting.value("image3D",0).toInt());
     ui->checkBoxSelectionColor->setChecked(setting.value("showSelection",false).toBool());

     //ui->checkBoxPreview->setChecked(setting.value("showPreview",false).toBool());
     setting.endGroup();

     btn_colorTop->setColor(listToColor(colorTop));
     btn_colorRight->setColor(listToColor(colorRight));
     btn_colorBot->setColor(listToColor(colorBot));
     btn_colorLeft->setColor(listToColor(colorLeft));
     btn_colorBorder->setColor(listToColor(colorBorder));
     btn_colorSelect->setColor(listToColor(colorSelect));
     //-----ifobul

//     btn_colorInfoBgr  ->setColor(InfoBgrColor);
//     btn_colorInfoBorder->setColor(InfoBorderColor);
//     btn_colorInfoFont->setColor(InfoFontColor);



     //add buttons colors to layouts
     if(edge<2)
          setupGradientTools(true);
     else
          setupGradientTools(false);


     //applique gui---------------------------------------
     QString dd=m_stop;
     dd.remove("0.");
     ui->verticalSlider->setValue(dd.toInt());
     QString dd2=m_stop2;
     dd2.remove("0.");
     ui->verticalSlider2->setValue(dd2.toInt());
}

//____________________________________________________________________________________
void DockDialogSettings::setupGradientTools(bool horizontal)
{
     QLayoutItem *child;
     while ((child = ui->gridLayoutGradient->takeAt(0)) != 0)
     {
          //  qDebug()<<"geometry---------------"<<child->geometry();
          delete child;
     }
     if(horizontal==true){
          ui->verticalSlider2->setOrientation(Qt::Vertical);
          ui->verticalSlider->setOrientation(Qt::Vertical);
          ui->verticalSlider2->setSizePolicy(QSizePolicy::Fixed,QSizePolicy::Expanding);
          ui->verticalSlider->setSizePolicy(QSizePolicy::Fixed,QSizePolicy::Expanding);

          ui->gridLayoutGradient->addWidget(btn_colorTop, 0, 2,Qt::AlignHCenter);
          ui->gridLayoutGradient->addWidget(btn_colorLeft, 1, 0 );
          ui->gridLayoutGradient->addWidget(ui->verticalSlider2, 1, 1);
          ui->gridLayoutGradient->addWidget(ui->widgetBack, 1, 2);
          ui->gridLayoutGradient->addWidget(ui->verticalSlider, 1, 3);
          ui->gridLayoutGradient->addWidget(btn_colorRight, 1, 4);
          ui->gridLayoutGradient->addWidget(btn_colorBot, 2, 2,Qt::AlignHCenter);

     }else{
          ui->verticalSlider2->setOrientation(Qt::Horizontal);
          ui->verticalSlider->setOrientation(Qt::Horizontal);
          ui->verticalSlider2->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Fixed);
          ui->verticalSlider->setSizePolicy(QSizePolicy::Expanding,QSizePolicy::Fixed);

          ui->gridLayoutGradient->addWidget(btn_colorLeft, 0, 1,Qt::AlignHCenter);
          ui->gridLayoutGradient->addWidget( ui->verticalSlider, 1, 1);
          ui-> gridLayoutGradient->addWidget(btn_colorBot, 2, 0);
          ui->gridLayoutGradient->addWidget( ui->widgetBack, 2, 1);
          ui->gridLayoutGradient->addWidget(btn_colorTop, 2, 2);
          ui->gridLayoutGradient->addWidget( ui->verticalSlider2, 3, 1);
          ui-> gridLayoutGradient->addWidget(btn_colorRight, 4, 1,Qt::AlignHCenter);
          QSpacerItem *verticalSpacerGr = new QSpacerItem(20, 20, QSizePolicy::Minimum, QSizePolicy::Expanding);

          ui-> gridLayoutGradient->addItem(verticalSpacerGr, 2, 3);


     }
}

//____________________________________________________________________________________
void DockDialogSettings::saveSetting()
{
     saveStyleQss();

     QSettings setting("elokab","settings");

     setting.beginGroup("Dock-Style");

     QString arrangement=EDGE::arrangementToString(ui->comboBoxArrangement->currentIndex());
     setting.setValue("Arrangement",arrangement);

     QString position=EDGE::posToString(ui->comboBoxPosition->currentIndex());
     setting.setValue("Position",position);

     setting.setValue("iconSize",ui->spinBoxIconSize->value());

     setting.setValue("animmationStyle",ui->comboBoxAnim->currentIndex());

     setting.setValue("Expanding",ui->checkBoxExpanding->isChecked());



     // setting.setValue("styleSheet",getStyle());


     setting.setValue("color1",colorToList(btn_colorTop->color()));

     setting.setValue("color2",colorToList(btn_colorRight->color()));

     setting.setValue("color3",colorToList(btn_colorBot->color()));

     setting.setValue("color4",colorToList(btn_colorLeft->color()));

     setting.setValue("colorBorder",colorToList(btn_colorBorder->color()));

     setting.setValue("colorSelect",colorToList(btn_colorSelect->color()));

//     setting.setValue("InfoBgrColor",btn_colorInfoBgr->color());

//     setting.setValue("InfoBorderColor",btn_colorInfoBorder->color());

//     setting.setValue("InfoFontColor",btn_colorInfoFont->color());

     setting.setValue("CustomToolTip",ui->cBoxCustumToolTip->isChecked());

     setting.setValue("stop",m_stop);

     setting.setValue("stop2",m_stop2);

     setting.setValue("pixFileName", ui->lineEditImageFile->text());

     setting.setValue("imageRepeat", ui->checkBoxRepeat->isChecked());


     setting.setValue("borderLeft", ui->spinBoxBleft->value());

     setting.setValue("borderRight", ui->spinBoxBright->value());

     setting.setValue("borderTop", ui->spinBoxBtop->value());

     setting.setValue("borderBot", ui->spinBoxBbottom->value());

     setting.setValue("backgroundStyle", ui->comboBoxBackStyle->currentIndex());

     setting.setValue("image3D", ui->comboBox3D->currentIndex());

     setting.setValue("showSelection",ui->checkBoxSelectionColor->isChecked());

     //setting.setValue("showPreview",ui->checkBoxPreview->isChecked());

     //setting.setValue("CssPath",QDir::homePath()+"/.config/elokab/dockTheme.css");

     setting.endGroup();
     //    QSettings settingIcons("elokab","elokabsettings");

     //    settingIcons.beginGroup("Themes");

     //      settingIcons.setValue("iconsTheme",ui->comboBoxIcons->currentText());
     //    settingIcons.endGroup();

    // iconsSetting->saveIconThemes();
}

//____________________________________________________________________________________
void DockDialogSettings::on_buttonBox_clicked(QAbstractButton *button)
{
     if(ui->buttonBox->standardButton(button)==QDialogButtonBox::Apply){
          saveSetting();
          emit accepteChange();

     }else   if(ui->buttonBox->standardButton(button)==QDialogButtonBox::Ok){
          saveSetting();
          emit accepteChange();
          this->accept();
     }
}

//____________________________________________________________________________________
void DockDialogSettings::on_verticalSlider_sliderMoved(int position)
{
     qreal q=position;
     QVariant d=q/100;
     m_stop=d.toString();
     getStyleGradien();
}

//____________________________________________________________________________________
void DockDialogSettings::on_verticalSlider2_sliderMoved(int position)
{
     qreal q=position;
     QVariant d=q/100;
     m_stop2=d.toString();
     getStyleGradien();
}

//____________________________________________________________________________________
QString DockDialogSettings::getStyleGradien()
{

     QString grad1=QString("stop:0 rgba(%1, %2, %3, %4), ")
               .arg(btn_colorTop->color().red()).arg(btn_colorTop->color().green())
               .arg(btn_colorTop->color().blue()).arg(btn_colorTop->color().alpha());
     QString grad2=QString("stop:%1 rgba(%2, %3, %4, %5),")
               .arg(m_stop).arg(btn_colorRight->color().red()).arg(btn_colorRight->color().green())
               .arg(btn_colorRight->color().blue()).arg(btn_colorRight->color().alpha());
     QString grad4=QString("stop:%1 rgba(%2, %3, %4, %5),")
               .arg(m_stop2).arg(btn_colorLeft->color().red()).arg(btn_colorLeft->color().green())
               .arg(btn_colorLeft->color().blue()).arg(btn_colorLeft->color().alpha());
     QString grad3=QString( "stop:1 rgba(%1, %2, %3, %4));")
               .arg(btn_colorBot->color().red()).arg(btn_colorBot->color().green())
               .arg(btn_colorBot->color().blue()).arg(btn_colorBot->color().alpha());
     QString borderRadius;



     if(ui->comboBoxPosition->currentIndex()==EDGE::POS_BOT){ //bottum edge
          borderRadius=QString("border-top-left-radius :%1px;"
                               "border-top-right-radius : %2px;") .arg(QString::number(ui->spinBoxBleft->value()))
                    .arg(QString::number(ui->spinBoxBright->value()));
     }else if(ui->comboBoxPosition->currentIndex()==EDGE::POS_TOP){ //top edge
          borderRadius=QString("border-bottom-left-radius :%1px;"
                               "border-bottom-right-radius :%2px;") .arg(QString::number(ui->spinBoxBleft->value()))
                    .arg(QString::number(ui->spinBoxBright->value()));
     }else if(ui->comboBoxPosition->currentIndex()==EDGE::POS_RIGHt){  //right edge
          borderRadius=QString("border-top-left-radius :%1px;"
                               "border-bottom-left-radius :%2px;") .arg(QString::number(ui->spinBoxBtop->value()))
                    .arg(QString::number(ui->spinBoxBbottom->value()));
     }else if(ui->comboBoxPosition->currentIndex()==EDGE::POS_LEFT){    //left edge
          borderRadius=QString("border-top-right-radius :%1px;"
                               "border-bottom-right-radius :%2px;") .arg(QString::number(ui->spinBoxBtop->value()))
                    .arg(QString::number(ui->spinBoxBbottom->value()));
     }

     QString styleBorder= QString("\n  border:	1px solid rgba(%1, %2, %3,%4);"
                                  " %5")
               .arg(btn_colorBorder->color().red()).arg(btn_colorBorder->color().green())
               .arg(btn_colorBorder->color().blue()).arg(btn_colorBorder->color().alpha()).arg(borderRadius);

     QString styleGradient;
     if(ui->comboBoxPosition->currentIndex()<2){    //horizontal gradient
          styleGradient= QString("QWidget #widgetBgr{background-color: qlineargradient(spread:pad,"
                                 "x1:0, y1:0, x2:0, y2:1, %1 %2 %3 %4")
                    .arg(grad1).arg(grad2).arg(grad4).arg(grad3);
     }else{                                            //verticale gradient
          styleGradient= QString("QWidget #widgetBgr{background-color: qlineargradient(spread:pad,"
                                 "x1:0, y1:0, x2:1, y2:0, %1 %2 %3 %4")
                    .arg(grad1).arg(grad2).arg(grad4).arg(grad3);
     }

     // background-color: qlineargradient(spread:pad, x1:0, y1:0, x2:1, y2:0,
     //stop:0 rgba(0, 0, 0, 255), stop:0.321429 rgba(0, 0, 255, 255), stop:0.668367 rgba(255, 0, 0, 255), stop:1 rgba(255, 255, 255, 255));
     ui->widgetBgr->setStyleSheet(styleGradient+styleBorder+"}");
     return styleGradient+styleBorder+"}";
}

//____________________________________________________________________________________
void DockDialogSettings::on_toolButtonImage_clicked()
{
     QString  fileName = QFileDialog::getOpenFileName(this,
                                                      tr("Open Image"), QDir::homePath(), tr("Image Files (*.png *.jpg *.bmp *.svg)"));

     if(!fileName.isEmpty()){
          ui->lineEditImageFile->setText(fileName);

     }
}

//____________________________________________________________________________________
void DockDialogSettings::saveStyleQss()
{


     QString myStyle,mystyleButton;

     if(ui->comboBoxBackStyle->currentIndex()==STYLE_GRAD){
          myStyle=getStyleGradien();
     }else if(ui->comboBoxBackStyle->currentIndex()==STYLE_IMAGE){
          myStyle=getStyleImage();
     }else if(ui->comboBoxBackStyle->currentIndex()==STYLE_3D){
          myStyle=getStyle3D();
     }


     mystyleButton=QString( "\n"
                             "QToolButton {\n"
                             " background-color:transparent;\n"
                             "  border: 1px solid  transparent;\n"
                             "  border-radius: 4px;\n"
                             " }"
                            "\n"
                             "QAction#DockButtonTask {\n"
                             "background-color: qconicalgradient(cx:0.5, cy:0.9, angle:90,"
                             "stop:0.324022 rgba(255, 0, 0, 0), stop:0.357542 rgba(0, 0, 0, 0),"
                             "stop:0.385475 rgba(%1, %2, %3, 255), stop:0.597765 rgba(%1, %2, %3, 255),"
                             "stop:0.625698 rgba(0, 0, 0, 0), stop:0.670391 rgba(255, 0, 0, 0));"
                             "  border-radius: 4px;\n"
                             " }"
                            "\n"
                             "  QToolButton:checked {\n"
                             "  border: 1px solid  rgba(%1, %2, %3, %4);\n"
                             "  border-radius: 4px;}\n"
                            "\n"
                             "  QToolButton:checked:hover {\n"
                             "  border: 1px solid  rgba(%1, %2, %3, %4);\n"
                             "  border-radius: 4px;}"
                             ).arg(btn_colorSelect->color().red()).arg(btn_colorSelect->color() .green()).arg(btn_colorSelect->color().blue())
               .arg(btn_colorSelect->color().alpha()) ;
     QString mystyleButtonHover;
     if(ui->checkBoxSelectionColor->isChecked()){
          mystyleButtonHover=QString("\n  QToolButton:hover {\n"
                                     "  background-color:  rgba(%1, %2, %3, %4);\n"
                                     "  border: 1px solid  rgba(%5, %6, %7, %8);\n"
                                     "  border-radius: 4px;\n"
                                     "      }\n"
                                     "  QToolButton:hover {\n"
                                     "  background-color: rgba(%1, %2, %3, %4);\n"
                                     "  border: 1px solid  rgba(%5, %6, %7, %8)\n;"
                                     "  border-radius: 4px;\n"
                                     "      }")
                    .arg(btn_colorSelect->color().red()).arg(btn_colorSelect->color() .green()).arg(btn_colorSelect->color().blue())
                    .arg(btn_colorSelect->color().alpha()) .arg(btn_colorBorder->color().red()).arg(btn_colorBorder->color() .green())
                    .arg(btn_colorBorder->color().blue()).arg(btn_colorBorder->color().alpha());


     }else{
          mystyleButtonHover=QString(" \n QToolButton:hover {\n"
                                     "  background-color: transparent;\n"
                                     "  border: 1px solid  transparent;}\n"
                                     "  QToolButton#btnTask:hover {"
                                     "  background-color: transparent;\n"
                                     "  border: 1px solid  transparent;\n}");
     }
     QFile fileCsv(QDir::homePath()+"/.config/elokab/dockTheme.css");
     if (!fileCsv.open(QFile::WriteOnly)){
          //    return ;
          qDebug()<<QDir::homePath()+"/.config/dockTheme.css";
     }
     QTextStream out(&fileCsv);
     out.setCodec(QTextCodec::codecForLocale());
     out<<myStyle+mystyleButton+mystyleButtonHover;
     //   return myStyle+mystyleButton+mystyleButtonHover;
}

//____________________________________________________________________________________
QString DockDialogSettings::getStyleImage()
{
     QString myStyle;
     QString borderRadius;
     if(ui->checkBoxRepeat->isChecked()){
          if(ui->comboBoxPosition->currentIndex()==EDGE::POS_BOT){
               borderRadius=QString("border-top-left-radius :%1px;"
                                    "border-top-right-radius : %2px;") .arg(QString::number(ui->spinBoxBleft->value()))
                         .arg(QString::number(ui->spinBoxBright->value()));
          }else if(ui->comboBoxPosition->currentIndex()==EDGE::POS_TOP){
               borderRadius=QString("border-bottom-left-radius :%1px;"
                                    "border-bottom-right-radius :%2px;") .arg(QString::number(ui->spinBoxBleft->value()))
                         .arg(QString::number(ui->spinBoxBright->value()));
          }else if(ui->comboBoxPosition->currentIndex()==EDGE::POS_RIGHt){
               borderRadius=QString("border-top-left-radius :%1px;"
                                    "border-bottom-left-radius :%2px;") .arg(QString::number(ui->spinBoxBleft->value()))
                         .arg(QString::number(ui->spinBoxBright->value()));
          }else if(ui->comboBoxPosition->currentIndex()==EDGE::POS_LEFT){
               borderRadius=QString("border-top-right-radius :%1px;"
                                    "border-bottom-right-radius :%2px;") .arg(QString::number(ui->spinBoxBleft->value()))
                         .arg(QString::number(ui->spinBoxBright->value()));
          }

          QString styleBorder= QString("\n  border:	1px solid rgba(%1, %2, %3,%4);"
                                       " %5")
                    .arg(btn_colorBorder->color().red()).arg(btn_colorBorder->color().green())
                    .arg(btn_colorBorder->color().blue()).arg(btn_colorBorder->color().alpha()).arg(borderRadius);


          myStyle=  QString("QWidget #widgetBgr{"
                            " background-image: url(%1) %2 %3 %4 %5;"
                            "background-repeat: repeat-xy;"
                            " border-top:%2 px transparent;"
                            " border-left: %3px transparent;"
                            " border-bottom:%4 px transparent;"
                            " border-right: %5px transparent;"


                            ).arg(ui->lineEditImageFile->text())
                    .arg(QString::number(ui->spinBoxBtop->value()))
                    .arg(QString::number(ui->spinBoxBleft->value()))
                    .arg(QString::number(ui->spinBoxBbottom->value()))
                    .arg(QString::number(ui->spinBoxBright->value()));

          myStyle=myStyle+styleBorder+ " }";
          qDebug()<<myStyle+styleBorder;
     }else{
          myStyle= QString("QWidget #widgetBgr{"
                           "border-image: url(%1) %2 %3 %4 %5;"
                           " border-top:%2 px transparent;"
                           " border-left: %3px transparent;"
                           " border-bottom:%4 px transparent;"
                           " border-right: %5px transparent;"
                           " }"

                           ).arg(ui->lineEditImageFile->text())
                    .arg(QString::number(ui->spinBoxBtop->value()))
                    .arg(QString::number(ui->spinBoxBleft->value()))
                    .arg(QString::number(ui->spinBoxBbottom->value()))
                    .arg(QString::number(ui->spinBoxBright->value()));
     }

     return myStyle;
}

//____________________________________________________________________________________
QString DockDialogSettings::getStyle3D()
{

     QString imageName=ui->comboBox3D->itemData(ui->comboBox3D->currentIndex()).toString();
     QString style3d;
     if(ui->comboBoxPosition->currentIndex()==EDGE::POS_BOT){
          ui->spinBoxBtop->setValue(0);
          ui->spinBoxBleft->setValue(30);
          ui->spinBoxBbottom->setValue(7);
          ui->spinBoxBright->setValue(30);
          style3d=QString("QWidget #widgetBgr{"
                          "border-image: url(%1) 0 30 0 30;"
                          " border-top:%2 px transparent;"
                          " border-bottom:0px transparent;"
                          " border-right: 30px transparent;"
                          "  border-left: 30px transparent;"
                          " }"

                          ).arg(imageName).arg(ui->spinBoxIconSize->value()/2+8);

     }else if(ui->comboBoxPosition->currentIndex()==EDGE::POS_TOP){
          imageName+="Top";
          ui->spinBoxBtop->setValue(7);
          ui->spinBoxBleft->setValue(30);
          ui->spinBoxBbottom->setValue(0);
          ui->spinBoxBright->setValue(30);
          style3d=QString("QWidget #widgetBgr{"
                          "border-image: url(%1) 0 30 0 30;"
                          " border-top:0 px transparent;"
                          " border-bottom:%2 px transparent;"
                          " border-right: 30px transparent;"
                          "  border-left: 30px transparent;"
                          " }"

                          ).arg(imageName).arg(ui->spinBoxIconSize->value()/2+8);
     }else if(ui->comboBoxPosition->currentIndex()==EDGE::POS_RIGHt){
          ui->spinBoxBtop->setValue(30);
          ui->spinBoxBleft->setValue(0);
          ui->spinBoxBbottom->setValue(30);
          ui->spinBoxBright->setValue(7);
          imageName+="Right";
          style3d=QString("QWidget #widgetBgr{"
                          "border-image: url(%1) 30 0 30 0;"
                          " border-top:30 px transparent;"
                          " border-bottom:30px transparent;"
                          " border-right: 0px transparent;"
                          "  border-left: %2px transparent;"
                          " }"

                          ).arg(imageName).arg(ui->spinBoxIconSize->value()/2+8);
     }else if(ui->comboBoxPosition->currentIndex()==EDGE::POS_LEFT){
          ui->spinBoxBtop->setValue(30);
          ui->spinBoxBleft->setValue(7);
          ui->spinBoxBbottom->setValue(30);
          ui->spinBoxBright->setValue(0);
          imageName+="Left";
          style3d=QString("QWidget #widgetBgr{"
                          "border-image: url(%1) 30 0 30 0;"
                          " border-top:30 px transparent;"
                          " border-bottom:30px transparent;"
                          " border-right: %2px transparent;"
                          "  border-left: 0px transparent;"
                          " }"

                          ).arg(imageName).arg(ui->spinBoxIconSize->value()/2+8);
     }

     //  QString imageName=ui->comboBox3D->itemData(ui->comboBox3D->currentIndex()).toString();


     return style3d;
}


//____________________________________________________________________________________
void DockDialogSettings::on_comboBoxPosition_activated(int index)
{
     if(index<2)
          setupGradientTools(true);
     else
          setupGradientTools(false);

     getStyleGradien();
}
