/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DIALOGSETTINGS_H
#define DIALOGSETTINGS_H
//#include "icontheme/widgeticonsthemes.h"
//#include "buttoncolor/buttoncolor.h"
#include "commonedge.h"
#include "buttonColor/buttoncolor.h"
#include <QDialog>
#include <QAbstractButton>

#define GRAD_TOP   1
#define GRAD_RIGHT   2
#define GRAD_BOT   3
#define GRAD_LEFT  4
#define COLOR_BORDER  5
#define COLOR_SELECT  6

//#define POS_BOT 0
//#define POS_TOP 1
//#define POS_RIGHT 2
//#define POS_LEFT 3

//#define TYPE_AUTO 0
//#define TYPE_SPACE 1
//#define TYPE_TOP 2
//#define TYPE_BOT 3

namespace Ui {
class DialogSettings;
}

class DockDialogSettings : public QDialog
{
    Q_OBJECT

public:
    explicit DockDialogSettings(QWidget *parent = 0);
    ~DockDialogSettings();
signals :
    void accepteChange();
private:
    Ui::DialogSettings *ui;


    QString m_stop,m_stop2;
    QString m_iconsTheme;

   // widgetIconsThemes *iconsSetting;

    ButtonColor *btn_colorTop,*btn_colorRight,*btn_colorBot,*btn_colorLeft;
    ButtonColor  *btn_colorBorder,*btn_colorSelect;
   // ButtonColor  *btn_colorInfoBgr,*btn_colorInfoBorder,*btn_colorInfoFont;
private slots:
    QString getDirIconTeme(QString dir);
    void loadSetting();

    void saveSetting();

    void on_buttonBox_clicked(QAbstractButton *button);


    void on_verticalSlider_sliderMoved(int position);

    void on_verticalSlider2_sliderMoved(int position);

    void setupGradientTools(bool horizontal);
    void on_toolButtonImage_clicked();

    QString getStyleGradien();

    void saveStyleQss();

    QString getStyleImage();

    QString getStyle3D();



   // void on_comboBoxScreenEdge_activated(const QString);

    void on_comboBoxPosition_activated(int index);
};

#endif // DIALOGSETTINGS_H
