/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "dockforminfo.h"
#include "ui_forminfo.h"
#include <QSettings>

//____________________________________________________________________________________
DockFormInfo::DockFormInfo(QWidget *parent) :
        QWidget(parent),
        ui(new Ui::FormInfo)
{
        ui->setupUi(this);

        setWindowFlags(Qt::FramelessWindowHint|Qt::ToolTip| Qt::CustomizeWindowHint);
         this->setAttribute(Qt::WA_TranslucentBackground,true);
        loadSettings();
}

//____________________________________________________________________________________
DockFormInfo::~DockFormInfo()
{
        delete ui;
}

//____________________________________________________________________________________
void   DockFormInfo::setTitle(QString title)
{
        ui->labelTitle->setText(title);
}

//____________________________________________________________________________________
void   DockFormInfo::setPixmap(QPixmap pix)
{
        ui->labelPixmap->setPixmap(pix);
}

//____________________________________________________________________________________
void   DockFormInfo::setpreview(QPixmap pix,bool v)
{
    ui->labelPreview->setVisible(v);
        ui->labelPreview->setPixmap(pix);

}

//____________________________________________________________________________________
void   DockFormInfo::loadSettings()
{
        QSettings setting("elokab","settings");

        setting.beginGroup("Dock-Style");
        QColor   InfoBgrColor=setting.value("InfoBgrColor",QColor(76, 76, 76, 255)).value<QColor>();
        QColor   InfoBorderColor=setting.value("InfoBorderColor",QColor(34, 34,34,255)).value<QColor>();
        QColor   InfoFontColor=setting.value("InfoFontColor",QColor(255, 255, 255,255)).value<QColor>();
        setting.endGroup();
         QString txt=QString("QWidget#widgetBgr{ background-color: rgba(%1, %2, %3, %4);"
                "border-style: outset;"
                "border-width: 1px;"
                "border-radius: 5px;"
                "border-color: rgba(%5, %6, %7, %8);"
                "padding: 6px;"
                "}").arg(InfoBgrColor.red())
                        .arg(InfoBgrColor.green())
                        .arg(InfoBgrColor.blue())
                        .arg(InfoBgrColor.alpha())
                        .arg(InfoBorderColor.red())
                        .arg(InfoBorderColor.green())
                        .arg(InfoBorderColor.blue())
                        .arg(InfoBorderColor.alpha())    ;
        ui->widgetBgr->setStyleSheet(txt);
        QString txtFont=QString("color:%1;").arg(InfoFontColor.name());
        ui->labelTitle->setStyleSheet(txtFont);
}

