/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "docklayout.h"
#include "dockbutton.h"
#include <QFrame>
#include <QDebug>

//____________________________________________________________________________________
DockLayout::DockLayout(QWidget * parent)
     : QGridLayout(parent)

{
     setSpacing(1);
     setContentsMargins(1, 1, 1,1);
     setSizeConstraint(QLayout::SetMaximumSize);
     menu=new QMenu;
     m_spacer = new QSpacerItem(5, 5);

}

//____________________________________________________________________________________
void DockLayout::addWidget(DockButton *b)
{
     m_buttons << b;
     relayout();
}

//____________________________________________________________________________________
void DockLayout::addWidget(DockActionTask *b)
{
     m_buttonsTaskbar << b;
     relayout();
     // QHBoxLayout::insertWidget(index,b)
}
//____________________________________________________________________________________
void DockLayout::insertWidget(DockActionTask */*btnTask*/,DockButton */*btn*/)
{

   //  relayout();

}
//____________________________________________________________________________________
void DockLayout::removeWidget(DockButton *b)
{
     m_buttons.removeAll(b);


     relayout();
}

//____________________________________________________________________________________
void DockLayout::removeWidget(DockActionTask *b)
{
     m_buttonsTaskbar.removeAll(b);

     relayout();
}

//____________________________________________________________________________________
DockButton* DockLayout::buttonAt(int index)
{
     if ((index >= 0) && (index < m_buttons.size()))
          return m_buttons[index];
     return NULL;
}
DockActionTask* DockLayout::buttonTaskAt(int index)
{
     if ((index >= 0) && (index < m_buttonsTaskbar.size()))
          return m_buttonsTaskbar[index];
     return NULL;
}

//____________________________________________________________________________________
void DockLayout::swapButtons(DockButton * b1, DockButton *b2)
{
     int tmp1 = indexOf(b1);
     int tmp2 = indexOf(b2);

     if (tmp1 != tmp2)
     {
          m_buttons.swap(tmp1, tmp2);
          relayout();
     }
}

//____________________________________________________________________________________
void DockLayout::relayout()
{
     /*
        QLayoutItem *child;
        while ((child = takeAt(0)) != 0)
        {
               //   qDebug()<<child->geometry();
                  delete child;
        }
        // addSpacing(10);

        foreach (QuickLaunchButton *b, m_buttons)
        {
               QGridLayout::addWidget(b);

        }

        */


     QGridLayout::removeItem(m_spacer);

     QLayoutItem *child;
     while ((child = takeAt(0)) != 0)
     {
          //  qDebug()<<"geometry---------------"<<child->geometry();
          delete child;
     }



     int col = 0;
     int row = 0;



     foreach (DockButton *b, m_buttons)
     {


          QGridLayout::addWidget(b, row, col);
          if (isHorizontal==true){++col;}
          else{  ++row; }

     }

//     foreach (DockActionTask *b, m_buttonsTaskbar)
//     {

//          QGridLayout::addWidget(b, row, col);

//          if (isHorizontal==true) { ++col;}
//          else{ ++row; }

//     }
     //   QRect screenAvailable = QApplication::desktop()->availableGeometry(-1);
     //int maxItem;
     //         if (isHorizontal==true) {
     //               maxItem= screenAvailable.width()/(m_sizeH+8);
     //         }else{
     //              maxItem= screenAvailable.height()/(m_sizeH+8);
     //         }

     //        if(isExpanding==true){
     //                if (isHorizontal==true) {
     //                        ++col;
     //                        QSpacerItem *verticalSpacerGr = new QSpacerItem(5, 5, QSizePolicy::Expanding,QSizePolicy::Minimum);

     //                        QGridLayout::addItem(verticalSpacerGr, row, col);
     //                }
     //                else{
     //                        ++row;
     //                        QSpacerItem *verticalSpacerGr = new QSpacerItem(5, 5,QSizePolicy::Minimum ,QSizePolicy::Expanding);
     //                        QGridLayout::addItem(verticalSpacerGr, row, col);
     //                }
     //        }

     if(isExpanding==true){
          if (isHorizontal==true) {
               ++col;
               //  QSpacerItem *verticalSpacerGr = new QSpacerItem(5, 5, QSizePolicy::Expanding,QSizePolicy::Minimum);
               m_spacer->changeSize(5, 5, QSizePolicy::Expanding,QSizePolicy::Minimum);
               QGridLayout::addItem(m_spacer, row, col);
          }
          else{
               ++row;
               //    QSpacerItem *verticalSpacerGr = new QSpacerItem(5, 5,QSizePolicy::Minimum ,QSizePolicy::Expanding);
               m_spacer->changeSize(5, 5,QSizePolicy::Minimum ,QSizePolicy::Expanding);
               QGridLayout::addItem(m_spacer, row, col);

          }
     }



}

