/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef QUICKLAUNCHLAYOUT_H
#define QUICKLAUNCHLAYOUT_H
#include <QHBoxLayout>
#include <QGridLayout>
#include "dockactiontask.h"
class DockButton;
class DockActionTask;
class DockLayout : public QGridLayout
{
    Q_OBJECT
public:
    explicit  DockLayout(QWidget *parent = 0);

    void addWidget(DockButton *b);
    void addWidget(DockActionTask *b);
void insertWidget(DockActionTask *, DockButton *);
    void removeWidget(DockButton *b);
    void removeWidget(DockActionTask *b);
    void swapButtons(DockButton * b1, DockButton *b2);
    DockButton* buttonAt(int index);
    DockActionTask* buttonTaskAt(int index);

    QList<DockButton*> buttons() { return m_buttons; }
    //         QList<DActionTaskbar*> buttonsTaskbar() { return m_buttonsTaskbar; }

    void setSizeH(int size)
    {
        m_sizeH=     size;
    }
    void setHorizontalLayout(bool horizontal,bool expanding)
    {
        isHorizontal= horizontal;
        isExpanding=expanding;
        relayout();
    }



private:
    //RazorPanel *m_panel;
    QList<DockButton*> m_buttons;
    QList<DockActionTask*> m_buttonsTaskbar;
    QList<QLabel*> m_label;
    int m_sizeH;
    bool isHorizontal;
    bool isExpanding;
    QMenu *menu;
    QSpacerItem *m_spacer;
private slots:
    void relayout();
public slots:

};

#endif // QUICKLAUNCHLAYOUT_H
