/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef DIALOGADDPLUGINS_H
#define DIALOGADDPLUGINS_H

#include <QDialog>
#include <QAbstractButton>
namespace Ui {
class DialogAddPlugins;
}
class DialogAddPlugins : public QDialog
{
          Q_OBJECT

public:
          explicit DialogAddPlugins(QWidget *parent = 0);
          ~DialogAddPlugins();

signals:
          void addPlugin(QString plugin);
          void unloadPlugin(QString Plugin);
          void accepteChange();
private:
          Ui::DialogAddPlugins *ui;
          QStringList   m_listPluginsFiles;
private slots:
          void loadPlugins();
          void loadAvailablePlugins();
          void loadSetting();
          void saveSetting();
          void on_buttonBox_clicked(QAbstractButton *button);
          void on_toolButtonRemove_clicked();
          void on_toolButtonAdd_clicked();
          void on_toolButtonUp_clicked();
          void on_toolButtonDown_clicked();
          QStringList openEntry(const QString &fileName);
};

#endif // DIALOGADDPLUGINS_H
