//
// C++ Interface: common
//
// Author: Oliver Groß <z.o.gross@gmx.de>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
#ifndef QBAT_COMMON_H
#define QBAT_COMMON_H

#include <QString>

#include "constants.h"

#define BUF_SIZE 256

namespace qbat {

	
	bool readStringFromFile(char * buffer, const char * fileName);
	int readIntSysFile(const char * fileName);
	int toStatusInt(const char * status);
	
	inline qint8 calcRelativeDef(int value, int border, qint8 defValue = -1) {
		return border ? (qint8)(100.0 * value / border) : defValue;
	}
}

#endif
