/* Compal Laptop Control
 * Author: Krzemin <pkrzemin@o2.pl>
 * WWW: http://krzemin.iglu.cz
 * This software is distributed under the GNU General Public License.
 */

#ifndef __COMPAL__H__
#define __COMPAL__H__

#include <QString>
#include <QFile>
#include <QFileInfo>
#include <QTextStream>
#include <QObject>

class CompalLaptop
{
	public:
		
		bool init();
		

		bool isLcdAvailable();

		int lcdStatus();
		int lcdMax();

		

		void setLcdStatus(int status);


		

		
		QString getLcdFile()
		{
			return lcdCurrentFile;
		}

		
		QString lastError()
		{
			return error;
		}
		
	private:
		
		QString error;
        QString lcdMaxFile, lcdCurrentFile, lcdSetFile;
		
		int readFromFile(const QString & file);
		void writeToFile(const QString & file, int value);
		
};

#endif
