#include "dbattery.h"
#include "batteryicon.h"
#include "ui_dbattery.h"
#include <EIcon>
Dbattery::Dbattery(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Dbattery),m_capacity(0)
{
    ui->setupUi(this);
     setObjectName("Battery");
     powerm=new CPowerManager(this);
     connect(powerm,SIGNAL(batteryChanged()),this,SLOT(updateBattIcon()));

     mWidgetPopup=new WidgetPopup(this);
      batteryDlg=new BatteryDlg(mWidgetPopup);
      mWidgetPopup->setWidget(batteryDlg);
   //
    lcdTimer=new QTimer;
    initLcd();
}

Dbattery::~Dbattery()
{
    delete ui;
}

void Dbattery::initLcd()
{
    if(!compal.init())
    {
        QMessageBox::critical(	this,
                                tr("Error"),
                                QString("%1\n\n%2")
                                .arg(compal.lastError())
                                .arg(tr("See %1/README for details.")));


        return ;
    }

    int max = compal.lcdMax();
    if(max > 0)
    {
        batteryDlg->setBrightnessMax(max);
    }
    m_lcd=compal.lcdStatus()* 100 / compal.lcdMax();

    connect(lcdTimer,SIGNAL(timeout()),this,SLOT(updatelcdStatus()));
    lcdTimer->start(500);
    batteryDlg->setBatteryVisible(false);
   // batteryDlg->resize(300,85);
   // video-display.
}
void Dbattery::updatelcdStatus()
{

    static int lcd;
    lcd = compal.lcdStatus()*100/ compal.lcdMax();


    if(lcd!=m_lcd){


        m_lcd=lcd;
        qDebug()<<"lcdStatus:"<<compal.lcdStatus();
        qDebug() <<"lcdMax:" <<compal.lcdMax();
        qDebug()<<lcd<<"%";
        batteryDlg->startTimeHide();

        batteryDlg->setBrightness(m_lcd);
        if(batteryDlg->isVisible()){


        }else{
            batteryDlg->setBatteryVisible(false);

            showPopup();


        }
        //show();
    }




//    QString toolTipStr= tr("LCD brightness:") + QString(" %1%").arg(lcd );

//	emit toolTipChange(toolTipStr);
}
void Dbattery::mouseReleaseEvent(QMouseEvent* event)
{

    if (event->button() != Qt::LeftButton)
        return;

    batteryDlg->setBatteryVisible(true);

    batteryDlg->setIcon(updatePixmap());
    batteryDlg->setText(toolTip());
    batteryDlg->setValue(m_capacity);
    batteryDlg->setBrightness(m_lcd);
 showPopup();




}
void Dbattery::showPopup()
{

      //  batteryDlg->show();
        int mPosbtn=mapToGlobal(QPoint(geometry().width()/2,geometry().bottom()/2)).x();

        int wW=(this->width()/2);

        mWidgetPopup->open(mapToGlobal(QPoint(geometry().width()-wW,geometry().bottom()))
                      , mPosbtn);
        /*
    int mPosbtn=mapToGlobal(QPoint(geometry().width()/2,geometry().bottom()/2)).x();
    QPoint mPos;
    Qt::Corner mAnchor;
    if (isLeftToRight())
    {
        mPos=mapToGlobal(QPoint(0,geometry().bottom()));
        mAnchor= Qt::TopLeftCorner;
    }else{

        mPos=mapToGlobal(QPoint(geometry().width(),geometry().bottom()));
        mAnchor=Qt::TopRightCorner;
    }
     //qDebug()<<"mPos   "<<mPos;
    QRect rect;
    rect.setSize(QSize(300,hight));
    switch (mAnchor)
    {
    case Qt::TopLeftCorner:
        rect.moveTopLeft(mPos);
        break;

    case Qt::TopRightCorner:
        rect.moveTopRight(mPos);
        break;
    }

    QRect screen = QApplication::desktop()->availableGeometry(mPos);

    if (rect.right() > screen.right())
        rect.moveRight(screen.right());
    if (rect.left()< screen.left())
        rect.moveLeft(screen.left());
    if (rect.bottom() > screen.bottom()){
        rect.moveBottom(screen.bottom());
        batteryDlg->setScreenBotum(true,mPosbtn-rect.left()-22);
    }else{
        batteryDlg->setScreenBotum(false,mPosbtn-rect.left()-22);
    }
 batteryDlg-> move(rect.topLeft());
 */
}

void Dbattery::setSize(QSize size)
{
    m_size=size;
       // setIconSize(size);
        setMaximumSize(size);
        setMinimumSize(size);
         updateIcon();
}
void Dbattery::updateBattIcon()
{
//    updatelcdStatus(QString());
//    if(batteryDlg->isVisible()){

//       batteryDlg->setBrightness(m_lcd);
//    }
   int status=powerm->DefaultIcon->data().status;
   int capacity=powerm->DefaultIcon->data().relativeCharge;
   if(status!=m_status||capacity!=m_capacity)
   {
    m_status= status;
    m_capacity= capacity;
     updateIcon();
     QString msg;
     switch (m_status) {
     case UI_BATTERY_DISCHARGING:
         msg = QString(tr(" %1 %2%")).arg(tr("Discharging")).arg(QString::number(m_capacity));
         break;
     case UI_BATTERY_CHARGING:
         msg += tr(" %1 %2%").arg(tr("Charging")).arg(QString::number(m_capacity));
         break;
     case UI_BATTERY_FULL:
         msg = tr(" %1 %2%").arg(tr("Full")).arg(QString::number(m_capacity));
         break;
     default:
         msg = tr("status: %1").arg(tr("unknown"));
         break;
     }
     setToolTip(msg);
    // updateToolTip();
     if(batteryDlg->isVisible()){
    //     qDebug()<<"battery updated----------<<<";

        batteryDlg->setIcon(updatePixmap());
        batteryDlg->setText(toolTip());
        batteryDlg->setValue(m_capacity);

     }
   }

}

void Dbattery::updateIcon() {
    QPixmap pix(40,40);
    pix.fill(Qt::transparent);
    int cap=m_capacity;

    int charged = (int)(27 * cap / 100.0);
    //qDebug()<<"charged"<<charged;
    QPainter painter;
    QColor color=this->palette().text().color();

    painter.begin(&pix);
    painter.setPen(color);

    //
    painter.drawRect(6, 1, 10, 4);
    painter.drawRect(1, 5, 20, 34);


    //
    painter.fillRect(5,9+(27-charged),13,charged,color);

    //
    if (m_status == UI_BATTERY_CHARGING){

        QPolygonF polygon;
        polygon << QPointF(33.5, 7.5) << QPointF(23.5, 19.0)
                << QPointF(29.0, 19.0)<< QPointF(33.5, 7.5);

        QPolygonF polygon2;
        polygon << QPointF(26.0, 29.5) << QPointF(30.5, 16.5)
                << QPointF(35.5, 16.5)<< QPointF(26.0, 29.5);

        QPainterPath myPath;

        myPath.addPolygon(polygon);
        myPath.addPolygon(polygon2);
        painter.setBrush(color);

        painter.drawPath(myPath);
    }
    if (m_status == UI_BATTERY_FULL){

        painter.fillRect(6, 1, 10, 4,color);
    }
    ui->label->setPixmap(pix);

}

QPixmap Dbattery::updatePixmap()
{
    QIcon icon=EIcon::fromTheme("battery");;
     int cap=m_capacity;

    switch (m_status) {
    case UI_BATTERY_FULL:
        icon=EIcon::fromTheme("battery-full",("gpm-battery-charged"));
        qDebug()<<"UI_BATTERY_FULL";;
        break;
    case UI_BATTERY_CHARGING:
        qDebug()<<"UI_BATTERY_CHARGING";;
        if(cap<10)
            icon=EIcon::fromTheme("battery-charging-low",("gpm-battery-000-charging"));
        else if(cap<=20)
            icon=EIcon::fromTheme("battery-charging-caution",("gpm-battery-020-charging"));
        else if(cap<=40)
            icon=EIcon::fromTheme("battery-charging-040",("gpm-battery-040-charging"));
        else if(cap<=60)
            icon=EIcon::fromTheme("battery-charging-060",("gpm-battery-060-charging"));
        else if(cap<=80)
            icon=EIcon::fromTheme("battery-charging-080",("gpm-battery-080-charging"));
        else
            icon=EIcon::fromTheme("battery-charging-100",("gpm-battery-100-charging"));

        break;
    case UI_BATTERY_DISCHARGING:
          qDebug()<<"UI_BATTERY_DISCHARGING";;
        if(cap<10)
            icon=EIcon::fromTheme("battery-low",("gpm-battery-000"));
        else if(cap<=20)
            icon=EIcon::fromTheme("battery-caution",("gpm-battery-020"));
        else if(cap<=40)
            icon=EIcon::fromTheme("battery-040",("gpm-battery-040"));
        else if(cap<=60)
            icon=EIcon::fromTheme("battery-060",("gpm-battery-060"));
        else if(cap<=80)
            icon=EIcon::fromTheme("battery-080",("gpm-battery-080"));
        else
            icon=EIcon::fromTheme("battery-100",("gpm-battery-100"));


        break;
    default:
        icon=EIcon::fromTheme("battery");
        break;
    }
 return (icon.pixmap(32));
    //setIcon(icon);
}

void Dbattery::updateToolTip() {
    QString newToolTip = tr("%1: %2%").arg(powerm->DefaultIcon->data().name) +'\n';

    if (powerm->DefaultIcon->data().relativeCharge == -1)
        newToolTip = newToolTip.arg('-');
    else
        newToolTip = newToolTip.arg(powerm->DefaultIcon->data().relativeCharge);

    switch (powerm->DefaultIcon->data().status) {
    case UI_BATTERY_DISCHARGING:
        newToolTip += tr("status: %1").arg(tr("discharging"));
        if (powerm->DefaultIcon->data().rate) {
            newToolTip += '\n';
            qreal remainingTime  = (qreal)(powerm->DefaultIcon->data().currentCapacity) / powerm->DefaultIcon->data().rate;
            int remainingHours   = (int)remainingTime;
            int remainungMinutes = (int)(remainingTime * 60) % 60;
            newToolTip += tr("remaining time: %1:%2").arg(remainingHours, 2, 10, QChar('0')).arg(remainungMinutes, 2, 10, QChar('0'));
        }
        break;
    case UI_BATTERY_CHARGING:
        newToolTip += tr("status: %1").arg(tr("charging"));
        if (powerm->DefaultIcon->data().rate && powerm->DefaultIcon->data().fullCapacity) {
            newToolTip += '\n';
            qreal remainingTime  = (qreal)(powerm->DefaultIcon->data().fullCapacity - powerm->DefaultIcon->data().currentCapacity) / powerm->DefaultIcon->data().rate;
            int remainingHours   = (int)remainingTime;
            int remainungMinutes = (int)(remainingTime * 60) % 60;
            newToolTip += tr("remaining time: %1:%2").arg(remainingHours, 2, 10, QChar('0')).arg(remainungMinutes, 2, 10, QChar('0'));
        }
        break;
    case UI_BATTERY_FULL:
        newToolTip += tr("status: %1").arg(tr("full"));
        break;
    default:
        newToolTip += tr("status: %1").arg(tr("unknown"));
        break;
    }
    newToolTip += '\n';

    if (powerm->DefaultIcon->data().energyUnits) {
        if ((powerm->DefaultIcon->data().rate) && (powerm->DefaultIcon->data().status != UI_BATTERY_FULL)) {
            double rateW = qRound(powerm->DefaultIcon->data().rate / 100000.0) / 10.0;
            if (powerm->DefaultIcon->data().voltage) {
                double rateA = qRound((powerm->DefaultIcon->data().rate / powerm->DefaultIcon->data().voltage) / 1000.0) / 10.0;
                newToolTip += tr("current rate: %1W / %2A").arg(rateW).arg(rateA) + '\n';
            }
            else
                newToolTip += tr("current rate: %1W").arg(rateW) + '\n';
        }

        newToolTip += tr("current capacity: %1mWh").arg(powerm->DefaultIcon->data().currentCapacity / 1000);

        if (powerm->DefaultIcon->data().fullCapacity)
            newToolTip += '\n' + tr("last full capacity: %1mWh").arg(powerm->DefaultIcon->data().fullCapacity / 1000);

        if (powerm->DefaultIcon->data().designCapacity)
            newToolTip += '\n' + tr("design capacity: %1mWh").arg(powerm->DefaultIcon->data().designCapacity / 1000);
    }
    else
    {
        if ((powerm->DefaultIcon->data().rate) && (powerm->DefaultIcon->data().status != UI_BATTERY_FULL)) {
            double rateA = powerm->DefaultIcon->data().rate / 100000.0;
            if (powerm->DefaultIcon->data().voltage) {
                double rateW = qRound(rateA * powerm->DefaultIcon->data().voltage / 100.0) / 10.0;
                newToolTip += tr("current rate: %1W / %2A").arg(rateW).arg(qRound(rateA) / 10.0) + '\n';
            }
            else
                newToolTip += tr("current rate: %1A").arg(qRound(rateA) / 10.0) + '\n';
        }

        newToolTip += tr("current capacity: %1mAh").arg(powerm->DefaultIcon->data().currentCapacity / 1000);

        if (powerm->DefaultIcon->data().fullCapacity)
            newToolTip += '\n' + tr("last full capacity: %1mAh").arg(powerm->DefaultIcon->data().fullCapacity / 1000);

        if (powerm->DefaultIcon->data().designCapacity)
            newToolTip += '\n' + tr("design capacity: %1mAh").arg(powerm->DefaultIcon->data().designCapacity / 1000);
    }

    if (powerm->DefaultIcon->data().designCapacity && powerm->DefaultIcon->data().fullCapacity < powerm->DefaultIcon->data().designCapacity)
            newToolTip += '\n' + tr("capacity loss: %1%").arg((int)((1 - (double)powerm->DefaultIcon->data().fullCapacity / powerm->DefaultIcon->data().designCapacity) * 100));

    setToolTip(newToolTip);
}
/*
 void Dbattery::loadSettings() {
     QSettings m_SettingsFile;
    m_SettingsFile.beginGroup("Main");
    m_Settings.pollingRate = m_SettingsFile.value("pollingRate", 3000).toUInt();
    m_Settings.showBalloon = m_SettingsFile.value("showBalloon", false).toBool();
    m_SettingsFile.endGroup();

    m_SettingsFile.beginGroup("TrayIcons");
    m_Settings.mergeBatteries = m_SettingsFile.value("mergeBatteries", false).toBool();
    m_Settings.colors[UI_COLOR_PEN_CHARGE] = m_SettingsFile.value("textChargingColor", 0).toUInt();
    m_Settings.colors[UI_COLOR_PEN_DISCHARGE] = m_SettingsFile.value("textDischargingColor", 0).toUInt();
    m_Settings.colors[UI_COLOR_PEN_FULL] = m_SettingsFile.value("textFullColor", 0).toUInt();
    m_Settings.colors[UI_COLOR_BRUSH_CHARGED] = m_SettingsFile.value("mainChargedColor", qRgb( 0, 255, 0)).toUInt();
    m_Settings.colors[UI_COLOR_BRUSH_EMPTY] = m_SettingsFile.value("mainEmptyColor", qRgb(255, 255, 255)).toUInt();
    m_Settings.colors[UI_COLOR_BRUSH_FULL] = m_SettingsFile.value("mainFullColor", m_Settings.colors[UI_COLOR_BRUSH_CHARGED]).toUInt();
    m_Settings.colors[UI_COLOR_BRUSH_POLE_CHARGE] = m_SettingsFile.value("poleChargingColor", qRgb(255, 255, 0)).toUInt();
    m_Settings.colors[UI_COLOR_BRUSH_POLE_DISCHARGE] = m_SettingsFile.value("poleDischargingColor", qRgb(255, 255, 0)).toUInt();
    m_Settings.colors[UI_COLOR_BRUSH_POLE_FULL] = m_SettingsFile.value("poleFullColor", m_Settings.colors[UI_COLOR_BRUSH_POLE_CHARGE]).toUInt();
    m_SettingsFile.endGroup();

    m_SettingsFile.beginGroup("CriticalEvent");
    m_Settings.handleCritical = m_SettingsFile.value("handle", false).toBool();
    m_Settings.criticalCapacity = m_SettingsFile.value("criticalCapacity", 7).toUInt();
    m_Settings.executeCommand = m_SettingsFile.value("executeCommand", false).toBool();
    m_Settings.criticalCommand = m_SettingsFile.value("command", "").toString();
    m_Settings.confirmCommand = m_SettingsFile.value("confirmCommand", false).toBool();
    m_Settings.confirmWithTimeout = m_SettingsFile.value("confirmWithTimeout", false).toBool();
    m_Settings.timeoutValue = m_SettingsFile.value("timeoutValue", 5).toUInt();
    m_SettingsFile.endGroup();
}

 void Dbattery::saveSettings()
 {
     QSettings m_SettingsFile;
    m_SettingsFile.beginGroup("Main");
    m_SettingsFile.setValue("pollingRate", m_Settings.pollingRate);
    m_SettingsFile.setValue("showBalloon", m_Settings.showBalloon);
    m_SettingsFile.endGroup();

    m_SettingsFile.beginGroup("TrayIcons");
    m_SettingsFile.setValue("mergeBatteries", m_Settings.mergeBatteries);
    m_SettingsFile.setValue("textChargingColor", m_Settings.colors[UI_COLOR_PEN_CHARGE]);
    m_SettingsFile.setValue("textDischargingColor", m_Settings.colors[UI_COLOR_PEN_DISCHARGE]);
    m_SettingsFile.setValue("textFullColor", m_Settings.colors[UI_COLOR_PEN_FULL]);
    m_SettingsFile.setValue("mainChargedColor", m_Settings.colors[UI_COLOR_BRUSH_CHARGED]);
    m_SettingsFile.setValue("mainEmptyColor", m_Settings.colors[UI_COLOR_BRUSH_EMPTY]);
    m_SettingsFile.setValue("mainFullColor", m_Settings.colors[UI_COLOR_BRUSH_FULL]);
    m_SettingsFile.setValue("poleChargingColor", m_Settings.colors[UI_COLOR_BRUSH_POLE_CHARGE]);
    m_SettingsFile.setValue("poleDischargingColor", m_Settings.colors[UI_COLOR_BRUSH_POLE_DISCHARGE]);
    m_SettingsFile.setValue("poleFullColor", m_Settings.colors[UI_COLOR_BRUSH_POLE_FULL]);
    m_SettingsFile.endGroup();

    m_SettingsFile.beginGroup("CriticalEvent");
    m_SettingsFile.setValue("handle", m_Settings.handleCritical);
    m_SettingsFile.setValue("criticalCapacity", m_Settings.criticalCapacity);
    m_SettingsFile.setValue("executeCommand", m_Settings.executeCommand);
    m_SettingsFile.setValue("command", m_Settings.criticalCommand);
    m_SettingsFile.setValue("confirmCommand", m_Settings.confirmCommand);
    m_SettingsFile.setValue("confirmWithTimeout", m_Settings.confirmWithTimeout);
    m_SettingsFile.setValue("timeoutValue", m_Settings.timeoutValue);
    m_SettingsFile.endGroup();
}
*/
Q_EXPORT_PLUGIN2(dpanel_battery, Dbattery)
