//
// C++ Interface: powermanager
//
// Author: Oliver Groß <z.o.gross@gmx.de>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
#ifndef QBAT_POWERMANAGER_H
#define QBAT_POWERMANAGER_H

#include <QHash>

#include "common.h"

namespace qbat {
	class CBatteryIcon;
	
	class CPowerManager : public QObject {
		Q_OBJECT
	private:
		int m_Timer;
		int m_DataTimer;
		
		bool m_ACPlug;
		bool m_CriticalHandled;


		QHash<QString, CBatteryIcon *> m_BatteryIcons;

		void timerEvent(QTimerEvent * event);
	public:
        CPowerManager(QObject * parent = 0);
		~CPowerManager();
        CBatteryIcon * DefaultIcon;
    signals:
        void batteryChanged();
	private:
		void updateSupplies();
		void updateMergedData();
		void checkCritical();
	private slots:
		void updateBatteryData();
		void restartTimer();
	public slots:

	};
}

#endif
