/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#ifndef DESKTOPSWITCH_H
#define DESKTOPSWITCH_H
#include "../../dpluginsinterface.h"
#include <QWidget>
class QSignalMapper;
class QButtonGroup;
class ToolButton : public QToolButton
{
          Q_OBJECT

public:
        ToolButton(){}
signals:
          void activated();
};
/**
 * @brief The DdSwitch class التبديل بين اسطح المكتب
 */
class DdSwitch : public QWidget,PluginsInterface
{
    Q_OBJECT
    Q_INTERFACES(PluginsInterface)
public:
    explicit    DdSwitch(QWidget* parent = 0);

    ~DdSwitch();
    /*!< PluginsInterface::x11EventFilter */
     void x11EventFilter(XEvent* event);
 /*!< PluginsInterface::setKeySequence */
     void setKeySequence(QKeySequence sequence);
 /*!< PluginsInterface::keySequence */
      QString  keySequence();
 /*!< PluginsInterface::setLayout */
     void setLayout(QHBoxLayout *p);/*لتضمين الودجات داخل محتوى اللوحة*/
 /*!< PluginsInterface::setSize */
    void setSize(QSize size);
 /*!< PluginsInterface::setActions */
   void setActions(QList<QAction *>/*list*/)
    {

    }
 /*!< PluginsInterface::themeChanged */
    void themeChanged()
    {


    }

private:
    /*!< قائمة بمجموعة ازرار */
    QButtonGroup * m_GroupBtns;
    QSignalMapper* m_pSignalMapper;
    int m_DeskCount;
    /*!< قائمة ياسماء اسطح المكتب */
    QStringList m_desktopNames;
    /*!< حجم الزر */
    QSize m_size;
    /*!< حجم الاب الحاوي */
    int parentH;
    /**
     * @brief wheelEvent تحريك مؤشر العجلة
     * @param e
     */
    void wheelEvent(QWheelEvent* e);
    /**
     * @brief setupBtns تكوين الازرار
     */
    void setupBtns();
    QGridLayout * m_gridLayout ;
   QString mNextShort;
   QString mPrevShort ;

private slots:
    /**
     * @brief setDesktop الانتقال الى سطح مكتب
     * @param desktop رقم سطح المكتب
     */
    void setDesktop(int desktop);
void goDesktop(int arg);
protected slots:
    /*!< تموضع */
    virtual void realign();
};




#endif
