/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

 #include <QtGui>
#include "keymap.h"
//#include  "dialogconfigmap.h"

#include <X11/XKBlib.h>

#include <X11UTILLS>
//#include <QWSKeyboardHandler>
#include <QX11Info>

Keymap::Keymap(QWidget *parent) :
        QToolButton(parent)
{

    mKeyCount=0;
    setObjectName("KeyMap");
    this->setWindowTitle(tr("Keyboard Layout"));
    this->setWindowIcon(QIcon::fromTheme("input-keyboard",QIcon(":/icons/preferences-desktop-keyboard")));
    this->setWhatsThis(tr("Keyboard Layout Switch... by AbouZakaria"));//شرح الاضافة
    setContextMenuPolicy(Qt::CustomContextMenu);
    connect(this,SIGNAL(customContextMenuRequested(QPoint)),this,SLOT(showMenuConfig(QPoint)));
    connect(this,SIGNAL(clicked()),this,SLOT(setKeySender()));
    m_settings=new ElokabSettings(this);
     connect(m_settings,SIGNAL(keyMapChanged()) ,this,SLOT(creatMenuLayouts()));
    apllyKeySettings();
    creatMenuLayouts();
  QTimer::singleShot(10,this,SLOT(keyChanged()));

    QString styleButton= QString( "\n QToolButton{"
                                  "\n      border-radius:3px;"
                                  "\n      border:1px transparent;"
                                  " }") ;

    setStyleSheet(styleButton);


}

/// قائمة البرنامج
void Keymap::showMenuConfig(QPoint)
{
    // WidgetKeySettings *wsetting=new WidgetKeySettings;
       QMenu menu;
       QAction *act=new QAction(trUtf8("configure..."),this);
        connect(act,SIGNAL(triggered()),this,SLOT(showConfig()));
        menu.addActions(m_menu.actions());
         menu.addAction(act)   ;
          menu.addActions(m_actList)   ;
        menu.exec(QCursor::pos());
}
/// نافذة اختيار لغة ادخال
void Keymap::showConfig()
{

//     DialogConfigMap *dlg = new DialogConfigMap;
//     connect(dlg,SIGNAL(settingChanged()),this,SLOT(creatMenuLayouts()));
//        dlg->show();
//        dlg->raise();
//        dlg->activateWindow();
    QProcess prosess;
    QString p="elokab-settings Keylayout";
    prosess.startDetached(p);
}


/// تطبيق التغييرات عند البدأ
void Keymap::apllyKeySettings()
{
        /* لوحة تبديل المفاتيح*/
        QStringList listLayou;
        QStringList listLayouName;
        QStringList listVariant;
        QStringList listOption;
        //جلب اعدادات المستخدم
        QSettings settings("elokab","elokabsettings");
         settings.sync();
        settings.beginGroup("KeyMap");
        listLayouName= settings.value("Names","English|us|Default").toStringList();
        listOption= settings.value("Options","").toStringList();

        settings.endGroup();
        //-------------------

        QString strlayou="setxkbmap -layout " ;
        QString strVariant=" -variant " ;
        QString strOption=" -option " ;
        foreach (QString s, listLayouName) {


                listLayou<<s.section("|",1,1);
                listVariant<<s.section("|",2,2);


        }

        strlayou+= "\""+listLayou.join(",")+"\"";
        strVariant+="\""+listVariant.join(",")+"\"";
        strOption+="\""+listOption.join(",")+"\"";
        strVariant.remove("Default");

        QProcess pr;
        pr.startDetached("setxkbmap -option \"\"");
        pr.waitForFinished();

        pr.startDetached(strlayou+" "+strOption+" "+strVariant);

}
/// انشاء قائمة بلغات الادخال كلما تغيرت الاعدادات
void Keymap::creatMenuLayouts()
{
       mKeyCount= retrieveNumKbdGroups();
// getGroupNames();
    //جلب اعدادات المستخدم
    QSettings settings("elokab","elokabsettings");
    settings.sync();
    settings.beginGroup("KeyMap");
    QStringList info=    settings.value("Info","").toStringList();
    QStringList  listLayouNames= settings.value("Names","English|us|Default").toStringList();
    switshByAppName=settings.value("SwitshByAppName",false).toBool();
    settings.endGroup();

    //   qDebug()<<mKeyCount<<"Keymap::==================="<<listLayouNames.count();
    if(mKeyCount!=listLayouNames.count()){
        apllyKeySettings();
        mKeyCount=listLayouNames.count();
    }

    mStrKeyInfo=info.join("\n");
    //-------------------
    //         mKeyCount=-1;
    foreach (QAction *act, m_menu.actions()) {
        delete act;
    }
    m_menu.clear();
    appSwichMap.clear();
    QActionGroup *alignmentGroup = new QActionGroup(this);

    foreach (QString s, listLayouNames) {
        //mKeyCount++;
        QAction *act=new QAction(s.section("|",0,0),this);
        alignmentGroup->addAction(act);
        act->setData(s.section("|",1,1));

        m_menu.addAction(act);
        connect(act,SIGNAL(triggered()),this,SLOT(setActionSender()));

    }


}


//QSettings Keymap::getTranslation(const QString &group,const QString &name)
//{
//    QString lc=this->locale().name().section("_",0,0);
//    QSettings settings("elokab","elokabsettings");

//    settings.beginGroup(group);

//    QString txt=settings.value("name"+"["+lc+"]",name);
//    settings.endGroup();
//    return txt;
//}

/// تفعيل اللغة التالية عند النقر على الرمز
void Keymap::setKeySender()
{

  int i= curentGroup();

  i++;

  if(i>mKeyCount)
      i=0;

    XkbLockGroup(QX11Info::display(), XkbUseCoreKbd, i);

// qDebug()<<"Keymap:: icon clicked===============";

}
/// عند النقر على لغة بالقائمة
void Keymap::setActionSender()
{
    QAction *action = qobject_cast<QAction *>(sender());
    int i=0;
    if(action)
        i=   m_menu.actions().indexOf(action);

    XkbLockGroup(QX11Info::display(), XkbUseCoreKbd, i);

}

/// معرفة اذا ما تغيرت لغة الادخال
void Keymap::changeEvent(QEvent *e)
{
    QToolButton::changeEvent(e);
    switch (e->type()) {

    case QEvent::KeyboardLayoutChange:

        QTimer::singleShot(10,this,SLOT(keyChanged()));
        break;


    default:
        break;
    }
}
/// عندما يتم تغيير لغة الاخال
void Keymap::keyChanged()
{


    int i= curentGroup();



    QLocale lc= QApplication::keyboardInputLocale();
    qDebug()<<"Keymap:: lc.language() :"<<lc.languageToString(lc.language());
     QString curLg=lc.languageToString(lc.language());
    QString curSymbol;
    int count=m_menu.actions().count();

    if(i<0||i>count){
        curSymbol=lc.name().section("_",0,0);
    }else{
        curSymbol=m_menu.actions().at(i)->data().toString();
    }

    this->setText(curSymbol);
    setToolTip(curLg+"\n"
               +mStrKeyInfo);
  if(switshByAppName){
    setactiveAppLayout(i);
  }
}


void Keymap::setSize(QSize size)
{
        setIconSize(size);
        setMaximumSize(size);
        setMinimumSize(size);
}

/// جلب رقم اللغة الحالية
int Keymap::curentGroup()
{
    XkbStateRec rec;
    XkbGetState(QX11Info::display(), XkbUseCoreKbd, &rec);
    return rec.group;
}




//----------------------------------------------
void Keymap:: x11EventFilter(XEvent* event)
{
//     XkbEvent *xkb_ev = (XkbEvent *) event;
//    if ((xkb_ev->any.xkb_type == XkbNewKeyboardNotify))
//    {
//        // keyboard layout has changed
//       mKeyCount= retrieveNumKbdGroups();
//       qDebug()<<" keyboard layout has changed";
//      // creatMenuLayouts();
//    }

    if(!switshByAppName)return;

    if(event->type==PropertyNotify) {

        if (event->xproperty.window == QX11Info::appRootWindow())
        {

            if (event->xproperty.atom == X11UTILLS::atom("_NET_CLIENT_LIST"))
            {
                //                qDebug()<<"getClientList : ";
                updatAppMapps();
                return;
            }

            // Activate window ....................................
            if (event->xproperty.atom == X11UTILLS::atom("_NET_ACTIVE_WINDOW"))
            {
                //                qDebug()<<"key map ====activeWindowChanged : "<<getActiveWindowAppName();
                //activeWindowChanged();
                activeWindowChanged ();

                return;
            }



        }
    }
}
void Keymap::activeWindowChanged ()
{


    Window window = X11UTILLS::getActiveWindow();
    if(  mActiveWindow==window) return;
     mActiveWindow=window;
    QString appName= X11UTILLS::getApplicationName(window);
    int curG=curentGroup();
    if(appName.isEmpty()||appName.isNull())return;

    if( appSwichMap.contains(appName)){

        int i=appSwichMap[appName];

        if(i==curG){
            return;
        }
        XkbLockGroup(QX11Info::display(), XkbUseCoreKbd, i);

    }else{
        appSwichMap.insert(appName,curG);
    }
//    qDebug()<<appName<<curG;
//    qDebug()<<app_lang[appName];
 // qDebug()<<"Keymap::activeWindowChanged"<<appSwichMap;
}
void Keymap::setactiveAppLayout (int curG)
{


    Window window = X11UTILLS::getActiveWindow();

    QString appName= X11UTILLS::getApplicationName(window);
      if(appName.isEmpty()||appName.isNull())return;
     if( appSwichMap.contains(appName)){
//         int i=app_lang[appName];

//         if(i==curG){
//             return;
//         }else{
//             app_lang[appName]=curG;
//         }
         appSwichMap[appName]=curG;

     }else{
         appSwichMap.insert(appName,curG);
     }
   //  qDebug()<<"Keymap::setactiveAppLayout"<<appSwichMap;

}
//------------------------------------------------------------------------------------
void Keymap::updatAppMapps()
{

    QList<Window> listWindow =X11UTILLS::getClientList();
    QStringList list;
    foreach (Window w, listWindow) {

         list.append( X11UTILLS::getApplicationName(w));
    }
   // qDebug()<<list;
    foreach (int s, appSwichMap) {
        QString name=appSwichMap.key(s);
        if(!list.contains(name))
            appSwichMap.remove(name);
    }
//    qDebug()<<"Keymap::updatAppMapps"<<appSwichMap;
}

//-----------------------------------------------------------------------------------------
/// جلب عدد لغات الادخال
int Keymap::retrieveNumKbdGroups(){
  XkbDescRec xkb;

  memset(&xkb, 0, sizeof(xkb));
  /* Interestingly, in RedHat 6.0 (XFree86 3.3.3.1) the XkbGetControls call
  below works even if xkb.device_spec is not set. But in RedHat 7.1 (XFree86 4.0.3)
  it returns BadImplementation status code, and you have to specify
  xkb.device_spec = XkbUseCoreKbd. */
  xkb.device_spec = XkbUseCoreKbd;
  XkbGetControls(QX11Info::display(), XkbGroupsWrapMask, &xkb);
  int  count = xkb.ctrls->num_groups;
  XkbFreeControls(&xkb, XkbGroupsWrapMask, 1);
  return count;
}

#ifndef HAVE_LIBXKLAVIER
extern "C" {
  static int IgnoreXError(Display *, XErrorEvent *) {
    return 0;
  }
}
#endif
QStringList Keymap::getGroupNames(){
    QStringList list;
  XkbDescRec xkb;
  Display *display = QX11Info::display();
  char *names[XkbNumKbdGroups];

  memset(&xkb, 0, sizeof(xkb));
  xkb.device_spec = XkbUseCoreKbd;
  XkbGetNames(display, XkbGroupNamesMask, &xkb);

  memset(names, 0, sizeof(char *) * XkbNumKbdGroups);

  // XGetAtomNames below may generate BadAtom error, which is not a problem.
  // (it may happen if the name for a group was not defined)
  // Thus we temporarily ignore X errors
  XErrorHandler old_handler = XSetErrorHandler(IgnoreXError);

  XGetAtomNames(display, xkb.names->groups, mKeyCount, names);

  // resume normal X error processing
  XSetErrorHandler(old_handler);

  for (int i = 0; i < mKeyCount; i++) {
    if (names[i]) {
      list.append(names[i]);
      XFree(names[i]);
    }
    else list.append(QString::null);
  }
  XkbFreeNames(&xkb, XkbGroupNamesMask, 1);
  qDebug()<<"xkb list"<<list;
return list;
}
Q_EXPORT_PLUGIN2(dpanel_Keymap, Keymap)
