/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#ifndef KEYMAP_H
#define KEYMAP_H
#include <ElokabSettings>
#include "../../dpluginsinterface.h"

#include <QWidget>
#include <X11/Xlib.h>
class Keymap : public QToolButton,PluginsInterface
{
          Q_OBJECT
          Q_INTERFACES(PluginsInterface)
     public:
          explicit Keymap(QWidget *parent = 0);
     public slots:

          /**
     * @brief x11EventFilter PluginsInterface::x11EventFilter()
     * @param event
     */
          void  x11EventFilter(XEvent* event);

          /**
      * @brief setLayout PluginsInterface::setLayout()
      * @param p
      */
          void setLayout(QHBoxLayout *p){ p->addWidget(this);}

          /**
   * @brief setSize  PluginsInterface::setSize()
   * @param size
   */
          void setSize(QSize size);

          /**
    * @brief setKeySequence PluginsInterface::setKeySequence()
    */
          void setKeySequence(QKeySequence){}
          /**
  * @brief keySequence PluginsInterface:: keySequence()
  * @return
  */
          QString   keySequence(){return "";}


          /**
  * @brief setActions PluginsInterface::setActions()
  * @param list
  */
          void setActions(QList<QAction *>list)
          {
               m_actList=list;
          }

          /*virtual*/  void themeChanged(){}
     protected :
          // virtual bool event ( QEvent * e );
          void changeEvent(QEvent *e);
     private slots:
          void setKeySender();
          void setActionSender();
          void keyChanged();
          void apllyKeySettings();
          void showMenuConfig(QPoint);
          void showConfig();
          void creatMenuLayouts();
          int curentGroup();
          QStringList getGroupNames();
          int retrieveNumKbdGroups();
          void activeWindowChanged ();
          void setactiveAppLayout (int curG);
          void updatAppMapps();
     signals:


     private:
          int m_numgroups;
          QList<QAction *> m_actList;
          QString m_ks;
          QMenu m_menu;

          int mKeyCount;
          bool switshByAppName;
          QString mStrKeyInfo;
          QHash< QString,int> appSwichMap;
ElokabSettings *m_settings;
          Window mActiveWindow;
};

#endif // KEYMAP_H
