/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef DIALOGCONFIGMAINMENU_H
#define DIALOGCONFIGMAINMENU_H

#include <QDialog>

namespace Ui {
class DialogConfigMainMenu;
}
/**
 * @brief The DialogConfigMainMenu class
 */
class DialogConfigMainMenu : public QDialog
{
    Q_OBJECT
    

public:
    /**
     * @brief DialogConfigMainMenu
     * @param parent
     */
    explicit DialogConfigMainMenu(QWidget *parent = 0);
    ~DialogConfigMainMenu();
signals:
    /**
     * @brief settingChanged
     */
    void settingChanged();
private slots:
    /**
     * @brief loadSetting
     */
    void loadSetting();
    /**
     * @brief saveSetting
     */
    void saveSetting();
    /**
     * @brief on_toolButtonIcon_clicked
     */
    void on_toolButtonIcon_clicked();
    /**
     * @brief on_toolButtonDefault_clicked
     */
    void on_toolButtonDefault_clicked();
    /**
     * @brief on_lineEditIcon_textChanged
     * @param arg1
     */
    void on_lineEditIcon_textChanged(const QString &arg1);
    /**
     * @brief on_buttonBox_accepted
     */
    void on_buttonBox_accepted();
    /**
     * @brief on_toolButtonSystemIcon_clicked
     */
    void on_toolButtonSystemIcon_clicked();
    /**
     * @brief on_toolButtonImage_clicked
     */
    void on_toolButtonImage_clicked();
    /**
     * @brief on_toolButtonHoverImage_clicked
     */
    void on_toolButtonHoverImage_clicked();

private:
    Ui::DialogConfigMainMenu *ui;
    QString m_iconName;
};

#endif // DIALOGCONFIGMAINMENU_H
