/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef MAINMENU_H
#define MAINMENU_H
#include "../../dpluginsinterface.h"
#include "formmainmenu.h"
#include "../widgetpopup/widgetpopup.h"
#include <QWidget>
#include <QToolButton>


class MainMenu : public QToolButton,PluginsInterface
{
    Q_OBJECT
    Q_INTERFACES(PluginsInterface)
public:
    explicit MainMenu(QWidget *parent = 0);
    
signals:
    

public slots:
    /*!< PluginsInterface::x11EventFilter */
    void  x11EventFilter(XEvent* /*event*/);
    /*!< PluginsInterface::setLayout */
    void setLayout(QHBoxLayout *p);
    /*!< PluginsInterface::setSize */
    void setSize(QSize size);
    /*!< PluginsInterface::setKeySequence */
    void setKeySequence(QKeySequence sequence);
    /*!< PluginsInterface::keySequence */
    QString   keySequence();
    /*!< PluginsInterface::setActions */
    void setActions(QList<QAction *> list);
    /*!< PluginsInterface::themeChanged */
    void themeChanged();


private:
    FormMainMenu *m_fmain;
    WidgetPopup *mWidgetPopup;
    QString m_ks;
    QList<QAction *> m_actList;
private slots:
    /*!< cmment */
    void coztumizMainMenu();
    /*!< cmment */
    void  loadSetting();
    /*!< cmment */
    void  customContextMenu(const QPoint & /*pos*/);
    /*!< cmment */
    void showFormMain();
    /*!< cmment */
    void initFormMain();
};

#endif // MAINMENU_H
