/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#include "page.h"
#include <QGridLayout>
#include <QScrollArea>
#include <QDebug>

Page::Page(QWidget *parent) :
    QWidget(parent),m_count(0)
{

          m_curColum=0;
          m_colum=0;
          m_row=0;
     QVBoxLayout *verticalLayout_2 = new QVBoxLayout(this);
      verticalLayout_2->setContentsMargins(0, 0, 0, 0);
      setObjectName("pageWidget");
    QScrollArea  *scrollArea = new QScrollArea(this);
    scrollArea->setFrameShape(QFrame::NoFrame);
    scrollArea->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
      scrollArea->setWidgetResizable(true);
      scrollArea->setObjectName("scrollArea");

   scrollAreaWidgetContents = new QWidget();
     scrollAreaWidgetContents->setObjectName("scrollAreaWidgetContents");
     // scrollAreaWidgetContents->setGeometry(QRect(0, 0, 224, 311));

   gridLayoutArea = new QGridLayout(scrollAreaWidgetContents);
   gridLayoutArea->setSpacing(3);
   gridLayoutArea->setObjectName(QString::fromUtf8("gridLayoutArea"));
   gridLayoutArea->setSizeConstraint(QLayout::SetFixedSize);
   scrollArea->setWidget(scrollAreaWidgetContents);

    verticalLayout_2->addWidget(scrollArea);

    foreach (QWidget *w, m_listwidget) {
       delete w;
    }
m_listwidget.clear();
//setStyleSheet(" QWidget #pageWidget{ background-color: transparent;} " );
//
//
}
void Page::addWidget(QWidget *w,bool mod)
{
//    qDebug()<<objectName()<<m_row<<m_colum<<w->toolTip();

        if(mod==false){
                gridLayoutArea->addWidget(w,m_row,0);
                gridLayoutArea->rowStretch(m_row);

                m_row++;
        }else{
                gridLayoutArea->addWidget(w,m_row,m_colum);
                m_curColum++;
                m_colum++;

                if(m_colum==4)m_colum=0;

                if(m_curColum==4){
                        m_curColum=0;

                        m_row++;
                }
        }

m_listwidget.append(w);
        m_count++;

}
void Page::removeWidget(QWidget *w)
{

      gridLayoutArea->removeWidget(w);

      m_listwidget.removeOne(w);
}
void Page::removeAll()
{
        m_curColum=0;
        m_colum=0;
        m_row=0;
         QLayoutItem *child;


       while ((child = gridLayoutArea->takeAt(0)) != 0) {


           delete child;
        }



}
void Page::realign(bool mod)
{
    removeAll();

    foreach (QWidget *w, m_listwidget) {
        if(w){
            if(mod==false){

                gridLayoutArea->addWidget(w,m_row,0);
                gridLayoutArea->rowStretch(m_row);
                m_row++;
            }else{
                gridLayoutArea->addWidget(w,m_row,m_colum);
                m_curColum++;
                m_colum++;

                if(m_colum==4)m_colum=0;

                if(m_curColum==4){
                    m_curColum=0;

                    m_row++;
                }
            }
        }

    }

//    qDebug()<<objectName()<<gridLayoutArea->columnCount()<<gridLayoutArea->rowCount();

//     qDebug()<<objectName()<<gridLayoutArea->count();
}
