/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef PAGE_H
#define PAGE_H

#include <QWidget>
#include <QGridLayout>

/**
 * @brief The Page class
 */
class Page : public QWidget
{
    Q_OBJECT
public:
    /**
     * @brief Page
     * @param parent
     */
    explicit Page(QWidget *parent = 0);

    int count()
    {
        return m_count;
    }
signals:
    
public slots:
    /**
     * @brief addWidget
     * @param w
     * @param mod
     */
    void addWidget(QWidget *w, bool mod);
    /**
     * @brief removeWidget
     * @param w
     */
    void removeWidget(QWidget *w);
    /**
    * @brief removeAll
    */
    void removeAll();
    /**
    * @brief realign
    * @param mod
    */
    void realign(bool mod);
private:

    QWidget *scrollAreaWidgetContents ;
    QGridLayout * gridLayoutArea ;
    QList<QWidget *> m_listwidget;
    int m_count;
    int  m_curColum;
    int m_colum;
    int m_row;
};

#endif // PAGE_H
