#include "menuapplications.h"
#include "menuconfigdialog.h"
#include <EMimIcon>

#include <QDir>
#include <QDebug>
#include<QSettings>
#include <QTextCodec>
#include  <QProcess>

#include  <QUrl>
#include  <QApplication>
//#include <X11/Xlib.h>

MenuApplications::MenuApplications(QWidget *parent) :
    QMenuBar(parent)

{

    //this->setTitle(tQTextStreamrUtf8("Applications"));
    QApplication::setAttribute(Qt::AA_DontShowIconsInMenus ,false);
    this->setObjectName("MenuBar");     //اسم الاضافة
    this->setWindowTitle(tr("classic Menu Bar"));   //النص الذي سيتم عرضه لتعريف الاضافة
    this->setWhatsThis(tr("classic menu lancher by AbouZakaria"));//شرح الاضافة
    this->setWindowIcon(EIcon::fromTheme("start-here","start-here"));//ايقونة الاضافة
    QSizePolicy sizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::Maximum);
    sizePolicy.setHorizontalStretch(0);
    sizePolicy.setVerticalStretch(0);
    sizePolicy.setHeightForWidth(this->sizePolicy().hasHeightForWidth());
    this->setSizePolicy(sizePolicy);
    setContentsMargins(0,0,0,0);
    this->setContextMenuPolicy(Qt::CustomContextMenu);
    connect(this,SIGNAL(customContextMenuRequested(const QPoint & )) ,this,SLOT(customContextMenu(const QPoint & )));

    setupMenu();
 // keySequence();

}



void MenuApplications::setupMenu()
{

    menuProgrammes=new MenuProgrammes;
    connect(menuProgrammes,SIGNAL(menuRecharged()),this,SLOT(rechargeMenu()));
    menuPower=new MenuSystem;

    mnuFile=new QMenu(trUtf8("&File"));

    menuFolders=new MenuFolders;


    toolStartHere=new QToolButton(this);
    toolStartHere->setText(trUtf8("Start Here"));
    toolStartHere->setPopupMode(QToolButton::InstantPopup);
    toolStartHere->setMenu(mnuFile);
    toolStartHere->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);



    this->setCornerWidget(toolStartHere);

    loadSetting();

}
void MenuApplications::rechargeMenu()
{
    this->clear();

    mnuFile->clear();

    if(m_multi==true){
        toolStartHere->setVisible(false);

        mnuFile->addActions(m_actList);
        mnuFile->addSeparator();
        mnuFile->addActions(menuPower->actions());
        this->addMenu(mnuFile);
        // this->addMenu(mnuApplications);
        this->addMenu(menuProgrammes);
        this->addMenu(menuFolders);

        mnuFile->setIcon(QIcon());
        menuFolders->setIcon(QIcon());
        menuProgrammes->setIcon(QIcon());
        getSizeHint();
        m_sizeHint=m_sizeHint-toolStartHere->sizeHint().width();

        this->setMinimumWidth(m_sizeHint);
        this->setMaximumWidth(m_sizeHint+10);
    }else{

        toolStartHere->setVisible(true);
        mnuFile->addActions(m_actList);
        mnuFile->addSeparator();
        foreach (QMenu *m, menuProgrammes->menus) {
            mnuFile->addMenu(m);

        }

        mnuFile->addSeparator();
        mnuFile->addMenu(menuFolders);
        mnuFile->addSeparator();

        mnuFile->addMenu(menuPower);
        this->setMinimumWidth(toolStartHere->sizeHint().width());
        this->setMaximumWidth(toolStartHere->sizeHint().width());
        menuFolders->setIcon(EIcon::fromTheme("folder"));

    }
    this->updateGeometry();
adjustSize();
}
void MenuApplications:: getSizeHint()
{
    if(this->layoutDirection()==Qt::LeftToRight){
        m_sizeHint=this->sizeHint().width();
    }else{
        this->setLayoutDirection(Qt::LeftToRight);
        this->updateGeometry();
        m_sizeHint=this->sizeHint().width();
        this->setLayoutDirection(Qt::RightToLeft);
    }

}
void MenuApplications::coztumizMenu()
{
    MenuConfigDialog *dlg=new MenuConfigDialog;
    connect(dlg,SIGNAL(settingChanged()),this,SLOT(loadSetting()));
    dlg->show();
}


void MenuApplications::loadSetting()
{


    QSettings setting;
    setting.beginGroup("MenuBar");
    m_multi=(setting.value("menuStyle",0).toInt());
    int bstyle=(setting.value("buttonStyle",0).toInt());
    toolStartHere->setText(setting.value("buttonText",trUtf8("Start Here")).toString());
    QString icon=(setting.value("buttonIcon","start-here").toString());

    setting.endGroup();
    if(bstyle==0){
        toolStartHere->setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
    }else{
        toolStartHere->setToolButtonStyle(Qt::ToolButtonIconOnly);
    }
    rechargeMenu();
    if(QFile::exists(icon)){
        toolStartHere->setIcon(QIcon(icon));
        mnuFile->setIcon(QIcon(icon));
    }else{
        toolStartHere->setIcon(EIcon::fromTheme(icon));
        mnuFile->setIcon(EIcon::fromTheme(icon));
    }


}
void MenuApplications::customContextMenu(const QPoint & /*pos*/)
{
    QMenu menu;
    QAction *act=new QAction(EIcon::fromTheme("configure")
                             ,trUtf8("Menu Settings"),this);
    connect(act,SIGNAL(triggered()),this,SLOT(coztumizMenu()));
    menu.addAction(act);
    menu.addSeparator();
    menu.addActions(m_actList);
    menu.exec(QCursor::pos());
}


void MenuApplications::execApplication()
{
    QAction *action = qobject_cast<QAction *>(sender());
    if (action){
        QString data=action->data().toString();
        QString exec=data.section("|",0,0);
        QProcess process;
        process.setWorkingDirectory(QDir::homePath());

        process.startDetached(exec);
        //   qDebug()<<exec;
    }
}

void MenuApplications::refreshIcons()
{

    menuProgrammes->refreshIcons();
    toolStartHere->setIcon(EIcon::fromTheme("start-here").pixmap(QSize(128, 128)));
    mnuFile->setIcon(EIcon::fromTheme("start-here").pixmap(QSize(128, 128)));
    menuFolders->refreshIcons();

    menuPower->refreshIcons();

}

void  MenuApplications::setKeySequence(QKeySequence sequence)
{
    //  qDebug()<<"plugins-----key---:b "<<sequence.toString();
    QKeySequence ks(m_ks);
    if(ks==sequence){
        mnuFile->show();
       activateWindow();

        QTimer::singleShot(10, this, SLOT(afterMenuActivated()));
    }
}

void MenuApplications::afterMenuActivated()
{

    QRect screen = QApplication::desktop()->availableGeometry();
    int posy;
    QPoint ps=mapToGlobal(QPoint(this->rect().left(),this->rect().top()));
    if(ps.y()>=screen.height()){
        posy= this->rect().top()- mnuFile->sizeHint().height();;
    }else{
        posy= this->rect().bottom();
    }

    QPoint mpos;

    if (isLeftToRight())
    {
        mpos=mapToGlobal(QPoint(toolStartHere->rect().left(),posy));
    }else{
        mpos=mapToGlobal(QPoint(this->rect().right()-mnuFile->sizeHint().width(),posy));
    }

    mnuFile->activateWindow();
    mnuFile->setFocus();
    //    mnuFile->hide();
    mnuFile->exec(mpos);


}
void MenuApplications::showHideMenu()
{
    if (mnuFile && mnuFile->isVisible())
        mnuFile->hide();
    else
        showMenu();
}
void MenuApplications::showMenu()
{

    mnuFile->activateWindow();
    QTimer::singleShot(10, this, SLOT(afterMenuActivated()));
}

QString   MenuApplications:: keySequence()
{

    QSettings settings("elokab","shortcut");
    settings.beginGroup("Panel-Plugins");
    settings.beginGroup("MenuBar");
    if(!settings.contains("Destination")){
        settings.setValue("Key",QKeySequence("Alt+F1").toString());
        settings.setValue("Destination","panel");
         settings.setValue("Comment","show the Main Menu panal");

    }


    m_ks= settings.value("Key","Alt+F1").toString();
    settings.endGroup();//MenuBar
    settings.endGroup();//Panel-Plugins
    return m_ks;
}
void  MenuApplications::setActions(QList<QAction *>list)
{
    m_actList=list;
    rechargeMenu();
}

void MenuApplications::setSize(QSize size)
{
    toolStartHere->setIconSize(size);
    //  toolStartHere->setMaximumHeight(size.height()+4);
    rechargeMenu();
}


void MenuApplications::setLayout(QHBoxLayout *p)
{
    p->addWidget(this);
}
void  MenuApplications::x11EventFilter(XEvent* /*event*/)
{
    //qDebug()<<event->type;
}

Q_EXPORT_PLUGIN2(dpanel_menubar, MenuApplications)
