#ifndef MENUAPPLICATIONS_H
#define MENUAPPLICATIONS_H
#include "../../dpluginsinterface.h"
#include <MenuSystem>
#include "../../../common/menuprogrammes.h"
#include "../../../common/menufolders.h"
#include <QWidget>
#include <QMenu>
#include <QMenuBar>
#include <QToolButton>
#include <QFileSystemWatcher>

class MenuApplications : public QMenuBar,PluginsInterface
{
    Q_OBJECT
    Q_INTERFACES(PluginsInterface)
public:
    explicit MenuApplications(QWidget *parent = 0);
    QMenu *mnuFile;



public slots:
    /*virtual*/ void  x11EventFilter(XEvent*);

    /*virtual*/ void setLayout(QHBoxLayout *p);
    /*virtual*/ void setSize(QSize size);

    /*virtual*/ void setKeySequence(QKeySequence sequence);
    /*virtual*/ QString   keySequence();
    /*virtual*/  void setActions(QList<QAction *>list);

    /*virtual*/  void themeChanged()
    {
        refreshIcons();
    }


    //    void setListAction( QList<QAction *>actList);
signals:

private slots:
    void afterMenuActivated();
    void showHideMenu();
    void showMenu();
    void setupMenu();



    void rechargeMenu();
    void  getSizeHint();
    void refreshIcons();

    void execApplication();
    void customContextMenu(const QPoint & /*pos*/);
    void coztumizMenu();
    void loadSetting();

private:
    MenuProgrammes *menuProgrammes;
    MenuFolders *menuFolders;
    MenuSystem *menuPower;

    QList<QAction *>m_actList;



    QFileSystemWatcher *m_sWatcher;


QAction *actDEfault;
    QToolButton *toolStartHere;
    bool m_multi;
    int m_sizeHint;
    QPoint menuPos;

    QString m_ks;
};

#endif // MENUAPPLICATIONS_H
