#include "menuconfigdialog.h"
#include <EIcon>
#include "ui_menuconfigdialog.h"
#include <QSettings>
#include <QFile>
#include <QFileDialog>
#include <QDebug>

MenuConfigDialog::MenuConfigDialog(QWidget *parent) :
          QDialog(parent),
          ui(new Ui::MenuConfigDialog)
{
          ui->setupUi(this);
           this->setAttribute(Qt::WA_DeleteOnClose,true);
          ui->toolButtonDefault->setIcon(EIcon::fromTheme("document-revert"));
          loadSetting();
}

MenuConfigDialog::~MenuConfigDialog()
{
        qDebug()<<"menu setting Ui deleted";
          delete ui;
}
void MenuConfigDialog::loadSetting()
{

          QSettings setting;
          setting.beginGroup("MenuBar");
          ui->comboBoxMenuStyle->setCurrentIndex(setting.value("menuStyle",0).toInt());
          ui->comboBoxButtonStyle->setCurrentIndex(setting.value("buttonStyle",0).toInt());
          ui->lineEditButtonName->setText(setting.value("buttonText",trUtf8("Start Here")).toString().trimmed());
          QString iconName=setting.value("buttonIcon",trUtf8("start-here")).toString();

          if(QFile::exists(iconName)){
                    ui->toolButtonIcon->setIcon(QIcon(iconName));
          }else{
                    ui->toolButtonIcon->setIcon(EIcon::fromTheme(iconName));
          }
          m_iconName=iconName;
          setting.endGroup();


}
void MenuConfigDialog::saveSetting()
{

          QSettings setting;
          setting.beginGroup("MenuBar");
          setting.setValue("menuStyle",  ui->comboBoxMenuStyle->currentIndex());
          setting.setValue("buttonStyle", ui->comboBoxButtonStyle->currentIndex());
          setting.setValue("buttonText",ui->lineEditButtonName->text()+"  ");
          setting.setValue("buttonIcon",m_iconName);
          setting.endGroup();
}


void MenuConfigDialog::on_buttonBox_accepted()
{
          saveSetting();
          emit settingChanged();
}

void MenuConfigDialog::on_toolButtonDefault_clicked()
{
          ui->toolButtonIcon->setIcon(EIcon::fromTheme("start-here"));
          m_iconName="start-here";
}

void MenuConfigDialog::on_toolButtonIcon_clicked()
{
          QFileDialog dlg;

          QString fn = dlg.getOpenFileName(this, tr("Open Images Files..."),
                                           QDir::homePath(), trUtf8("Image File (*.png );;All Files (*)"));
          if (!fn.isEmpty())
          {
                    ui->toolButtonIcon->setIcon(QIcon(fn));
                    m_iconName=fn;


          }
}
