/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#include "dialogmountconfig.h"
#include "ui_dialogmountconfig.h"

#include <QComboBox>
#include <QDebug>
#include <QSettings>
#define ACT_SHOW_MENU "showMenu"
#define ACT_SHOW_INFO "showInfo"
#define ACT_NOTHING   "nothing"

DialogMountConfig::DialogMountConfig( QWidget *parent) :
          QDialog( parent),
          ui(new Ui::DialogMountConfig)
{

          ui->setupUi(this);
    this->setAttribute(Qt::WA_DeleteOnClose,true);
          this->setWindowIcon(QIcon::fromTheme("configure",QIcon::fromTheme("document-properties")));
          this->setObjectName("mountConfig");
          ui->devAddedCombo->addItem(tr("Popup menu"), ACT_SHOW_MENU);
          ui->devAddedCombo->addItem(tr("Show info"),  ACT_SHOW_INFO);
          ui->devAddedCombo->addItem(tr("Do nothing"), ACT_NOTHING);

          loadSettings();
       }

DialogMountConfig::~DialogMountConfig()
{
        qDebug()<<"mount setting UI deleted";
          delete ui;
}


void DialogMountConfig::loadSettings()
{
          //  setComboboxIndexByData(ui->devAddedCombo, settings().value("newDeviceAction", ACT_SHOW_INFO), 1);
          QSettings settings;
          settings.beginGroup("Mount Device");
          QString s = settings.value("deviceAction", ACT_SHOW_INFO).toString();
          bool showPartition=settings.value("showPartition", false).toBool();
          settings.endGroup();
          int i=ui->devAddedCombo->findData(s);
          ui->devAddedCombo->setCurrentIndex(i);
          ui->checkBoxPartion->setChecked(showPartition);
}



void DialogMountConfig::on_buttonBox_accepted()
{
          QSettings settings;
          settings.beginGroup("Mount Device");
          int index= ui->devAddedCombo->currentIndex();
          QString s = ui->devAddedCombo->itemData(index).toString();
          settings.setValue("deviceAction", s);
          settings.setValue("showPartition", ui->checkBoxPartion->isChecked());
           settings.endGroup();
          emit settingChanged();
}
