

#ifndef DCKLAUNCH_H
#define DCKLAUNCH_H


#include "../../dpluginsinterface.h"
#include <QHash>
#include <QString>
#include <QWidget>
#include <QHBoxLayout>

class QuickAction;
class QDragEnterEvent;
class QuickLaunchLayout;
class QuickButton;



class DQuickLaunch : public QWidget,PluginsInterface
{
          Q_OBJECT
          Q_INTERFACES(PluginsInterface)
public:
          DQuickLaunch( QWidget* parent = 0);
          ~DQuickLaunch();

          QAction *actAddActions;
          int indexOfButton(QuickButton* button) const;
          int countOfButtons() const;
private:

          //QHash<QString,XdgDesktopFile*> m_xdgFiles;
          QuickLaunchLayout *m_layout;
          QHash<int,QuickButton*> m_buttons;
          QSize m_size;
          void dragEnterEvent(QDragEnterEvent *e);
          void dropEvent(QDropEvent *e);



private slots:
          void addButton(QuickAction* action);
          void switchButtons(int,int);
          void buttonDeleted(int);
          void customContextMenu(QPoint);
          void addLancher();
          void addButton(QString txt);
          void saveSettings();
public slots:

          /*virtual*/ void  x11EventFilter(XEvent* /*event*/){}
          /*virtual*/ void setLayout(QHBoxLayout *p){p->addWidget(this);}
          /*virtual*/ void setSize(QSize size);
          /*virtual*/ void setKeySequence(QKeySequence /*sequence*/){}
          /*virtual*/  QString   keySequence(){ return ("");}
          /*virtual*/   void setActions(QList<QAction *>/*list*/){}
          void themeChanged();



};




#endif //DCKLAUNCH_H
