

#ifndef DQUICKLAUNCHBUTTON_H
#define DQUICKLAUNCHBUTTON_H
#include <QAction>
#include <QToolButton>
#include "../../common/addactions/dialogaddaction.h"
//
class QuickAction : public QAction
{
          Q_OBJECT

public:

       //   QuickAction(const QString & name,const QString & exec,QWidget * parent);

          QuickAction(const QString &name, const QString &exec, const QString &icon, QWidget * parent);

          QuickAction(const QString & fileName, QWidget * parent);



          QHash<QString, QString> settingsHash() { return m_settingsHash; }
          void setSettingsHash(const QStringList &list);
public slots:
          void execAction();
          void upgatIcon();
private slots:

private:
          enum ActionType { ActionLegacy, ActionScript, ActionFile };
          ActionType m_type;
          QString m_data;

          QHash<QString, QString> m_settingsHash;
};


class QuickButton : public QToolButton
{
          Q_OBJECT

public:
          QuickButton(QSize size,int id, QuickAction * act, QWidget* parent = 0);
          ~QuickButton();

          QHash<QString,QString> settingsMap();
          int id() { return m_id; }

signals:
          void buttonDeleted(int index);
          void switchButtons(int first, int second);
          void settingsChanged();
      //    void movedRight();

protected:

          void mousePressEvent(QMouseEvent *e);
          void mouseMoveEvent(QMouseEvent *e);
          void dragEnterEvent(QDragEnterEvent *e);
          void dragMoveEvent(QDragMoveEvent * e);

private:
          QuickAction *m_act;
          QAction *m_deleteAct;

          QAction *m_moveRightAct;
          QAction *m_propertyAct;
          QMenu *m_menu;
          QPoint m_dragStart;
          int m_id;
          QSize m_size;
private slots:
          void this_customContextMenuRequested(const QPoint & pos);
          void parentRemoveMe();
          void getProperty();
          void changeAction(const QStringList &list);

public slots:
          void setSize(QSize size);
};

#endif //DQUICKLAUNCHBUTTON_H
