#include "quicklaunchlayout.h"
#include "quicklaunchbutton.h"
#include <QFrame>

QuickLaunchLayout::QuickLaunchLayout(QWidget * parent)
          : QHBoxLayout(parent)

{
          setSpacing(1);
          setContentsMargins(1, 1, 1,1);
setSizeConstraint(QLayout::SetFixedSize);
}

void QuickLaunchLayout::addWidget(QuickButton *b)
{
          m_buttons << b;

          relayout();
}

void QuickLaunchLayout::removeWidget(QuickButton *b)
{
          m_buttons.removeAll(b);

          relayout();
}

void QuickLaunchLayout::swapButtons(QuickButton * b1, QuickButton *b2)
{
          int tmp1 = indexOf(b1);
          int tmp2 = indexOf(b2);

          if (tmp1 != tmp2)
          {
                    m_buttons.swap(tmp1, tmp2);
                    relayout();
          }
}

QuickButton* QuickLaunchLayout::buttonAt(int index)
{
          if ((index >= 0) && (index < m_buttons.size()))
                    return m_buttons[index];
          return NULL;
}




void QuickLaunchLayout::relayout()
{


          QLayoutItem *child;
          while ((child = takeAt(0)) != 0)
          {
                 //   qDebug()<<child->geometry();
                    delete child;
          }
          // addSpacing(10);

          foreach (QuickButton *b, m_buttons)
          {
                 QHBoxLayout::addWidget(b);

          }

}

