#include "sensorpopup.h"
#include "ui_sensorpopup.h"
#include <QGraphicsDropShadowEffect>
#include <QX11Info>

SensorPopup::SensorPopup(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::SensorPopup)
{
    ui->setupUi(this);
    setWindowFlags(   Qt::Popup  | Qt::WindowStaysOnTopHint | Qt::CustomizeWindowHint );

    QGraphicsDropShadowEffect *fx = new QGraphicsDropShadowEffect();
    if(this->isRightToLeft())
        fx->setOffset(-3,3);
    else
        fx->setOffset(3,3);
    fx->setBlurRadius(10);
    fx->setColor(QColor(63, 63, 63, 200));

    this->setPalette(Qt::transparent);
    this->setAttribute(Qt::WA_TranslucentBackground,true);
    setGraphicsEffect(fx);

}

//_______________________________________________________________
void SensorPopup::setScreenBotum(bool b,int p)
{
    if(b==true){
        ui->widgetBotContenair->setVisible(true);
        ui->widgetTopContenair->setVisible(false);
    }else{
        ui->widgetBotContenair->setVisible(false);
        ui->widgetTopContenair->setVisible(true);
    }

    if(p<1)
        p=1;

    ui->widgetTop->move(p,0);
    ui->widgetBot->move(p,0);
}

//_______________________________________________________
void SensorPopup::show()
{
    QWidget::show();
    if(QX11Info::isCompositingManagerRunning()){
        ui->verticalLayoutPop->setMargin(4);
    }else{
        ui->verticalLayoutPop->setMargin(1);
        ui->widgetBotContenair->setVisible(false);
        ui->widgetTopContenair->setVisible(false);
    }
}

//_______________________________________________________
void  SensorPopup::setInfo(const QString &info)
{
    ui->labelInfo->setText(info);
}

//_______________________________________________________
SensorPopup::~SensorPopup()
{
    delete ui;
}
