﻿#ifndef SENSORWIDGET_H
#define SENSORWIDGET_H
#include "../../dpluginsinterface.h"

#include "sensor/sensors.h"
#include "../widgetpopup/widgetpopup.h"
#include <QLabel>

class SensorWidget : public QLabel,PluginsInterface
{
          Q_OBJECT
          Q_INTERFACES(PluginsInterface)
public:
    explicit SensorWidget(QWidget *parent = 0);
public slots:
          /*virtual*/ void  x11EventFilter(XEvent */*event*/){}

          /*virtual*/ void setLayout(QHBoxLayout *p){p->addWidget(this);}

          /*virtual*/ void setSize(QSize size);

          /*virtual*/ void setKeySequence(QKeySequence /*sequence*/){}

          /*virtual*/  QString keySequence() { return ("");}

          /*virtual*/  void setActions(QList<QAction *>/*list*/){}
           /*virtual*/  void themeChanged(){}

protected:
          virtual void mouseReleaseEvent(QMouseEvent* event);

private:

    QLabel *mLabelInfo;
    WidgetPopup *mWidgetPopup;
    Sensors mSensors;
    std::vector<Chip> mDetectedChips;
    bool mFahrenheit;
    int  mTimeUpdat;
    int mChipIndex;
     QTimer *timer;
private slots:
    void updateSensor();
    void loadSettings();
    void configSettings();
    void customContextMenu(QPoint);
    double celsiusToFahrenheit(double celsius);
};

#endif // SENSORWIDGET_H
