/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef DSHOWDESKTOP_H
#define DSHOWDESKTOP_H
#include <QWidget>
#include "../../dpluginsinterface.h"
#include <X11/Xlib.h>

class DshowDesktop : public QToolButton,PluginsInterface
{
          Q_OBJECT
          Q_INTERFACES(PluginsInterface)
public:
          explicit DshowDesktop(QWidget *parent = 0);

signals:

public slots:
    /*virtual*/ void  x11EventFilter(XEvent* /*event*/){}
          /*virtual*/  void setLayout(QHBoxLayout *p){ p->addWidget(this);}


          /*virtual*/  void setSize(QSize size);
          /*virtual*/  void setKeySequence(QKeySequence sequence);
          /*virtual*/  QString   keySequence();
    /*virtual*/  void setActions(QList<QAction *>/*list*/){}

       /*virtual*/  void themeChanged();

private:
QString m_ks;


private slots:
          void showDesktopNew();
                void loadSetting();
      Atom atom(const char* atomName);
};

#endif // DSHOWDESKTOP_H
