#include "dialogconfigstat.h"
#include "ui_dialogconfigstat.h"
#include <QSettings>
#include <QDebug>

DialogConfigStat::DialogConfigStat(QWidget *parent) :
        QDialog(parent),
        ui(new Ui::DialogConfigStat)
{
        ui->setupUi(this);
         this->setAttribute(Qt::WA_DeleteOnClose,true);
        loadSettings();


}

DialogConfigStat::~DialogConfigStat()
{
        qDebug()<<"deletet";
        delete ui;
}

void DialogConfigStat::loadSettings()
{
        QSettings setting("elokab","settings");

        setting.beginGroup("System-Load");
        int    m_interval=setting.value("intervale",1500).toInt();
        QColor   m_colorCpuNice=setting.value("colorCpuNice",QColor("#FFFF00")).value<QColor>();
        QColor   m_colorCpuUser=setting.value("colorCpuUser",QColor("#0000FF")).value<QColor>();
        QColor   m_colorCpuIowait=setting.value("colorCpuIowait",QColor("#006400")).value<QColor>();
        QColor   m_colorCpuSystem=setting.value("colorCpuSystem",QColor("#FF0000")).value<QColor>();

        QColor   m_colorMemBuffers=setting.value("colorMemBuffers",QColor("#FFFF00")).value<QColor>();
        QColor  m_colorMemCached=setting.value("colorMemCached",QColor("#006400")).value<QColor>();
        QColor  m_colorMemUsed=setting.value("colorMemUsed",QColor("#0000FF")).value<QColor>();

        QColor  m_colorSwap=setting.value("colorSwap",QColor("#00CDCD")).value<QColor>();

        setting.endGroup();

        btnCpuNice   =new ButtonColor(tr("Nice :"),true,m_colorCpuNice);
        btnCpuUser   =new ButtonColor(tr("User :"),true,m_colorCpuUser);
        btnCpuIOwait   =new ButtonColor(tr("IOWait :"),true,m_colorCpuIowait);
        btnCpuSystem   =new ButtonColor(tr("System :"),true,m_colorCpuSystem);

        ui->verticalLayoutCpu->addWidget(btnCpuNice);
        ui->verticalLayoutCpu->addWidget(btnCpuUser);
        ui->verticalLayoutCpu->addWidget(btnCpuIOwait);
        ui->verticalLayoutCpu->addWidget(btnCpuSystem);

        btnMemBuffers   =new ButtonColor(tr("Buffers :"),true,m_colorMemBuffers);
        btnMemCached   =new ButtonColor(tr("Cached :"),true,m_colorMemCached);
        btnMemUsed   =new ButtonColor(tr("Used :"),true,m_colorMemUsed);

        ui->verticalLayoutMem->addWidget(btnMemBuffers);
        ui->verticalLayoutMem->addWidget(btnMemCached);
        ui->verticalLayoutMem->addWidget(btnMemUsed);

        btnSwap   =new ButtonColor(tr("Used :"),true,m_colorSwap);
        ui->verticalLayoutSwap->addWidget(btnSwap);

        ui->spinBoxInterval->setValue(m_interval);

}
void DialogConfigStat::saveSetting()
{



        QSettings setting("elokab","settings");
        setting.beginGroup("System-Load");

        setting.setValue("colorCpuNice",btnCpuNice->color());
        setting.setValue("colorCpuUser",btnCpuUser->color());
        setting.setValue("colorCpuIowait",btnCpuIOwait->color());
        setting.setValue("colorCpuSystem",btnCpuSystem->color());

        setting.setValue("colorMemBuffers",btnMemBuffers->color());
        setting.setValue("colorMemCached",btnMemCached->color());
        setting.setValue("colorMemUsed",btnMemUsed->color());

        setting.setValue("colorSwap",btnSwap->color());

        setting.setValue("intervale",ui->spinBoxInterval->value());


        setting.endGroup();


}

void DialogConfigStat::on_buttonBox_clicked(QAbstractButton *button)
{
        if(ui->buttonBox->standardButton(button)==QDialogButtonBox::Apply){

                  saveSetting();
                  emit   accepteChange();

        }else  if(ui->buttonBox->standardButton(button)==QDialogButtonBox::Ok){

                  saveSetting();
                  emit   accepteChange();

        }
}
