#ifndef WIDGETSYSSTAT_H
#define WIDGETSYSSTAT_H
#include "../../common/dpluginsinterface.h"
#include "../widgetpopup/widgetpopup.h"
#include <QWidget>


//@  نافذة المعلومات
class PopupInfo: public QWidget
{
        Q_OBJECT

public:
        explicit PopupInfo(QWidget* parent = 0);
void show();
signals:

protected :

    void resizeEvent (QResizeEvent *);
public slots:
        void setScreenBotum(bool b,int p)
        {
                if(b==true){
                    widgetBot->setVisible(true);
                    widgetTop->setVisible(false);
                }else{
                    widgetBot->setVisible(false);
                    widgetTop->setVisible(true);
                }
pMap=p;
        }



private slots:

 private:
QLabel *labelCpu ;
QLabel *labelMem ;
QLabel *labelSwap;
 QVBoxLayout  *verticalLayoutPop ;
  QWidget  *widgetTopContenair;
 QWidget  *widgetBotContenair;
 QWidget  *widgetTop ;
 QWidget  *widgetBot ;
 int pMap;

};
namespace SysStat {
    class BaseStat;
}

class WidgetSysStat : public QWidget,PluginsInterface
{
        Q_OBJECT
        Q_INTERFACES(PluginsInterface)

public:
        explicit WidgetSysStat(QWidget *parent = 0);
     void mouseReleaseEvent ( QMouseEvent * event ) ;
signals:
        void cpuTextChanged(const QString &txt);
        void memTextChanged(const QString &txt);
         void swapTextChanged(const QString &txt);
public slots:
        /*virtual*/ void  x11EventFilter(XEvent */*event*/){}

        /*virtual*/ void setLayout(QHBoxLayout *p){p->addWidget(this);}

        /*virtual*/ void setSize(QSize/* size*/){}

        /*virtual*/ void setKeySequence(QKeySequence /*sequence*/){}

        /*virtual*/  QString keySequence() { return ("");}

        /*virtual*/  void setActions(QList<QAction *>list){}
        void themeChanged()
        {

        }
private:
        //     Ui::WidgetSysStat *ui;
        QLabel *labelCpu;
        QLabel *labelMem;
        QLabel *labelSwap;

        SysStat::BaseStat *mMemStat;
        SysStat::BaseStat *mCpuStat;
        SysStat::BaseStat *mSwapStat;
        //  SysStat::BaseStat *mNetStat;

        QString m_memTotal;
        QString m_cpuTotal;
        QString m_swapTotal;

        QAction *m_actSetting;
  int m_interval;
        QColor m_colorCpuNice;
        QColor m_colorCpuUser;
        QColor m_colorCpuIowait;
        QColor m_colorCpuSystem;

        QColor m_colorMemBuffers;
        QColor m_colorMemCached;
        QColor m_colorMemUsed;

        QColor m_colorSwap;
PopupInfo *m_popup;
WidgetPopup *mWidgetPopup;
private slots:
        void  getStatInfo();
        void memoryUpdate(float apps, float buffers, float cached);
        void cpuUpdate(float user, float nice, float system, float other);
        void swapUpdate(float used);
        // void networkUpdate(unsigned received, unsigned transmitted);
        QString readAllFile(const char *filename);
         void configureSettings();
         void customContextMenu(QPoint);
         void loadSettings();
};

#endif // WIDGETSYSSTAT_H
