#include "widgetsysstat.h"
//#include "ui_widgetsysstat.h"
#include "dialogconfigstat.h"
#include <QPainter>
#include <QDebug>
#include <QAction>
#include <QX11Info>
#include <fcntl.h>
#include <unistd.h>
#include <sysstat/cpustat.hpp>
#include <sysstat/memstat.hpp>
#include <sysstat/netstat.hpp>

PopupInfo::PopupInfo(QWidget *parent) :
         QWidget(parent )
{
        //  setWindowFlags(  Qt::Dialog | Qt::WindowStaysOnTopHint | Qt::CustomizeWindowHint | Qt::X11BypassWindowManagerHint);


        verticalLayoutPop = new QVBoxLayout(this);
        verticalLayoutPop->setSpacing(0);
        verticalLayoutPop->setMargin(4);
        widgetTopContenair = new QWidget(this);
//        widgetTopContenair->setObjectName(QString::fromUtf8("widgetTopContenair"));
//        widgetTopContenair->setMinimumSize(QSize(0, 10));
//        widgetTopContenair->setMaximumSize(QSize(16777215, 12));
//        widgetTop = new QWidget(widgetTopContenair);
//        widgetTop->setObjectName(QString::fromUtf8("widgetTop"));
//        widgetTop->setGeometry(QRect(0, 0, 45, 10));
//        widgetTop->setMinimumSize(QSize(45, 10));
//        widgetTop->setMaximumSize(QSize(45, 10));
//        verticalLayoutPop->addWidget(widgetTopContenair);

        QWidget  *widgetBgrmenu = new QWidget(this);

        QGridLayout *gridLayout = new QGridLayout(widgetBgrmenu);
      gridLayout->setSpacing(3);
 gridLayout->setContentsMargins(0,0,0,0);
      QLabel *labelPixmap = new QLabel(widgetBgrmenu);
        labelPixmap->setObjectName(QString::fromUtf8("labelPixmap"));

        QIcon icon=(QIcon::fromTheme("utilities-system-monitor",QIcon(":/icons/applications-utilities.png")));
 //    QPixmap(":/icons/applications-utilities.png");
        labelPixmap->setPixmap(icon.pixmap(64));

        gridLayout->addWidget(labelPixmap, 0, 0, 3, 1);


        labelCpu = new QLabel(widgetBgrmenu);


        gridLayout->addWidget(labelCpu, 0, 1, 1, 1);

        labelMem = new QLabel(widgetBgrmenu);


        gridLayout->addWidget(labelMem, 1, 1, 1, 1);

        labelSwap = new QLabel(widgetBgrmenu);

        gridLayout->addWidget(labelSwap, 2, 1, 1, 1);


        verticalLayoutPop->addWidget(widgetBgrmenu);

//        widgetBotContenair = new QWidget(this);
//        widgetBotContenair->setObjectName(QString::fromUtf8("widgetBotContenair"));
//        widgetBotContenair->setMinimumSize(QSize(0, 10));
//        widgetBotContenair->setMaximumSize(QSize(16777215, 10));
//        widgetBot = new QWidget(widgetBotContenair);
//        widgetBot->setObjectName(QString::fromUtf8("widgetBot"));
//        widgetBot->setGeometry(QRect(0, 0, 45, 10));
//        widgetBot->setMinimumSize(QSize(45, 10));
//        widgetBot->setMaximumSize(QSize(45, 10));
//        verticalLayoutPop->addWidget(widgetBotContenair);

//        verticalLayoutPop->setAlignment(widgetBot,Qt::AlignCenter);
//        verticalLayoutPop->setAlignment(widgetTop,Qt::AlignCenter);

        WidgetSysStat *SysStat = qobject_cast<WidgetSysStat*>(parent);
        connect(SysStat,SIGNAL(cpuTextChanged(QString)),labelCpu,SLOT(setText(QString)));
        connect(SysStat,SIGNAL(memTextChanged(QString)),labelMem,SLOT(setText(QString)));
        connect(SysStat,SIGNAL(swapTextChanged(QString)),labelSwap,SLOT(setText(QString)));


}
void PopupInfo::resizeEvent ( QResizeEvent * /*event*/ )
{
    /*
    QRect screen = QApplication::desktop()->availableGeometry(this);
    QRect rect=QRect(pos(),size());

    if (rect.right() > screen.right())
        rect.moveRight(screen.right());



    if (rect.left()< screen.left())
        rect.moveLeft(screen.left());


    if (rect.bottom() > screen.bottom())
        rect.moveBottom(screen.bottom());
    if (rect.top()< screen.top())
        rect.moveTop(screen.top());




    int p=pMap-rect.left()-22;
    if(p>rect.width()-46)
        p=rect.width()-46;
    if(p<1)
        p=1;

    widgetTop->move(p,0);
    widgetBot->move(p,0);
      move(rect.topLeft());
      */
}
void PopupInfo::show()
{
    /*
    QWidget::show();
    if(QX11Info::isCompositingManagerRunning()){
         verticalLayoutPop->setMargin(4);
    }else{
         verticalLayoutPop->setMargin(1);
         widgetBotContenair->setVisible(false);
        widgetTopContenair->setVisible(false);

    }
    int p=pMap-this->pos().x()-22;
    if(p>this->width()-46)
        p=this->width()-46;
    if(p<1)
        p=1;

    widgetTop->move(p,0);
    widgetBot->move(p,0);
    */
}

WidgetSysStat::WidgetSysStat(QWidget *parent) :
        QWidget(parent)
{


        this->setObjectName("sysstat");
        this->setWindowTitle(trUtf8("System load"));
        this->setWhatsThis(tr("System load viewer by AbouZakaria"));//شرح الاضافة
        this->setWindowIcon(QIcon::fromTheme("utilities-system-monitor",QIcon(":/icons/applications-utilities.png")));

        this->resize(40, 43);
        this->setMaximumWidth(40);

        this->setContextMenuPolicy(Qt::CustomContextMenu);
        connect(this,SIGNAL(customContextMenuRequested(QPoint)) ,this,SLOT(customContextMenu(QPoint)));
        m_actSetting=new QAction(QIcon::fromTheme("configure",QIcon::fromTheme("document-properties")),
                                 trUtf8("System load Settings"),this);

        connect(m_actSetting,SIGNAL(triggered()) ,this,SLOT(configureSettings()));

         //--------------setup ui--------------------------------
        QHBoxLayout   *horizontalLayout = new QHBoxLayout(this);
        horizontalLayout->setSpacing(2);
        horizontalLayout->setContentsMargins(2, 2, 2, 2);

        horizontalLayout->setObjectName(QString::fromUtf8("horizontalLayout"));
        labelCpu = new QLabel(this);
        labelCpu->setObjectName(QString::fromUtf8("labelCpu"));
        //  labelCpu->setMaximumSize(QSize(20, 16777215));
        // labelCpu->setFrameShape(QFrame::StyledPanel);
        labelCpu->setScaledContents(true);
        labelCpu->setAlignment(Qt::AlignCenter);
        horizontalLayout->addWidget(labelCpu);

        labelMem = new QLabel(this);
        labelMem->setObjectName(QString::fromUtf8("labelMem"));
        //    labelMem->setMaximumSize(QSize(20, 16777215));
        //  labelMem->setFrameShape(QFrame::StyledPanel);
        labelMem->setScaledContents(true);
        labelMem->setAlignment(Qt::AlignCenter);
        horizontalLayout->addWidget(labelMem);

        labelSwap = new QLabel(this);
        labelSwap->setObjectName(QString::fromUtf8("labelSwap"));
        //   labelSwap->setMaximumSize(QSize(20, 16777215));
        //   labelSwap->setFrameShape(QFrame::StyledPanel);
        labelSwap->setScaledContents(true);
        labelSwap->setAlignment(Qt::AlignCenter);
        horizontalLayout->addWidget(labelSwap);

        //----------------setup stat-------------------------------
        mMemStat = new SysStat::MemStat(this);
        mCpuStat= new SysStat::CpuStat(this);
        mSwapStat= new SysStat::MemStat(this);
       // mNetStat= new SysStat::NetStat(this);

        qobject_cast<SysStat::CpuStat*>(mCpuStat)->setMonitoring(SysStat::CpuStat::LoadOnly);
        qobject_cast<SysStat::MemStat*>(mMemStat)->setMonitoredSource("memory");
        qobject_cast<SysStat::MemStat*>(mSwapStat)->setMonitoredSource("swap");

        connect(qobject_cast<SysStat::CpuStat*>(mCpuStat), SIGNAL(update(float, float, float, float)), this, SLOT(cpuUpdate(float, float, float, float)));
        connect(qobject_cast<SysStat::MemStat*>(mSwapStat), SIGNAL(swapUpdate(float)), this, SLOT(swapUpdate(float)));
        //connect(qobject_cast<SysStat::NetStat*>(mNetStat), SIGNAL(update(unsigned, unsigned)), this, SLOT(networkUpdate(unsigned, unsigned)));
        connect(qobject_cast<SysStat::MemStat*>(mMemStat), SIGNAL(memoryUpdate(float, float, float)), this, SLOT(memoryUpdate(float, float, float)));

        getStatInfo();
        loadSettings();

        labelCpu->setToolTip(tr("reading ..."));
        labelMem->setToolTip(tr("reading ..."));
        labelSwap->setToolTip(tr("reading ..."));
        m_popup=new PopupInfo(this);
        mWidgetPopup=new WidgetPopup(this,m_popup);
}
void WidgetSysStat::loadSettings()
{
        QSettings setting("elokab","settings");
        setting.beginGroup("System-Load");
        m_interval=setting.value("intervale",1500).toInt();
        m_colorCpuNice=setting.value("colorCpuNice",QColor("#FFFF00")).value<QColor>();
        m_colorCpuUser=setting.value("colorCpuUser",QColor("#0000FF")).value<QColor>();
        m_colorCpuIowait=setting.value("colorCpuIowait",QColor("#006400")).value<QColor>();
        m_colorCpuSystem=setting.value("colorCpuSystem",QColor("#FF0000")).value<QColor>();

        m_colorMemBuffers=setting.value("colorMemBuffers",QColor("#FFFF00")).value<QColor>();
        m_colorMemCached=setting.value("colorMemCached",QColor("#006400")).value<QColor>();
        m_colorMemUsed=setting.value("colorMemUsed",QColor("#0000FF")).value<QColor>();

        m_colorSwap=setting.value("colorSwap",QColor("#00CDCD")).value<QColor>();

        setting.endGroup();
        mCpuStat->setUpdateInterval(m_interval);
        mMemStat->setUpdateInterval(m_interval);
        mSwapStat->setUpdateInterval(m_interval );
        // mNetStat->setUpdateInterval(2 * 1000.0);

}
void  WidgetSysStat::mouseReleaseEvent ( QMouseEvent * event )
{
        if(event->button()!=Qt::LeftButton)
                return;
      /*
        QPoint mPos;
        Qt::Corner mAnchor;
        if (isLeftToRight())
        {
                  mPos=mapToGlobal(QPoint(0,geometry().bottom()));
                  mAnchor= Qt::TopLeftCorner;
        }else{

                  mPos=mapToGlobal(QPoint(geometry().width(),geometry().bottom()));
                  mAnchor=Qt::TopRightCorner;
        }
        int mPosbtn=mapToGlobal(QPoint(geometry().width()/2,geometry().bottom()/2)).x();

        QRect rect;
        rect.setSize(QSize(m_popup->sizeHint().width(),m_popup->sizeHint().height()));
        switch (mAnchor)
        {
        case Qt::TopLeftCorner:
                  rect.moveTopLeft(mPos);
                  break;

        case Qt::TopRightCorner:
                  rect.moveTopRight(mPos);
                  break;
        }

        QRect screen = QApplication::desktop()->availableGeometry(mPos);

        if (rect.right() > screen.right())
                  rect.moveRight(screen.right());

        if (rect.bottom() > screen.bottom()){
                rect.moveBottom(screen.bottom());
                mWidgetPopup->setScreenBotum(true,mPosbtn);
        }else{
                mWidgetPopup->setScreenBotum(false,mPosbtn);
        }

        if (rect.left()< screen.left())
                  rect.moveLeft(screen.left());

qDebug()<<mPosbtn;
*/
int mPosbtn=mapToGlobal(QPoint(geometry().width()/2,geometry().bottom()/2)).x();

int wW=(this->width()/2);

mWidgetPopup->open(mapToGlobal(QPoint(geometry().width()-wW,geometry().bottom()))
              , mPosbtn);

   //     m_popup-> move(rect.topLeft());
//        m_popup->show();

}

//----------------------------------------------------
template <typename T>
T clamp(const T &value, const T &min, const T &max)
{
    return qMin(qMax(value, min), max);
}
/********************************************
 ************get the cpu freq****************
 ************get the mem total***************
*************get the swap total**************
*********************************************/
void WidgetSysStat::getStatInfo()
 {
        //---cpu mh
        foreach (QString row, readAllFile("/proc/cpuinfo").split(QChar('\n'), QString::SkipEmptyParts))
        {
                //   qDebug()<<row;
                QStringList tokens = row.split(QChar(':'));
                QString cpuTotal;
                //qDebug()<<tokens[0];
                QString txt=tokens[0];
                if (txt.trimmed()== "cpu MHz")
                        cpuTotal = tokens[1];

                if (!cpuTotal.isEmpty())
                {
                       m_cpuTotal=cpuTotal;

                }

        }
        //--mem swap---
        qulonglong memTotal;
        qulonglong swapTotal;

        foreach (QString row, readAllFile("/proc/meminfo").split(QChar('\n'), QString::SkipEmptyParts))
        {
                QStringList tokens = row.split(QChar(' '), QString::SkipEmptyParts);
                if (tokens.size() != 3)
                        continue;

                if (tokens[0] == "MemTotal:")
                        memTotal = tokens[1].toULong();

                else if(tokens[0] == "SwapTotal:")
                        swapTotal = tokens[1].toULong();

        }

        if (memTotal)
        {
              //  qDebug()<<"memTotalmega"<<memTotal/1024;
                m_memTotal=QString::number(memTotal/1024);

        }

        if (swapTotal)
        {
              //  qDebug()<<"swapTotalmega"<<swapTotal/1024;
                  m_swapTotal=QString::number(swapTotal/1024);

        }

 }

QString WidgetSysStat::readAllFile(const char *filename)
{
    QString result;

    static const size_t bufferSize = 1 << 12; // 4096
    static char buffer[bufferSize];

    int fd = ::open(filename, O_RDONLY);
    if (fd > 0)
    {
        ssize_t size = ::read(fd, buffer, bufferSize);
        ::close(fd);
        if (size > 0)
            result = QString::fromAscii(buffer, size);
    }

    return result;
}

//-------------------------------Update Stat-----------------------------------------
/*******************************************
 ************update the memory used*********
 *******************************************/
 void WidgetSysStat::memoryUpdate(float apps, float buffers, float cached)
 {

         int y_apps    = clamp(static_cast<int>(apps    * 100.0)            , 0, 99);
         int y_buffers = clamp(static_cast<int>(buffers * 100.0) + y_apps   , 0, 99);
         int y_cached  = clamp(static_cast<int>(cached  * 100.0) + y_buffers, 0, 99);

         int mbuffers = clamp(static_cast<int>(buffers  * 100.0), 0, 99);
 int mcached  = clamp(static_cast<int>(cached  * 100.0), 0, 99);
         QPainter p;
         QPixmap pix(20,100);
         pix.fill(Qt::transparent);


         QLinearGradient linearGrad(QPointF(0,y_cached), QPointF(20, y_cached));
             linearGrad.setColorAt(0, Qt::transparent);
             QColor color=Qt::black;
             color.setAlpha(130);
             linearGrad.setColorAt(0.9, color);

         p.begin(&pix);
         p.fillRect(0,100-y_cached,20,y_cached,m_colorMemCached);
         p.fillRect(0,100-y_buffers,20,y_buffers,m_colorMemBuffers);
         p.fillRect(0,100-y_apps,20,y_apps,m_colorMemUsed);
          p.fillRect(0,100-y_cached,20,y_cached,linearGrad);

         p.end();
         labelMem->setPixmap(pix);
QString txt=QString(tr("Mem Usage:%1% Mem cached:%2% of %3 MiB  "))
                .arg(QString::number(y_apps))
                .arg(QString::number(mcached+mbuffers))
                .arg(m_memTotal);

         labelMem->setToolTip(txt);
         if(m_popup->isVisible())
             emit memTextChanged(txt);
 }
 /*******************************************
  **************update the cpu used*********
  *******************************************/
 void WidgetSysStat::cpuUpdate(float user, float nice, float system, float other)
 {
         int y_system = clamp(static_cast<int>(system * 100.0)           , 0, 99);
         int y_user   = clamp(static_cast<int>(user   * 100.0) + y_system, 0, 99);
         int y_nice   = clamp(static_cast<int>(nice   * 100.0) + y_user  , 0, 99);
         int y_other  = clamp(static_cast<int>(other  * 100.0) + y_nice  , 0, 99);

         QPainter p;
         QPixmap pix(20,100);
         pix.fill(Qt::transparent);
         QLinearGradient linearGrad(QPointF(0,y_other), QPointF(20, y_other));
             linearGrad.setColorAt(0, Qt::transparent);
             QColor color=Qt::black;
             color.setAlpha(130);
             linearGrad.setColorAt(0.9, color);

         p.begin(&pix);
         p.fillRect(0,100-y_other,20,y_other,m_colorCpuIowait);
         p.fillRect(0,100-y_nice,20,y_nice,m_colorCpuNice);
         p.fillRect(0,100-y_user,20,y_user,m_colorCpuUser);
         p.fillRect(0,100-y_system,20,y_system,m_colorCpuSystem);
  p.fillRect(0,100-y_other,20,y_other,linearGrad);
//         p.setPen(this->palette().shadow().color());
//         p.drawRect(pix.rect());
//         p.setPen(this->palette().light().color());
//         p.drawRect(-1,-1,20,99);
         p.end();
         labelCpu->setPixmap(pix);
QString txt=QString(tr("Cpu Usage:%1% at %2  MHz/cpu")).arg(QString::number(y_other)).arg(m_cpuTotal);
       //  labelCpu->setToolTip("Cpu :"+QString::number(y_other)+"% at "+m_cpuTotal +" MHz/cpu");
         labelCpu->setToolTip(txt);
        if(m_popup->isVisible())
         emit cpuTextChanged(txt);

  }
 /*******************************************
  **************update the swap used*********
  *******************************************/
 void WidgetSysStat::swapUpdate(float used)
 {
         int y_used = clamp(static_cast<int>(used * 100.0), 0, 99);

         QPainter p;
         QPixmap pix(20,100);
         pix.fill(Qt::transparent);
         QLinearGradient linearGrad(QPointF(0,y_used), QPointF(20, y_used));
             linearGrad.setColorAt(0, Qt::transparent);
             QColor color=Qt::black;
             color.setAlpha(130);
             linearGrad.setColorAt(0.9, color);

         p.begin(&pix);
         p.fillRect(0,100-y_used,20,y_used,m_colorSwap);
 p.fillRect(0,100-y_used,20,y_used,linearGrad);
//         p.setPen(this->palette().shadow().color());
//         p.drawRect(pix.rect());
//         p.setPen(this->palette().light().color());
//         p.drawRect(-1,-1,20,99);
         p.end();
         labelSwap->setPixmap(pix);
        QString txt=QString(tr("Swap Usage:%1% of %2 MiB")).arg(QString::number(y_used)).arg(m_swapTotal);
         labelSwap->setToolTip(txt);
         if(m_popup->isVisible())
         emit swapTextChanged(txt);
 }
 /*
 void WidgetSysStat::networkUpdate(unsigned received, unsigned transmitted)
 {
      qreal mNetRealMaximumSpeed=1;

     qreal min_value = qMin(qMax(static_cast<qreal>(qMin(received, transmitted)) /mNetRealMaximumSpeed, static_cast<qreal>(0.0)), static_cast<qreal>(1.0));
     qreal max_value = qMin(qMax(static_cast<qreal>(qMax(received, transmitted)) / mNetRealMaximumSpeed, static_cast<qreal>(0.0)), static_cast<qreal>(1.0));
     int y_min_value = clamp(static_cast<int>(min_value * 100.0)              , 0, 99);
     int y_max_value = clamp(static_cast<int>(max_value * 100.0) + y_min_value, 0, 99);
     qDebug()<<"y_min_value"<<y_min_value;
     qDebug()<<"y_max_value"<<y_max_value;
 }
*/

 /*************************************
  **********show the configurations****
  *************************************/
 void WidgetSysStat::configureSettings()
 {
         DialogConfigStat *dlg=new DialogConfigStat;
         connect(dlg, SIGNAL(accepteChange()), this, SLOT(loadSettings()));
         dlg->show();
 }
 /*************************************
  *****************ContextMenu*********
  *************************************/
 void WidgetSysStat:: customContextMenu(QPoint)
 {
         QMenu menu;
         menu.addAction(m_actSetting);
         menu.exec(this->cursor().pos());
 }

Q_EXPORT_PLUGIN2(dpanel_sysstat, WidgetSysStat)
