/********************************************************************
 *(c)GPL3+
  Inspired by freedesktops tint2
original code  http://razor-qt.org
 modified by abou zakaria
*********************************************************************/

#ifndef SYSTRAY_H
#define SYSTRAY_H


#include "../../dpluginsinterface.h"
#include <X11/X.h>
#include <X11/Xlib.h>
#include <QObject>
#include <QFrame>
#include <QList>
#include <QToolButton>

#include <X11/extensions/Xdamage.h>
class Xatom
{
public:
 static   Atom atom(const char* atomName);
};
class TrayIcon;

class SysTray: public  QWidget,PluginsInterface
{
          Q_OBJECT
          Q_INTERFACES(PluginsInterface)



public:
          explicit  SysTray(QWidget* parent = 0);

          ~SysTray();

          QSize iconSize() const { return m_iconSize; }
        //  void setIconSize(QSize iconSize);


          /*virtual*/     void x11EventFilter(XEvent* event);
          /*virtual*/  void setKeySequence(QKeySequence /*sequence*/){}
          /*virtual*/   QString   keySequence(){  return ("");}
          /*virtual*/   void setLayout(QHBoxLayout *p){ p->addWidget(this);}

          /*virtual*/        void setSize(QSize/* size*/);
          /*virtual*/  void setActions(QList<QAction *>/*list*/){}
          /*virtual*/   void themeChanged(){ }



signals:
         // void iconSizeChanged(int iconSize);

private slots:
          void startTray();
          void stopTray();
          void realign();
  TrayIcon* findIcon(Window trayId);
private:
          VisualID getVisual();

          void clientMessageEvent(XClientMessageEvent* e);

          void addIcon(Window id);


          bool m_valid;
          Window m_trayId;
          QList<TrayIcon*> m_iconsList;
          int m_damageEvent;
          int m_damageError;
          QSize m_iconSize;
          QGridLayout *m_gridLayout;
int m_row;
int m_col;
int m_panelH;
};

class TrayIcon: public QWidget
{
    Q_OBJECT


public:

    TrayIcon(Window iconId, QWidget* parent);
    virtual ~TrayIcon();
public slots:
    Window iconId() { return m_iconId; }
    Window windowId() { return m_windowId; }

    bool isValid() const { return m_iconValid; }

    QSize iconSize() const { return m_iconSize; }
    void setIconSize(const QSize &iconSize);


    QSize sizeHint() const;


protected:
    bool event(QEvent *event);
    void draw(QPaintEvent* event);

private:
    bool init();

    QRect iconGeometry();
    Window m_iconId;
    Window m_windowId;
    bool m_iconValid;
    QSize m_iconSize;
    Damage m_damage;


};



#endif //SYSTRAY_H
