/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef DIALOGCONFIGTIMER_H
#define DIALOGCONFIGTIMER_H

#include <QDialog>
#include <QAbstractButton>
namespace Ui {
class DialogConfigTimer;
}
/**
 * @brief The DialogConfigTimer class اعدادات الساعة
 */
class DialogConfigTimer : public QDialog
{
          Q_OBJECT


public:
    /**
           * @brief DialogConfigTimer تكوين النافذة
           * @param parent
           */
          explicit DialogConfigTimer(QWidget *parent = 0);
          ~DialogConfigTimer();
signals:
    /**
           * @brief settingsChangedاشارة بتغير الاعدادات
           */
          void  settingsChanged();
private:
          Ui::DialogConfigTimer *ui;

private slots:
          /**
           * @brief loadSetting تحميل الاعدادات
           */
          void loadSetting();
          /*!< حفظ الاعدادات */
          void saveSetting();
          /*!< تحميل الايام */
void chargeDays(int indx);

          void on_buttonBox_accepted();
          void on_buttonBox_clicked(QAbstractButton *button);
          void on_comboBoxNumber_activated(int index);
          void on_comboBoxLocale_currentIndexChanged(int index);
          void on_comboBoxFirstDay_currentIndexChanged(int index);
};

#endif // DIALOGCONFIGTIMER_H
