/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#include "formcaldlg.h"
#include "ui_formcaldlg.h"
#include <QCalendarWidget>
#include <QTextCharFormat>
#include <QGraphicsDropShadowEffect>
#include <QX11Info>
#include <QListWidget>
#include <QDebug>
FormCaldlg::FormCaldlg(QLocale lc, int day, QWidget *parent) :
    QWidget(parent),
    ui(new Ui::FormCaldlg)
{
        ui->setupUi(this);

        setWindowFlags(  Qt::Dialog | Qt::WindowStaysOnTopHint | Qt::CustomizeWindowHint | Qt::X11BypassWindowManagerHint);


        QCalendarWidget* mcalDlg=new QCalendarWidget;
        ui->verticalLayoutCal->addWidget(mcalDlg);
        ui->verticalLayoutPop->setAlignment(ui->widgetTop,Qt::AlignCenter);
        ui->verticalLayoutPop->setAlignment(ui->widgetBot,Qt::AlignCenter);
        mcalDlg->setLocale(lc);
        mcalDlg->setFirstDayOfWeek(Qt::DayOfWeek(day));
        mcalDlg->setAttribute(Qt::WA_TranslucentBackground,false);
        mcalDlg->setStyleSheet("color: palette(text);");
//mcalDlg->setStyleSheet(QString("QTableView,QToolTip{"
//                               "  background-color:red;"
//                               "   border-radius:0px;"
//                               "    border:0px outset palette(dark);"
//                               " }"));






        QGraphicsDropShadowEffect *fx = new QGraphicsDropShadowEffect();
        if(this->isRightToLeft())
                fx->setOffset(-3,3);
        else
                fx->setOffset(3,3);
        fx->setBlurRadius(10);
        fx->setColor(QColor(63, 63, 63, 200));

//        if(QX11Info::isCompositingManagerRunning()){
//                this->setPalette(Qt::transparent);
//                this->setAttribute(Qt::WA_TranslucentBackground,true);
//                 setGraphicsEffect(fx);
//        }else{
//                setObjectName("widgetBgrmenu");
//        }
        this->setPalette(Qt::transparent);
        this->setAttribute(Qt::WA_TranslucentBackground,true);
         setGraphicsEffect(fx);

}

FormCaldlg::~FormCaldlg()
{
    delete ui;
}
void FormCaldlg::setScreenBotum(bool b,int p)
{
        if(b==true){
            ui->widgetBotContenair->setVisible(true);
            ui->widgetTopContenair->setVisible(false);
        }else{
            ui->widgetBotContenair->setVisible(false);
            ui->widgetTopContenair->setVisible(true);
        }
//qDebug()<<this->geometry().width();
//        if(this->geometry().width()-46)
//            p=this->geometry().width()-46;
        if(p<1)
            p=1;

         ui->widgetTop->move(p,0);
         ui->widgetBot->move(p,0);
}
void FormCaldlg::show()
{
    QWidget::show();
    if(QX11Info::isCompositingManagerRunning()){
          ui->verticalLayoutPop->setMargin(4);
    }else{
      ui->verticalLayoutPop->setMargin(1);
      ui->widgetBotContenair->setVisible(false);
      ui->widgetTopContenair->setVisible(false);
    }
}
