/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef LABELTIME_H
#define LABELTIME_H
#include <QWidget>
#include "../../dpluginsinterface.h"
#include "../widgetpopup/widgetpopup.h"

#include <QLabel>
#include <QTimer>
#include <QHBoxLayout>

/**
 * @brief The LabelTime class اضافة الساعة
 */
class LabelTime : public QLabel,PluginsInterface
{
          Q_OBJECT
          Q_INTERFACES(PluginsInterface)
public:
          explicit LabelTime(QWidget *parent = 0);
protected:
          virtual void mouseReleaseEvent(QMouseEvent* event);
signals:

public slots:
          /*virtual*/ void  x11EventFilter(XEvent */*event*/){}

          /*virtual*/ void setLayout(QHBoxLayout *p){p->addWidget(this);}

          /*virtual*/ void setSize(QSize size);

          /*virtual*/ void setKeySequence(QKeySequence /*sequence*/){}

          /*virtual*/  QString keySequence() { return ("");}

          /*virtual*/  void setActions(QList<QAction *>list){mlistAction=list;}
    void themeChanged();

private:
          QTimer *timer;
          QString m_timeFormat;

        //   FormCaldlg * calDlg;
private slots:
          void updatTime();
          void loadSetting();
       //   void saveSetting();
          void getFormat();
          void customContextMenu(QPoint);
private:
        QList<QAction *>mlistAction;
          int mSize;
          int m_numberStyle;
WidgetPopup *mWidgetPopup;
  QCalendarWidget* mCalendarWidget;
         int m_firstDay;
         QLocale localTimerNum;
         QLocale localCalandar;
};

#endif // LABELTIME_H
