/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef ELOKABVOLUME_H
#define ELOKABVOLUME_H

#include "../../dpluginsinterface.h"
#include "audioengine.h"
#include "widgetvolume.h"
#include "../widgetpopup/widgetpopup.h"


class AudioEngine;
class AudioDevice;



#define SETTINGS_MIXER_COMMAND          "mixerCommand"
#define SETTINGS_DEFAULT_MIXER_COMMAND      "kmix"
#define SETTINGS_DEVICE                 "device"
#define SETTINGS_DEFAULT_DEVICE                 0



class ElokabVolume : public QLabel,PluginsInterface
{
        Q_OBJECT
        Q_INTERFACES(PluginsInterface)
public:
    ElokabVolume( QWidget* parent = 0);
    /*virtual*/ void  x11EventFilter(XEvent */*event*/){}

    /*virtual*/ void setLayout(QHBoxLayout *p){p->addWidget(this);}

    /*virtual*/ void setSize(QSize size){
        mSize=size;
        setMaximumSize(size);

    mWidgetVolume->updateStockIcon();

    }

    /*virtual*/ void setKeySequence(QKeySequence /*sequence*/);

    /*virtual*/ QString keySequence();

    /*virtual*/ void setActions(QList<QAction *>/*list*/){}

    /*virtual*/ void themeChanged()
    {
         mWidgetVolume->updateStockIcon();
    }
 private slots:
    void iconChanged(int value);
void showDialogDevice();
void showDialogMexer();
    void setAudioEngine(AudioEngine *engine);

    void shortcutVolumeUp();
    void shortcutVolumeDown();
    void shortcutVolumeMute();
    void progressShow();
    void progressHide();



        void togglePopupVolume();
        void realignePopup(bool progress);
        void launchMixer();
  void wheelEvent(QWheelEvent* e);

        void showMenuContext();
        void setupProgressSlider();
        void mixerLineEditChanged(const QString &command);
      void sinkSelectionChanged(const QString &item);
signals:
 void   isVisible(bool v);

protected:
          virtual void mouseReleaseEvent(QMouseEvent* event);
  virtual void settingsChanged();
private:
    AudioEngine *mEngine;
QString m_ksUp;
QString m_ksDown;
QString m_ksMute;
    int mSinkIndex;
    AudioDevice *mSink;
QSize mSize;

      WidgetVolume *mWidgetVolume;
      WidgetPopup *mwidgetpopup;
      QString mMixerCommand;

      //***********

      QProgressBar *progressBar;
QTimer *timeSlide;
};



#endif // ELOKABVOLUME_H
