#include "elokabsaver.h"
#include "saver_adaptor.h"
#include <QApplication>

#include <QDBusConnection>
int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

    a.setApplicationName("elokab-ssaver");
    a.setApplicationVersion("0.1");
    a.setOrganizationName("elokab");

    //--------------------------------------------------------------------
    QStringList argA = a.arguments();
    QString act;
    QDBusConnection connection = QDBusConnection::sessionBus();
    qDebug()<<argA.count();
    if(argA.count()>1)
    {
        QString help=QObject::tr
                ("Usage: elokab-ssaver [OPTION]\n"
                 " \n"
                 "OPTION:\n"
                 " -l  lock            activate screensaver locked.\n"
                 " -a  activate         activate screensaver no locked"
                 );

        QString arg = argA.at(1);
        if (arg == "-h" || arg == "--help" ) { qDebug()<<help;return 0; }
        else if (arg == "-l"|| arg == "lock" )    {act="lock";}
        else if (arg == "-a" ||arg == "activate" ) {act="activate";}
        else { qWarning() << "Unknown option: " << argA;  qDebug()<<help; return 1;}
        QDBusInterface dbus("org.elokab.ScreenSaver",
                            "/org/elokab/ScreenSaver",
                            "org.elokab.ScreenSaver");

        if (dbus.isValid()) {
            QList<QVariant> args;
            dbus.callWithArgumentList(QDBus::NoBlock, act, args);
            return 1;
        }

    }


        //----------------------------------------------------------------------

        if (!  connection.registerService("org.freedesktop.ScreenSaver"))
        {
            qWarning() << "Unable to register 'freedesktop.ScreenSaver' service - is another instance of freedesktop.ScreenSaver running?";
            QDBusInterface dbus("org.freedesktop.Notifications",
                                "/org/freedesktop/Notifications",
                                "org.freedesktop.Notifications");

            if (!dbus.isValid()) {
                qDebug() << "QDBusInterface is not valid!";
                return 1;
            }

            QList<QVariant> args;
            args.append("Elokab ScreenSaver");       // Application Name
            args.append(0123U);         // Replaces ID (0U)
            args.append("elokab");     // Notification Icon
            args.append("Elokab ScreenSaver");          // Body
            args.append( "Unable to register 'freedesktop.ScreenSaver' service - is another instance of freedesktop.ScreenSaver running?");       // Summary
            args.append(QStringList()); // Actions
            args.append(QVariantMap());
            args.append(3000);
            dbus.callWithArgumentList(QDBus::NoBlock, "Notify", args);
            //if(argA.count()<1)
            return 1;
        }




    if (!connection.registerService("org.elokab.ScreenSaver"))
    {
        qWarning() << "Unable to register 'elokab.ScreenSaver' service - is another instance of elokab.ScreenSaver running?";


        return 1;
    }
    ElokabSaver *elokabSaver = new ElokabSaver;

    new Saver_Adaptor(elokabSaver);
    connection.registerObject("/org/elokab/ScreenSaver", elokabSaver);


    //-----------------------------------------
    a.setQuitOnLastWindowClosed(false);

    if(argA.count()>1)
    {
        if(act=="lock")
            elokabSaver->setLockAction(true);
        else
            elokabSaver->setLockAction(false);

    }
    return a.exec();
}
