#include "widgetssaver.h"
#include "passworddlg.h"
#include <QProcess>
#include <QPushButton>
#include <QApplication>
#include <QDesktopWidget>
#include <QMessageBox>
#include <QDebug>
#include <QTime>
#include <QSettings>
#include <QInputDialog>
//____________________________________________________________
WidgetSsaver::WidgetSsaver(bool lock,QWidget *parent)
    : QWidget(parent),mLock(lock),passwordDlg(0)
{
    setWindowFlags(Qt::X11BypassWindowManagerHint| Qt::CustomizeWindowHint);

    setAttribute(Qt::WA_DeleteOnClose);
    if(mLock){
        passwordDlg =new PasswordDlg;
        connect(passwordDlg, SIGNAL(accepted()), this, SLOT(acceptedPassword()));
        connect(passwordDlg, SIGNAL(rejected()), this, SLOT(setGrab()) );

    }


    gridLayout = new QGridLayout(this);
    gridLayout->setMargin(0);

    widgetContent=new QWidget;

    widgetContent-> setObjectName("WidgetSsaver");


    labelTimer = new QLabel("00:00:00",widgetContent);
    labelTimer->setObjectName(QString::fromUtf8("WTimer"));
    QSizePolicy sizePolicy1(QSizePolicy::Preferred, QSizePolicy::Fixed);
    sizePolicy1.setHorizontalStretch(0);
    sizePolicy1.setVerticalStretch(0);
    sizePolicy1.setHeightForWidth(labelTimer->sizePolicy().hasHeightForWidth());
    labelTimer->setSizePolicy(sizePolicy1);
    QFont font;
    font.setPointSize(37);
    labelTimer->setFont(font);
    labelTimer->setAlignment(Qt::AlignCenter);

    gridLayout->addWidget(widgetContent);




    updatTime();
    timer=new QTimer(this);
    connect(timer,SIGNAL(timeout()) ,this,SLOT(updatTime()));
    //  timer->start(1000);
    //   QPushButton *btn=new QPushButton("tttt",this);
    // connect(btn,SIGNAL(clicked()),this,SLOT(close()));
    loadSettings();
    show();

}

//____________________________________________________________
WidgetSsaver::~WidgetSsaver()
{
    qDebug()<<"~WidgetSsaver()";

    deleteLater();
    emit finiched();
}

//____________________________________________________________
void WidgetSsaver::mousePressEvent(QMouseEvent */*e*/)
{
    activated();
}

//____________________________________________________________
void WidgetSsaver::keyPressEvent(QKeyEvent * /*event*/ )
{
    activated();

}

//____________________________________________________________
void WidgetSsaver::show()
{

    QDesktopWidget scren;

    QWidget:: show();

    setMinimumSize(scren.size());
    resize(scren.width(),scren.height());





    activateWindow();

    QApplication::setActiveWindow(this);

    QTimer::singleShot(100,this,SLOT(setGrab()));
     resize(scren.width(),scren.height());
         labelTimer->move((scren.width()-labelTimer->width())/2,scren.height()/2);

}

//____________________________________________________________
void WidgetSsaver::activated()
{
    //releaseKeyboard();
    QApplication::restoreOverrideCursor();

    if(mLock&&passwordDlg){
        QDesktopWidget scren;
        passwordDlg->show();
        passwordDlg->move((scren.width()/2)-150,(scren.height()/2)-40);
        //  qDebug()<<scren.size();
        passwordDlg->setGrab();
        QTimer::singleShot(10,passwordDlg,SLOT(setGrap()));

    }else{
        acceptedPassword();
    }


}
//____________________________________________________________
void WidgetSsaver::setGrab()
{

    grabKeyboard();
    setFocus();
    QApplication::setOverrideCursor(Qt::BlankCursor) ;

}

//____________________________________________________________

void WidgetSsaver::acceptedPassword()
{
/*
    if (arg.isEmpty()){
        setGrab();
        return;
    }
    QString  i="USER";
    QString mUser=(qgetenv(i.toUtf8().constData()));
    AmeUserProcess *p = new AmeUserProcess();
    p->setUser(mUser, arg);
    if (p->exec("sudo", AmeUserProcess::WaitForExit)){

        if(p->status()==5){

            releaseKeyboard();

            //      timer->stop();
            // emit finiched();
            close();

        }

        qDebug() << "process status = " << p->status();
    }
    setGrab();
    */

    releaseKeyboard();
    close();
}

//____________________________________________________________
void WidgetSsaver::loadSettings()
{


    QSettings settings("elokab","screensaver");

    QString bgColor=settings.value("BgrStyle","background-color: rgb(255, 170, 0);").toString();
    QString timerColor=settings.value("TimerStyle","color:rgb(255, 255, 255);").toString();

    int styleType=settings.value("ScreenType",0).toInt();

    QString xScreenPath=settings.value("xScreenPath").toString();



    setStyleSheet("background-color: rgb(0, 0, 0);");
    if(styleType==2){


        widgetContent->setVisible(false);
        QString  argument=QString("%1 -window-id  %2"
                                  ).arg(xScreenPath).arg(this->winId());
        QProcess *processDesktop=new QProcess ;
        processDesktop->start(argument);
     //   qDebug( )<<argument;

    }else{
        widgetContent->setVisible(true);
        setStyleSheet(QString("QWidget#WidgetSsaver{%1}"
                              "QLabel#WTimer{%2}")
                      .arg(bgColor)
                      .arg(timerColor));
      //  qDebug( )<<styleSheet();
        // labelTimer->setVisible(true);
        timer->start(1000);
    }
}

//____________________________________________________________
void WidgetSsaver::updatTime()
{

    QLocale localTimer;
    labelTimer->setText( localTimer.toString( QTime::currentTime(),"hh:mm:ss"));
   // qDebug()<<labelTimer->text();
}
