/****************************************************************************
**
** Copyright (C) 2011 Nokia Corporation and/or its subsidiary(-ies).
** All rights reserved.
** Contact: Nokia Corporation (qt-info@nokia.com)
**
** This file is part of the examples of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:BSD$
** You may use this file under the terms of the BSD license as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of Nokia Corporation and its Subsidiary(-ies) nor
**     the names of its contributors may be used to endorse or promote
**     products derived from this software without specific prior written
**     permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
** $QT_END_LICENSE$
**
****************************************************************************/
#include <QtGui>
#include "Tawhid.h"

#include <math.h>
//#include "dialogselectwm.h"
#include <unistd.h>
#include <QtGui>
#include <QX11Info>
#include <QDesktopWidget>
#include <QMessageBox>
#include "elokabautostart.h"
#include <X11UTILLS>
#include "notificationutill.h"
#define TYPE_EXEC "exec"
#define TYPE_SCRIPT "script"


Tawhid::Tawhid()
{
        Mnum=0;

}
void Tawhid::startSession()
{
    //! XDG_CONFIG_DIRS everenment---------------------------------------------------

    QString  xdgENV="XDG_CONFIG_DIRS";

    QVariant myXDG=QString("/etc/xdg:/etc/xdg/elokab:") ;

    QByteArray xdg=qgetenv(xdgENV.toUtf8().constData());

    qputenv(xdgENV.toUtf8().constData(),myXDG.toByteArray()+xdg);

    qDebug()<<"XDG_CONFIG envirenment :"<<   qgetenv(xdgENV.toUtf8().constData());

    //! CONFIG_DIRS PATH----------------------------------------------------------
    QDir dirp(QDir::homePath());
    dirp.mkpath(QDir::homePath()+"/.config");
    dirp.mkpath(QDir::homePath()+"/.local/share/elokab");


 QSettings sT("elokab","elokabsettings");

    ///! check if start the screen welcom----------------------------------------
//
//    sT.beginGroup("Welcome");

//    bool startWelcom=sT.value("ShowStartup",true).toBool();

//    sT.endGroup();

//    if(startWelcom==true){
//        QProcess p;
//        p.execute("elokab-welcome");
//    }

//    sT.sync();
 ///!  مدير النوافذ WINDOW MANAGER----------------------------------------



    //!ICONS THEM----------------------------------------------------------
    loadIconThems();

    //! مؤشر الفأرة CURSOR-------------------------------------------------
    QString  key="XCURSOR_THEME";

    sT.beginGroup("Cursor");
    QByteArray cursor=  sT.value(key).toByteArray();
    qputenv(key.toUtf8().constData(), cursor);
    sT.endGroup();

    qDebug()<<"cursor envirenment :"<<   qgetenv(key.toUtf8().constData());
    startWindowManager();

    //! مدير الملفات FILEMANAGER--------------------------------------------

    sT.sync();
    //----------------file manager failback----------
    QStringList listFailback;
    QString failback;
    listFailback <<"elokab-fm"<< "dolphin"<< "nautilus"<< "pcmanfm"<< "caja"<< "thunar"<< "konqueror";
    //
    QDir dir("/usr/bin/");
    foreach (QString s, listFailback)
    {
        if (dir.exists(s))
        {
            failback=s;

            break;
        }
    }
    if(failback.isEmpty())
        failback="elokab-fm";


    key="BROWSER";
    sT.beginGroup("DefaultBrowser");
    QByteArray browser=  sT.value(key,failback).toByteArray();
    qputenv(key.toUtf8().constData(), browser);
    sT.endGroup();

    qDebug()<<"browser envirenment :"<<   qgetenv(key.toUtf8().constData());


    //! gtk everenment--------------------------------------------------------
    QString  gtkENV="GTK_RC_FILES";
    QString  gtk2ENV="GTK2_RC_FILES";
    QString  gtk3ENV="GTK3_RC_FILES";

    QVariant gtk=QString("/etc/gtk/gtkrc:%1/.gtkrc")
            .arg(QDir::homePath());

    QVariant gtk2=QString("/etc/gtk-2.0/gtkrc:%1/.gtkrc-2.0")
            .arg(QDir::homePath());

    QVariant gtk3=QString("/etc/gtk-3.0/settings.ini:%1/.config/gtk-3.0/settings.ini")
            .arg(QDir::homePath());

    //TODO :ADD Her GTK RC file
    qputenv(gtkENV.toUtf8().constData(), gtk.toByteArray());
    qputenv(gtk2ENV.toUtf8().constData(), gtk2.toByteArray());
    qputenv(gtk3ENV.toUtf8().constData(), gtk3.toByteArray());
    //TODO add copy gtk file
    qDebug()<<"gtk envirenment :"<<   qgetenv(gtkENV.toUtf8().constData());
    qDebug()<<"gtk2 envirenment :"<<   qgetenv(gtk2ENV.toUtf8().constData());
    //----------------------------------------------------------------
  QString gtkPathName=QDir::homePath()+"/.gtkrc-2.0";
    if(!QFile::exists(gtkPathName)){
        QFile fileS(gtkPathName);

        fileS.open(QIODevice::WriteOnly );
        QTextStream out(&fileS);
        out.setCodec(QTextCodec::codecForName("UTF-8"));
        out<<"# File created by elokab Gtk Config"<<endl;;

        out<<"#Configs for GTK2 programs"<<endl;

        out<<"include \"/usr/share/themes/ElokabClear/gtk-2.0/gtkrc\""<<endl;

        out<<"gtk-theme-name=\"ElokabClear\""<<endl;

        out<<"gtk-icon-theme-name=\"Elokab\""<<endl;

        fileS.close();
    }
    // ---------------------------------------------------------------------


    ///! البرامج الافتراضية DEFAULT PROGRAMs------------------------------------
    sT.beginGroup("Session");
  QStringList mList=sT.value("DefaultAutostart").toStringList();
  if(mList.isEmpty())
      mList<< "elokab-desktop"<<"elokab-run"<<"elokab-shortcuts"<<"elokab-panel";

  qDebug()<<mList;

  foreach (QString prog, mList) {
       startApp(QApplication::applicationDirPath()+"/"+prog,prog);

  }

//    startApp(QApplication::applicationDirPath()+"/elokab-desktop","elokab-desktop");

//    startApp(QApplication::applicationDirPath()+"/elokab-run","elokab-run");

//    startApp(QApplication::applicationDirPath()+"/elokab-shortcuts","elokab-shortcuts");

//    startApp(QApplication::applicationDirPath()+"/elokab-panel","elokab-panel");

    /* البرامج المدخلة بواسطة المستخدم*/




    QSettings setting("elokab","autostart") ;
    int count = setting.beginReadArray("AutoStart");
    QStringList listExclude;
    for (int i = 0; i < count; ++i){

        setting.setArrayIndex(i);
        QString   DesktopName = setting.value("FileName").toString();
        // qDebug()<<"name  "<<DesktopName;
        listExclude.append(DesktopName);

    } // for
    setting.endArray();


    QStringList list=ElokabAutoStart::filesList();
    QString fileName;
    bool needTray;
    foreach (QString s, list) {
        QStringList lisDescktop=ElokabAutoStart::elokabDescktopEntry(s);
        //   return list<<name 0<<icon 1<<coment  2<<exec 3<<QString::number(needtry) 4<<QString::number(autoStart) 5;

        fileName= lisDescktop.at(3);
        needTray=lisDescktop.at(4).toInt();


        if (! fileName.isEmpty()&&!listExclude.contains(fileName)){

            if(needTray==true){
                m_listTray.append(fileName);
            }else{
                startAppDetached(fileName);
            }


        }
    }
    //---------------------------------------------------

    /* لوحة تبديل المفاتيح*/
    QStringList listLayou;
    QStringList listLayouName;
    QStringList listVariant;
    QStringList listOption;
    //جلب اعدادات المستخدم
    QSettings settings("elokab","elokabsettings");
    settings.beginGroup("KeyMap");
    listLayouName= settings.value("Names","English|us|Default").toStringList();
    listOption= settings.value("Options","").toStringList();

    settings.endGroup();
    //-------------------

    QString strlayou="setxkbmap -layout " ;
    QString strVariant=" -variant " ;
    QString strOption=" -option " ;
    foreach (QString s, listLayouName) {


        listLayou<<s.section("|",1,1);
        listVariant<<s.section("|",2,2);


    }


    strlayou+= "\""+listLayou.join(",")+"\"";
    strVariant+="\""+listVariant.join(",")+"\"";
    strOption+="\""+listOption.join(",")+"\"";
    strVariant.remove("Default");

    QProcess pr;
    pr.startDetached("setxkbmap -option \"\"");
    pr.waitForFinished();

    pr.startDetached(strlayou+" "+strOption+" "+strVariant);
    qDebug()<<"listLayou--------:"<<strlayou<<strVariant<<strOption;


    qDebug()<<"QSystemTrayIcon::isSystemTrayAvailable()"<<QSystemTrayIcon::isSystemTrayAvailable();

    if(QSystemTrayIcon::isSystemTrayAvailable()){
        startAppTray();
        qDebug()<<"QSystemTrayIcon::isSystemTrayAvailable()"<<QSystemTrayIcon::isSystemTrayAvailable();
    }else{
        QTimer::singleShot(10000,this,SLOT(startAppTray()));
        qDebug()<<"QTimer::singleShot";
    }
}


void Tawhid::loadIconThems()
{


     QSettings setting("elokab","elokabsettings");
     setting.beginGroup("Themes");
     QString icnThem=  setting.value("iconsTheme",QIcon::themeName()).toString();


     if(icnThem=="hicolor"||icnThem.isEmpty()){

          QStringList failback;
          failback<< "Elokab" << "oxygen"<< "Mint-X"<< "Humanity"<< "Tango"<< "Prudence-icon"<< "elementary"<< "gnome";

          QDir dir("/usr/share/icons/");
          foreach (QString s, failback)
          {
               if (dir.exists(s))
               {
                    icnThem=s;

                    break;
               }
          }

          if(icnThem.isEmpty())
               icnThem="hicolor";

          setting.setValue("iconsTheme",icnThem);
     }



     setting.endGroup();
     QIcon::setThemeName(icnThem);


}

void Tawhid::startWindowManager()
{
        // اذا كان مدير النوافذ مشتغلا يوقف العملية.
        if (X11UTILLS::isWindowManagerActive())
                return;

        QSettings setting("elokab","wmrc");
        setting.beginGroup("WindowManagers");

        m_windowManager = setting.value("WM","openbox").toString();

        qDebug()<<m_windowManager;

        // .
        if (!findProgram(m_windowManager)||m_windowManager.isEmpty())
        {
                  QProcess process;
                  process.execute("elokab-settings",QStringList()<<"windowmanager");
                  qApp->processEvents();
                  setting.sync();
                   m_windowManager = setting.value("WM","openbox").toString();

        }

         setting.endGroup();
        QStringList args ;
        args<<"--replace";

        startApp(m_windowManager,"window-manager");

        // Wait until the WM loads
        int waitCnt = 300;
        while (!X11UTILLS::isWindowManagerActive() && waitCnt)
        {
             qApp->processEvents();
                waitCnt--;

        }


             if(m_windowManager=="openbox"){
                 startAppDetached("xcompmgr");
             }

}

void Tawhid::startApp(const QString fileName,const QString name)
{

        TawhidModule* proc = new TawhidModule(fileName, this);
        connect(proc, SIGNAL(moduleStateChanged(QString,bool)), this, SIGNAL(moduleStateChanged(QString,bool)));
        proc->start();
        connect(proc, SIGNAL(finished(int, QProcess::ExitStatus)),
                this, SLOT(restartModules(int, QProcess::ExitStatus)));

        mNameMap[name] = proc;

}
bool Tawhid::findProgram(const QString &program)
{

    QFileInfo fi(program);
    if (fi.isExecutable())
        return true;

    QString path = qgetenv("PATH");
    foreach(QString dir, path.split(":"))
    {
        QFileInfo fi= QFileInfo(dir + QDir::separator() + program);
        qDebug()<<fi.filePath();
        if (fi.isExecutable() )
            return true;
    }
    return false;
}

void Tawhid::startAppDetached(const QString appName)
{
        QProcess process;
        process.startDetached(appName);
}

void Tawhid::startAppTray()
{

    if (!m_listTray.isEmpty())
    {
                        int waitCnt = 600;
                        while (!QSystemTrayIcon::isSystemTrayAvailable())
                        {
                                //            qDebug() << "******************** Wait for tray" << waitCnt;
                                if (!waitCnt)
                                {
                                        qWarning() << "******************** No systray implementation started in session. Continuing.";
                                        break;
                                }
                                waitCnt--;
                                usleep(100000);
                        }
            foreach (QString p, m_listTray) {
                qDebug()<<p<<"-----------------------------------------tray";
                    startAppDetached(p);
            }
    }
}

void Tawhid::startScriptDetached(const QString fileName)
{
        QFile file(fileName);
        if (!file.open(QFile::ReadOnly)){

                return ;
        }
        QTextStream textStream(&file);
        QString line;

        line= textStream.readLine();//1 line

        if(line.contains("#!"))
                line.remove("#!").trimmed();

        QProcess process;
        qDebug()<<"lineScripte : "<<line+" "+ fileName;
        process.startDetached(line.trimmed() +" "+ fileName);
}

void Tawhid::logout()
{

        Mnum++;

        //qDebug()<<"ghhhhhhhhh   :"<<Mnum;
        //qApp->quit();
        // modules
        ModulesMapIterator i(mNameMap);
        while (i.hasNext())
        {
                i.next();
                qDebug() << "Module logout" << i.key();
                TawhidModule* p = i.value();
                p->terminate();
        }
        i.toFront();
        while (i.hasNext())
        {
                i.next();
                TawhidModule* p = i.value();
                if (p->state() != QProcess::NotRunning && !p->waitForFinished())
                {
                        qWarning() << QString("Module '%1' won't terminate ... killing.").arg(i.key());
                        p->kill();
                }
        }



        QCoreApplication::exit(0);
}

void Tawhid::restartModules(int /*exitCode*/, QProcess::ExitStatus exitStatus)
{
        TawhidModule* proc = qobject_cast<TawhidModule*>(sender());
        Q_ASSERT(proc);
        qDebug()<<proc->m_fileName;
        if (!proc->isTerminating())
        {
                QString procName = proc->m_fileName;
                switch (exitStatus)
                {
                case QProcess::NormalExit:
                        qDebug() << "Process" << procName << "(" << proc << ") exited correctly.";

                        break;
                case QProcess::CrashExit:
                {
                        qDebug() << "Process" << procName << "(" << proc << ") has to be restarted";
                        time_t now = time(NULL);
                        mCrashReport[proc].prepend(now);
                        while (now - mCrashReport[proc].back() > 60)
                                mCrashReport[proc].pop_back();
                        if (mCrashReport[proc].length() >= 5)
                        {

                            NotificationUtill::Notify("elokab session","elokab",
                                                      tr(" Crash Report"),   tr("Application '%1' crashed too many times. ").arg(procName),5000);
                        }
                        else
                        {
                                  NotificationUtill::Notify("elokab session","elokab",
                                                            tr(" Crash Report"),   tr("Application '%1' crashed too %2. ").arg(procName).arg(QString::number(mCrashReport[proc].length())),5000);
                                proc->start();
                                return;
                        }
                        break;
                }
                }
        }
}

TawhidModule::TawhidModule(QString file, QObject* parent) :
        QProcess(parent),
        //  file(file),
        m_fileName(file),
        mIsTerminating(false)
{
        connect(this, SIGNAL(stateChanged(QProcess::ProcessState)), SLOT(updateState(QProcess::ProcessState)));
}

void TawhidModule::start()
{
        mIsTerminating = false;
        QStringList args ;
        args<<m_fileName;
        QString command = args.takeFirst();
        QProcess::start(command, args);
        qDebug()<<command<<" "<<args;
}

void TawhidModule::terminate()
{
        mIsTerminating = true;
        QProcess::terminate();
}

bool TawhidModule::isTerminating()
{
        return mIsTerminating;
}

void TawhidModule::updateState(QProcess::ProcessState newState)
{
        if (newState != QProcess::Starting)
                emit moduleStateChanged(m_fileName, (newState == QProcess::Running));
}
