/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef Tawhid_H
#define Tawhid_H

#include <QtCore/QObject>
#include <QtDBus/QtDBus>
class TawhidModule;
typedef QMap<QString,TawhidModule*> ModulesMap;
typedef QList<time_t> ModuleCrashReport;
typedef QMap<QProcess*, ModuleCrashReport> ModulesCrashReport;
typedef QMapIterator<QString,TawhidModule*> ModulesMapIterator;
/**
 * @brief The Tawhid class فئة جلسة العقاب
 */
class Tawhid : public QObject
{
    Q_OBJECT
public:
    Tawhid();
signals:
    void moduleStateChanged(QString moduleName, bool state);
public slots:
  void  startSession();

void restartModules(int /*exitCode*/, QProcess::ExitStatus exitStatus);

public Q_SLOTS:
    void logout();


Q_SIGNALS:
    void crashed();

protected:
private slots:
       void loadIconThems();
void startApp(const QString fileName,const QString name);
void startAppDetached(const QString appName);
void startAppTray();
 void startScriptDetached(const QString fileName);
 void startWindowManager();

bool findProgram(const QString &program);


private:
int Mnum;
QStringList m_listTray;
QString m_windowManager;
  ModulesMap mNameMap;
    ModulesCrashReport mCrashReport;
};

class TawhidModule : public QProcess
{
    Q_OBJECT
public:
    TawhidModule(QString file, QObject *parent = 0);
    void start();
    void terminate();
    bool isTerminating();


    const QString m_fileName;

signals:
    void moduleStateChanged(QString name, bool state);

private slots:
    void updateState(QProcess::ProcessState newState);


private:
    bool mIsTerminating;

};

#endif // Tawhid_H
