/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef CAR_ADAPTOR_H_1264773009
#define CAR_ADAPTOR_H_1264773009

#include <QtCore/QObject>
#include <QtDBus/QtDBus>

QT_BEGIN_NAMESPACE
class QByteArray;
template<class T> class QList;
template<class Key, class Value> class QMap;
class QString;
class QStringList;
class QVariant;
QT_END_NAMESPACE

/*
 * Adaptor class for interface org.tawhid.session.org
 */

class tawhidInterfaceAdaptor: public QDBusAbstractAdaptor
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.tawhid.session.TawhidInterface")
    Q_CLASSINFO("D-Bus Introspection", ""
                "  <interface name=\"org.tawhid.session.TawhidInterface\">\n"
                "    <method name=\"logout\"/>\n"
                "    <method name=\"decelerate\"/>\n"
                "    <method name=\"turnLeft\"/>\n"
                "    <method name=\"turnRight\"/>\n"
                "    <signal name=\"crashed\"/>\n"
                "  </interface>\n"
                "")
public:
    tawhidInterfaceAdaptor(QObject *parent);
    virtual ~tawhidInterfaceAdaptor();

public: // PROPERTIES
public Q_SLOTS: // METHODS
    void logout();

Q_SIGNALS: // SIGNALS
    void crashed();
};

#endif
