/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef ELOKABSETTINGSDLG_H
#define ELOKABSETTINGSDLG_H
#include "about/widgetabout.h"
#include "../plugins/spluginsinterface.h"
#include <ElokabSettings>

#include <QDialog>
#include <QTabWidget>
#include <QAbstractButton>
#include <QHash>

namespace Ui {
class ElokabSettingsDlg;
}
/*!
 * \brief The ElokabSettings class حامل لكل الودجات الخاصة بالاعدادات
 */
class ElokabSettingsDlg : public QDialog
{
    Q_OBJECT
    
public:
    explicit ElokabSettingsDlg(QWidget *parent = 0);
    ~ElokabSettingsDlg();
signals:



private:
    Ui::ElokabSettingsDlg *ui;
    ElokabSettings *msetting;
    QHash<QString,QTabWidget*>mHashItems;
    QHash<QString,QListWidget*>mHashListWidget;

    PluginsInterface *pluginsInterface;

    QWidget *widgetModule;

  //  QHash<QString, PluginsInterface*>m_hatchPligins ;
    QDir pluginsDir;
    WidgetAbout *widgetabout;

public slots:

    //! جلب كل الموديولات
    void loadAllServices();

    //! جلب موديول واحد
    bool loadServicemodule(const QString &pfile, bool panel=true);

    //! ارجاع قائمة بالموديولات المتورة
    QStringList listModules();

private slots:


    /**
     * @brief addNewPageWidget صفحة جديدة
     * @param data اسم الصفحة للتخزين
     */
    void addNewPageWidget(const QString &data);
void itemActivated(QListWidgetItem *item);
    /**
     * @brief loadModules جلب موديولات
     * @param parent الحاوي الاب
     * @param list قائمة باسماء الموديولات
     */
    void loadModules(const QString &parent, const QStringList &list);

    /**
     * @brief loadModuleInfo جلب معلومات الموديول من ملف desktop
     * @param file اسم ملف ديسكتوب
     * @return
     */
    QHash<QString,QString> loadModuleInfo(const QString &file);

    //!
//    void addNewTabWidget(const QString &parent,
//                         const QString &icon,
//                         const QString &name, const QString &libName);
//NEW------------
    void addNewIcons(const QString &parent,
                         const QString &icon,
                         const QString &name, const QString &libName);

    //!
    bool loadPlugin(const QString &pfile);

    //!
    void on_buttonBox_clicked(QAbstractButton *button);

    //!
    void applyChanges();
    void on_toolButtonAll_clicked();
    void stackindexChanged(int arg);

};

#endif // ELOKABSETTINGSDLG_H
