/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#include <ElokabApplication>
#include "elokabsettingsDlg.h"
#include <QDir>
#include <QTranslator>
#include <QLibraryInfo>
#include <QSettings>

int main(int argc, char *argv[])
{


    ElokabApplication a(argc, argv);
     a.setApplicationName("elokab-settings");
           /// جلب ترجمة البرنامج من مجلد البرنامج

    QTranslator translator;
           translator.load(a.translationPath());
           a.installTranslator(&translator);

   //------------------------------------argument-------------------------------------------------

    QStringList args = a.arguments();
    ElokabSettingsDlg w;
    a.setWindowIcon(QIcon::fromTheme("preferences-system"));
    if(args.count()==2)
    {
        QString help=QObject::tr
                ("Elokab settings Version 0.1 .\n"
                 " \n"
                 "Usage: elokab-settings [OPTION] module\n"
                 "OPTION:\n"
                 "--list        List all possible modules"
                 "--help        Show help about options.\n"
                 "Arguments:\n"
                 "module        Configuration module to open"

               );

        QString plugin = args.at(1);

        if(plugin=="--help"){
             qWarning() <<help;
              return 0;
        }
        if(plugin=="--list"){
          QStringList list =   w.listModules();
          qDebug()<<list;
              return 0;
        }
        if( !w.loadServicemodule(plugin,false)){

             qWarning() <<help;
             return 0;
        }
    }else{
        w.loadAllServices();
    }


    w.show();
    
    return a.exec();
}
