/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef DIALOGCONFIGDESKTOP_H
#define DIALOGCONFIGDESKTOP_H
#include "../spluginsinterface.h"
#include <ButtonColor>
#include <QDialog>
#include <QAbstractButton>
namespace Ui {
class DialogConfigDesktop;
}

/**
 * @brief The DialogConfigDesktop class
 * @brief نافذة تخصيص سطح المكنب
 * @author أبو زكريا
 * @date 19/10/2014
 */
class DialogConfigDesktop : public QWidget,PluginsInterface
{
    Q_OBJECT
    Q_INTERFACES(PluginsInterface)
    

public:
    explicit DialogConfigDesktop(QWidget *parent = 0);
    ~DialogConfigDesktop();
signals:
    void  settingChanged();

public slots:
    void saveSettings();
    QWidget *widget(){return this;}

private slots:


    void loadSettings();

  //  QPixmap buttonIcon(QColor color);
    QPixmap getBrushPattern();
    void brushPatternChanged();
    void brushcolorChanged();
    void imagefileChanged();
    void imagePathChanged();
    void animationFileChanged();

    void loadQmlAnimation();

    void on_comboBoxType_currentIndexChanged(int index);

    void on_toolButtonChooseImage_clicked();

    void on_toolButtonFolderPath_clicked();

    void on_lineEditImagePath_textEdited(const QString &arg1);

    void on_lineEditFolderPath_textEdited(const QString &arg1);

    void on_hSliderIconSize_valueChanged(int value);

    void on_comboBoxQml_activated(const QString &);

private:

    Ui::DialogConfigDesktop *ui;
    QString m_appPath;

    ButtonColor *btnGlobalColor;
    ButtonColor *btnPatternColor1;
    ButtonColor *btnPatternColor2;

    QPixmap m_pixPattern;
    int m_iconSize;
    // QStringList m_listWidget;
};

#endif // DIALOGCONFIGDESKTOP_H
