#include "widgetnotify.h"
#include "ui_widgetnotify.h"
#include "notificationutill.h"
#include <QSettings>
#include <QDebug>
#include <QDBusInterface>

#define TOP_LEFT 0
#define TOP_RIGHT 1
#define BOT_LEFT 2
#define BOT_RIGHT 3

#define TOP_CENTER 4
#define LEFT_CENTER 5
#define RIGHT_CENTER 6
#define BOT_CENTER 7


WidgetNotify::WidgetNotify(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::WidgetNotify)
{
    ui->setupUi(this);
    ui->widgetScreen->setLayoutDirection(Qt::LeftToRight);
    QSettings  setting("elokab","settings");

    setting.beginGroup("Notification");
 int   mPosition=setting.value("position",TOP_LEFT).toInt();
    setting.endGroup();


            QRadioButton *rButton =   ui->widgetScreen->findChild<QRadioButton *>("radioButton_"+QString::number(mPosition));
//            qDebug()<<"*********************"<<rButton->objectName();
//            qDebug()<<"*********************"<<"radioButton_"+QString::number(mPosition);
            if(rButton)rButton->setChecked(true);



}

WidgetNotify::~WidgetNotify()
{
    delete ui;
}

void WidgetNotify::on_pushButtonTest_clicked()
{
    saveSettings();
    NotificationUtill::Notify("elokab","elokab","Elokab Notification","<a href=\"org.freedesktop.Notifications\">org.freedesktop.Notifications </a>",3000);
 /*
    QDBusInterface dbus("org.freedesktop.Notifications",
                        "/org/freedesktop/Notifications",
                        "org.freedesktop.Notifications");

    if (!dbus.isValid()) {
        qDebug() << "QDBusInterface is not valid!";
        return ;
    }

    QList<QVariant> args;
    args.append("Elokab Notification");       // Application Name
    args.append(0123U);         // Replaces ID (0U)
    args.append("information");     // Notification Icon
    args.append("Elokab Notification");          // Body
    args.append( "org.freedesktop.Notifications");       // Summary
    args.append(QStringList()); // Actions
    args.append(QVariantMap());
    args.append(3000);
    dbus.callWithArgumentList(QDBus::NoBlock, "Notify", args);
    */
}
void WidgetNotify::saveSettings()
{
    int pos=0;
    for(int i=0;i<8;i++)
    {
        QRadioButton *rButton =   ui->widgetScreen->findChild<QRadioButton *>("radioButton_"+QString::number(i));
        if(rButton)
            if(rButton->isChecked()){
                pos=i;
                break;
            }

    }
    QSettings  setting("elokab","settings");

    setting.beginGroup("Notification");
    setting.setValue("position",pos);

    setting.endGroup();
}
Q_EXPORT_PLUGIN2(setting_Notifycations, WidgetNotify)
