#include "panelsettings.h"
#include "ui_panelsettings.h"
#include <EDir>
#include <QDebug>
#include <QColorDialog>
#include  <QSettings>
#include  <QFileDialog>
#include  <QMenu>
#include  <QTextCodec>
#define TOP_SCREEN "top"
#define BOT_SCREEN "bottom"
PanelSettings::PanelSettings(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::PanelSettings)
{
    ui->setupUi(this);
    //applique ui---------------------------------------
   //******************
    btn_colorTop   =new ButtonColor(QString(),true);
   btn_colorRight=new ButtonColor(QString(),true);
   btn_colorBot=new ButtonColor(QString(),true);
   btn_colorLeft=new ButtonColor(QString(),true);
btn_colorRight->setSizePolicy(QSizePolicy::Fixed,QSizePolicy::Fixed);
btn_colorLeft->setSizePolicy(QSizePolicy::Fixed,QSizePolicy::Fixed);
   btn_colorBorder=new ButtonColor(tr("&Border Color :"),true);
   btn_colorSelect=new ButtonColor(tr("Selec&tion Color :"),true);
   btn_colorFont=new ButtonColor(tr("&Font Color :"),true);
   btn_colorGlobale=new ButtonColor(tr("&Global Color :"),true);

   connect(btn_colorTop,SIGNAL(colorChanged()),this,SLOT( setStylePanel()));
   connect(btn_colorRight,SIGNAL(colorChanged()),this,SLOT(setStylePanel()));
   connect(btn_colorBot,SIGNAL(colorChanged()),this,SLOT(setStylePanel()));
   connect(btn_colorLeft,SIGNAL(colorChanged()),this,SLOT(setStylePanel()));
   connect(btn_colorBorder,SIGNAL(colorChanged()),this,SLOT(setStylePanel()));
   connect(btn_colorSelect,SIGNAL(colorChanged()),this,SLOT(setStylePanel()));
   connect(btn_colorFont,SIGNAL(colorChanged()),this,SLOT(setStylePanel()));
   connect(btn_colorGlobale,SIGNAL(colorChanged()),this,SLOT(setStylePanel()));

   ui->horizontalLayout_top->insertWidget(1,btn_colorTop);
   ui->horizontalLayout_bot->insertWidget(1,btn_colorBot);
   ui->horizontalLayout_center->insertWidget(0,btn_colorLeft);
   ui->horizontalLayout_center->addWidget(btn_colorRight);
   ui->horizontalLayout_select->addWidget(btn_colorSelect);
   ui->horizontalLayout_border->addWidget(btn_colorBorder);
   ui->horizontalLayout_font->addWidget(btn_colorFont);
   ui->horizontalLayout_globale->addWidget(btn_colorGlobale);

   ///*******************************
    this->setWindowIcon(EIcon::fromTheme("configure",("document-properties")));
    this->setObjectName("panalConfig");
   // this->setAttribute(Qt::WA_DeleteOnClose,true);
    ui->listWidget->item(0)->setIcon(EIcon::fromTheme("preferences-system").pixmap(64));
    ui->listWidget->item(1)->setIcon(EIcon::fromTheme("preferences-desktop-theme").pixmap(64));
setupThemes();

    loadSetting();
    setStylePanel();
   ui->listWidget->setCurrentRow(0);
}

PanelSettings::~PanelSettings()
{
    delete ui;
}
void PanelSettings::setupThemes()
{
    /// مسار مجلد البرنامج

   QString userThemePath =Edir::dataDir() +"/themes";
    QString  localThemePath=Edir::dataHomeDir()+"/elokab/themes";
    QStringList listPath;
    listPath<<localThemePath<<userThemePath;
    QStringList listThemes;

    foreach (QString dirPath, listPath) {
        QDir dirS(dirPath);
        foreach(QString dir,dirS.entryList(QDir::AllDirs| QDir::NoSymLinks| QDir::NoDotAndDotDot )) {
            QString path=dirS.absoluteFilePath(dir);
            // qDebug()<<"path"<<path;
            if (QFile::exists(path+"/settings.conf")){
                if(!listThemes.contains(dir)){
                    listThemes.append(dir);
                    ui->comboBoxTheme->addItem(dir,path);
                }
            }
        }
    }

    listThemes.clear();
}

QColor listToColor(QList<QVariant>list)
{
    int red=0,green=0, bleu=0,alpha=255;
    int count=list.count();
    if(count>0)red=list.at(0).toInt();
    if(count>1)green=list.at(1).toInt();
    if(count>2)bleu=list.at(2).toInt();
    if(count>3)alpha=list.at(3).toInt();
    return QColor(red,green,bleu,alpha);
}
QList<QVariant> colorToList(QColor color)
{
    int red=(color.red());
    int green=(color.green());
    int bleu=(color.blue());
    int alpha=(color.alpha());
    return QList<QVariant>()<<red<<green<<bleu<<alpha;
}
void PanelSettings::loadSetting(const QString &path)
{

    if(QFile::exists(path)&&!path.isEmpty()){
 qDebug()<<"loadSetting"<<path;
     //   setting.setPath(QSettings::IniFormat,QSettings::UserScope,path);
        msetting=new QSettings(path,QSettings::IniFormat);
    }else{
        msetting=new QSettings("elokab","settings");
    }

    msetting->beginGroup("Panel-Style");
    QList<QVariant> colorTop=msetting->value("color1",QList<QVariant>()<<56<< 56<< 56<< 255).toList();
    QList<QVariant> colorRight=msetting->value("color2",QList<QVariant>()<<76<<76<< 76<< 255).toList();
    QList<QVariant> colorBot=msetting->value("color3",QList<QVariant>()<<0<<0<< 0<< 255).toList();
    QList<QVariant> colorLeft=msetting->value("color4",QList<QVariant>()<<43<<43<<43<<255).toList();

    QList<QVariant> colorBorder=msetting->value("colorBorder",QList<QVariant>()<<34<< 34<<34<<255).toList();
    QList<QVariant> colorSelect=msetting->value("colorSelect",QList<QVariant>()<<255<< 50<< 20<<255).toList();
    QList<QVariant> colorGlobale=msetting->value("colorGlobale",QList<QVariant>()<<56<<56<< 56<< 255).toList();
    QList<QVariant> colorFont=msetting->value("colorFont",QList<QVariant>()<<255<<255<<255<<255).toList();

    m_panelSize=msetting->value("panelSize","24").toInt();
    QString image=msetting->value("pixFileName","").toString();
    if(!QFile::exists(image)){
      QString img=  QFileInfo(image).fileName();
       QString curpath=QFileInfo(path).absolutePath();
      qDebug()<<curpath+"/images/"+img;
       m_pixFileName=(curpath+"/images/"+img);

    }else{
        m_pixFileName=(image);
    }
  //  m_pixFileName=msetting->value("pixFileName","").toString();
    bool isImage=msetting->value("isImage",false).toBool();
    ui->checkBoxRepeat->setChecked(msetting->value("imageRepeat",false).toBool());

    m_stop=msetting->value("stop","0.02").toString();
    m_stop2=msetting->value("stop2","0.96").toString();

    QString position=msetting->value("Position",TOP_SCREEN).toString();
    if(position==BOT_SCREEN)m_Position=1;
    else m_Position=0;

    //   m_iconsTheme=setting.value("iconsTheme",QIcon::themeName()).toString();
    ui->checkBoxDefault->setChecked(msetting->value("styleDefault",false).toBool());


    //        setting.setValue("TestColor",getColorString(btn_colorSelect->color()));
    //        setting.setValue("TestColorList",colorList(btn_colorSelect->color()));

    msetting->endGroup();
    //colors ui---------------------------------------
    //******************
    btn_colorTop->setColor(listToColor(colorTop));
    btn_colorRight->setColor(listToColor(colorRight));
    btn_colorBot->setColor(listToColor(colorBot));
    btn_colorLeft->setColor(listToColor(colorLeft));

    btn_colorBorder->setColor(listToColor(colorBorder));
    btn_colorSelect->setColor(listToColor(colorSelect));
    btn_colorFont->setColor(listToColor(colorFont));
    btn_colorGlobale->setColor(listToColor(colorGlobale));




    ///*******************************

    QString dd=m_stop;
    dd.remove("0.");
    ui->verticalSlider->setValue(dd.toInt());
    QString dd2=m_stop2;
    dd2.remove("0.");
    ui->verticalSlider2->setValue(dd2.toInt());
    //          ui->radioButtonImage->setChecked(m_isImage);
    //          ui->radioButtonGradient->setChecked(!m_isImage);
    ui->comboBoxStyle->setCurrentIndex(isImage);
    ui->lineEditImageFile->setText(m_pixFileName);
    ui->spinBoxSize->setValue(m_panelSize);
    ui->comboBoxPos->setCurrentIndex(m_Position);
    ui->spinBoxSize->setMinimum(16);

    // qDebug()<<"QSettings  "<<setting.fileName();
}
void PanelSettings::saveSettings()
{


    QSettings setting("elokab","settings");
    setting.beginGroup("Panel-Style");
    setting.setValue("color1",colorToList(btn_colorTop->color()));
    setting.setValue("color2",colorToList(btn_colorRight->color()));
    setting.setValue("color3",colorToList(btn_colorBot->color()));
    setting.setValue("color4",colorToList(btn_colorLeft->color()));

    setting.setValue("stop",m_stop);
    setting.setValue("stop2",m_stop2);
    setting.setValue("pixFileName",m_pixFileName);
    setting.setValue("imageRepeat", ui->checkBoxRepeat->isChecked());

    setting.setValue("panelSize",m_panelSize);

    QString position;
    if(m_Position==1)position=BOT_SCREEN;
    else position=TOP_SCREEN;

    setting.setValue("Position",position);
    // setting.setValue("stylePanel",getPanelStyle());
    setting.setValue("colorFont",colorToList(btn_colorFont->color()));
    setting.setValue("colorBorder",colorToList(btn_colorBorder->color()));
    setting.setValue("colorSelect",colorToList(btn_colorSelect->color()));
    setting.setValue("colorGlobale",colorToList(btn_colorGlobale->color()));
    //     setting.setValue("iconsTheme",m_iconsTheme);

    setting.setValue("isImage",ui ->comboBoxStyle->currentIndex());
    setting.setValue("styleDefault",ui->checkBoxDefault->isChecked());
    // setting.setValue("CssPath",QDir::homePath()+"/.config/elokab/panelTheme.css");



    setting.endGroup();

    savePanelStyle();

    QSettings s("elokab","elokabsettings");

    s.beginGroup("AppChangeSetting");

    QString name=s.value("PanelTheme").toString();
    QString newName="changed_0";
    int i=0;
    while (name==newName) {
        i++;
        newName="changed_"+QString::number(i);
    }
    s.setValue("PanelTheme",newName);
    s.endGroup();

}


void PanelSettings::setStylePanel()
{


        QString grad1=QString("stop:0 rgba(%1, %2, %3, %4), ")
                        .arg(btn_colorTop->color().red())
                        .arg(btn_colorTop->color().green())
                        .arg(btn_colorTop->color().blue())
                        .arg(btn_colorTop->color().alpha());
        QString grad2=QString("stop:%1 rgba(%2, %3, %4, %5),")
                        .arg(m_stop)
                        .arg(btn_colorRight->color().red())
                        .arg(btn_colorRight->color().green())
                        .arg(btn_colorRight->color().blue())
                        .arg(btn_colorRight->color().alpha());
        QString grad4=QString("stop:%1 rgba(%2, %3, %4, %5),")
                        .arg(m_stop2)
                        .arg(btn_colorLeft->color().red())
                        .arg(btn_colorLeft->color().green())
                        .arg(btn_colorLeft->color().blue())
                        .arg(btn_colorLeft->color().alpha());
        QString grad3=QString( "stop:1 rgba(%1, %2, %3, %4));")
                        .arg(btn_colorBot->color().red())
                        .arg(btn_colorBot->color().green())
                        .arg(btn_colorBot->color().blue())
                        .arg(btn_colorBot->color().alpha());


        QString styleBorder= QString("\n  border:	1px solid rgba(%1, %2, %3,%4);")
                        .arg(btn_colorBorder->color().red())
                        .arg(btn_colorBorder->color().green())
                        .arg(btn_colorBorder->color().blue())
                        .arg(btn_colorBorder->color().alpha());

        QString myStyle= QString("\n/*style for panel background... */"
                                 "\n QWidget #widgetBgr{\n background-color: qlineargradient(spread:pad,"
                                 "x1:0, y1:0, x2:0, y2:1, %1 %2 %3 %4")
                        .arg(grad1)
                        .arg(grad2)
                        .arg(grad4)
                        .arg(grad3);

        ui->widgetBgr->setStyleSheet(myStyle+styleBorder+"}");

}



void PanelSettings::on_verticalSlider_sliderMoved(int position)
{
          qreal q=position;
          QVariant d=q/100;
          m_stop=d.toString();
          setStylePanel();

}
void PanelSettings::on_verticalSlider2_sliderMoved(int position)
{
          qreal q=position;
          QVariant d=q/100;
          m_stop2=d.toString();
          setStylePanel();

}



void PanelSettings::savePanelStyle()
{
         //*********************QToolButton*************************
        QString styleButton= QString("\n/*style for Global buttons Quicklanche taskbar etc... */"
                                     "\n QToolButton{"
                                     "\n      border-radius:3px;"
                                     "\n      border:1px outset rgba(%1, %2, %3, %4);"
                                     "\n      background:transparent;\n }")
                        .arg(btn_colorBorder->color().red())
                        .arg(btn_colorBorder->color().green())
                        .arg(btn_colorBorder->color().blue())
                        .arg(btn_colorBorder->color().alpha());

        int alpha=btn_colorSelect->color().alpha();
        int alphacheked=alpha-50;
        if(alpha<100) alphacheked=alpha+50;


        QString styleButtonchecked= QString("\n QToolButton:checked{"
                                             "\n      border:1px inset rgba(%5, %6, %7, %8);"
                                            "\n   background:rgba(%1, %2, %3 ,%4);\n }")
                        .arg(btn_colorSelect->color().red())
                        .arg(btn_colorSelect->color().green())
                        .arg(btn_colorSelect->color().blue())
                        .arg(alphacheked)
                        .arg(btn_colorBorder->color().red())
                        .arg(btn_colorBorder->color().green())
                        .arg(btn_colorBorder->color().blue())
                        .arg(btn_colorBorder->color().alpha());


        QString styleButtonHover=  QString("\n QToolButton:hover{"
                                           "\n    background:rgba(%1, %2, %3 ,%4);\n }")
                        .arg(btn_colorSelect->color().red())
                        .arg(btn_colorSelect->color().green())
                        .arg(btn_colorSelect->color().blue())
                        .arg(alpha);

        int mbarH=m_panelSize-4;

        QString styleMenuBar= QString("\n/*for menubar standard menu... */"
                                      "\n QMenuBar {"
                                      "\n     background: transparent;"
                                      "\n     min-height:%1 ;\n }"
                                      "\n QMenuBar::item:!selected { "
                                      "\n     background: transparent;\n  }").arg(mbarH);

        QString styleMenuBarSelect=QString("\n QMenuBar::item:selected { "
                                           "\n   border:1px solid rgba(%1, %2, %3, %4);"
                                           "\n    background:rgba(%5, %6, %7 ,%8)  ;"
                                           "\n    border-top-right-radius:4px;"
                                           "\n    border-top-left-radius:4px;\n }")
                        .arg(btn_colorBorder->color().red())
                        .arg(btn_colorBorder->color().green())
                        .arg(btn_colorBorder->color().blue())
                        .arg(btn_colorBorder->color().alpha())
                        .arg(btn_colorSelect->color().red())
                        .arg(btn_colorSelect->color().green())
                        .arg(btn_colorSelect->color().blue())
                        .arg(btn_colorSelect->color().alpha());

        QString styleFont=QString("\n/*for global font color... */"
                                  "\n QWidget{\n  color: rgb(%1, %2, %3);\n }")
                        .arg(btn_colorFont->color().red())
                        .arg(btn_colorFont->color().green())
                        .arg(btn_colorFont->color().blue());

        QString myStyle;
        if(ui->comboBoxStyle->currentIndex()==0){
                myStyle= ui->widgetBgr->styleSheet();
        }else{
                QString styleFont=QString("\n color: rgb(%1, %2, %3);")
                                .arg(btn_colorFont->color().red())
                                .arg(btn_colorFont->color().green())
                                .arg(btn_colorFont->color().blue());


                myStyle=getStyleImage() +styleFont+"\n }";
        }


        //*********************popup*************************
        QString myStylePopup=QString("\n/*syle for main menu background... */"
                                     "\n QWidget #widgetBgrmenu{"
                                     "\n   background-color: rgba(%1, %2, %3,%4);"
                                   "\n   border-radius:10px;"
                                     "\n }"
                                     "\n QWidget #widgetBot{"
                                     "\n  background-color: qconicalgradient(cx:0.479864, cy:1, angle:270,"
                                     "stop:0 transparent,"
                                     "stop:0.417143 transparent,"
                                     "stop:0.422857 rgba(%1, %2, %3,%4),"
                                     "stop:0.571429 rgba(%1, %2, %3,%4),"
                                     "stop:0.577143 transparent,"
                                     "stop:1 transparent);"
                                     "margin-right: 15px;"
                                     "margin-left: 15px;"
                                     "\n  }"
                                     "\n/*style corner of mainmenu... */"
                                     "\n QWidget #widgetTop{"
                                     "\n  background-color: qconicalgradient(cx:0.536723, cy:0, angle:90.1,"
                                     "stop:0 transparent, stop:0.417143 transparent,"
                                     "stop:0.422857 rgba(%1, %2, %3,%4), stop:0.565714 rgba(%1, %2, %3,%4),"
                                     "stop:0.577143 transparent, stop:1 transparent);"
                                     "margin-right: 15px;"
                                     "margin-left: 15px;"
                                     "\n }"
                                     )   .arg(btn_colorGlobale->color().red())
                        .arg(btn_colorGlobale->color().green())
                        .arg(btn_colorGlobale->color().blue())
                        .arg(btn_colorGlobale->color().alpha())
                        .arg(btn_colorBorder->color().red())
                        .arg(btn_colorBorder->color().green())
                        .arg(btn_colorBorder->color().blue())
                        .arg(btn_colorBorder->color().alpha());

        QString styleButtonPopup= QString("\n/*syle for button lancher of main menu... */"
                                          "\n QToolButton #btnMenu{"
                                          "\n    border:1px solid transparent;"
                                          "\n    border-radius:3px;"
                                          "\n    background:transparent;}"
                                          "\n }")
                        ;

        QString styleButtonPopupHover=  QString("\n QToolButton #btnMenu:hover{"
                                                "\n   background:rgba(%1, %2, %3 ,%4);"
                                                "\n }"
                                                "\n QToolButton #btnMenu:focus{"
                                                "\n   background:rgba(%1, %2, %3 ,%4);"
                                                "\n }")
                        .arg(btn_colorSelect->color().red())
                        .arg(btn_colorSelect->color().green())
                        .arg(btn_colorSelect->color().blue())
                        .arg(alpha);
        //***************************listViw********************
        QString styleListView=QString("\n/*syle for listView group menu of main menu... */"
                                      "\n  QListView#listWidgetMenu{"
                                      "\n show-decoration-selected: 1; /* make the selection span the entire width of the view */"
                                      "\n background-color: transparent;"
                                      "\n }"
                                      "\n  QListView::item#listWidgetMenu {"
                                      "\n    border-radius:3px;"
                                      "\n color: rgb(%10, %11, %12);"
                                      "\n }"
                                      "\n  QListView::item:selected#listWidgetMenu {"
                                      "\n  border: 1px solid rgba(%1, %2, %3,%4);"
                                      "\n    border-radius:3px;"
                                      "\n }"
                                      "\n QListView::item:selected:!active#listWidgetMenu {"
                                      "\n  background-color: rgba(%5, %6, %7 ,%8);"
                                      "\n }"
                                      " \n QListView::item:selected:active#listWidgetMenu {"
                                      "\n  background-color: rgba(%5, %6, %7 ,%9);"
                                      "\n }"
                                      "\n QListView::item:hover#listWidgetMenu{"
                                      "\n  background-color: rgba(%5, %6, %7 ,%8);"
                                      "\n }")
                        .arg(btn_colorBorder->color().red()) /*1*/
                        .arg(btn_colorBorder->color().green()) /*2*/
                        .arg(btn_colorBorder->color().blue()) /*3*/
                        .arg(btn_colorBorder->color().alpha()) /*4*/
                        .arg(btn_colorSelect->color().red()) /*5*/
                        .arg(btn_colorSelect->color().green()) /*6*/
                        .arg(btn_colorSelect->color().blue()) /*7*/
                        .arg(alphacheked-50) /*8*/
                        .arg(alpha) /*9*/
                        .arg(btn_colorFont->color().red()) /*10*/
                        .arg(btn_colorFont->color().green()) /*11*/
                        .arg(btn_colorFont->color().blue()); /*12*/
    //----------------------------------
        QString mediaStyle=QString("\n/*syle for any Continaires... */"
                                "\n QWidget#widgetContinair{"
                                "\n border-radius:5px;"
                                "\n border:1px double rgba(%1, %2, %3,%4);"
                                "}")
                        .arg(btn_colorBorder->color().red()) /*1*/
                        .arg(btn_colorBorder->color().green()) /*2*/
                        .arg(btn_colorBorder->color().blue()) /*3*/
                        .arg(btn_colorBorder->color().alpha()) /*4*/;

        //*******************************************************

                     QString myStyleInfoBull=QString("\n/*syle for InfoBull background... */"
                                                  "\n QWidget #InfoBull{"
                                                  "\n   background-color: rgba(%1, %2, %3,%4);"
                                                  "\n }")
                                     .arg(btn_colorGlobale->color().red())
                                     .arg(btn_colorGlobale->color().green())
                                     .arg(btn_colorGlobale->color().blue())
                                     .arg(btn_colorGlobale->color().alpha());
        QString myStyleShet=styleFont
                        +myStyle+styleButton
                        +styleButtonHover
                        +styleButtonchecked
                        +styleMenuBar
                        +styleMenuBarSelect
                        +myStylePopup+styleButtonPopup
                        +styleButtonPopupHover
                        +styleListView
                        +mediaStyle
                        +myStyleInfoBull;

        QFile fileCsv(Edir::configDir()+"/panelTheme.css");
        if (!fileCsv.open(QFile::WriteOnly)){
                //    return ;
             //   qDebug()<<QDir::homePath()+"/.config/panelTheme.css";
        }
        QTextStream out(&fileCsv);
        out.setCodec(QTextCodec::codecForLocale());
        out<<myStyleShet;
        //return myStyleShet;

}
QString PanelSettings::getStyleImage()
{
        QString myStyle;

        if(ui->checkBoxRepeat->isChecked()){


                QString styleBorder= QString("\n  border:	1px solid rgba(%1, %2, %3,%4);"
                                             )
                        .arg(btn_colorBorder->color().red()).arg(btn_colorBorder->color().green())
                        .arg(btn_colorBorder->color().blue()).arg(btn_colorBorder->color().alpha());


           myStyle=  QString("\n QWidget #widgetBgr{"
                               " background-image: url(%1);"
                                "background-repeat: repeat-xy;"



                               ).arg(ui->lineEditImageFile->text());


           myStyle=myStyle+styleBorder;

        }else{
           myStyle= QString("\n QWidget #widgetBgr{"
                              "border-image: url(%1);"

                              ).arg(m_pixFileName);

        }

    return myStyle;
}
void PanelSettings::on_pushButtonGetImage_clicked()
{
          QString  fileName = QFileDialog::getOpenFileName(this,
                          tr("Open Image"), m_pixFileName, tr("Image Files (*.png *.jpg *.bmp)"));

          if(!fileName.isEmpty()){
                    ui->lineEditImageFile->setText(fileName);
                    m_pixFileName=fileName;
          }
}

void PanelSettings::on_spinBoxSize_editingFinished()
{
          m_panelSize=ui->spinBoxSize->value();
}

void PanelSettings::on_comboBoxPos_activated(int index)
{
          m_Position=index;
}

void PanelSettings::on_spinBoxSize_valueChanged(int arg1)
{
          m_panelSize=arg1;
}




void PanelSettings::on_comboBoxTheme_currentIndexChanged(int index)
{
    QString path=ui->comboBoxTheme->itemData(index).toString();
    loadSetting(path+"/settings.conf");
    setStylePanel();
}


Q_EXPORT_PLUGIN2(setting_PanelSettings, PanelSettings)
