#ifndef PANELSETTINGS_H
#define PANELSETTINGS_H


#include "../spluginsinterface.h"
#include <EIcon>
#include <ButtonColor>
#include <QWidget>
#include <QAbstractButton>

namespace Ui {
class PanelSettings;
}

class PanelSettings : public QWidget,PluginsInterface
{
    Q_OBJECT
    Q_INTERFACES(PluginsInterface)
    
public:
    explicit PanelSettings(QWidget *parent = 0);
    ~PanelSettings();
signals:
        void accepteChange();

        public slots:
        void saveSettings();
        QWidget *widget(){return this;}

private:
    Ui::PanelSettings *ui;


 QSettings *msetting;

 void  loadSetting(const QString &path=QString());

        QString m_stop;
        QString m_stop2;

        ButtonColor *btn_colorTop,*btn_colorRight,*btn_colorBot,*btn_colorLeft;
        ButtonColor  *btn_colorBorder,*btn_colorSelect,*btn_colorFont,*btn_colorGlobale;

        int m_panelSize;
        int m_Position;
        QString m_pixFileName;
        //   bool m_isImage;
        QString m_iconsTheme;
private slots:
        void setupThemes();
        void setStylePanel();
        //    QString getDirIconTeme(QString dir);
        void savePanelStyle();

        QString getStyleImage();
        void on_verticalSlider_sliderMoved(int position);
        void on_verticalSlider2_sliderMoved(int position);



        void on_pushButtonGetImage_clicked();
        void on_spinBoxSize_editingFinished();
        void on_comboBoxPos_activated(int index);
        void on_spinBoxSize_valueChanged(int arg1);

        void on_comboBoxTheme_currentIndexChanged(int index);
};

#endif // PANELSETTINGS_H
