/***************************************************************************
 *   elokab Copyright (C) 2014 AbouZakaria <yahiaui@gmail.com>             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef WIGGETCURSOR_H
#define WIGGETCURSOR_H
#include "../spluginsinterface.h"
#include <QWidget>

#include <QAbstractButton>
class XCursorThemeData;
namespace Ui {
class WiggetCursor;
}

class WiggetCursor : public QWidget,PluginsInterface
{
          Q_OBJECT
          Q_INTERFACES(PluginsInterface)
        
public:
        explicit WiggetCursor(QWidget *parent = 0);
        ~WiggetCursor();
        
private:
        Ui::WiggetCursor *ui;


 QList<XCursorThemeData *>m_listThemes;
 QStringList m_dirsPaths;
int m_oldIndex;
public slots:

void saveSettings();
QWidget *widget(){return this;}

private slots:
           void setCurrentCursor();
           void currentComboChanged(int index);
           void on_buttonBox_clicked(QAbstractButton *button);


           void updatePreview(const XCursorThemeData &theme);
           QPixmap previewPix(const XCursorThemeData &theme,const QString &name);

           //-------------------------------------------
           void loadListThemesCursor();
           bool themeExist(const QString &name) const;//to be modified
           bool isCursorTheme(const QString &theme,  const int depth = 0);

           void createlistPixmapThemes();
};

#endif // WIGGETCURSOR_H
