/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#include "widgetdefaultbrowser.h"
#include "ui_widgetdefaultbrowser.h"
#include <EMimIcon>
#include <QSettings>
#include <QFile>
#include <QTextStream>
#include <QDir>
#include <QDebug>
WidgetDefaultBrowser::WidgetDefaultBrowser(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::WidgetDefaultBrowser)
{
    ui->setupUi(this);

    QStringList listApp=EMimIcon::associatedApplication("inode/directory");

  //  ui->comboBox->addItems(listApp);
        QHash<QString ,QString> hash;
    foreach (QString f, listApp) {

              hash=EMimIcon:: desktopFile(EMimIcon::desktopFilePath(f));
               QString app=EMimIcon::replaceArgument( hash ["Exec"]);
 // QString app= hash ["Exec"];
//              QRegExp ex("\\%[A-Z]");
//                                   QRegExp ex2("\\%[a-z]");
//                                app.remove(ex);
//                                app.remove(ex2);
//                            app.remove("-caption");

                  ui->comboBox->addItem(QIcon::fromTheme(  hash ["Icon"]),app);
    }

    //--------------------------------------
//    QFile file(QDir::homePath()+"/.config/elokab/mimeApp");
//qDebug()<<file.fileName();
//    if (file.open(QFile::ReadOnly)){

//            QTextStream textStream(&file);
//            QString line;

//            line= textStream.readLine();//premier line

//            while (!line.isNull()) {

//                    if(line.contains("inode/directory")){

//                            QString app=line.section("|",1,1);
//                            QString icon=line.section("|",2,2);
//                            QRegExp ex("\\%[A-Z]");
//                            QRegExp ex2("\\%[a-z]");
//                            app.remove(ex);
//                            app.remove(ex2);
//                            app.remove("-caption");
//                            ui->comboBox->addItem(QIcon::fromTheme(icon),app);
//                    }
//                    line= textStream.readLine();
//            }
//    }


    QSettings globalSetting("elokab","elokabsettings");
    globalSetting.beginGroup("DefaultBrowser");
    ui->radioButtonDefaultBrowser->setChecked(globalSetting.value("defaultBrowser",false).toBool());
    ui->radioButtonCostumBrowser->setChecked(!globalSetting.value("defaultBrowser",true).toBool());
    ui->comboBox->setEditText(globalSetting.value("BROWSER","elokab-fm").toString());
    globalSetting.endGroup();

    oldDefault=ui->radioButtonDefaultBrowser->isChecked();
    oldBrowser= ui->comboBox->currentText();
}

WidgetDefaultBrowser::~WidgetDefaultBrowser()
{
    delete ui;
}

void WidgetDefaultBrowser::saveSettings()
{
    if(oldDefault!=ui->radioButtonDefaultBrowser->isChecked()||
            oldBrowser!= ui->comboBox->currentText()){

        QSettings globalSetting("elokab","elokabsettings");
        globalSetting.beginGroup("DefaultBrowser");
        globalSetting.setValue("defaultBrowser", ui->radioButtonDefaultBrowser->isChecked());
        globalSetting.setValue("BROWSER",ui->comboBox->currentText());
        globalSetting.endGroup();
    }
}
Q_EXPORT_PLUGIN2(setting_DefaultBrowser, WidgetDefaultBrowser)
