#include "widgetdesktopthem.h"
#include "ui_widgetdesktopthem.h"
//#include"dialogsettings.h"
#include <EDir>
#include <QDebug>
#include <QSettings>
#include <QTime>
#include <QTextCodec>
#include <QInputDialog>
#include <QMessageBox>
#include <QDesktopWidget>
#include <QTimer>
#include <QProcess>
#define CURRENT_T   "CurrentTheme"

#define TYPE_COLOR   0
#define TYPE_PATTERN   1
#define TYPE_IMAGE   2
#define TYPE_IMAGEFOLDER   3
#define TYPE_ANIMATION   4

WidgetDesktopThem::WidgetDesktopThem(bool showButtons, QWidget *parent) :
          QWidget(parent),
    ui(new Ui::WidgetDesktopThem)
{


    ui->setupUi(this);
    ui->WidgetToolButton->setVisible(showButtons);
    //add item curent themes
QListWidgetItem *item=new QListWidgetItem;
QString image=":/images/preview.png";
item->setIcon(QIcon(image).pixmap(128,128));
item->setText(trUtf8("Current theme"));
item->setData(Qt::UserRole,CURRENT_T);
ui->listWidgetThemes->addItem(item);
//****QDir appDir(a.applicationDirPath());
// QDir appDir(QApplication::applicationDirPath());
//appDir.cdUp();

usersPath=Edir::dataDir()+"/themes";
localPath=Edir::dataHomeDir()+"/elokab/themes";

    chargeTemes(localPath);
    chargeTemes(usersPath);

    ui->listWidgetThemes->setCurrentRow(0);

}

WidgetDesktopThem::~WidgetDesktopThem()
{
    delete ui;
}

QColor listToColor(QList<QVariant>list)
{
    int red=0,green=0, bleu=0,alpha=255;
    int count=list.count();
    if(count>0)red=list.at(0).toInt();
    if(count>1)green=list.at(1).toInt();
    if(count>2)bleu=list.at(2).toInt();
    if(count>3)alpha=list.at(3).toInt();
    return QColor(red,green,bleu,alpha);
}
QList<QVariant> colorToList(QColor color)
{
    int red=(color.red());
    int green=(color.green());
    int bleu=(color.blue());
    int alpha=(color.alpha());
    return QList<QVariant>()<<red<<green<<bleu<<alpha;
}

/*************************************************
 *charge themes
 **************************************************/
void WidgetDesktopThem::chargeTemes(const QString &dirPath)
{

    QDir dirS(dirPath);
    foreach(QString dir,dirS.entryList(QDir::AllDirs| QDir::NoSymLinks| QDir::NoDotAndDotDot )) {
        QString path=dirPath+QDir::separator()+dir+QDir::separator();
        if (QFile::exists(path+"settings.conf")&&QFile::exists(path+"theme")){
             addThemeToList( path,dir);
        }
    }
}
/*************************************************
 *add new theme to listwidget
 **************************************************/
void WidgetDesktopThem::addThemeToList(const QString &path, const QString &dir)
{
    if(m_listThemes.contains(dir))
        return;
    m_listThemes.append(dir);
    QListWidgetItem *item=new QListWidgetItem;
    QString image=path+"preview.png";
    if(!QFile::exists(image))
        image=":/images/preview.png";
    item->setIcon(QIcon(image).pixmap(64,64));
    item->setText(dir);
    item->setData(Qt::UserRole,path);
    ui->listWidgetThemes->addItem(item);
}

/*************************************************
 *save themes
 **************************************************/

void WidgetDesktopThem::saveSettings()
{
          qDebug()<<"themes";
    QListWidgetItem *item= ui->listWidgetThemes->currentItem();
    if(!item)
        return;

       qDebug()<<"oldTheme"<<oldTheme;
    if(oldTheme==item->text())
        return;

       qDebug()<<"(item->data(Qt::UserRole)"<<item->data(Qt::UserRole);
    if(item->data(Qt::UserRole)==CURRENT_T)
        return;

    oldTheme=item->text();

    setDesktopTheme( item->data(Qt::UserRole).toString());
    stPanelTheme(item->data(Qt::UserRole).toString());
    setDockTheme(item->data(Qt::UserRole).toString());

    //! read theme global info -------------------------
    QSettings setting(item->data(Qt::UserRole).toString()+"/theme",QSettings::IniFormat);
   //  qDebug()<<"(item->data(Qt::UserRole)"<<item->data(Qt::UserRole).toString()+oldTheme+"/theme";
    setting.beginGroup("Themes");
    QString themeName= setting.value("ThemeName","default").toString();
    QString iconTheme= setting.value("IconsName").toString();
    QString widgetStyle=setting.value("StyleName","default").toString();
    setting.endGroup();

     //! save theme global info --------------------------
    QSettings globalSetting("elokab","elokabsettings");
    globalSetting.beginGroup("Themes");
    globalSetting.setValue("ThemeName",themeName);
    if(isValidIcon(iconTheme))
    globalSetting.setValue("iconsTheme",iconTheme);

    globalSetting.endGroup();
    globalSetting.beginGroup("Style");
    globalSetting.setValue("Name",widgetStyle);
    globalSetting.endGroup();
    qDebug()<<"themes finish";

}
bool WidgetDesktopThem::isValidIcon(QString name)
{
        QStringList listThemePath=QIcon::themeSearchPaths();
        listThemePath.append(QDir::homePath()+"/.icons");
        listThemePath.append("/usr/share/icons");
        listThemePath.removeDuplicates();


        int count=listThemePath.count();
        QStringList pathList;
        for (int i=0;i<count;i++){
                QString dirPath= listThemePath.at(i);
                QDir dirS(dirPath);
                foreach(QString dir,dirS.entryList(QDir::AllDirs| QDir::NoSymLinks| QDir::NoDotAndDotDot )) {
                        pathList<<      getDirIconTeme(dirPath+"/"+dir);
                }

        }
        pathList.removeDuplicates();
        pathList.removeAll("");
        if(pathList.contains(name)){
                return true;
        }
        return false;
}
QString WidgetDesktopThem::getDirIconTeme(QString dir)
{
          QDir dirPath(dir);
          if(!QFile::exists(dir+"/index.theme"))return "";
          QSettings settings(dir+"/index.theme",QSettings::IniFormat);
           settings.beginGroup("Icon Theme");
          if(!settings.contains("Directories"))return "" ;

          settings.endGroup();
          return dirPath.dirName();

}

void WidgetDesktopThem::setDesktopTheme(const QString &path)
{
    /*********************************
    *load the setting from theme path*
    **********************************/
    QSettings setting(path+"settings.conf",QSettings::IniFormat);
    setting.beginGroup("Desktop-Wallpaper");

    QString  m_color=setting.value("wallpaperColor",QColor(60,60,60).name()).toString();
    QString  m_colorPattern1=setting.value("colorPattern1",QColor(148,159,255).name()).toString();
    QString  m_colorPattern2=setting.value("colorPattern2",QColor(195,222,255).name()).toString();

    int curentPattern=setting.value("curentPattern",0).toInt();
    int aspectRatio=setting.value("aspectRatio",0).toInt();
    QString imagePath=setting.value("imagePath","").toString();
    QString folderPath=setting.value("folderPath","").toString();
    int wallpaperType=setting.value("wallpaperType",2).toInt();
//QString timr=setting.value("slideShowTaime","").toString();
      int icn=setting.value("iconSize",48).toInt();

    setting.endGroup();

    if(wallpaperType==TYPE_IMAGE){

        QFileInfo fi(imagePath);
        imagePath=path+"images/"+fi.fileName();

    }else if(wallpaperType==TYPE_PATTERN){

      QFile::copy( path+"/images/pixPattern.png",
                   Edir::dataHomeDir()+"/elokab/elokab-desktop/pixPattern.png");

    }

    /*****************************
     *save the setting to .config*
     *****************************/

    QSettings settingS("elokab","settings");
    settingS.beginGroup("Desktop-Wallpaper");

    settingS.setValue("wallpaperColor",m_color);
    settingS.setValue("colorPattern1",m_colorPattern1);
    settingS.setValue("colorPattern2",m_colorPattern2);
    settingS.setValue("wallpaperType",wallpaperType);
    settingS.setValue("curentPattern",curentPattern);
    settingS.setValue("aspectRatio",aspectRatio);
    settingS.setValue("imagePath", imagePath);
    settingS.setValue("folderPath", folderPath);

//    settingS.setValue("slideShowTaime", time);

    setting.setValue("iconSize",icn);

    settingS.endGroup();

}
void WidgetDesktopThem::stPanelTheme(const QString &path)
{
    /***********************************
     *load setting from the themes path*
     ***********************************/



    QSettings setting(path+"settings.conf",QSettings::IniFormat);
    setting.beginGroup("Panel-Style");

    QList<QVariant> m_colorTop=setting.value("color1",QList<QVariant>()<<56<< 56<< 56<< 255).toList();
    QList<QVariant> m_colorRight=setting.value("color2",QList<QVariant>()<<76<<76<< 76<< 255).toList();
    QList<QVariant> m_colorBot=setting.value("color3",QList<QVariant>()<<0<<0<< 0<< 255).toList();
    QList<QVariant> m_colorLeft=setting.value("color4",QList<QVariant>()<<43<<43<<43<<255).toList();

    QList<QVariant> m_colorBorder=setting.value("colorBorder",QList<QVariant>()<<34<< 34<<34<<255).toList();
    QList<QVariant> m_colorSelect=setting.value("colorSelect",QList<QVariant>()<<255<< 50<< 20<<255).toList();
    QList<QVariant> m_colorGlobale=setting.value("colorGlobale",QList<QVariant>()<<56<<56<< 56<< 255).toList();
    QList<QVariant> m_colorFont=setting.value("colorFont",QList<QVariant>()<<255<<255<<255<<255).toList();


    QString pixFileName=setting.value("pixFileName","").toString();
    bool m_isImage=setting.value("isImage",false).toBool();
    bool imageRepeat=  setting.value("imageRepeat", false).toBool();

    QString m_stop=setting.value("stop","0.02").toString();
    QString m_stop2=setting.value("stop2","0.96").toString();
    int m_Position=setting.value("Position",0).toInt();
    int m_panelSize=setting.value("panelSize","24").toInt();
       bool styleDefault=setting.value("styleDefault",false).toBool();

    setting.endGroup();
    /*********************************************
     *styl for the main menu                     *
     *********************************************/
    setting.beginGroup("MainMenu");

    int menuButtonStyle=(setting.value("ButtonStyle",0).toInt());
    QString menuButtonText=(setting.value("ButtonText",("Start Here")).toString().trimmed());
    QString menuiconName=setting.value("ButtonIcon",":/icons/start-here.png").toString();
   bool menuIsCostumImage=(setting.value("IsCostumImage",false).toBool());
   QString menuNormalImage=(setting.value("NormalImage").toString());
   QString menuHoverImage=(setting.value("HoverImage").toString());

   setting.endGroup();

    /**********************************
     *read the css file*
     *********************************/
  qDebug()<<"panel"<<path+"panelTheme.css";
    QString qssFile=path+"panelTheme.css";
    if(!QFile::exists(qssFile))
        return;

    QFile file(qssFile);
    if( !file.open( QFile::ReadOnly)){
             qDebug()<<"panel returned";
        return;
    }
    QTextStream textStream(&file);
    textStream.setCodec(QTextCodec::codecForName("UTF-8"));
    QString line= textStream.readAll();
    file.close();

    /*********************************************
     *replace images path to path/themes/imagges*
     *********************************************/
    if(m_isImage==true){

            QFileInfo fi(pixFileName);
            line.replace(pixFileName,path+"images/"+fi.fileName());
            pixFileName=path+"images/"+fi.fileName();

    }

 if(menuIsCostumImage==true){

         QFileInfo fi(menuNormalImage);
         menuNormalImage=path+"images/"+fi.fileName();

         QFileInfo fi2(menuHoverImage);
         menuHoverImage=path+"images/"+fi2.fileName();
 }

 /*********************************************
  *save the css to  config/elokab/dockTheme.css*
  **********************************************/

  QFile fileCsv(Edir::configDir()+"/panelTheme.css");
  if (!fileCsv.open(QFile::WriteOnly)){
      return;

       }
  QTextStream out(&fileCsv);
  out.setCodec(QTextCodec::codecForName("UTF-8"));
  out<<line;
  fileCsv.close();
    /********************************************************************
    *save settings  to the default settings home/.config/elokab/settings*
     ********************************************************************/

    QSettings settingS("elokab","settings");
    settingS.beginGroup("Panel-Style");

    settingS.setValue("color1",(m_colorTop));
    settingS.setValue("color2",(m_colorRight));
    settingS.setValue("color3",(m_colorBot));
    settingS.setValue("color4",(m_colorLeft));
    settingS.setValue("colorFont",(m_colorFont));
    settingS.setValue("colorBorder",(m_colorBorder));
    settingS.setValue("colorSelect",(m_colorSelect));
    settingS.setValue("colorGlobale",(m_colorGlobale));

    settingS.setValue("stop",m_stop);
    settingS.setValue("stop2",m_stop2);
    settingS.setValue("pixFileName",pixFileName);
    settingS.setValue("isImage",m_isImage);
    setting.setValue("imageRepeat", imageRepeat);
    settingS.setValue("panelSize",m_panelSize);
    settingS.setValue("Position",m_Position);
    settingS.setValue("styleDefault",styleDefault);

    settingS.endGroup();

   settingS.beginGroup("MainMenu");
   settingS.setValue("ButtonStyle",menuButtonStyle);
   settingS.setValue("ButtonText",menuButtonText);
   settingS.setValue("iconName",menuiconName);
   settingS.setValue("IsCostumImage",menuIsCostumImage);
   settingS.setValue("NormalImage",menuNormalImage);
   settingS.setValue("HoverImage",menuHoverImage);
   settingS.endGroup();


}

void WidgetDesktopThem::setDockTheme(const QString &path)
{
    /***********************************
     *load setting from the themes path*
     ***********************************/
    QSettings setting(path+"settings.conf",QSettings::IniFormat);
    setting.beginGroup("Dock-Style");

    int position=(setting.value("position",0).toInt());
    int screenEdge=(setting.value("screenEdge",0).toInt());
    int iconSize=(setting.value("iconSize",48).toInt());
    int animmationStyle=(setting.value("animmationStyle",0).toInt());


    QList<QVariant>   colorTop=setting.value("color1",QList<QVariant>()<<56<< 56<< 56<< 255).toList();
    QList<QVariant>   colorRight=setting.value("color2",QList<QVariant>()<<76<< 76<< 76<<255).toList();
    QList<QVariant>   colorBot=setting.value("color3",QList<QVariant>()<<0<< 0<< 0<< 255).toList();
    QList<QVariant>   colorLeft=setting.value("color4",QList<QVariant>()<<43<< 43<< 43<< 255).toList();
    QList<QVariant>   colorBorder=setting.value("colorBorder",QList<QVariant>()<<34<< 34<<34<<255).toList();
    QList<QVariant>   colorSelect=setting.value("colorSelect",QList<QVariant>()<<255<< 50<< 20<<255).toList();

    QString m_stop=setting.value("stop","0.02").toString();
    QString m_stop2=setting.value("stop2","0.96").toString();

    int borderLeft=(setting.value("borderLeft",5).toInt());
    int borderRight=(setting.value("borderRight",5).toInt());
    int borderTop=setting.value("borderTop",3).toInt();
    int borderBot=(setting.value("borderBot",1).toInt());
    int backgroundStyle=(setting.value("backgroundStyle",0).toInt());
    QString pixFileName=(setting.value("pixFileName","").toString());
    bool imageRepeat=  setting.value("imageRepeat", false).toBool();

    int image3D=setting.value("image3D",0).toInt();
    bool showSelection=setting.value("showSelection",true).toBool();

 //   bool CustomToolTip=setting.value("CustomToolTip",true).toBool();
//    QColor   InfoBgrColor=setting.value("InfoBgrColor",QColor(76, 76, 76, 255)).value<QColor>();
//    QColor   InfoBorderColor=setting.value("InfoBorderColor",QColor(34, 34,34,255)).value<QColor>();
//    QColor   InfoFontColor=setting.value("InfoFontColor",QColor(255, 255, 255,255)).value<QColor>();


    setting.endGroup();

    /**********************************
     *read the css file*
     *********************************/
    QString qssFile=path+"dockTheme.css";
    if(!QFile::exists(qssFile))
        return;

    QFile file(qssFile);
    if( !file.open( QFile::ReadOnly))
        return;

    QTextStream textStream(&file);
    textStream.setCodec(QTextCodec::codecForName("UTF-8"));
    QString line= textStream.readAll();
    file.close();

    /*********************************************
     *replace images path to themes/images*
     *********************************************/
    if(backgroundStyle==1){
        if(!QFile::exists(pixFileName)){
            QFileInfo fi(pixFileName);
            line.replace(pixFileName,path+"images/"+fi.fileName());
            pixFileName=path+"images/"+fi.fileName();
        }
    }
    /*********************************************
    *save the css to  config/elokab/dockTheme.css*
    **********************************************/
    QFile fileCsv(Edir::configDir()+"/dockTheme.css");
    if (!fileCsv.open(QFile::WriteOnly)){
        return;

    }
    QTextStream out(&fileCsv);
    out.setCodec(QTextCodec::codecForName("UTF-8"));
    out<<line;
    fileCsv.close();

    /********************************************************************
    *save settings  to the default settings home/.config/elokab/settings*
     ********************************************************************/

    QSettings settingS("elokab","settings");

    settingS.beginGroup("Dock-Style");

    settingS.setValue("position",position);
    settingS.setValue("screenEdge",screenEdge);
    settingS.setValue("iconSize",iconSize);
    settingS.setValue("animmationStyle",animmationStyle);
    settingS.setValue("color1",(colorTop));
    settingS.setValue("color2",(colorRight));
    settingS.setValue("color3",(colorBot));
    settingS.setValue("color4",(colorLeft));
    settingS.setValue("colorBorder",(colorBorder));
    settingS.setValue("colorSelect",(colorSelect));
    settingS.setValue("stop",m_stop);
    settingS.setValue("stop2",m_stop2);
    settingS.setValue("pixFileName", pixFileName);
    setting.setValue("imageRepeat", imageRepeat);
    settingS.setValue("borderLeft",borderLeft);
    settingS.setValue("borderRight", borderRight);
    settingS.setValue("borderTop", borderTop);
    settingS.setValue("borderBot",borderBot);
    settingS.setValue("backgroundStyle", backgroundStyle);
    settingS.setValue("image3D", image3D);
    settingS.setValue("showSelection",showSelection);
  //  setting.setValue("CustomToolTip",CustomToolTip);
//    settingS.setValue("InfoBgrColor", InfoBgrColor);
//    settingS.setValue("InfoBorderColor", InfoBorderColor);
//    settingS.setValue("InfoFontColor",InfoFontColor);
   // settingS.setValue("CssPath",path+"dockTheme.css");


    settingS.endGroup();


}

/*************************************************
 *creat themes
 **************************************************/
void WidgetDesktopThem::on_pushButtonCreat_clicked()
{
    bool ok;
    QString text = QInputDialog::getText(this, tr("theme name"),
                                         tr("enter name:"), QLineEdit::Normal,
                                         "", &ok);
    if (ok && !text.isEmpty())
        creatThemes(text);
}

void WidgetDesktopThem::creatThemes(const QString &themeName)
{
    QDir dir;
    newThemName=themeName;
    if (dir.exists(localPath+"/"+themeName)){
        QMessageBox::information(this,"",trUtf8("this directory exist"));
        return;
    }
    dir.mkpath(localPath+"/"+themeName+"/images");

     //! copy files---------------------------------
    QFile::copy(Edir::configDir()+"/settings.conf",localPath+"/"+themeName+"/settings.conf");
    QFile::copy(Edir::configDir()+"/dockTheme.css",localPath+"/"+themeName+"/dockTheme.css");
    QFile::copy(Edir::configDir()+"/panelTheme.css",localPath+"/"+themeName+"/panelTheme.css");

     //! read theme global info --------------------
    QSettings settingS("elokab","elokabsettings");

    settingS.beginGroup("Themes");
    QString iconTheme=settingS.value("iconsTheme","Elokab").toString();
    settingS.endGroup();

    settingS.beginGroup("Style");
    QString widgetStyle=settingS.value("Name","default").toString();
    settingS.endGroup();
    //! save theme global info --------------------
    QSettings setting(localPath+"/"+themeName+"/theme",QSettings::IniFormat);

    setting.beginGroup("Themes");
    setting.setValue("ThemeName",themeName);
    setting.setValue("IconsName",iconTheme);
    setting.setValue("StyleName",widgetStyle);
    setting.setValue("AuthorName",QDir::home().dirName());
    setting.endGroup();

    //! copy image if exists---------------
    QSettings s(localPath+"/"+themeName+"/settings.conf",QSettings::IniFormat);
    s.sync();

    s.beginGroup("Desktop-Wallpaper");
    QString imagePath=s.value("imagePath","").toString();
    int wallpaperType=s.value("wallpaperType","").toInt();
    s.endGroup();
    //! [1]-----------------Desktop-------------------------
    if(wallpaperType==TYPE_IMAGE){
        QFileInfo fi(imagePath);
        QFile::copy(imagePath,localPath+"/"+themeName+"/images/"+fi.fileName());
        qDebug()<<"imagePath"<<localPath+"/"+themeName+"/images/"+fi.fileName();
    }else if(wallpaperType==TYPE_PATTERN){

        QFile::copy(Edir::dataHomeDir()+"/elokab/elokab-desktop/pixPattern.png"
                    , localPath+"/"+themeName+"/images/pixPattern.png") ;

    }

     //! [2]-----------------Panel-------------------------
    s.beginGroup("Panel-Style");

    QString pixFileName=s.value("pixFileName","").toString();
    bool isImage=s.value("isImage",false).toBool();
    s.endGroup();
    qDebug()<<"pixFileName"<<pixFileName;
    if(isImage==true){

        QFileInfo fi(pixFileName);
        QFile::copy(pixFileName,localPath+"/"+themeName+"/images/"+fi.fileName());

    }
    //! [2][1]-----------------Main Menu-------------------------

    s.beginGroup("MainMenu");
    bool menuIsCostumImage=(s.value("IsCostumImage",false).toBool());
    QString menuNormalImage=(s.value("NormalImage").toString());
    QString menuHoverImage=(s.value("HoverImage").toString());
    s.endGroup();
    if(menuIsCostumImage==true){

        QFileInfo fi(menuNormalImage);
        QFile::copy(menuNormalImage,localPath+"/"+themeName+"/images/"+fi.fileName());

        QFileInfo fi2(menuHoverImage);
        QFile::copy(menuHoverImage,localPath+"/"+themeName+"/images/"+fi2.fileName());

    }

    //! [3]-----------------Dock-------------------------
    s.beginGroup("Dock-Style");
    int backgroundStyle=(s.value("backgroundStyle",0).toInt());
    QString pixFileName2=(s.value("pixFileName","").toString());
    s.endGroup();
    if(backgroundStyle==1){
        QFileInfo fi(pixFileName2);
        QFile::copy(pixFileName2,localPath+"/"+themeName+"/images/"+fi.fileName());

    }

    emit parentHide();
                    //! screen shots----------------------
    QTimer::singleShot(1000,this,SLOT(screenSHotDesktop()));

}
/*************************************************
 *creat screenshot for the new theme
 **************************************************/
void WidgetDesktopThem::screenSHotDesktop()
{
    QPixmap  originalPixmap = QPixmap::grabWindow(QApplication::desktop()->winId());
    if(originalPixmap.scaled(QSize(256,256), Qt::KeepAspectRatio).
            save(localPath+"/"+newThemName+"/preview.png"))
        addThemeToList(localPath+"/"+ newThemName+"/", newThemName);
  //   DialogSettings *DSettings = qobject_cast<DialogSettings*>(m_parent);
//DSettings->show();
    emit parentShow();
}
/*************************************************
 *remove selected theme
 **************************************************/
void WidgetDesktopThem::on_pushButtonRemove_clicked()
{
    QListWidgetItem *item= ui->listWidgetThemes->currentItem();

    if(!item)
        return;
  QString path=  item->data(Qt::UserRole).toString();
  if(path.contains("/usr/share/themes"))
       return;

  int ret = QMessageBox::question(this, "",
                                  tr("Do you  to remove selected theme? \n ")+path,
                                  QMessageBox::Ok | QMessageBox::Cancel );
  if (ret==QMessageBox::Ok){

      QProcess process;
      process.startDetached("rm -r \""+path+"\"");
   int index=    m_listThemes.indexOf(item->text());
   if(index!=-1)
       m_listThemes.takeAt(index);
      ui->listWidgetThemes->takeItem( ui->listWidgetThemes->currentRow());

  }
}

void WidgetDesktopThem::on_listWidgetThemes_itemSelectionChanged()
{
    QListWidgetItem *item= ui->listWidgetThemes->currentItem();

    if(!item)
        return;


  QString path=  item->data(Qt::UserRole).toString();
  QString image=path+"preview.png";
  if(!QFile::exists(image))
      image=":/images/preview.png";

  ui->labelPreview->setPixmap(QPixmap(image));
  //! read theme global info -------------------------
  QSettings setting(item->data(Qt::UserRole).toString()+"/theme",QSettings::IniFormat);
   qDebug()<<"(item->data(Qt::UserRole)"<<item->data(Qt::UserRole).toString()+oldTheme+"/theme";
  setting.beginGroup("Themes");
  QString themeName= setting.value("ThemeName","").toString();
  QString iconTheme= setting.value("IconsName","").toString();
  QString widgetStyle=setting.value("StyleName","").toString();
    QString AuthorName=setting.value("AuthorName","").toString();
  setting.endGroup();
  ui->labelInfo->setText("\n"+tr("Theme Name :")+themeName+"\n"+
                         tr("icon theme :")+iconTheme+"\n"+
                         tr("Widgets Style :")+widgetStyle+"\n"+
                         tr("Author :")+AuthorName+"\n");

  QFileInfo fi(path);
  if(fi.isWritable()){
       ui->pushButtonRemove->setEnabled(true);
  }else{
       ui->pushButtonRemove->setEnabled(false);
  }


}
Q_EXPORT_PLUGIN2(setting_DesktopThem, WidgetDesktopThem)
