/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#include "dialogeditshortcut.h"
#include "ui_dialogeditshortcut.h"
#include <EIcon>
#include<QToolButton>
DialogEditShortcut::DialogEditShortcut(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DialogEditShortcut)
{
    QToolButton *tbtnClair=new QToolButton(this);
    tbtnClair->setText(tr("clair"));
    tbtnClair->setIcon(EIcon::fromTheme("edit-clear"));
     tbtnClair->setAutoRaise(true);
    ui->setupUi(this);
    linShortcut=new LineEdit;
    ui->horizontalLayout->addWidget(linShortcut);
     ui->horizontalLayout->addWidget(tbtnClair);

    linShortcut->setFocus();
     connect(tbtnClair,SIGNAL(clicked()),linShortcut,SLOT(clear()));
}

DialogEditShortcut::~DialogEditShortcut()
{
    delete ui;
}

void DialogEditShortcut::setEditable(bool arg)
{
    ui->widgetInfo->setVisible(arg);
    adjustSize();
}

QString DialogEditShortcut::getProg()
{
    return ui->lineEditProg->text();
}

QString DialogEditShortcut::getComment()
{
    return ui->lineEditComment->text();
}

void DialogEditShortcut::setProg(const QString txt)
{
    ui->lineEditProg->setText(txt);
}

void DialogEditShortcut::setComment(const QString txt)
{
    ui->lineEditComment->setText(txt);
}


