/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef DIALOGEDITSHORTCUT_H
#define DIALOGEDITSHORTCUT_H

#include <QDialog>
#include <QLineEdit>
#include <QKeyEvent>
//*********************class edit
class  LineEdit : public QLineEdit
{
    Q_OBJECT
public:
    LineEdit(QWidget* parent=0)
        : QLineEdit(parent)
    {
    }

protected:
    void keyReleaseEvent(QKeyEvent *)
    {

        txtControl=QString::null;
    }
    void keyPressEvent(QKeyEvent *event)
    {
        if ( event->key()==Qt::Key_AltGr||event->key()==Qt::Key_Print||
                event->key()==Qt::Key_CapsLock||event->key()==Qt::Key_NumLock||
                event->key()==Qt::Key_Return||event->key()==Qt::Key_Enter
                ||event->key()==Qt::Key_Escape)

            return;

        if (event->key()==Qt::Key_Control){
            txtControl=txtControl+"Ctrl+";
            return;
        }
        if (event->key()==Qt::Key_Shift){
            txtControl=txtControl+"Shift+";
            return;
        }
        if (event->key()==Qt::Key_Alt){
            txtControl=txtControl+"Alt+";
            return;
        }
        if (event->key()==Qt::Key_Meta){
            txtControl=txtControl+"Meta+";
            return;
        }
        QKeySequence key=event->key();
        QString txt=key.toString();
        this->setText(txtControl+txt);
        txtControl=QString::null;
        //this->setText(txtControl);
    }

private:
    QString txtControl;
};

//! class Dialog----------------------

namespace Ui {
class DialogEditShortcut;
}

class DialogEditShortcut : public QDialog
{
    Q_OBJECT
    
public:
    explicit DialogEditShortcut(QWidget *parent = 0);
    ~DialogEditShortcut();

private:
    Ui::DialogEditShortcut *ui;
     LineEdit *linShortcut;


public slots:
     void setKey(QString arg)
     {

         linShortcut->setText(arg);
     }
     QString getKey()
     {
         return linShortcut->text();
     }
     void setEditable(bool arg);
     void setProg(const QString txt);
      void setComment(const QString txt);
      QString getProg();
       QString getComment();

private slots:

};

#endif // DIALOGEDITSHORTCUT_H
