/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef WIDGETSHORTCUTS_H
#define WIDGETSHORTCUTS_H
#include "../spluginsinterface.h"
#include <QWidget>
#include <QTreeWidgetItem>
namespace Ui {
class widgetShortcuts;
}

class widgetShortcuts : public QWidget,PluginsInterface
{
          Q_OBJECT
          Q_INTERFACES(PluginsInterface)
    
public:
    explicit widgetShortcuts(QWidget *parent = 0);
    ~widgetShortcuts();
public slots:

    void saveSettings();
    QWidget *widget(){return this;}
private slots:
    void loadSettings(const QString filePath,QTreeWidget *treeWidget);
    void outSettings(const QString filePath,QTreeWidget *treeWidget);


    void on_treeWidgeGlobaltShort_itemActivated(QTreeWidgetItem *item, int);
    void on_toolButtonGlobalEdit_clicked();
void editGlobalItem(QTreeWidgetItem *item);
void on_treeWidgetCustomShort_itemActivated(QTreeWidgetItem *item, int /*column*/);
void on_toolButtonCustomEdit_clicked();
void editCustomItem(QTreeWidgetItem *item);
void on_toolButtonAdd_clicked();

void on_toolButtonDelete_clicked();

private:
    Ui::widgetShortcuts *ui;
   bool keysChanged;
};

#endif // WIDGETSHORTCUTS_H
