/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#include "dialogkeyadd.h"
#include "ui_dialogkeyadd.h"
#include <QDir>
#include <QDebug>
DialogKeyAdd::DialogKeyAdd(QWidget *parent) :
        QDialog(parent),
        ui(new Ui::DialogKeyAdd)
{
        ui->setupUi(this);
          this->setAttribute(Qt::WA_DeleteOnClose,true);
        setObjectName("addKey");
       QStringList xkbListFile;
             xkbListFile   <<  "/etc/X11/"<<

                "/usr/share/X11/"<<
                "/usr/local/share/X11/"<<
                "/usr/X11R6/lib/X11/"<<
                "/usr/X11R6/lib64/X11/"<<
                "/usr/local/X11R6/lib/X11/"<<
                "/usr/local/X11R6/lib64/X11/"<<
                "/usr/lib/X11/"<<
                "/usr/lib64/X11/"<<
                "/usr/local/lib/X11/"<<
                "/usr/local/lib64/X11/"<<
                "/usr/pkg/share/X11/"<<
                "/usr/pkg/xorg/lib/X11/"
           ;
             foreach (QString s, xkbListFile) {
                 if(xkbDirS.exists(s+"/xkb/symbols"))
                              xkbDirS.setPath(s+"/xkb/symbols");

             }
        qDebug()<<xkbDirS.absolutePath();
         chargeLanguage();
}

DialogKeyAdd::~DialogKeyAdd()
{
        delete ui;
}

void DialogKeyAdd::chargeLanguage()
{

   //  dirS("/usr/share/X11/xkb/symbols");
    foreach (QString subfile, xkbDirS.entryList(QDir::AllEntries|  QDir::NoDotAndDotDot )){

    //    qDebug()<<dirS.absolutePath()+"/"+subfile;
        QFile files( xkbDirS.absolutePath()+"/"+subfile);
        if(files.open( QFile::ReadOnly)){
            QTextStream textStream(&files);
            QString line = textStream.readLine();//premier line;
            QString layoutName;

            while   (!line.isNull()) {
                line = textStream.readLine();

                if(line.contains("name[Group1]=")){

                    layoutName=line.remove("name[Group1]=");
                    layoutName=layoutName.trimmed().remove("\"");
                    layoutName=layoutName.trimmed().remove(";");
                    ui->comboBoxLanguage->addItem(layoutName.trimmed(),subfile);
                    break;
                }



            }
        }
        files.close();

    }
    on_comboBoxLanguage_activated(0);
}
void DialogKeyAdd::chargeSubLanguage(const QString &file)
{
        QFile files(file);
        if(files.open( QFile::ReadOnly)){
                  QTextStream textStream(&files);
                  QString line = textStream.readLine();//premier line;
QString layoutName;
QString symbol;
QString  nlayout;
                  while   (!line.isNull()) {
                            line = textStream.readLine();
                            if(line.contains("xkb_symbols")){

                               nlayout=line.remove("xkb_symbols");
                               nlayout=line.remove("{");


                            }
                            if(layoutName!=nlayout){
                                if(line.contains("name[Group1]=")){
                                        layoutName=nlayout;
                                            symbol=line.remove("name[Group1]=");
                                            QString layout=symbol.trimmed()+layoutName.trimmed();
 layout=layout.trimmed().remove("\"");
                                             if(layout.contains("basic")){
                                                     ui->comboBoxSubLangue->addItem("Default",layout.section(";",1,1));

                                             }else{
                                                     ui->comboBoxSubLangue->addItem(layout.section(";",0,0),layout.section(";",1,1));

                                             }
                                                  }
                            }


                  }
        }
        files.close();
}



void DialogKeyAdd::on_comboBoxLanguage_activated(int index)
{
        QString lng=ui->comboBoxLanguage->itemData(index).toString();
     qDebug()<<lng;
      ui->comboBoxSubLangue->clear();
     chargeSubLanguage(xkbDirS.absolutePath()+"/"+lng);
}



void DialogKeyAdd::on_comboBoxSubLangue_activated(int index)
{
        QString lng=ui->comboBoxSubLangue->itemData(index).toString();
     qDebug()<<lng;
}

void DialogKeyAdd::on_buttonBox_accepted()
{
        QString layout=ui->comboBoxLanguage->itemData(ui->comboBoxLanguage->currentIndex()).toString();
        QString synbole=ui->comboBoxSubLangue->itemData(ui->comboBoxSubLangue->currentIndex()).toString();
        QString text=ui->comboBoxLanguage->currentText();
        emit accepteChange(text+"|"+layout+"|"+synbole);
  //   delete this;
}
