/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#ifndef WIDGETKEYSETTINGS_H
#define WIDGETKEYSETTINGS_H
#include "../spluginsinterface.h"
#include <QWidget>
#include <QTreeWidgetItem>
namespace Ui {
class WidgetKeySettings;
}

class WidgetKeySettings : public QWidget,PluginsInterface
{
          Q_OBJECT
          Q_INTERFACES(PluginsInterface)
        
public:
        explicit WidgetKeySettings(QWidget *parent = 0);
        ~WidgetKeySettings();
signals:

private slots:

        void loadSettings();

        void addNewKey(QString arg);

        void on_toolButtonUp_clicked();

        void on_toolButtonDown_clicked();

        void on_treeWidgetKeyboard_itemChanged(QTreeWidgetItem *, int);

        void on_toolButtonRemove_clicked();

        void on_toolButtonAdd_clicked();

public slots:

        void saveSettings();
        QWidget *widget(){return this;}
private:
        Ui::WidgetKeySettings *ui;

        bool  settingsChanged;
};

#endif // WIDGETKEYSETTINGS_H
