/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#include "widgetlanguages.h"
#include "ui_widgetlanguages.h"
#include <QSettings>
#include <QFile>
#include <QDir>
 #include <QLocale>
#include <QDebug>
WidgetLanguages::WidgetLanguages(QWidget *parent) :
        QWidget(parent),
        ui(new Ui::WidgetLanguages)
{
        ui->setupUi(this);
           ui->comboBox->addItem(trUtf8("Default"),"Default");
          ui->comboBox->addItem(trUtf8("Arabic"),"ar");

         ui->comboBox->addItem(trUtf8("English"),"en");
          ui->comboBox->addItem(trUtf8("French"),"fr");


//           for (int _lang = 2; _lang <= QLocale::LastLanguage; ++_lang) {

//               QLocale::Language lang = static_cast<QLocale::Language>(_lang);
//                  QString langName=QLocale::languageToString(lang);
//                QLocale(lang).setDefault(QLocale::English);
//                QString langSym=QLocale(lang).name().section("_",0,0);
////qDebug()<<langName<<langSym;
//                  ui->comboBox->addItem(langName,langSym);
//           }




          QSettings globalSetting("elokab","elokabsettings");
        globalSetting.beginGroup("Language");
        m_curent=globalSetting.value("Name","Default").toString();
        globalSetting.endGroup();
      //  int indx= ui->comboBox->findText(m_curent);
          int indx= ui->comboBox->findData(m_curent);
        ui->comboBox->setCurrentIndex(indx);
}

WidgetLanguages::~WidgetLanguages()
{
        delete ui;
}
void WidgetLanguages::saveSettings()
{
              int indx= ui->comboBox->currentIndex();
        if(m_curent==ui->comboBox->itemData(indx).toString())
                return;

        m_curent=ui->comboBox->itemData(indx).toString();
        QSettings globalSetting("elokab","elokabsettings");
        globalSetting.beginGroup("Language");
        globalSetting.setValue("Name",m_curent);
        globalSetting.endGroup();
        QFile::remove(QDir::homePath()+"/.config/elokab/applictions") ;

}
Q_EXPORT_PLUGIN2(setting_Languages, WidgetLanguages)
