#include "dialoggtk.h"
#include "ui_dialoggtk.h"
#include <QDir>
#include <QDebug>
#include <QFontDialog>
#include <QSettings>
DialogGtk::DialogGtk(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DialogGtk)
{
    ui->setupUi(this);
mFont=this->font();
ui->pushButtonFont->setText(mFont.family()+" "
                            +mFont.styleName()+" "
                            +QString::number(mFont.pointSize()));

    QStringList list;
    list<<QDir::homePath()+"/.themes"<<"/usr/share/themes";

    QStringList tempList;
    foreach (QString s, list) {
        QDir dir(s);
        QStringList dirList=dir.entryList(QDir::Dirs|QDir::NoDotAndDotDot);
        foreach (QString d, dirList) {
            if(tempList.contains(d))
                continue;
            tempList.append(d);
            if(QFile::exists(s+"/"+d+"/gtk-2.0/gtkrc")){

               QListWidgetItem *item=new QListWidgetItem(ui->listWidget);
               item->setText(d);
               item->setData(Qt::UserRole,s+"/"+d);


            }

        }

    }
    QSettings s("elokab","elokabsettings");
    s.beginGroup("Style");
    QString GtkThemeName=s.value("GtkThemeName","ElokabClear").toString();
    s.endGroup();

 QList<QListWidgetItem *>listItem=  ui->listWidget->findItems(GtkThemeName,Qt::MatchExactly);
    if(listItem.count()>0)
  ui->listWidget->setCurrentItem(listItem.at(0));

}

DialogGtk::~DialogGtk()
{
    delete ui;
}
QString DialogGtk::themName()
{
 return ui->listWidget->currentItem()->text();
}
QString DialogGtk::pathName()
{
 return ui->listWidget->currentItem()->data(Qt::UserRole).toString();
}

void DialogGtk::on_buttonBox_accepted()
{

}

void DialogGtk::on_pushButtonFont_clicked()
{
  bool ok;
    QFont font=QFontDialog::getFont(&ok);
    if(ok){
        ui->pushButtonFont->setText(font.family()+" "
                                    +font.styleName()+" "
                                    +QString::number(font.pointSize()));
        mFont=font;
}

}
