#include "widgetcolors.h"
#include "ui_widgetcolors.h"
#include <QGridLayout>
#include <QLabel>
#include <QGroupBox>
#include <QDebug>
#include <QSettings>
WidgetColors::WidgetColors(QWidget *parent) :
        QWidget(parent),
        ui(new Ui::WidgetColors)
{
        ui->setupUi(this);
colorsChanged=false;
        QGridLayout *gridLayout;


//        groupBox = new QGroupBox(this);
//        groupBox->setObjectName(QString::fromUtf8("groupBox"));
//        groupBox->setGeometry(QRect(50, 50, 461, 211));
        gridLayout = new QGridLayout(ui->groupBoxColors);
        gridLayout->setSpacing(3);
        gridLayout->setContentsMargins(11, 11, 11, 11);
        gridLayout->setObjectName(QString::fromUtf8("gridLayout"));



        p_Highlight = new ButtonColor(tr("Hi&ghlight :"),false,QApplication::palette().color(QPalette::Highlight));
        gridLayout->addWidget(p_Highlight, 3, 1, 1, 1);
        connect(p_Highlight,SIGNAL(colorChanged()),this,SLOT(setPalletChanged()));

        p_BaseText = new ButtonColor(tr("Ba&seText :"),false,QApplication::palette().color(QPalette::Text));
        gridLayout->addWidget(p_BaseText, 2, 4, 1, 1);
        connect(p_BaseText,SIGNAL(colorChanged()),this,SLOT(setPalletChanged()));

        p_Link = new ButtonColor(tr("&Link :"),false,QApplication::palette().color(QPalette::Link));
        gridLayout->addWidget(p_Link, 5, 1, 1, 1);
        connect(p_Link,SIGNAL(colorChanged()),this,SLOT(setPalletChanged()));

        p_ToolTipBase = new ButtonColor(tr("T&oolTipBase :"),false,QApplication::palette().color(QPalette::ToolTipBase));
        gridLayout->addWidget(p_ToolTipBase, 4, 1, 1, 1);
        connect(p_ToolTipBase,SIGNAL(colorChanged()),this,SLOT(setPalletChanged()));

        p_ButtonText = new ButtonColor(tr("Butto&nText :"),false,QApplication::palette().color(QPalette::ButtonText));
        gridLayout->addWidget(p_ButtonText, 1, 4, 1, 1);
        connect(p_ButtonText,SIGNAL(colorChanged()),this,SLOT(setPalletChanged()));

        p_Base = new ButtonColor(tr("Ba&seText :"),false,QApplication::palette().color(QPalette::Base));
        gridLayout->addWidget(p_Base, 2, 1, 1, 1);
        connect(p_Base,SIGNAL(colorChanged()),this,SLOT(setPalletChanged()));

        p_LinkVisited = new ButtonColor(tr("Link&Visited :"),false,QApplication::palette().color(QPalette::LinkVisited));
        gridLayout->addWidget(p_LinkVisited, 5, 4, 1, 1);
        connect(p_LinkVisited,SIGNAL(colorChanged()),this,SLOT(setPalletChanged()));

        p_HighlightedText = new ButtonColor(tr("&HighlightedText :"),false,QApplication::palette().color(QPalette::HighlightedText));
        gridLayout->addWidget(p_HighlightedText, 3, 4, 1, 1);
        connect(p_HighlightedText,SIGNAL(colorChanged()),this,SLOT(setPalletChanged()));

        p_Window = new ButtonColor(tr("&Window : "),false,QApplication::palette().color(QPalette::Window));
        gridLayout->addWidget(p_Window, 0, 1, 1, 1);
        connect(p_Window,SIGNAL(colorChanged()),this,SLOT(setPalletChanged()));

        p_Button = new ButtonColor(tr("B&utton :"),false,QApplication::palette().color(QPalette::Button));
        gridLayout->addWidget(p_Button, 1, 1, 1, 1);
        connect(p_Button,SIGNAL(colorChanged()),this,SLOT(setPalletChanged()));

        p_WindowText = new ButtonColor(tr("Window&Text :"),false,QApplication::palette().color(QPalette::WindowText));
        gridLayout->addWidget(p_WindowText, 0, 4, 1, 1);
        connect(p_WindowText,SIGNAL(colorChanged()),this,SLOT(setPalletChanged()));

        p_ToolTipText = new ButtonColor(tr("ToolTi&pText :"),false,QApplication::palette().color(QPalette::ToolTipText));
        gridLayout->addWidget(p_ToolTipText, 4, 4, 1, 1);
        connect(p_ToolTipText,SIGNAL(colorChanged()),this,SLOT(setPalletChanged()));

        QSpacerItem   *horizontalSpacer = new QSpacerItem(40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

        gridLayout->addItem(horizontalSpacer, 0, 2, 1, 1);

}


WidgetColors::~WidgetColors()
{
        delete ui;
}

//void WidgetColors::on_pushButton_clicked()
//{
//        saveColors();

//}
void WidgetColors::setPalletChanged()
{
        colorsChanged=true;
        QColor dark=p_Button->color().dark(200);
        QColor lieght=p_Button->color().light(200);
        QColor mid=p_Button->color().dark(150);
        QColor shadow=dark.dark(200);
        QColor midlight=p_Button->color().light(112);



        QColor InHighlight=p_Highlight->color().lighter(110);
        QColor InHighlightedText=p_HighlightedText->color();
        if(p_Highlight->color().value()<=50){
                InHighlight=QColor(60,60,60);
        }else{
                InHighlight=p_Highlight->color().lighter(110);
        }
        /*
        qDebug()<<"WindowText"<<p_WindowText->color().name();
         qDebug()<<"Button"<<p_Button->color().name();
           qDebug() <<"Light"<<p_Button->color().light(200).name();
           qDebug() <<"Midlight"<<p_Button->color().light(112).name();
            qDebug()<<"Dark"<<dark.name();
           qDebug() <<"Mid"<<p_Button->color().dark(150).name();
       qDebug() <<"Text"  <<p_BaseText->color().name();
          qDebug() <<"BrightText";
           qDebug() <<"ButtonText"<<p_ButtonText->color().name();
             qDebug() <<"Base"  <<p_Base->color().name();
               qDebug() <<"Window" <<p_Window->color().name();
          qDebug() <<  "Shadow"<<dark.dark(200).name();
          qDebug() <<  "Highlight"    <<p_Highlight->color().name()   ;
        qDebug() <<  "HighlightedText"<<p_HighlightedText->color().name();
             qDebug() <<  "Link" <<p_Link->color().name();
            qDebug() <<  "LinkVisited" <<  p_LinkVisited->color().name();
             qDebug() <<  "p_ToolTipBase"    <<p_ToolTipBase->color().name();
             qDebug() <<  "p_ToolTipText"   <<p_ToolTipText->color().name();
*/

        //________________________________________________________________________________
        QPalette palette;
        QBrush brush(p_WindowText->color());//QBrush brush(QColor(0, 0, 0, 255));
        QBrush brush1(p_Window->color());// QBrush brush1(QColor(191, 201, 184, 255));
        QBrush brush2(p_Base->color());//       QBrush brush2(QColor(255, 255, 255, 255));
        QBrush brush3(midlight);
        QBrush brush4(dark);// QBrush brush4(QColor(95, 100, 92, 255));
        QBrush brush5(mid);
        QBrush brush6(p_Highlight->color());
        QBrush brush7(p_HighlightedText->color());
        QBrush brush8(p_Link->color());
        QBrush brush9( p_LinkVisited->color());
        QBrush brush10(p_ToolTipBase->color());
        QBrush brush19(p_ButtonText->color());
        QBrush brush20(p_Button->color());
        QBrush brush21(lieght);
        QBrush brush22(p_BaseText->color());
        QBrush brush23(shadow);
        QBrush brush24(InHighlight);
        QBrush brush25(InHighlightedText);
        QBrush brush26(p_ToolTipText->color());

        //_______________________________________________________________________________________
        //Active palatte
        {
                palette.setBrush(QPalette::Active, QPalette::WindowText, brush);//ok
                palette.setBrush(QPalette::Active, QPalette::Button, brush20);//ok
                palette.setBrush(QPalette::Active, QPalette::Light, brush21);//ok
                palette.setBrush(QPalette::Active, QPalette::Midlight, brush3);
                palette.setBrush(QPalette::Active, QPalette::Dark, brush4);//ok
                palette.setBrush(QPalette::Active, QPalette::Mid, brush5);//ok
                palette.setBrush(QPalette::Active, QPalette::Text, brush22);//ok
                palette.setBrush(QPalette::Active, QPalette::BrightText, brush2);//ok!
                palette.setBrush(QPalette::Active, QPalette::ButtonText, brush19);//ok
                palette.setBrush(QPalette::Active, QPalette::Base, brush2);//ok
                palette.setBrush(QPalette::Active, QPalette::Window, brush1);//ok
                palette.setBrush(QPalette::Active, QPalette::Shadow, brush23);//ok
                palette.setBrush(QPalette::Active, QPalette::Highlight, brush6);//ok
                palette.setBrush(QPalette::Active, QPalette::HighlightedText, brush7);//ok
                palette.setBrush(QPalette::Active, QPalette::Link, brush8);//ok
                palette.setBrush(QPalette::Active, QPalette::LinkVisited, brush9);//ok
                palette.setBrush(QPalette::Active, QPalette::AlternateBase, brush3);//ok
                palette.setBrush(QPalette::Active, QPalette::ToolTipBase, brush10);//ok
                palette.setBrush(QPalette::Active, QPalette::ToolTipText, brush26);//ok
        }
        //_______________________________________________________________________________________
        //inactive palatte
        {
                palette.setBrush(QPalette::Inactive, QPalette::WindowText, brush);//ok
                palette.setBrush(QPalette::Inactive, QPalette::Button, brush20);//ok
                palette.setBrush(QPalette::Inactive, QPalette::Light, brush21);//ok
                palette.setBrush(QPalette::Inactive, QPalette::Midlight, brush3);
                palette.setBrush(QPalette::Inactive, QPalette::Dark, brush4);//ok
                palette.setBrush(QPalette::Inactive, QPalette::Mid, brush5);//ok
                palette.setBrush(QPalette::Inactive, QPalette::Text, brush22);//ok
                palette.setBrush(QPalette::Inactive, QPalette::BrightText, brush2);//ok!
                palette.setBrush(QPalette::Inactive, QPalette::ButtonText, brush19);//ok
                palette.setBrush(QPalette::Inactive, QPalette::Base, brush2);//ok
                palette.setBrush(QPalette::Inactive, QPalette::Window, brush1);//ok
                palette.setBrush(QPalette::Inactive, QPalette::Shadow, brush23);//ok
                palette.setBrush(QPalette::Inactive, QPalette::Highlight, brush24);//!
                palette.setBrush(QPalette::Inactive, QPalette::HighlightedText, brush25);//!
                palette.setBrush(QPalette::Inactive, QPalette::Link, brush8);
                palette.setBrush(QPalette::Inactive, QPalette::LinkVisited, brush9);
                palette.setBrush(QPalette::Inactive, QPalette::AlternateBase, brush3);//ok
                palette.setBrush(QPalette::Inactive, QPalette::ToolTipBase, brush10);//ok
                palette.setBrush(QPalette::Inactive, QPalette::ToolTipText, brush26);//ok
        }
        //_______________________________________________________________________________________
        //Disabled Palette
        {

                palette.setBrush(QPalette::Disabled, QPalette::WindowText, brush4);//ok
                palette.setBrush(QPalette::Disabled, QPalette::Button, brush1);//ok
                palette.setBrush(QPalette::Disabled, QPalette::Light, brush21);//ok
                palette.setBrush(QPalette::Disabled, QPalette::Midlight, brush3);
                palette.setBrush(QPalette::Disabled, QPalette::Dark, brush4);//ok
                palette.setBrush(QPalette::Disabled, QPalette::Mid, brush5);//ok
                palette.setBrush(QPalette::Disabled, QPalette::Text, brush4);//ok
                palette.setBrush(QPalette::Disabled, QPalette::BrightText, brush2);//ok!
                palette.setBrush(QPalette::Disabled, QPalette::ButtonText, brush4);//ok
                palette.setBrush(QPalette::Disabled, QPalette::Base, brush1);//ok
                palette.setBrush(QPalette::Disabled, QPalette::Window, brush1);//ok
                palette.setBrush(QPalette::Disabled, QPalette::Shadow, brush23);//ok
                palette.setBrush(QPalette::Disabled, QPalette::Highlight, brush1);//!
                palette.setBrush(QPalette::Disabled, QPalette::HighlightedText, brush4);//!
                palette.setBrush(QPalette::Disabled, QPalette::Link, brush4);
                palette.setBrush(QPalette::Disabled, QPalette::LinkVisited, brush4);
                palette.setBrush(QPalette::Disabled, QPalette::AlternateBase, brush1);//ok
                palette.setBrush(QPalette::Disabled, QPalette::ToolTipBase, brush10);//ok
                palette.setBrush(QPalette::Disabled, QPalette::ToolTipText, brush26);//ok

        }
        //_______________________________________________________________________________________
        ui->labelH->setText("<a href=\"www.xxxxx.com\">www.xxxxx.com</a>");

        ui->framePreview->setPalette(palette);
}

void WidgetColors::saveSettings()
{
        if (colorsChanged==false) {
                return;
        }
        qDebug()<<"colorsChanged";

           QColor dark=p_Button->color().dark(200);
        QColor light=p_Button->color().light(200);
        QColor mid=p_Button->color().dark(150);
        QColor shadow=dark.dark(200);
        QColor midlight=p_Button->color().light(112);




        QColor InHighlight=p_Highlight->color().lighter(110);
        QColor InHighlightedText=p_HighlightedText->color();
        if(p_Highlight->color().value()<=50){
                InHighlight=QColor(60,60,60);
        }else{
                InHighlight=p_Highlight->color().lighter(110);
        }
        //_____________________________________________________________________

        QStringList listActive;
        QStringList listInactive;
        QStringList listDisabled;

        //_____________________________________________________________________
        listActive<<p_WindowText->color().name()  /*WindowText*/
                 <<p_Button->color().name()     /*Button */
                << light.name()                 /* Light*/
                <<midlight.name()               /*Midlight*/
               <<dark.name()                    /*dark*/
              <<mid.name()                      /*mid*/
             <<p_BaseText->color().name()       /*Text*/
            <<p_Base->color().name()            /*BrightText*/
           <<p_ButtonText->color().name()       /*ButtonText*/
          <<p_Base->color().name()              /*Base*/
         <<p_Window->color().name()             /*Window*/
        <<shadow.name()                         /*Shadow*/
        <<p_Highlight->color().name()           /*Highlight*/
        <<p_HighlightedText->color().name()     /*HighlightedText*/
        <<p_Link->color().name()                /*Link*/
        <<p_LinkVisited->color().name()         /*LinkVisited*/
        <<midlight.name()                       /*AlternateBase*/
        <<"#000000"                             /*NoRole*/
        <<p_ToolTipBase->color().name()         /*ToolTipBase*/
        <<p_ToolTipText->color().name();        /*ToolTipText*/

        qDebug()<<listActive;
        //_____________________________________________________________________
        listInactive<<  p_WindowText->color().name()<<p_Button->color().name()<<light.name()<<midlight.name()
                     <<dark.name()<<mid.name()<<p_BaseText->color().name()<<p_Base->color().name() <<p_ButtonText->color().name()
                    <<p_Base->color().name() <<p_Window->color().name() <<shadow.name() <<InHighlight.name()
                   <<InHighlightedText.name() <<p_Link->color().name()  <<p_LinkVisited->color().name() <<midlight.name()
                  <<"#000000"/*NoRole*/  <<p_ToolTipBase->color().name()  <<p_ToolTipText->color().name();
        qDebug()<<listInactive;

        //_____________________________________________________________________
        listDisabled <<dark.name() <<p_Window->color().name() <<light.name() <<midlight.name()<<dark.name() <<mid.name()
                    <<dark.name()<<p_Base->color().name()<<dark.name()<<p_Window->color().name()<<p_Window->color().name()<<shadow.name()
                   <<p_Window->color().name() <<dark.name()  <<dark.name()  <<dark.name()
                  <<p_Window->color().name()   <<"#000000"/*NoRole*/   <<p_ToolTipBase->color().name()  <<p_ToolTipText->color().name();
        qDebug()<<listDisabled;

        //! save settings---------------------------------------

        QSettings settings("elokab","widgetColors") ;

        settings.beginGroup("qt");
        settings.beginWriteArray("Palette");
        settings.setValue("active", listActive);
        settings.setValue("inactive", listInactive);
        settings.setValue("disabled", listDisabled);

        settings.endArray();
        settings.endGroup();

        QSettings settingsQt("Trolltech") ;
        //
        settingsQt.beginGroup("qt");
        settingsQt.beginWriteArray("Palette");
        settingsQt.setValue("active", listActive);
        settingsQt.setValue("inactive", listInactive);
        settingsQt.setValue("disabled", listDisabled);

        settingsQt.endArray();
        settingsQt.endGroup();
        //! aplyque change-----------------------------------------
        setPalletChanged();
        colorsChanged=false;
}
Q_EXPORT_PLUGIN2(setting_WidgetColors, WidgetColors)
