﻿/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#include "widgetwmanager.h"
#include "ui_widgetwmanager.h"
#include <DesktopFile>
#include <QSettings>
#include <QFileInfo>
#include <EDir>
#include <QDebug>
#include <QStyleFactory>
#include <QMessageBox>
#include <QFileDialog>
#include <QPushButton>
WidgetWmanager::WidgetWmanager(QWidget *parent) :
   QWidget(parent),
    ui(new Ui::WidgetWmanager),m_parent(parent)
{

    ui->setupUi(this);
//    if(m_closeParent==true){
//        QApplication::setStyle(QStyleFactory::create("Cleanlooks"));
// ui->pushButtonApply->setVisible(false);
//    }else{
         ui->pushButtonApply->setVisible(true);
//    }

    /// مسار مجلد البرنامج

   QString appPath= Edir::dataHomeAppDir()+"/wmservice";
   QString localPath=Edir::dataAppDir() +"/wmservice";

    ///
   QStringList list;
   list<<localPath<<appPath;

   foreach (QString s, list) {


       QDir dir(s);
       foreach (QString subfile, dir.entryList(QStringList()<<"*.desktop"))
       {
             QFileInfo fi(s+"/"+subfile);
             QString file=fi.absoluteFilePath();
             bool exist=false;
             foreach (QString f, listWm) {
                 QFileInfo fi(f);
                 if(fi.fileName()==subfile)
                     exist=true;
             }
           if(!exist){
               listWm.append(file);

           }


       }


   }

/*
    listWm.append("openbox|Light-weight window manager" );
    listWm.append("kwin|Window manager of the KDE Software Compilation" );
    listWm.append("metacity|Window manager of the GNOME desktop environment" );
    listWm.append("windowmaker|A classical lightweight window manager" );
    listWm.append("e16|Light-weight window manager" );
    listWm.append("e17|Enlightenement 17" );
    listWm.append("xfwm4|A window manager for the Xfce desktop environment" );
    listWm.append("sawfish|A lightweight, flexible window manager" );
    listWm.append("marco|Window manager of the Mate desktop environment" );
    listWm.append("mutter|Window manager of the GNOME 3 desktop environment" );
    listWm.append("compiz|Compositing window-manager using OpenGL for rendering" );
*/

    chargeTree();
}

WidgetWmanager::~WidgetWmanager()
{
    delete ui;
}
void WidgetWmanager::chargeTree()
{

    QString lc=this->locale().name().section("_",0,0);
    foreach (QString s, listWm) {
        DesktopFile dsf(s,"Desktop Entry",lc);
        QString oldname=dsf.value("Name").toString();
        QString name=dsf.value("Name["+lc+"]",oldname).toString();

        QString oldcomment=dsf.value("Comment").toString();
        QString comment=dsf.value("Comment["+lc+"]",oldcomment).toString();

        QString exec=dsf.value("Exec").toString();

        if(findProgram(exec)){

            QTreeWidgetItem *item=new QTreeWidgetItem;
            item->setText(0,name);
            item->setText(1,comment);
            item->setText(2,exec);
            ui->treeWidget->addTopLevelItem(item);
        }
    }
    /*
    for(int i=0;i<listWm.count();i++){


        QString name=listWm.at(i).section("|",0,0);
        QString comment=listWm.at(i).section("|",1,1);

        if(findProgram(name)){

            QTreeWidgetItem *item=new QTreeWidgetItem;
            item->setText(0,name);
            item->setText(1,comment);
            ui->treeWidget->addTopLevelItem(item);
        }

    }
*/

    if(ui->treeWidget->topLevelItemCount()==0){
        return;
    }
    ui->treeWidget->resizeColumnToContents(0);
    ui->treeWidget->resizeColumnToContents(1);
    QSettings setting("elokab","wmrc");
    setting.beginGroup("WindowManagers");

    QString   windowManager = setting.value("WM").toString();




    if (!windowManager.isEmpty())
    {
        bool exist=false;
        for (int i = 0; i < ui->treeWidget->topLevelItemCount(); ++i) {
            if(windowManager==ui->treeWidget->topLevelItem(i)->text(2)){
                exist=true;
                ui->treeWidget->setCurrentItem(ui->treeWidget->topLevelItem(i));
                WM=   windowManager;
                oldWm=windowManager;
            }

        }
        if (exist==false){
            QTreeWidgetItem *item=new QTreeWidgetItem;
            item->setText(0,windowManager);
            item->setText(2,windowManager);
            ui->treeWidget->addTopLevelItem(item);
            ui->treeWidget->setCurrentItem(item);
            WM=   windowManager;
            oldWm=windowManager;
        }

    }else{
        ui->treeWidget->setCurrentItem(ui->treeWidget->topLevelItem(0));
        WM=   ui->treeWidget->topLevelItem(0)->text(2);

    }

}

bool WidgetWmanager::findProgram(const QString &program)
{

    QFileInfo fi(program);
    if (fi.isExecutable())
        return true;

    QString path = qgetenv("PATH");
    foreach(QString dir, path.split(":"))
    {
        QFileInfo fi= QFileInfo(dir + QDir::separator() + program);
       //  qDebug()<<fi.filePath();
        if (fi.isExecutable() )
            return true;
    }
    return false;
}

void WidgetWmanager::on_treeWidget_itemActivated(QTreeWidgetItem *item, int /*column*/)
{
   // saveSettings();
   WM=item->text(2);
//    if(m_closeParent==true)
       // m_parent->close();
      //  qApp->quit();
}



void WidgetWmanager::on_treeWidget_itemSelectionChanged()
{
    QTreeWidgetItem *item=ui->treeWidget->currentItem();
    if (item)
         WM=item->text(2);
}


 void WidgetWmanager::saveSettings()
 {

     QTreeWidgetItem *item=ui->treeWidget->currentItem();
     if (!item)
      return;

     if(oldWm!=item->text(2)){
         oldWm=item->text(2);
         QSettings setting("elokab","wmrc");
         setting.beginGroup("WindowManagers");
         setting.setValue("WM", oldWm);
         setting.endGroup();
         qDebug()<<"set window manager is :"<<oldWm;
     }

 }

void WidgetWmanager::on_pushButtonOther_clicked()
{


      QString fileName = QFileDialog::getOpenFileName(this, tr("Choose your favorite one"),
                                                       "/usr/bin",
                                                       tr("All Files (*)"));
      if (!fileName.isEmpty()){
           if(findProgram(fileName)==true){
                QTreeWidgetItem *item=new QTreeWidgetItem;
                QFileInfo fi(fileName);
                item->setText(0,fi.fileName());
                item->setText(2,fi.fileName());
                WM=item->text(2);
                ui->treeWidget->addTopLevelItem(item);
                ui->treeWidget->setCurrentItem(item);
           }else{
                QMessageBox::information(0,"error",tr("This File is no executable file"));
           }
      }

}
Q_EXPORT_PLUGIN2(setting_WindowManager, WidgetWmanager)

void WidgetWmanager::on_pushButtonApply_clicked()
{
    QString windowM=   WM;
    if(!windowM.isEmpty()){
        QProcess process;
        QStringList args ;
        args<<"--replace";
        process.startDetached(windowM,args);
    }
}
