/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)GPL3+
 *
 * elokab - a lightweight, Qt based, desktop toolset
 * https://sourceforge.net/project/elokab/
 *
 * Copyright: 2013-2014 elokab team
 * Authors:
 *   Abou Zakaria <yahiaui@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef WIDGETWMANAGER_H
#define WIDGETWMANAGER_H
#include "../spluginsinterface.h"
#include <QWidget>

#include <QTreeWidgetItem>
namespace Ui {
class WidgetWmanager;
}
class WidgetWmanager : public QWidget,PluginsInterface
{
          Q_OBJECT
          Q_INTERFACES(PluginsInterface)

public:
    explicit WidgetWmanager(QWidget *parent = 0);
    ~WidgetWmanager();
      QString WM;
      QString oldWm;

private:
    Ui::WidgetWmanager *ui;

      QWidget *m_parent;

       QStringList listWm;


public slots:

    void saveSettings();
    QWidget *widget(){return this;}

  private slots:
    bool findProgram(const QString &program);
    void on_treeWidget_itemActivated(QTreeWidgetItem *item, int /*column*/);
    void chargeTree();

    void on_treeWidget_itemSelectionChanged();
    void on_pushButtonOther_clicked();
    void on_pushButtonApply_clicked();
};

#endif // WIDGETWMANAGER_H
