#ifndef GLOBALSHORTCUTS_H
#define GLOBALSHORTCUTS_H
#include <QxtGlobalShortcut>
#include <ElokabSettings>
#include <QObject>
enum SType{
    Type_Exec,
    Type_Dbus
};

class ShortcutItem : public  QxtGlobalShortcut
{
    Q_OBJECT
public:
    ShortcutItem(const QKeySequence &sequence,
                 SType type ) ;

    ~ShortcutItem();
public slots:

    void setDebusMap(const QString &Destination){m_dbusMap=Destination; }
    void setExecCommand( const QString &command) {m_command=command;    }

private slots:

    void  exec();

private:

    SType m_type;
    QString m_command;
    QString m_dbusMap;
};

class GlobalShortcuts : public QObject
{
    Q_OBJECT
public:

    explicit GlobalShortcuts(QObject *parent = 0);
    ~GlobalShortcuts();
    
private slots:

    void rechargeAllSettings();
    void rechargeSettings(const QString &filePath);

private:

    QList<ShortcutItem *>listShortcuts;
    ElokabSettings *m_shortSettings;
};

#endif // GLOBALSHORTCUTS_H
