#include "dialogpower.h"

#include "ui_dialogpower.h"
#include <QSettings>
#include <EDir>
#include <QTextCodec>
#include <QDebug>
DialogPower::DialogPower(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DialogPower)
{
    QSettings globalSetting("elokab","elokabsettings");
    globalSetting.beginGroup("Themes");
    QIcon::setThemeName(globalSetting.value("iconsTheme",QIcon::themeName()).toString());
    globalSetting.endGroup();

    ui->setupUi(this);
    QDir serviceDir(Edir::dataAppDir());
//    serviceDir.cdUp();
//    serviceDir.cd( serviceDir.absolutePath()+"/share/elokab/elokab-power") ;
//   QDir derr(Edir::dataAppDir());
   qDebug()<<"power"<<serviceDir.path();
//     qDebug()<<"powerderr"<<derr.path();
    QSettings s;
    s.beginGroup("Power");
    int lastPower=s.value("LastPower",0).toInt();
    s.endGroup();
     QIcon  pixmap1 = PowerMain::ICON(PowerMain::Shutdown).pixmap(24);
    QIcon  pixmap2 = PowerMain::ICON(PowerMain::Reboot).pixmap(24);
    QIcon  pixmap3 = PowerMain::ICON(PowerMain::Hibernate).pixmap(24);
    QIcon  pixmap4 =PowerMain::ICON(PowerMain::Suspend).pixmap(24);
    QIcon  pixmap6 =PowerMain::ICON(PowerMain::Logout).pixmap(24);

    mpower=new PowerMain;
    if(mpower->canAction(PowerMain::Logout))
        ui->comboBox->addItem(pixmap6,
                              loadService(serviceDir.absoluteFilePath("Logout.desktop")),
                              PowerMain::Logout);

    if(mpower->canAction(PowerMain::Shutdown))
        ui->comboBox->addItem(pixmap1,
                              loadService(serviceDir.absoluteFilePath("Shutdown.desktop")),
                              PowerMain::Shutdown);

    if(mpower->canAction(PowerMain::Reboot))
        ui->comboBox->addItem(pixmap2,
                              loadService(serviceDir.absoluteFilePath("Reboot.desktop")),
                              PowerMain::Reboot);

    if(mpower->canAction(PowerMain::Suspend))
        ui->comboBox->addItem(pixmap4,
                              loadService(serviceDir.absoluteFilePath("Suspend.desktop")),
                              PowerMain::Suspend);

    if(mpower->canAction(PowerMain::Hibernate))
        ui->comboBox->addItem(pixmap3,
                              loadService(serviceDir.absoluteFilePath("Hibernate.desktop")),
                              PowerMain::Hibernate);

    connect(ui->comboBox,SIGNAL(currentIndexChanged(int)),this,SLOT(actionChanged(int)));
    connect(ui->buttonBox,SIGNAL(clicked(QAbstractButton*)),this,SLOT(buttonBoxClicked(QAbstractButton* )));
    ui->comboBox->setCurrentIndex(lastPower);
    actionChanged(lastPower);
}

DialogPower::~DialogPower()
{
    delete ui;
}
QString DialogPower::loadService(const QString &path)
{
    QFileInfo fi(path);

    QString lc=locale().name().section("_",0,0);
    QSettings gs(path,QSettings::IniFormat);
    gs.setIniCodec(QTextCodec::codecForName("UTF-8"));
     gs.beginGroup("Desktop Entry");
     QString nameOld=gs.value("Name",fi.baseName()).toString();
     QString name=gs.value("Name["+lc+"]",nameOld).toString();
     gs.endGroup();
     return name;
}
void DialogPower::actionChanged(int index)
{
     QPixmap  p_Shutdown =PowerMain:: ICON(PowerMain::Shutdown).pixmap(64);
     QPixmap  p_Reboot   =PowerMain::ICON(PowerMain::Reboot).pixmap(64);
     QPixmap  p_Hibernate=PowerMain::ICON(PowerMain::Hibernate).pixmap(64);
     QPixmap  p_Suspend  =PowerMain::ICON(PowerMain::Suspend).pixmap(64);
     QPixmap  p_Logout   =PowerMain::ICON(PowerMain::Logout).pixmap(64);

     int act=ui->comboBox->itemData(index).toInt();
     switch (act) {
          case PowerMain::Logout:
               ui->quitIcon->setPixmap(p_Logout);

               break;
          case PowerMain::Reboot:
               ui->quitIcon->setPixmap(p_Reboot);

               break;
          case PowerMain::Shutdown:
               ui->quitIcon->setPixmap(p_Shutdown);

               break;
          case PowerMain::Hibernate:
               ui->quitIcon->setPixmap(p_Hibernate);

               break;
          case PowerMain::Suspend:
               ui->quitIcon->setPixmap(p_Suspend);

               break;

     }
     ui->question->setText(QString(tr("Are you sure you want to quit all applications and %1 now ?"))
                           .arg(ui->comboBox->currentText()));

}

void DialogPower::buttonBoxClicked(QAbstractButton* button)
{
     int index=ui->comboBox->currentIndex();
     QSettings s;
     s.beginGroup("Power");
     s.setValue("LastPower",index);
     s.endGroup();

     if(ui->buttonBox->standardButton(button)==QDialogButtonBox::Ok)
     {


          int act=ui->comboBox->itemData(index).toInt();
          switch (act) {
               case PowerMain::Logout:
                    mpower->doAction(PowerMain::Logout);
                    break;
               case PowerMain::Reboot:
                    mpower->doAction(PowerMain::Reboot);
                    break;
               case PowerMain::Shutdown:
                    mpower->doAction(PowerMain::Shutdown);
                    break;
               case PowerMain::Hibernate:
                    mpower->doAction(PowerMain::Hibernate);
                    break;
               case PowerMain::Suspend:
                    mpower->doAction(PowerMain::Suspend);
                    break;

          }

     }
}
