#include "uptimestat.h"
#include <fcntl.h>
#include <unistd.h>
#include <QTimer>
UptimeStat::UptimeStat(QObject *parent) :
        QObject(parent)
{
        QTimer *timer=new QTimer;
        connect(timer,SIGNAL(timeout()),this,SLOT(loadUpTime()));
        timer->start(5000);
}
void UptimeStat::loadUpTime()
{

QString proc=readAllFile("/proc/uptime").trimmed();
proc=proc.section(" ",0,0).remove(".");
int mcs=proc.toInt();

int h=mcs/360000;
int m=(mcs/6000)-(h*60);

QString hour="00"+QString::number(h);
hour=hour.right(2);

QString minut="00"+QString::number(m);
minut=minut.right(2);

emit setUptime(hour+minut);
//qDebug()<<hour+minut;
}

QString UptimeStat::readAllFile(const char *filename)
{
    QString result;

    static const size_t bufferSize = 1 << 12; // 4096
    static char buffer[bufferSize];

    int fd = ::open(filename, O_RDONLY);
    if (fd > 0)
    {
        ssize_t size = ::read(fd, buffer, bufferSize);
        ::close(fd);
        if (size > 0)
            result = QString::fromAscii(buffer, size);
    }

    return result;
}
